import {
  browser,
  by,
  element,
  ElementArrayFinder,
  ElementFinder,
  Key,
  logging,
} from "protractor";
import { isRegExp } from "util";
import { GlobalFunctions } from "../global-functions";
import { SNSE003Page } from "./batch-sale.po";

describe(`ขาย Batch - Initial`, () => {
  let CustomerCode: ElementFinder,
    CustomerName: ElementFinder,
    BranchCode: ElementFinder,
    BranchName: ElementFinder,
    OrderNumber: ElementFinder,
    OrderClass: ElementFinder,
    OrderDate: ElementFinder,
    OrderType: ElementFinder,
    BOFlag: ElementFinder,
    RouteCode: ElementFinder,
    TransportCode: ElementFinder,
    DeliveryCode: ElementFinder,
    TotalQuantity: ElementFinder,
    TotalAmount: ElementFinder,
    AvailableCredit: ElementFinder,
    PartsNo: ElementArrayFinder,
    SaveButton: ElementFinder;

  let setElements = (page: SNSE003Page) => {
    CustomerCode = page.getCustomerCodeElement();
    CustomerName = page.getCustomerNameElement();
    BranchCode = page.getBranchCodeElement();
    BranchName = page.getBranchNameElement();
    OrderNumber = page.getOrderNumberElement();
    OrderClass = page.getOrderClassElement();
    OrderDate = page.getOrderDateElement();
    OrderType = page.getOrderTypeElement();
    BOFlag = page.getBOFlagElement();
    RouteCode = page.getRouteCodeElement();
    TransportCode = page.getTransportCodeElement();
    DeliveryCode = page.getDeliveryCodeElement();
    TotalQuantity = page.getTotalQuantityElement();
    TotalAmount = page.getTotalAmountElement();
    AvailableCredit = page.getAvailableCreditElement();
    PartsNo = page.getAllPartNoElement();
    SaveButton = page.getSaveButtonElement();
  };

  let page: SNSE003Page = new SNSE003Page();

  beforeAll(() => {
    page.navigateTo();

    setElements(page);
  });

  it(`CustomerCode is not disabled.`, () => {
    expect(CustomerCode.getAttribute("disabled")).not.toEqual("true");
  });
  it(`CustomerName is disabled.`, () => {
    expect(CustomerName.getAttribute("disabled")).toEqual("true");
  });
  it(`BranchCode is not disabled.`, () => {
    expect(BranchCode.getAttribute("disabled")).not.toEqual("true");
  });
  it(`BranchName is disabled.`, () => {
    expect(BranchName.getAttribute("disabled")).toEqual("true");
  });
  it(`OrderNumber is not disabled.`, () => {
    expect(OrderNumber.getAttribute("disabled")).not.toEqual("true");
  });
  it(`OrderClass is not disabled.`, () => {
    expect(OrderClass.getAttribute("disabled")).not.toEqual("true");
  });
  it(`OrderDate is not disabled.`, () => {
    expect(OrderDate.getAttribute("disabled")).not.toEqual("true");
  });
  it(`OrderType is not disabled.`, () => {
    expect(OrderType.getAttribute("disabled")).not.toEqual("true");
  });
  it(`BOFlag is not disabled.`, () => {
    expect(BOFlag.getAttribute("disabled")).not.toEqual("true");
  });
  it(`RouteCode is not disabled.`, () => {
    expect(RouteCode.getAttribute("disabled")).not.toEqual("true");
  });
  it(`TransportCode is not disabled.`, () => {
    expect(TransportCode.getAttribute("disabled")).not.toEqual("true");
  });
  it(`DeliveryCode is not disabled.`, () => {
    expect(DeliveryCode.getAttribute("disabled")).not.toEqual("true");
  });
  it(`TotalQuantity is disabled.`, () => {
    expect(TotalQuantity.getAttribute("disabled")).toEqual("true");
  });
  it(`TotalAmount is disabled.`, () => {
    expect(TotalAmount.getAttribute("disabled")).toEqual("true");
  });
  it(`AvailableCredit is disabled.`, () => {
    expect(AvailableCredit.getAttribute("disabled")).toEqual("true");
  });
  it(`Parts list should not be disabled.`, () => {

    //All should not be disabled
    PartsNo.each((v) => {
      expect(v.getAttribute("disabled")).not.toEqual("true");
    });
  });
});
