import {
  browser,
  by,
  element,
  ElementArrayFinder,
  ElementFinder,
  Key,
} from "protractor";

export class SNSE004_MPage {
  navigateTo(): Promise<unknown> {
    return browser.get("/DomSales/SNSE004_M") as Promise<unknown>;
  }

  getDynamicElementText(query: string): Promise<string> {
    return element(by.css(query)).getText() as Promise<string>;
  }

  getCustomerCodeElement(): ElementFinder {
    return element(by.css("input[name=CUSTOMER_CODE]"));
  }

  getCustomerNameElement(): ElementFinder {
    return element(by.css("input[name=CUSTOMER_NAME]"));
  }

  getBranchCodeElement(): ElementFinder {
    return element(by.css("input[name=BRANCH_CODE]"));
  }

  getBranchNameElement(): ElementFinder {
    return element(by.css("input[name=BRANCH_NAME]"));
  }

  getAddressElement(): ElementFinder {
    return element(by.css("input[name=CUST_ADDR]"));
  }

  // getAddress2Element(): ElementFinder {
  //   return element(by.css("input[name=address2]"));
  // }

  getOrderNumberElement(): ElementFinder {
    return element(by.css("input[name=ORDER_NO]"));
  }

  getOrderClassElement(): ElementFinder {
    return element(by.css("mat-select[name=ORDER_CLASS]"));
  }

  getPaymentTermElement(): ElementFinder {
    return element(by.css("input[name=PAYMENT_TERM]"));
  }

  getOrderDateElement(): ElementFinder {
    return element(by.css("input[name=ORDER_DATE]"));
  }

  getOrderTypeElement(): ElementFinder {
    return element(by.css("mat-select[name=ORDER_TYPE]"));
  }

  getBOFlagElement(): ElementFinder {
    return element(by.css("mat-select[name=BO_FLAG]"));
  }

  getRouteCodeElement(): ElementFinder {
    return element(by.css("input[name=ROUTE_CODE]"));
  }

  getTransportCodeElement(): ElementFinder {
    return element(by.css("input[name=TRANSPORT_CODE]"));
  }

  getDeliveryCodeElement(): ElementFinder {
    return element(by.css("mat-select[name=DELIVER_CODE]"));
  }

  getTotalQuantityElement(): ElementFinder {
    return element(by.css("input[name=TOTAL_QTY]"));
  }

  getTotalAmountElement(): ElementFinder {
    return element(by.css("input[name=TOTAL_AMT]"));
  }

  getAvailableCreditElement(): ElementFinder {
    return element(by.css("input[name=CREDIT_LIMIT]"));
  }

  getPrintRemarkElement(): ElementFinder {
    return element(by.css("input[name=PRINT_REMARK]"));
  }

  getPrintPickingCardElement(): ElementFinder {
    return element(by.css("input[name=PRINT_PICKING_CARD]"));
  }

  getAllPartNoElement(): ElementArrayFinder {
    return element.all(by.css("input[name=ORDER_PART_NO]"));
  }

  getDetailRowsElement(): ElementArrayFinder {
    return element.all(
      by.css("auto-table-hl#tbl1 table[mat-table] tr[mat-row]")
    );
  }

  getSaveButtonElement(): ElementFinder {
    return element(by.css("button[name=BtnSave]"));
  }

  getMessageModalElement(optionalClass: string): ElementFinder {
    return element(by.css(".modal-dialog-panel"+optionalClass));
  }
}
