import {
  browser,
  by,
  element,
  ElementArrayFinder,
  ElementFinder,
  Key,
} from "protractor";

export class SNPE015P_Page { 
  navigateTo(): Promise<unknown> {
    return browser.get("/WareHouse/SNPE015_P") as Promise<unknown>;
  }

  getDynamicElementText(query: string): Promise<string> {
    return element(by.css(query)).getText() as Promise<string>;
  }

  getVendorCodeElement(): ElementFinder {
    return element(by.css("input[name=INVOICEHEADER_VENDOR_CODE]"));
  }

  getVendorNameElement(): ElementFinder {
    return element(by.css("input[name=INVOICEHEADER_VENDOR_NAME]"));
  }

  getInvoiceNoElement(): ElementFinder {
    return element(by.css("input[name=INVOICEHEADER_INVOICE_NO]"));
  }

  getInvoiceDateElement(): ElementFinder {
    return element(by.css("input[name=INVOICEHEADER_INVOICE_DATE]"));
  }

  getTotalStickerElement(): ElementFinder {
    return element(by.css("input[name=TOTAL_ITEM]"));
  }

  getTotalQuantityElement(): ElementFinder {
    return element(by.css("input[name=TOTAL_QTY]"));
  }

  getInvoiceStatusElement(): ElementFinder {
    return element(by.css("input[name=INVOICEHEADER_INVOICE_STATUS]"));
  }

  getAllPartNoElement(): ElementArrayFinder {
    return element.all(by.css("input[name=ACCEPT_PART_NO]"));
  }

  getDetailRowsElement(): ElementArrayFinder {
    return element.all(by.css("auto-table#tbl2 table[mat-table] tr[mat-row]"));
  }

  getSelectPOElement(): ElementArrayFinder {
    return element.all(by.css("auto-table#tbl4 table[mat-table] tr[mat-row]"));
  }

  getSaveButtonElement(): ElementFinder {
    return element(by.css("button[name=BtnSave]"));
  }

  getAcceptButtonElement(): ElementFinder {
    return element(by.css("button[name=BtnAccept]"));
  }

  getReportButtonElement(): ElementFinder {
    return element(by.css("button[name=BtnReport]"));
  }

  getMessageModalElement(optionalClass: string): ElementFinder {
    return element(by.css(".modal-dialog-panel"+optionalClass));
  }

  getDialogModalElement(): ElementFinder {
    return element(by.css(".dialog-panel")); 
  }


}
