import { Component, OnInit, Input, Output, EventEmitter } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { Title } from '@angular/platform-browser';
import { ActivatedRoute } from '@angular/router';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'form-header-enissan',
  template: `
      <div class="row pb-2 pt-2" style="background-color:#007f7f; margin-left:5px; margin-right:5px;">
        <div class="col-md-12">
            <div class="text-center" style="color:#ffffff; font-size: 12pt;">{{formName}}</div>
        </div>
      </div>
        `
})

export class FormHeaderEnissanComponent implements OnInit {
  @Input("formID") formID: string;
  @Output() formTitle = new EventEmitter<any>();
  public formName: string;

  constructor(
    private http: HttpService,
    private title: Title,
    private route: ActivatedRoute,
    private global: Globals
  ) {
    this.route.data.subscribe(d => {
      this.global.SetRoleDetail(d.role);
    })
  }

  ngOnInit() {
    this.GetFormName();
  }

  GetFormName() {
    this.http.get("SystemEn", "GetFormName", this.formID)
      .subscribe(result => {
        if (result.length > 0) {
          this.formName = result[0].MENU_NAME_EN;
        }
        else {
          this.formName = this.formID;
        }
        this.formTitle.emit(this.formName);
        this.title.setTitle('PMS : ' + this.formName);
      })
  }
}
