import { Injectable } from "@angular/core";

export class PackExportToken {
	public constructor() { }

	public PROCESS: string;
	public CUSTOMER_CODE: string;
	public BRANCH_CODE: string;
	public ORDER_TYPE: string;
	public CASE_NO: string;
	public CASE_GROUP: string;

	public setDetail(
		process: string,
		customerCode: string,
		branchCode: string,
		orderType: string,
		caseNo: string,
		caseGroup: string,
	) {
		if (!process) throw "undefined";
		if (!customerCode) throw "undefined";
		if (!branchCode) throw "undefined";
		if (!orderType) throw "undefined";
		if (!caseNo) throw "undefined";
		if (!caseGroup) throw "undefined";

		this.PROCESS = process;
		this.CUSTOMER_CODE = customerCode;
		this.BRANCH_CODE = branchCode;
		this.ORDER_TYPE = orderType;
		this.CASE_NO = caseNo;
		this.CASE_GROUP = caseGroup;
	}
}
@Injectable()
export class PackExportTokenExtractor {
	private token: PackExportToken = new PackExportToken();
	public INVALID_TOKEN: string = "Invalid QR";

	public getToken(tokenString: string): PackExportToken {
		this.token = new PackExportToken();
		this.extractToken(tokenString);

		return this.token;
	}

	private extractToken(tokenString: string) {
		try {
			const tokenDetail = tokenString.split("|");
			this.token.setDetail.apply(this.token, tokenDetail);
		} catch (e) {
			throw this.INVALID_TOKEN;
		}
	}
}
