import { Injectable } from "@angular/core";
import * as moment from "moment";

export class PickToken {
	public constructor() {}

	public COMPANY_CODE: string;
	public PICKING_LIST_NO: string;
	public CUSTOMER_CODE: string;
	public BRANCH_CODE: string;
	public INSTRUCTION_NO: string;

	public setDetail(
		companyCode: string,
		pickListNo: string,
		customerCode: string,
		branchCode: string,
		instructionNo: string
	) {
		if (!companyCode) throw "undefined";
		if (!pickListNo) throw "undefined";
		if (!customerCode) throw "undefined";
		if (!branchCode) throw "undefined";
		if (!instructionNo) throw "undefined";

		this.COMPANY_CODE = companyCode;
		this.PICKING_LIST_NO = pickListNo;
		this.CUSTOMER_CODE = customerCode;
		this.BRANCH_CODE = branchCode;
		this.INSTRUCTION_NO = instructionNo;
	}
}

@Injectable()
export class PickTokenExtractor {
	private token: PickToken = new PickToken();
	public INVALID_TOKEN: string = "Invalid QR";

	public getToken(tokenString: string): PickToken {
		this.token = new PickToken();
		this.extractToken(tokenString);

		return this.token;
	}

	private extractToken(tokenString: string) {
		try {
			const tokenDetail = tokenString.split("|");
			this.token.setDetail.apply(this.token, tokenDetail);
		} catch (e) {
			throw this.INVALID_TOKEN;
		}
	}
}
