import { ReceiveExportToken } from "./ReceiveTokenExtractor";

type propName = "QR" | "partNo" | "caseNo" | "baBy" | "caseNoExport";

export class ReceiveControl {
	public reset(): void {
		this.QR = null;
		this.caseNo = null;
		this.partNo = null;
		this.latestScanned = null;
		this.baBy = null;
		this.caseNoExport = null;
	}
	public set(args: ReceiveControlSetValue) {
		if (args.propName == "QR" && args.value instanceof ReceiveExportToken)
			this.QR = args.value;

		if (args.propName == "caseNo" && args.value instanceof CaseNo)
			this.caseNo = args.value;

		if (args.propName == "partNo" && typeof args.value == "string")
			this.partNo = args.value;

		if (args.propName == "baBy" && typeof args.value == "string")
			this.baBy = args.value;
		if (args.propName == "caseNoExport" && args.value instanceof CaseNoExport)
			this.caseNoExport = args.value;
		this.latestScanned = args.propName
	}
	public QR: ReceiveExportToken;
	public caseNo: CaseNo;
	public partNo: string;
	public latestScanned: propName;
	public baBy : string;
	public caseNoExport: CaseNoExport;
}
export class ReceiveControlSetValue {
	public propName: propName;
	public value: ReceiveExportToken | CaseNo | string | CaseNoExport;
}

export class CaseNo {
	public constructor(caseno: string, casedate: string, casetype?:'BOX' | 'BAG') {
		this.caseNo = caseno;
		this.caseDate = casedate;
		
		if(casetype)
			this.caseType = casetype;
	}
	
	public caseNo: string;
	public caseDate: string;
	public caseType?: 'BOX' | 'BAG';
}
export class CaseNoExport {
	public constructor(caseno: string, casedate: string, casetype?: string, casename?: string) {
		this.caseNo = caseno;
		this.caseDate = casedate;
		this.caseName = casename;
		if (casetype) this.caseType = casetype;
	}
	public caseNo: string;
	public caseDate: string;
	public caseType?: string;
	public caseName: string;
}