import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';
import { AuthGuard } from 'src/app/core/auth-guard.service';
import { MaterialImportModule } from '../shared/material.module';
import { SharedComponentModule } from '../shared/shared-component.module';
import { DocumentComponent } from 'src/app/pages/document/document.component';
import { ListComponent } from '../../pages/document/list/list.component';
import { UpdateComponent } from '../../pages/document/update/update.component';


@NgModule({
  declarations: [DocumentComponent, ListComponent, UpdateComponent],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,

    //Material imports
    MaterialImportModule,

    RouterModule.forChild([
      {
        path: '',
        component: DocumentComponent,
        children: [
          {
            path: '',
            redirectTo: 'list',
          },
          {
            path: 'list',
            component: ListComponent
          },
          {
            path: 'update',
            component: UpdateComponent
          }
        ],
        canActivate: [AuthGuard]
      }
    ])
  ]
})
export class DocumentModule { }
