import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';

import { LayoutModule } from '@angular/cdk/layout';
//import { FlexLayoutModule } from '@angular/flex-layout';
import { ExportBizComponent } from '../../pages/exportbiz/exportbiz.component';
import { SaleOrderComponent } from 'src/app/pages/saleorder/saleorder.component';

import { SNSQ022Component } from '../../pages/exportbiz/SNSQ022/SNSQ022.component';
import { SNSQ074EComponent } from '../../pages/exportbiz/SNSQ074E/SNSQ074E.component';
import { SNSE053_MComponent } from '../../pages/exportbiz/SNSE053_M/SNSE053_M.component';
import { SNSE199Component } from '../../pages/exportbiz/SNSE199/SNSE199.component';
import { SNSQ01E_UPLOADComponent } from '../../pages/exportbiz/SNSQ01E_UPLOAD/SNSQ01E_UPLOAD.component';
import { SNSE170Component } from '../../pages/exportbiz/SNSE170/SNSE170.component';
import { SNSE171Component } from '../../pages/exportbiz/SNSE171/SNSE171.component';
// import { SNSE180Component } from '../../pages/exportbiz/SNSE180/SNSE180.component';
// import { SNSE188Component } from '../../pages/exportbiz/SNSE188/SNSE188.component';

import { SNM123Component } from '../../pages/exportbiz/SNM123/SNM123.component';

import { SNM123SComponent } from '../../pages/exportbiz/SNM123S/SNM123S.component';
import { SNSE213Component } from '../../pages/exportbiz/SNSE213/SNSE213.component';
import { SNSE214Component } from '../../pages/exportbiz/SNSE214/SNSE214.component';
import { MaterialImportModule } from '../shared/material.module';
import { RoleResolver } from 'src/app/core/role-resolver.service';
import { SaleOrderModule } from '../saleorder/saleorder.module';
//import { SNM124Component } from '../../pages/saleorder/SNM124/SNM124.component';
//import { SNM032EComponent } from '../../pages/saleorder/SNM032E/SNM032E.component';
import { SNSE225Component } from 'src/app/pages/exportbiz/SNSE225/SNSE225.component';
import { SNM168Component } from '../../pages/exportbiz/SNM168/SNM168.component';



@NgModule({
  declarations: [
    ExportBizComponent,
    SNSQ022Component,
    SNSQ074EComponent,
    SNSE053_MComponent,
    SNSE199Component,
    SNSQ01E_UPLOADComponent,
    SNSE170Component,
    SNSE171Component,
    SNM123Component,
    SNM123SComponent,
    SNSE213Component,
    SNSE214Component,
    //SNSE180Component,
    //SNM124Component,
    //SNM032EComponent,
    // SNSE188Component,
    SNM168Component,
    SNSE225Component,
  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,

    //Material imports
    MaterialImportModule,

    LayoutModule,
    //FlexLayoutModule,
    SaleOrderModule,

    RouterModule.forChild([
      {
        path: '',
        component: ExportBizComponent,
        children: [
          {
            path: 'SNSQ022',
            component: SNSQ022Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSQ074E',
            component: SNSQ074EComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE053_M',
            component: SNSE053_MComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE199',
            component: SNSE199Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSQ01E_UPLOAD',
            component: SNSQ01E_UPLOADComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE170',
            component: SNSE170Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE171',
            component: SNSE171Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM123',
            component: SNM123Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM123S',
            component: SNM123SComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE213',
            component: SNSE213Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE214',
            component: SNSE214Component,
            resolve: {
              role: RoleResolver
            },
          },
          
          // {
          //     path: 'SNSE180',
          //     component: SNSE180Component,
          //     resolve: {
          //         role: RoleResolver
          //     },
          //},

          //{
          //  path: 'SNM124',
          //  component: SNM124Component,
          //  resolve: {
          //    role: RoleResolver
          //  },
          //},
          // {
          //     path: 'SNSE188',
          //     component: SNSE188Component,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          {
            path: 'SNM168',
            component: SNM168Component,
            resolve: {
              role: RoleResolver
            },
          } ,
	  {
            path: 'SNSE225',
            component: SNSE225Component,
            resolve: {
              role: RoleResolver
            }
          },

        ],
        canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [SNSQ01E_UPLOADComponent, SNM123SComponent],
  providers: [AuthGuard, RoleResolver],
})
export class ExportBizModule { }


