import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';

import { MaterialImportModule } from '../shared/material.module';
import { RoleResolver } from 'src/app/core/role-resolver.service';
import { K9Component } from 'src/app/pages/k9/k9.component';
import { SNM117PComponent } from 'src/app/pages/k9/SNM117P/SNM117P.component';
import { SNM118PComponent } from 'src/app/pages/k9/SNM118P/SNM118P.component';
import { SNM119PComponent } from 'src/app/pages/k9/SNM119P/SNM119P.component';
import { SNM120PComponent } from 'src/app/pages/k9/SNM120P/SNM120P.component';
import { SNPE051Component } from 'src/app/pages/k9/SNPE051/SNPE051.component';
import { SNPE051ReceiveComponent } from 'src/app/pages/k9/SNPE051/Receive/SNPE051_RECEIVE.component';
import { SNPE051ProcessComponent } from 'src/app/pages/k9/SNPE051/Process/SNPE051_PROCESS.component';
import { SNPE051InvoiceComponent } from 'src/app/pages/k9/SNPE051/Invoice/SNPE051_INVOICE.component';
import { SNPE051CancelComponent } from 'src/app/pages/k9/SNPE051/Cancel/SNPE051_CANCEL.component';
import { SNPP205Component } from 'src/app/pages/k9/SNPP205/SNPP205.component';
import { SNM149Component } from "src/app/pages/k9/SNM149/SNM149.component";
import { SNM150Component } from "src/app/pages/k9/SNM150/SNM150.component";
import { SNM151Component } from "src/app/pages/k9/SNM151/SNM151.component";
import { SNM152Component } from "src/app/pages/k9/SNM152/SNM152.component";
import { SNM153Component } from "src/app/pages/k9/SNM153/SNM153.component";
import { SNM154Component } from "src/app/pages/k9/SNM154/SNM154.component";
import { SNM155Component } from "src/app/pages/k9/SNM155/SNM155.component";
import { SNM156Component } from "src/app/pages/k9/SNM156/SNM156.component";
import { SNM157Component } from "src/app/pages/k9/SNM157/SNM157.component";
import { SNM158Component } from "src/app/pages/k9/SNM158/SNM158.component";
import { SNM159Component } from "src/app/pages/k9/SNM159/SNM159.component";
import { SNPE051AssembleComponent } from 'src/app/pages/k9/SNPE051/Assemble/SNPE051_ASSEMBLE.component';
import { SNPE051DisAssembleComponent } from 'src/app/pages/k9/SNPE051/DisAssemble/SNPE051_DISASSEMBLE.component';
import { SNM161Component } from 'src/app/pages/k9/SNM161/SNM161.component';
import { SNM160Component } from "src/app/pages/k9/SNM160/SNM160.component";
import { SNM162Component } from "src/app/pages/k9/SNM162/SNM162.component";
import { SNM164Component } from "src/app/pages/k9/SNM164/SNM164.component";
import { SNPP207Component } from 'src/app/pages/k9/SNPP207/SNPP207.component';
import { SNPP208Component } from 'src/app/pages/k9/SNPP208/SNPP208.component';
import { SNPP209Component } from 'src/app/pages/k9/SNPP209/SNPP209.component';

@NgModule({
    declarations: [
        K9Component,
        SNM117PComponent,
        SNM118PComponent,
        SNM119PComponent,
        SNM120PComponent,
        SNPE051Component,
        SNPE051ReceiveComponent,
        SNPE051ProcessComponent,
        SNPE051InvoiceComponent,
        SNPE051CancelComponent,
        SNPE051AssembleComponent,
        SNPE051DisAssembleComponent,
        SNPP205Component,
        SNM149Component,
        SNM150Component,
        SNM151Component,
        SNM152Component,
        SNM153Component,
        SNM154Component,
        SNM155Component,
        SNM156Component,
        SNM157Component,
        SNM158Component,
        SNM159Component,
        SNM160Component,
        SNM161Component,
        SNM162Component,
        SNPP207Component,
        SNPP208Component,
        SNM164Component,
        SNPP209Component
    ],
    imports: [
        CommonModule,
        HttpClientModule,
        FormsModule,
        ReactiveFormsModule,
        SharedComponentModule,

        //Material imports
        MaterialImportModule,


        RouterModule.forChild([
            {
                path: '',
                component: K9Component,
                children: [
                  {
                    path: 'SNPP209',
                    component: SNPP209Component,
                    resolve: {
                        role: RoleResolver
                    },
                  },
                  {
                    path: 'SNPP208',
                    component: SNPP208Component,
                    resolve: {
                        role: RoleResolver
                    },
                  },
                  {
                    path: 'SNPP207',
                    component: SNPP207Component,
                    resolve: {
                        role: RoleResolver
                    },
                  },
                    {
                      path: 'SNM161',
                      component: SNM161Component,
                      resolve: {
                          role: RoleResolver
                      },
                    },
                    {
                        path: 'SNPE051',
                        component: SNPE051Component,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNM117P',
                        component: SNM117PComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNM118P',
                        component: SNM118PComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    {
                        path: 'SNM119P',
                        component: SNM119PComponent,
                        resolve: {
                            role: RoleResolver
                        }
                    },
                    {
                        path: 'SNM120P',
                        component: SNM120PComponent,
                        resolve: {
                            role: RoleResolver
                        }
                    },
                    {
                        path: 'SNPP205',
                        component: SNPP205Component,
                        resolve: {
                            role: RoleResolver
                        }
                    },
                    {
                      path: "SNM149",
                      component: SNM149Component,
                      resolve: {
                        role: RoleResolver,
                      },
                    },
                    {
                      path: "SNM150",
                      component: SNM150Component,
                      resolve: {
                        role: RoleResolver,
                      },
                    },
                    {
                      path: "SNM151",
                      component: SNM151Component,
                      resolve: {
                        role: RoleResolver,
                      },
                    },
                    {
                      path: "SNM152",
                      component: SNM152Component,
                      resolve: {
                        role: RoleResolver,
                      },
                    },
                    {
                      path: "SNM153",
                      component: SNM153Component,
                      resolve: {
                        role: RoleResolver,
                      },
                    },
                    {
                      path: "SNM154",
                      component: SNM154Component,
                      resolve: {
                        role: RoleResolver,
                      },
                    },
                    {
                      path: "SNM155",
                      component: SNM155Component,
                      resolve: {
                        role: RoleResolver,
                      },
                    },
                    {
                      path: "SNM156",
                      component: SNM156Component,
                      resolve: {
                        role: RoleResolver,
                      },
                    },
                    {
                      path: "SNM157",
                      component: SNM157Component,
                      resolve: {
                        role: RoleResolver,
                      },
                    },
                    {
                      path: "SNM158",
                      component: SNM158Component,
                      resolve: {
                        role: RoleResolver,
                      },
                    },
                    {
                      path: "SNM159",
                      component: SNM159Component,
                      resolve: {
                        role: RoleResolver,
                      },
                    },
                    {
                      path: "SNM160",
                      component: SNM160Component,
                      resolve: {
                        role: RoleResolver,
                      },
                    },
                    {
                      path: "SNM162",
                      component: SNM162Component,
                      resolve: {
                        role: RoleResolver,
                      },
                    },
                    {
                      path: "SNM164",
                      component: SNM164Component,
                      resolve: {
                        role: RoleResolver,
                      },
                    },
                ],
                canActivate: [AuthGuard]
            }
        ])
    ],
    exports: [],
    providers: [
        AuthGuard,
        RoleResolver
    ],
    entryComponents: []
})
export class K9Module { }


