import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';

import { MKTComponent } from '../../pages/mkt/mkt.component';

import { SNM101PComponent } from '../../pages/mkt/SNM101P/SNM101P.component';
// import { SNM103PComponent } from '../../pages/mkt/SNM103P/SNM103P.component';
// import { SNM104PComponent } from '../../pages/mkt/SNM104P/SNM104P.component';
// import { SNM105PComponent } from '../../pages/mkt/SNM105P/SNM105P.component';
// import { SNM104P_UPLOADComponent } from '../../pages/mkt/SNM104P_UPLOAD/SNM104P_UPLOAD.component';
 import { SNM106PComponent } from '../../pages/mkt/SNM106P/SNM106P.component';
// import { SNM113PComponent } from '../../pages/mkt/SNM113P/SNM113P.component';
//import { SNSE197Component } from '../../pages/technical/SNSE197/SNSE197.component';
import { MaterialImportModule } from '../shared/material.module';
import { RoleResolver } from 'src/app/core/role-resolver.service';





@NgModule({
    declarations: [

        MKTComponent,
        SNM101PComponent,
        // SNM103PComponent,
        // SNM104PComponent,
        // SNM105PComponent,
        // SNM104P_UPLOADComponent,
         SNM106PComponent,
        // SNM113PComponent,
        //SNSE197Component,

    ],
    imports: [
        CommonModule,
        HttpClientModule,
        FormsModule,
        ReactiveFormsModule,
        SharedComponentModule,
        FormsModule,

        //Material imports
        MaterialImportModule,


        RouterModule.forChild([
            {
                path: '',
                component: MKTComponent,
                children: [
                    //,
                    // },
                    {
                        path: 'SNM101P',
                        component: SNM101PComponent,
                        resolve: {
                            role: RoleResolver
                        },
                    },
                    // {
                    //     path: 'SNM103P',
                    //     component: SNM103PComponent,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNM104P',
                    //     component: SNM104PComponent,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNM105P',
                    //     component: SNM105PComponent,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                    // {
                    //     path: 'SNM104P_UPLOAD',
                    //     component: SNM104P_UPLOADComponent,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                     {
                         path: 'SNM106P',
                         component: SNM106PComponent,
                         resolve: {
                             role: RoleResolver
                         },
                     },
                    // {
                    //     path: 'SNM113P',
                    //     component: SNM113PComponent,
                    //     resolve: {
                    //         role: RoleResolver
                    //     },
                    // },
                //   {
                //     path: 'SNSE197',
                //     component: SNSE197Component,
                //     resolve: {
                //       role: RoleResolver
                //     },
                //   }
                ],
                canActivate: [AuthGuard]
            }
        ])
    ],
    exports: [],
    providers: [AuthGuard, RoleResolver],
})
export class MKTModule { }
