import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';
import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';
import { MaterialImportModule } from '../shared/material.module';
import { RoleResolver } from 'src/app/core/role-resolver.service';
import { MonitoringComponent } from 'src/app/pages/monitoring/monitoring.component';
import { SNWR020Component } from 'src/app/pages/monitoring/SNWR020/SNWR020.component';
import { SNWR016_MComponent } from 'src/app/pages/monitoring/SNWR016_M/SNWR016_M.component';
import { SNWR025Component } from 'src/app/pages/monitoring/SNWR025/SNWR025.component';




@NgModule({
  declarations: [

    MonitoringComponent,
    SNWR020Component,
    SNWR016_MComponent,
    SNWR025Component
  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,

    //Material imports
    MaterialImportModule,



    RouterModule.forChild([
      {
        path: '',
        component: MonitoringComponent,
        children: [
          {
            path: 'SNWR020',
            component: SNWR020Component,
          },
          {
            path: 'SNWR016_M',
            component: SNWR016_MComponent,
          },
          {
            path: 'SNWR025',
            component: SNWR025Component,
          },
        ],
        //canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [],
  providers: [AuthGuard, RoleResolver],
})
export class MonitoringModule { }
