import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';

import { PS_SCG_GestOrderComponent } from '../../pages/ps_scg_gest_order/ps_scg_gest_order.component';
// import { SNPP021PRN_001Component } from '../../pages/ps_scg_gest_order/SNPP021PRN_001/SNPP021PRN_001.component';
// import { SNPP021LO_001Component } from '../../pages/ps_scg_gest_order/SNPP021LO_001/SNPP021LO_001.component';
// import { SNPE003_001Component } from '../../pages/ps_scg_gest_order/SNPE003_001/SNPE003_001.component';
import { SNPE003Component } from '../../pages/ps_scg_gest_order/SNPE003/SNPE003.component';
import { NgxCurrencyModule } from "ngx-currency";
import { MaterialImportModule } from '../shared/material.module';
import { RoleResolver } from 'src/app/core/role-resolver.service';


@NgModule({
  declarations: [
    PS_SCG_GestOrderComponent,
    // SNPP021PRN_001Component,
    // SNPP021LO_001Component,
    // SNPE003_001Component,
    SNPE003Component,
  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,

    //Material imports
    MaterialImportModule,
    NgxCurrencyModule,
    RouterModule.forChild([
      {
        path: '',
        component: PS_SCG_GestOrderComponent,
        children: [
          // {
          //   path: 'SNPP021LO_001',
          //   component: SNPP021LO_001Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNPP021PRN_001',
          //   component: SNPP021PRN_001Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNPE003_001',
          //   component: SNPE003_001Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          {
            path: 'SNPE003',
            component: SNPE003Component,
            resolve: {
                role: RoleResolver
            },
          },
        ],
        canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [],
  providers: [AuthGuard, RoleResolver],
})
export class PS_SCG_GestOrderModule { }


