import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';
import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';
import { MaterialImportModule } from '../shared/material.module';
import { RoleResolver } from 'src/app/core/role-resolver.service';
import { TechnicalComponent } from 'src/app/pages/technical/technical.component';
import { SNM008PComponent } from 'src/app/pages/technical/SNM008P/SNM008P.component';
import { SNM009PComponent } from 'src/app/pages/technical/SNM009P/SNM009P.component';
import { SNSQ030Component } from 'src/app/pages/technical/SNSQ030/SNSQ030.component';
import { SNM010PComponent } from 'src/app/pages/technical/SNM010P/SNM010P.component';
import { SNM039PComponent } from 'src/app/pages/technical/SNM039P/SNM039P.component';
import { SNM054PComponent } from 'src/app/pages/technical/SNM054P/SNM054P.component';
import { SNSQ031Component } from 'src/app/pages/technical/SNSQ031/SNSQ031.component';
import { SNSQ032Component } from 'src/app/pages/technical/SNSQ032/SNSQ032.component';
import { SNSQ038Component } from 'src/app/pages/technical/SNSQ038/SNSQ038.component';
import { SNSE143F2Component } from 'src/app/pages/technical/SNSE143_F2/SNSE143_F2.component';
import { SNM105PComponent } from 'src/app/pages/technical/SNM105P/SNM105P.component';
import { SNM041PComponent } from 'src/app/pages/technical/SNM041P/SNM041P.component';
import { SNSE165Component } from 'src/app/pages/technical/SNSE165/SNSE165.component';
import { SNSE127_1Component } from 'src/app/pages/technical/SNSE127_1/SNSE127_1.component';
import { SNM038PComponent } from 'src/app/pages/technical/SNM038P/SNM038P.component';
import { SNM034PComponent } from 'src/app/pages/technical/SNM034P/SNM034P.component';
import { SNM115PComponent } from 'src/app/pages/technical/SNM115P/SNM115P.component';
import { SNSE143Component } from 'src/app/pages/technical/SNSE143/SNSE143.component';
import { SNSE144Component } from 'src/app/pages/technical/SNSE144/SNSE144.component';
import { SNSE145Component } from 'src/app/pages/technical/SNSE145/SNSE145.component';
import { SNSE147Component } from 'src/app/pages/technical/SNSE147/SNSE147.component';
import { SNM023PComponent } from 'src/app/pages/master/SNM023P/SNM023P.component';
import { SNM130PComponent } from 'src/app/pages/technical/SNM130P/SNM130P.component';
import { SNSE131_MComponent } from 'src/app/pages/technical/SNSE127_1/SNSE131_M/SNSE131_M.component';
import { SNM131PComponent } from 'src/app/pages/technical/SNM131P/SNM131P.component';
import { SNM132PComponent } from 'src/app/pages/technical/SNM132P/SNM132P.component';
import { SNSE207Component } from 'src/app/pages/technical/SNSE207/SNSE207.component';
import { MasterModule } from '../master/master.module';
import { SNSE218PComponent } from 'src/app/pages/technical/SNSE218/SNSE218.component';
import { SNSE197Component } from 'src/app/pages/technical/SNSE197/SNSE197.component';
import { SNSE197_MComponent } from 'src/app/pages/technical/SNSE197_M/SNSE197_M.component';
import { SNM121PComponent } from 'src/app/pages/technical/SNM121P/SNM121P.component';
import { SNSQ039_001Component } from 'src/app/pages/technical/SNSQ039_001/SNSQ039_001.component';
import { SNM135PComponent } from 'src/app/pages/technical/SNM135P/SNM135P.component';
import { SNM113PComponent } from 'src/app/pages/technical/SNM113P/SNM113P.component';
import { SNM142PComponent } from 'src/app/pages/technical/SNM142P/SNM142P.component';
import { SNM172PComponent } from 'src/app/pages/technical/SNM172P/SNM172P.component';

@NgModule({
  declarations: [
    TechnicalComponent,
    SNM130PComponent,
    SNM008PComponent,
    SNM009PComponent,
    SNSQ030Component,
    SNM010PComponent,
    SNM039PComponent,
    SNSQ031Component,
    SNSQ032Component,
    SNSQ038Component,
    SNSE143F2Component,
    SNM105PComponent,
    SNM041PComponent,
    SNSE165Component,
    SNSE127_1Component,
    SNM038PComponent,
    SNM034PComponent,
    SNM115PComponent,
    SNM054PComponent,
    SNSE143Component,
    SNSE144Component,
    SNSE145Component,
    SNSE147Component,
    SNSE131_MComponent,
    SNM131PComponent,
    SNM132PComponent,
    SNSE207Component,
    SNSE218PComponent,
    SNSE197Component,
    SNSE197_MComponent,
    SNM121PComponent,
    SNSQ039_001Component,
    SNM135PComponent,
    SNM113PComponent,
    SNM142PComponent,
    SNM172PComponent
  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,
    MasterModule,
    // SNM023PComponent,

    //Material imports
    MaterialImportModule,

    RouterModule.forChild([
      {
        path: '',
        component: TechnicalComponent,
        children: [
          {
            path : 'SNM113P',
            component : SNM113PComponent,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNM135P',
            component : SNM135PComponent,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNSQ039',
            component : SNSQ039_001Component,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNM121P',
            component : SNM121PComponent,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNSE197_M',
            component : SNSE197_MComponent,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNSE197',
            component : SNSE197Component,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNSE218',
            component : SNSE218PComponent,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNSE207',
            component : SNSE207Component,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNM132P',
            component : SNM132PComponent,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNM131P',
            component : SNM131PComponent,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNM130P',
            component : SNM130PComponent,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNSE147',
            component : SNSE147Component,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNSE145',
            component : SNSE145Component,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNSE144',
            component : SNSE144Component,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNSE143',
            component : SNSE143Component,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNM115P',
            component : SNM115PComponent,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNM034P',
            component : SNM034PComponent,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNM038P',
            component : SNM038PComponent,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNSE127_1',
            component : SNSE127_1Component,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNSQ038',
            component : SNSQ038Component,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path: 'SNM008P',
            component: SNM008PComponent,
            resolve: {
                role: RoleResolver
            },
          },
          {
            path : 'SNM009P',
            component : SNM009PComponent,
            resolve:{
              role: RoleResolver
            }
          },
          {
            path : 'SNSQ030',
            component : SNSQ030Component,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNM010P',
            component : SNM010PComponent,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNSQ031',
            component : SNSQ031Component,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path: 'SNM039P',
            component : SNM039PComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNM054P',
            component: SNM054PComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path : 'SNSQ032',
            component : SNSQ032Component,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path: 'SNSE143_F2',
            component: SNSE143F2Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path : 'SNM105P',
            component : SNM105PComponent,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNM041P',
            component : SNM041PComponent,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNSE165',
            component : SNSE165Component,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNM142P',
            component : SNM142PComponent,
            resolve:{
              role : RoleResolver
            }
          },
          {
            path : 'SNM172P',
            component : SNM172PComponent,
            resolve:{
              role : RoleResolver
            }
          }
         
        ],
        canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [],
  providers: [AuthGuard, RoleResolver],
})
export class TechnicalModule { }

