import { Component, OnInit } from '@angular/core';
import * as moment from 'moment';
import { Globals } from 'src/app/core/global';
import { HttpService } from 'src/app/core/http.service';

@Component({
    selector: 'snsd118_adj',
    templateUrl: 'SNSD118_ADJ.component.html'
})

export class SNSD118ADJComponent implements OnInit {
    constructor(
    private http: HttpService,
        private global: Globals
    ) { }

    public params = {
        FROM_DATE: moment(),
        TO_DATE: moment()
    }

    ngOnInit() { }

    public Export() {
        this.global.GoToExport("PMS_RPT_ACC_SNSD118_ADJ",
        {
            P_COMPANY_CODE: this.global.GetTokenDetail('ssComCode'),
            P_FROM_DATE: this.global.ConvertDateToFormatSTD(this.params.FROM_DATE),
            P_TO_DATE: this.global.ConvertDateToFormatSTD(this.params.TO_DATE)
        }, true, 'EXCELOPENXML')
    }
}