import { Component, OnInit, ViewContainerRef, ViewChild, ElementRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { SelectionModel } from '@angular/cdk/collections';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';
import { AutoCompleteQueryComponent } from 'src/app/components/shared/auto-complete-query/auto-complete-query.component';
import * as moment from 'moment';


enum PageAction {
  Search = 0,
  Detail,
  Retrive
}

@Component({
    selector: 'SNPE019_M',
    templateUrl: './SNPE019_M.component.html',
    styleUrls: ['./SNPE019_M.component.css']
})



export class SNPE019_MComponent implements OnInit {


    constructor(
        private http: HttpService,
        private router: Router,
        private modal : ModalService,
        private viewref : ViewContainerRef,
        private global : Globals
    ) { }
      @ViewChild("dialogDetail",{static : false}) dialogDetail : any;
      @ViewChild("dialogPart",{static : false}) dialogPart : any;
      @ViewChild("autoCompleteVat") autoCompleteVat : AutoCompleteQueryComponent;
      @ViewChild("autoCompleteBranch") autoCompleteBranch: AutoCompleteQueryComponent;
      @ViewChild("autoCompleteVendor") autoCompleteVendor: AutoCompleteQueryComponent;
      @ViewChild("inputVendor") inputVendor: ElementRef;
      
      public currentDate: string;
      public CustomerList: any;
      public tableData: any = [];
      public tableDataDetail: any = [];
      public Searched : boolean = false;
      public PageAction : number ;
      public oldValue : any;
      public tempOrderNo: string
      public iSWarning : boolean =false;

    public ConfigDocNo: any = {
        ColName: "DOCUMENT_NO",
        ColValue: "",
        PlaceholderText: "Select Document No.",
        SourceController: "AC",
        SourceMethodName: "SNPE019_M_GetDocNo",
        NoOfShowRecords: 50,
        MinLengthSearch: 2,
        UpperCase: true
      }

      public ConfigDocDate: any = {
        ColName: "DOCUMENT_DATE",
        ColValue: "",
        PlaceholderText: "Select Document Date",
        SourceController: "AC",
        SourceMethodName: "SNPE018_M_GetDocDate",
        NoOfShowRecords: 50,
        MinLengthSearch: 2
      }

      public ConfigVatCode: any = {
        ColName: "LOOKUP",
        ColValue: "",
        PlaceholderText: "Select Vat Code",
        SourceController: "AC",
        SourceMethodName: "SNPE019_M_GetVatCode",
        NoOfShowRecords: 50,
        MinLengthSearch: 1,
        SourceParams: {},
      }

      public ConfigInvoiceNo: any = {
        ColName: "REF_INV_NO",
        ColValue: "",
        PlaceholderText: "Select Invoice No",
        SourceController: "AC",
        SourceMethodName: "SNPE018_M_GetInvoice",
        NoOfShowRecords: 50,
        MinLengthSearch: 3
      }

      public ConfigInvoiceDate: any = {
        ColName: "REF_INV_DATE",
        ColValue: "",
        PlaceholderText: "Select Invoice Date",
        SourceController: "AC",
        SourceMethodName: "SNPE018_M_GetInvoiceDate",
        NoOfShowRecords: 50,
        MinLengthSearch: 2
      }

      public ConfigReason: any = {
        ColName: "LOOKUP",
        ColValue: "",
        PlaceholderText: "Select Reason Code",
        SourceController: "AC",
        SourceMethodName: "SNPE019_M_GetReason",
        NoOfShowRecords: 50,
        MinLengthSearch: 1
      }

      public ConfigPart: any = {
        ColName: "LOOKUP",
        ColValue: "",
        PlaceholderText: "Select Part No.",
        SourceController: "AC",
        SourceMethodName: "SNPE019_M_GetPartNo",
        NoOfShowRecords: 30,
        MinLengthSearch: 3,
        UpperCase: false,
        SourceParams: {
          VENDOR_CODE : null
        },
      }

      public ConfigVendor: any = {
        ColName: "LOOKUP_VENDOR_NAME",
        ColValue: "",
        PlaceholderText: "Select Vendor",
        SourceController: "wPMS",
        SourceMethodName: "GetVendorCode",
        NoOfShowRecords: 50,
        MinLengthSearch: 2
      }

      public ConfigCustomer: any = {
        ColName: "LOOKUP",
        ColValue: "",
        PlaceholderText: "Select Customer",
        SourceController: "AC",
        SourceMethodName: "SNPE019_M_GetCustomer",
        NoOfShowRecords: 50,
        MinLengthSearch: 2,
        UpperCase: true,
        TextSelect : 'Select Customer'
      }

      public ConfigBranch: any = {
        ColName: "LOOKUP",
        ColValue: "",
        PlaceholderText: "Select Branch",
        SourceController: "AC",
        SourceMethodName: "SNPE019_M_GetBranchCode",
        NoOfShowRecords: 50,
        MinLengthSearch: 0,
        SourceParams: {
          CUSTOMER_CODE : null
        },
      }

      public ParamsSearch = {
          DOCUMENT_NO : null,
          DOCUMENT_DATE : null,
          DOCUMENT_DATE_SEARCH : null,
          DEST_PORT : null,
          VAT_NAME : null,
          VAT_LOOKUP : null,
          INVOICE_NO : null,
          INVOICE_DATE : null,
          INVOICE_DATE_SEARCH : null
      }

      public ParamsHeadData = {
         DOCUMENT_TYPE : null,
         DOCUMENT_TIME : null,
         DOCUMENT_NO : null,
         DOCUMENT_DATE : null,
         JOB_TYPE : null,
         REF_DOC_TYPE : null,
         REF_DOC_NO : null,
         REF_DOC_DATE : null,
         REF_INV_NO : null,
         REF_INV_DATE : null,
         CUSTOMER_CODE : null,
         CUSTOMER_NAME : null,
         TOTAL_AVG_AMT : null,
         TOTAL_STD_AMT : null,
         TOTAL_RETAIL_B : null,
         TOTAL_RETAIL_C : null,
         TOTAL_NET_B : null,
         TOTAL_DISCOUNT : null,
         TOTAL_VAT : null,
         VENDOR_CODE : '070',
         VENDOR_TYPE : null,
         CONFIRM_DATE : null,
         DEST_PORT : null,
         VAT_FLAG : null,
         VAT_RATE : null,
         ATTRIBUTE5 : '01',
         TOTAL_CASE : null,
         TOTAL_ITEM : null,
         TOTAL_QTY : null,
         REASON_CODE : '10',
         LAST_UPD_BY : null,
         LAST_UPD_DATE : null,
         TOTAL_OLD_AMT : null,
         BUSINESS_PLACE : null,
         VAT_DESC : null,
         TAX_FLAG : null,
         TAX_RATE : null,
         VENDOR_NAME : null,
         TOTAL_AMOUNT : null,
         TNAME : null,
         TMP_TOT_LOC : null, 
         TMP_TOT_IMP : null,
         INDENT_STATUS : null,
         DSP_DOC_NO : null,
         REF_INV_DATE_FORMAT : null,
         DOCUMENT_DATE_FORMAT : null,
         TMP_INV_NO : null,
         TMP_INV_DATE : null,
         C_TMP_ORDER_NO : null,
         D_TMP_ORDER_DATE : null,
         PAYMENT_TERM : null,
         BRANCH_CODE : null,
         BRANCH_NAME : null,
         SUM_ITEM_QTY : null,
         SELECT_DOC_TYPE : 'DO',
         LOCK_CUSTOMER : null,
         BRANCH_STATUS : null,
         WHT_AMOUNT : 0,
         BRANCH_DESC : null,
         REF_OTHER_DOC : null
      }



      public ParamsDetailData = {
        DOCUMENT_TYPE : null,
        DOCUMENT_NO : null,
        ITEM_NO : null,
        CONFIRM_DATE : null,
        VENDOR_CODE : null,
        VENDOR_TYPE : null,
        RETAIL_PRICE_B : null,
        UNIT_PRICE_B : null,
        UNIT_PRICE_C : null,
        NET_AMT_B : null,
        ORDER_NO : null,
        ORDER_DATE : null,
        ORDER_ITEM_NO : null,
        SUB_ITEM_NO : null,
        ORDER_PART_NO : null,
        ACCEPT_PART_NO : null,
        REASON_CODE : null,
        ITEM_QTY : null,
        KIT_FLAG : null,
        SUB_DOC_NO : null,
        JOB_TYPE : null,
        SEQ : null
      }

      public Params = {
        N_TMP_TOTAL_NET_B : 0,
        N_TMP_TOTAL_VAT : 0,
        N_TMP_NET_AMT : 0,
        PRINT_REPORT : true
      }

     
      public tblFooter: any = [
        {
          fieldName: "PART_NAME",
          value: 'Total',
          show: true
        },
        {
          fieldName: "ITEM_QTY",
          value: null,
          show: true
        },
        {
          fieldName: "NET_AMT_B",
          value: null,
          show: true
        },
        {
          fieldName: "VAT",
          value: null,
          show: true
        },
        {
          fieldName: "NET_AMOUNT",
          value: null,
          show: true
        },
    
      ]


      public selection = new SelectionModel<any>(true, []);
      public DOCUMENT_DATE : any  = null  ;
      public BusinessList : any = [] ;
      public tableWorkFile : any = [];
      public valid : boolean = false ;
      public CannotConfirm : boolean = false;
      public SK_SYSTEM_LIST : any = [];
      public Retrived : boolean = false;
      public Saved : boolean = false;
      public hideCols: Array<string> = []
      @ViewChild("alertMsg") alert: ElementRef;
      public IsRetrive : boolean = false;

    ngOnInit() {
        this.PageAction = PageAction.Retrive
        this.ConfigPart.SourceParams.VENDOR_CODE = this.ParamsHeadData.VENDOR_CODE
       
        let i = 0;
        while (i < 131){
          if(i.toString().length == 1){
            this.BusinessList.push('0000'+i)
          }else if(i.toString().length == 2){
            this.BusinessList.push('000'+i)
          }else if(i.toString().length == 3){
            this.BusinessList.push('00'+i)
          }
          i++
        }

      this.http.get("AC","SNPE019_M_GetSKSYSTEM")
        .subscribe(res => {
          
          this.SK_SYSTEM_LIST = res.Table
          this.ShowRetrive()
        })

        this.http.GetSystemDate().subscribe(res => {
          this.ParamsHeadData.DOCUMENT_DATE = res
         
        })

       //this.ShowRetrive()

       

    }

    ngAfterViewInit(): void {

      setTimeout(() => {
        this.inputVendor.nativeElement.select();
        this.inputVendor.nativeElement.focus();
      }, 100);
      
    }


    Search(){
      if(!this.ParamsSearch.DOCUMENT_NO && !this.ParamsSearch.DOCUMENT_DATE_SEARCH && !this.ParamsSearch.INVOICE_NO && !this.ParamsSearch.INVOICE_DATE_SEARCH){
        this.modal.warning("Please input 1 criteria",this.viewref);
        return;
      }
      this.PageAction = PageAction.Search;
      this.tableData = [];
      if(this.ParamsSearch.DOCUMENT_DATE_SEARCH){
        this.ParamsSearch.DOCUMENT_DATE = this.FormatDate(this.ParamsSearch.DOCUMENT_DATE_SEARCH)
      }else{
        this.ParamsSearch.DOCUMENT_DATE = null;
      }

      if(this.ParamsSearch.INVOICE_DATE_SEARCH){
        this.ParamsSearch.INVOICE_DATE = this.FormatDate(this.ParamsSearch.INVOICE_DATE_SEARCH)
      }else{
        this.ParamsSearch.INVOICE_DATE = null
      }

      this.http.post("AC","SNPE019_M_GetTransactionHeader",this.ParamsSearch)
      .subscribe(res => {
        this.tableData = res.Table;
       
      })
    }

    ViewClick(event){
      
      this.hideCols.push("EDIT");
      if(event.CONFIRM_DATE){
        this.CannotConfirm = true;
      }
      this.ParamsHeadData = event;
      this.ParamsHeadData.C_TMP_ORDER_NO = event.ORDER_NO;
      this.ParamsHeadData.D_TMP_ORDER_DATE = event.ORDER_DATE;
      
      //this.tempOrderNo =  event.ORDER_NO;
      let param = {
        DOCUMENT_TYPE : event.DOCUMENT_TYPE,
        DOCUMENT_NO : event.DOCUMENT_NO,
        CUSTOMER_CODE : event.CUSTOMER_CODE,
        BRANCH_CODE : event.BRANCH_CODE,
        ORDER_NO : event.C_TMP_ORDER_NO,
        ORDER_DATE : this.FormatDate(event.D_TMP_ORDER_DATE),
        VENDOR_CODE : event.VENDOR_CODE

      }
     
      this.http.post("AC","SNPE019_M_GetTransactionDeatail",param)
      .subscribe(res =>{
         
        if(res.Table.length > 0){
          this.ParamsHeadData.C_TMP_ORDER_NO = res.Table[0].ATTRIBUTE3
          this.ParamsHeadData.D_TMP_ORDER_DATE = res.Table[0].TEMP_ORDER_DATE
          this.tempOrderNo =   res.Table[0].ATTRIBUTE3;

          //console.log('xxxxxxxxx',res.Table[0])
         
        }
        this.tableDataDetail = res.Table;
        this.Calculate();
        this.Sum();
        this.PageAction = PageAction.Detail;
      })
      this.PageAction = PageAction.Detail;
      
    }


    SelectedDocument(event){
 
      
    }

    QuantityChange(data,index){
    
    //  let index = this.tableDataDetail.findIndex(x => x.ORDER_PART_NO == data.ORDER_PART_NO)
     this.tableDataDetail[index].NET_AMT_B = data.ITEM_QTY * data.UNIT_PRICE_B;
     this.tableDataDetail = this.tableDataDetail.slice()
     this.Calculate();
     this.Sum();
     
    }

    ValidatePart(autocomplete,event,data,index){

      if(this.tableDataDetail.filter(x => x.ORDER_PART_NO).length > 0){
        
          let foundDup = this.tableDataDetail.some((x,i) => index !== i && x.ORDER_PART_NO == event.PART_NO)
          if(foundDup){
            this.modal.warning("P# " +event.PART_NO+ " is duplicated!",this.viewref)
            this.valid = false;
          }else{
            let index = this.tableDataDetail.findIndex(x => x.ORDER_PART_NO == data.ORDER_PART_NO)
            this.tableDataDetail[index].ORDER_PART_NO = event.PART_NO
            this.tableDataDetail[index].PART_NAME = event.PART_NAME_EN
            this.tableDataDetail[index].UNIT_PRICE_B = event.BASE_PRICE

            let param = {
              CUSTOMER_CODE : this.ParamsHeadData.CUSTOMER_CODE,
              BRANCH_CODE : this.ParamsHeadData.BRANCH_CODE,
              C_TMP_ORDER_NO : this.ParamsHeadData.C_TMP_ORDER_NO,
              ORDER_PART_NO : event.PART_NO,
              D_TMP_ORDER_DATE : this.ParamsHeadData.D_TMP_ORDER_DATE ? this.FormatDate(this.ParamsHeadData.D_TMP_ORDER_DATE) : this.FormatDate(new Date()),
              VENDOR_CODE : this.ParamsHeadData.VENDOR_CODE
            }

            this.http.post("AC","SNPE019_M_FindSalePrice",param)
              .subscribe(res => {

                this.tableDataDetail[index].RETAIL_PRICE = res.RETAIL_PRICE
                // if(res.RETAIL_PRICE != 'null'){
                //   this.tableDataDetail[index].RETAIL_PRICE = res.RETAIL_PRICE
                // }else{
                //   this.tableDataDetail[index].RETAIL_PRICE = 3000
                // }
                
                this.tableDataDetail = this.tableDataDetail.slice();
              },err =>{
                this.modal.error('Found an error, please contact support team', this.viewref);
              })
                this.valid = false;
              
          }
      }else{
        let index = this.tableDataDetail.findIndex(x => x.ORDER_PART_NO == data.ORDER_PART_NO)
        this.tableDataDetail[index].ORDER_PART_NO = event.PART_NO
        this.tableDataDetail[index].PART_NAME = event.PART_NAME_EN
        this.tableDataDetail[index].UNIT_PRICE_B = event.BASE_PRICE

        let param = {
          CUSTOMER_CODE : this.ParamsHeadData.CUSTOMER_CODE,
          BRANCH_CODE : this.ParamsHeadData.BRANCH_CODE,
          C_TMP_ORDER_NO : this.ParamsHeadData.C_TMP_ORDER_NO,
          ORDER_PART_NO : event.PART_NO,
          D_TMP_ORDER_DATE : this.ParamsHeadData.D_TMP_ORDER_DATE ? this.FormatDate(this.ParamsHeadData.D_TMP_ORDER_DATE) : this.FormatDate(new Date()),
          VENDOR_CODE : this.ParamsHeadData.VENDOR_CODE
        }

        this.http.post("AC","SNPE019_M_FindSalePrice",param)
          .subscribe(res => {
            
            this.tableDataDetail[index].RETAIL_PRICE = res.RETAIL_PRICE
            // if(res.RETAIL_PRICE != 'null'){
            //   this.tableDataDetail[index].RETAIL_PRICE = res.RETAIL_PRICE
            // }else{
            //   this.tableDataDetail[index].RETAIL_PRICE = 3000
            // }
           
            this.tableDataDetail = this.tableDataDetail.slice();
          },err =>{
            this.modal.error('Found an error, please contact support team', this.viewref);
          })

        this.valid = false;
       
      }
    }

    Clear(){
    
    }

 

    BackToGrid(){
      this.ParamsSearch.DOCUMENT_NO = null
      this.ParamsSearch.DOCUMENT_DATE_SEARCH = null//moment()
      this.ParamsSearch.INVOICE_NO = null
      this.ParamsSearch.INVOICE_DATE_SEARCH = null//moment()
      this.PageAction = PageAction.Search;
      this.Retrived = false;
      this.Saved = false;
    }

    Back(){
      this.dialogPart.Close()
    }


    ShowRetrive () {
      this.iSWarning = false
      this.Params.N_TMP_NET_AMT = 0
      this.Params.N_TMP_TOTAL_NET_B = 0
      this.Params.N_TMP_TOTAL_VAT = 0
      this.hideCols = [];
      this.tableDataDetail = [];
      this.ClearParamsHead();
      this.ParamsHeadData.DEST_PORT = '10'
      this.ConfigVatCode.SourceParams.DOCUMENT_DATE = this.FormatDate(this.ParamsHeadData.DOCUMENT_DATE)
      this.ParamsHeadData.TNAME = this.SK_SYSTEM_LIST[0].TNAME
      this.ParamsHeadData.BUSINESS_PLACE = '00000'
      this.Retrived = false;
      this.Saved = false;
      this.tempOrderNo = null
      //console.log('xxx',this.ParamsHeadData.DOCUMENT_DATE)
    this.tableDataDetail.push({
      'EDIT': 'ADD',
                                      'ITEM_QTY': 0 ,
                                      'UNIT_PRICE_B' : 0,
                                      'RETAIL_PRICE' : 0,                                     
                                      'NET_AMT_B':0,
                                      'ORDER_NO' : 0,
                                      'ORDER_DATE' :null,
                                      'ORDER_ITEM_NO':0,
                                      'ATTRIBUTE3':null,
                                      'ATTRIBUTE4':null,
                                      'VAT' : 0,
                                      'NET_AMOUNT' : 0 
                                    });
      this.tableDataDetail = this.tableDataDetail.slice();
      
      this.PageAction = PageAction.Retrive;
      setTimeout(() => {
        this.autoCompleteVendor.query();
        this.autoCompleteVat.query();
      }, 100);

      setTimeout(() => {
        this.inputVendor.nativeElement.select();
        this.inputVendor.nativeElement.focus();
      }, 200);
    }

    Retrive(){
     
     if(!this.ParamsHeadData.CUSTOMER_CODE){
       this.modal.warning("CUSTOMER CODE HAVE NOT VALUE",this.viewref)
       return;
     }else if(!this.ParamsHeadData.C_TMP_ORDER_NO){
       this.modal.warning("ORDER NO HAVE NOT VALUE",this.viewref)
       return
     }else if(!this.ParamsHeadData.D_TMP_ORDER_DATE){
       this.modal.warning("ORDER DATE HAVE NOT VALUE",this.viewref)
       return
     }else if(!this.ParamsHeadData.REF_INV_NO){
       this.modal.warning("Please input invoice no information!",this.viewref)
       return
     }else if(!this.ParamsHeadData.REF_INV_DATE){
       this.modal.warning("Please input invoice date information!",this.viewref)
       return
     }else{
      this.tableDataDetail = [];
      let param = {
        CUSTOMER_CODE : this.ParamsHeadData.CUSTOMER_CODE.toUpperCase(),
        ORDER_NO : this.ParamsHeadData.C_TMP_ORDER_NO,
        VENDOR_CODE : this.ParamsHeadData.VENDOR_CODE,
        BRANCH_CODE : this.ParamsHeadData.BRANCH_CODE,
        ORDER_DATE : this.FormatDate(this.ParamsHeadData.D_TMP_ORDER_DATE)
      }

        this.http.post("AC","SNPE019_M_Retrive",param)
        .subscribe(res => {
          this.Retrived = true;
          this.tableDataDetail = res.Table
          this.tableDataDetail.push({
            'EDIT': 'ADD',
                                      'ITEM_QTY': 0 ,
                                      'UNIT_PRICE_B' : 0,
                                      'RETAIL_PRICE' : 0,                                     
                                      'NET_AMT_B':0,
                                      'ORDER_NO' : 0,
                                      'ORDER_DATE' :null,
                                      'ORDER_ITEM_NO':0,
                                      'ATTRIBUTE3':null,
                                      'ATTRIBUTE4':null,
                                      'VAT' : 0,
                                      'NET_AMOUNT' : 0 
                                    });
          this.tableDataDetail = this.tableDataDetail.slice();
          let found = this.tableDataDetail.some(x => x.FROM_TABLE == 'S');
          if(found) {
            this.ParamsHeadData.SELECT_DOC_TYPE = 'TF';
            this.ParamsHeadData.REASON_CODE = '396';
          }
          setTimeout(() => {
            if(res.Table.length > 0){
              this.Calculate();
              this.Sum()
            }
          }, 500);   
        },err => {
          this.modal.error('Found an error, please contact support team', this.viewref);
        })
     }

      
    }

    Save(){
      this.Saved = true;   
      const uniqueValues = new Set(this.tableDataDetail.map(v => v.ORDER_PART_NO));
      if (uniqueValues.size < this.tableDataDetail.length) {
        this.modal.warning("Duplicate part no ,please check!",this.viewref);
        this.Saved = false;   
        return
      }
      if (!this.ParamsHeadData.DOCUMENT_DATE ||
   	      !this.ParamsHeadData.VENDOR_CODE ||
   	      !this.ParamsHeadData.CUSTOMER_CODE ||
   	      !this.ParamsHeadData.REF_INV_NO ||
   	      !this.ParamsHeadData.REF_INV_DATE ||
   	      !this.ParamsHeadData.C_TMP_ORDER_NO ||
   	      !this.ParamsHeadData.D_TMP_ORDER_DATE) {

          this.modal.warning("Permision denine,field must entrie",this.viewref)
          this.Saved = false;   
      }
      // else if(!this.ParamsHeadData.REF_OTHER_DOC){
      //   this.modal.warning("Please input delivery number",this.viewref)
      //   this.Saved = false;   
      // }

      else if(this.tableDataDetail.filter(x => x.ORDER_PART_NO).length == 0){
        this.modal.warning("Don't have detail data.",this.viewref)
        this.Saved = false;   
      }else if(this.ParamsHeadData.SELECT_DOC_TYPE == 'SP' && !this.ParamsHeadData.REASON_CODE){
        this.modal.warning("Please select Reason Code",this.viewref);
        this.Saved = false;   
      }
      else{
        let find = this.tableDataDetail.some(x => x.ORDER_PART_NO && x.UNIT_PRICE_B == 0)
        if(find){
          this.modal.confirm("Some part unit price = 0, are you sure to save document",this.viewref,this.ConfirmSave)
          this.Saved = false;   
        }
        else{
        this.modal.confirm('Do you want to save change you have made?',this.viewref,this.ConfirmSave,this.CancelSave)
        }
      }
    }

    CancelSave = () =>{
      this.Saved = false;
    }

    ConfirmSave = () => {
      this.Saved = true;   
      let tabledetail =  this.tableDataDetail.filter(x => x.ORDER_PART_NO)
      
      tabledetail.map(x => {
        x.ORDER_DATE_FORMAT = this.FormatDate(x.ORDER_DATE)
      })

      this.ParamsHeadData.SUM_ITEM_QTY = tabledetail.map(x => x.ITEM_QTY).reduce((prev,next) => prev + next)

      let paramHead = {
        VENDOR_CODE : this.ParamsHeadData.VENDOR_CODE,
        CUSTOMER_CODE : this.ParamsHeadData.CUSTOMER_CODE,
        BRANCH_CODE : this.ParamsHeadData.BRANCH_CODE,
        C_TMP_ORDER_NO : this.ParamsHeadData.C_TMP_ORDER_NO,
        REF_INV_NO : this.ParamsHeadData.REF_INV_NO,
        REF_INV_DATE : this.FormatDate(this.ParamsHeadData.REF_INV_DATE),
        VAT_FLAG : this.ParamsHeadData.VAT_FLAG,
        VAT_RATE : this.ParamsHeadData.VAT_RATE,
        TAX_FLAG : this.ParamsHeadData.TAX_FLAG,
        TAX_RATE : this.ParamsHeadData.TAX_RATE,
        SUM_ITEM_QTY : this.ParamsHeadData.SUM_ITEM_QTY,
        D_TMP_ORDER_DATE : this.FormatDate(this.ParamsHeadData.D_TMP_ORDER_DATE),
        DEST_PORT : this.ParamsHeadData.DEST_PORT,
        BUSINESS_PLACE : this.ParamsHeadData.BUSINESS_PLACE,
        REASON_CODE : this.ParamsHeadData.REASON_CODE,
        SELECT_DOC_TYPE : this.ParamsHeadData.SELECT_DOC_TYPE,
        PAYMENT_TERM : this.ParamsHeadData.PAYMENT_TERM,
        REF_OTHER_DOC : this.ParamsHeadData.REF_OTHER_DOC
      }


      this.http.post("AC","SNPE019_M_Save",{Header : paramHead, Detail : tabledetail})
      .subscribe(res => {
          let document = res.DOCUMENT_NO.split(",")

          if(document[0] == 'DUPLICATE'){
            this.modal.warning("Invoice no " + paramHead.REF_INV_NO + " duplicate please change invoice no",this.viewref);
            this.Saved = false;  
          }else if(document[0] == 'PRICE_ERROR'){
            this.modal.error("Can not save transaction because average cost or net amount is null",this.viewref);
            this.Saved = false;  
          }else{
            this.alert.nativeElement.hidden = false
            this.Saved = true;      
            //this.modal.info("Process Complete",this.viewref)
            
            this.ParamsHeadData.DOCUMENT_NO = document[0];
            this.ParamsHeadData.REF_DOC_NO = document[1];
            this.ParamsHeadData.DOCUMENT_TYPE = 'RL';
            this.ParamsHeadData.LAST_UPD_BY = this.global.GetTokenDetail("ssNameEN");
            this.ParamsHeadData.LAST_UPD_DATE = new Date();
            
            this.ViewClick(this.ParamsHeadData)
            // if(this.Params.PRINT_REPORT && this.ParamsHeadData.SELECT_DOC_TYPE != 'TF'){
            //   this.OpenReport("R2");
            // }
            setTimeout(() => {
              this.alert.nativeElement.hidden = true;
            }, 3000);
          }
      
          
      },(err)=>{
        //console.log(err)
        this.Saved = false;  
        this.modal.error('Found an error, please contact support team', this.viewref);
      })
    }


    OpenReport(type: string){
      switch(type) {
        case "R1": 
            this.global.GoToReport("PMS_RPT_ACC_SNPE019R1", {  
              P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
              P_DOCUMENT_NO_FROM: this.ParamsHeadData.DOCUMENT_NO, 
          P_DOCUMENT_NO_TO: this.ParamsHeadData.DOCUMENT_NO
        })
          break;
        case "R2": 
            this.global.GoToReport("PMS_RPT_ACC_SNPE019R2_A4_new", {  
              P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
              P_REF_DOC_NO : this.ParamsHeadData.REF_DOC_NO,
              P_DOCUMENT_NO_FROM: this.ParamsHeadData.DOCUMENT_NO, 
          P_DOCUMENT_NO_TO: this.ParamsHeadData.DOCUMENT_NO
        })
          break;
      }
    }

    SetVendor(event){
      this.ParamsHeadData.VENDOR_CODE = event.VENDOR_CODE;
      this.ParamsHeadData.VENDOR_NAME = event.VENDOR_NAME_TH; 
      //this.ParamsHeadData.PAYMENT_TERM = event.PAYMENT_TERM;
      this.ConfigPart.SourceParams.VENDOR_CODE = event.VENDOR_CODE
    }

    SelectedVat(event){
      
      this.ParamsHeadData.DEST_PORT = event.VAT_CODE;
      this.ParamsHeadData.VAT_DESC = event.VAT_DESC;
      this.ParamsHeadData.VAT_FLAG = event.VAT_FLAG
      this.ParamsHeadData.VAT_RATE = event.VAT_RATE
      this.ParamsHeadData.TAX_FLAG = event.TAX_FLAG
      this.ParamsHeadData.TAX_RATE = event.TAX_RATE
      
      
      this.Calculate()
      this.Sum();
    }

    SelectedCust(event){
      //console.log('eeeee',event)
      this.ParamsHeadData.CUSTOMER_CODE = event.CUSTOMER_CODE;
      this.ParamsHeadData.CUSTOMER_NAME = event.CUST_NAME_EN;
      this.ParamsHeadData.PAYMENT_TERM = event.PAYMENT_TERM;
      this.ParamsHeadData.LOCK_CUSTOMER = event.LOCK_CUSTOMER;
      this.ConfigBranch.SourceParams.CUSTOMER_CODE = event.CUSTOMER_CODE
    if ((this.ParamsHeadData.LOCK_CUSTOMER != 0 && this.ParamsHeadData.LOCK_CUSTOMER != 2) && !this.iSWarning) {
        this.iSWarning = true
        this.modal.warning("This customer is locked, This document will be suspend instead of tax invoice",this.viewref)
      }
      this.CheckStatus();
      if(this.ParamsHeadData.C_TMP_ORDER_NO){
        let param = {
          CUSTOMER_CODE : this.ParamsHeadData.CUSTOMER_CODE,
          ORDER_NO : this.ParamsHeadData.C_TMP_ORDER_NO
        }
        this.http.post("AC","SNPE019_M_FindOrderDate",param)
        .subscribe(res => {
            
            if(res.Table.length > 0){
              this.ParamsHeadData.D_TMP_ORDER_DATE = res.Table[0].ORDER_DATE
              this.ParamsHeadData.BRANCH_CODE = res.Table[0].BRANCH_CODE
              this.ParamsHeadData.BRANCH_NAME = res.Table[0].BRANCH_NAME
              this.autoCompleteBranch.textInput = this.ParamsHeadData.BRANCH_CODE;
              this.autoCompleteBranch.query();
            }

        })
      }
    }

    OrderChange() {
     
      if(this.ParamsHeadData.CUSTOMER_CODE){
        let param = {
          CUSTOMER_CODE : this.ParamsHeadData.CUSTOMER_CODE.toUpperCase(),
          ORDER_NO : this.ParamsHeadData.C_TMP_ORDER_NO
        }
        this.http.post("AC","SNPE019_M_FindOrderDate",param)
        .subscribe(res => {
           this.ParamsHeadData.D_TMP_ORDER_DATE = null;
            if(res.Table.length > 0){
              this.ParamsHeadData.D_TMP_ORDER_DATE = res.Table[0].ORDER_DATE
              this.ParamsHeadData.BRANCH_CODE = res.Table[0].BRANCH_CODE
              this.autoCompleteBranch.textInput = this.ParamsHeadData.BRANCH_CODE;
              this.autoCompleteBranch.query();
              // this.ParamsHeadData.BRANCH_NAME = res.Table[0].BRANCH_NAME
            }
        })
      }
    }

    SelectedBranch(event){
      if(event){
      this.ParamsHeadData.BRANCH_CODE = event.BRANCH_CODE
      this.ParamsHeadData.BRANCH_NAME = event.BRANCH_NAME_TH
      this.ParamsHeadData.BRANCH_STATUS = event.BRANCH_STATUS
      this.ParamsHeadData.BRANCH_DESC = event.REASON_NAME_TH

      if ((this.ParamsHeadData.BRANCH_STATUS != 0 && this.ParamsHeadData.BRANCH_STATUS != 2) && !this.iSWarning) {
        this.iSWarning = true
        this.modal.warning("This branch is locked, This document will be suspend instead of tax invoice",this.viewref)
      }
      this.CheckStatus()
    }
    }

    RadioChange(event){
      if(event.value == 'TF'){
        this.ParamsHeadData.REASON_CODE = '395'
      }else{
        this.ParamsHeadData.REASON_CODE = '10'
      }
      //console.log(event)
    }

    CheckStatus(){
    if (((this.ParamsHeadData.LOCK_CUSTOMER != 0 && this.ParamsHeadData.LOCK_CUSTOMER != 2) || (this.ParamsHeadData.BRANCH_STATUS != 0 && this.ParamsHeadData.BRANCH_STATUS != 2))) {
        this.ParamsHeadData.SELECT_DOC_TYPE = 'TF'
        this.ParamsHeadData.REASON_CODE = '395'
      }else{
        this.ParamsHeadData.SELECT_DOC_TYPE = 'DO'
        this.ParamsHeadData.REASON_CODE = '10'
      }
    }

    AppendRow() {
      for (var i = 0; i < this.tableDataDetail.length; i++) {
        if (this.tableDataDetail[i].EDIT === "ADD") {
          this.tableDataDetail[i].EDIT = 'DEL';
          this.tableDataDetail[i].ITEM = this.tableDataDetail.length;
        }
      }
    this.tableDataDetail.push({
      'EDIT': 'ADD',
      'ITEM_QTY': 0 ,
      'UNIT_PRICE_B' : 0,
      'RETAIL_PRICE' : 0,                                     
      'NET_AMT_B':0,
      'ORDER_NO' : 0,
      'ORDER_DATE' :null,
      'ORDER_ITEM_NO':0,
      'ATTRIBUTE3':null,
      'ATTRIBUTE4':null,
      'VAT' : 0,
      'NET_AMOUNT' : 0 
      });

      this.tableDataDetail = this.tableDataDetail.slice();
  
      
    }
    DeleteRow(Item) {
      if (this.PageAction == PageAction.Retrive) {

        let index = this.tableDataDetail.findIndex(x => x == Item)
        this.tableDataDetail.splice(index, 1);
        //this.tableDataDetail = this.tableDataDetail.slice();
        this.Calculate();
      }
    }

 

    Calculate(){
      
      this.Params.N_TMP_TOTAL_NET_B = this.tableDataDetail.map(x => x.NET_AMT_B).reduce((prev,next) => prev + next);
      this.Params.N_TMP_TOTAL_VAT = this.tableDataDetail.map(x => (x.NET_AMT_B * 7) / 100).reduce((prev,next) => prev + next);//this.global.Round(this.Params.N_TMP_TOTAL_NET_B * ((this.ParamsHeadData.VAT_RATE|0) / 100),2);
      this.Params.N_TMP_NET_AMT = this.global.Round(this.Params.N_TMP_TOTAL_NET_B + this.Params.N_TMP_TOTAL_VAT,2);

      this.tblFooter[3].value = this.global.Round(this.Params.N_TMP_TOTAL_VAT,2);
      this.tblFooter[4].value = this.Params.N_TMP_NET_AMT;
      //this.tblFooter = this.tblFooter.slice();
      this.tableDataDetail = this.tableDataDetail.slice();
    }

    Sum(){
      this.ParamsHeadData.WHT_AMOUNT = 0;
      this.tableDataDetail.map(x => {
        x.VAT = this.global.Round(x.NET_AMT_B * (this.ParamsHeadData.VAT_RATE / 100),2)
        x.NET_AMOUNT = this.global.Round(x.NET_AMT_B + x.VAT,2)
        this.ParamsHeadData.WHT_AMOUNT += x.NET_AMT_B * (this.ParamsHeadData.TAX_RATE / 100)
      })

      this.tableDataDetail = this.tableDataDetail.slice()
    }

    ChenkBusinessplace(event){
     
      if(event.length <= 5){
        let getlenght = 5 - event.length
      switch (getlenght) {
          case 0 :
            this.ParamsHeadData.BUSINESS_PLACE = event
            break;
          case 1 :
            this.ParamsHeadData.BUSINESS_PLACE = "0" + event
            break;
          case 2 :
            this.ParamsHeadData.BUSINESS_PLACE = "00" + event
            break;
          case 3 :
            this.ParamsHeadData.BUSINESS_PLACE = "000" + event
            break;
          case 4 :
            this.ParamsHeadData.BUSINESS_PLACE = "0000" + event
            break;
          case 5 :
            this.ParamsHeadData.BUSINESS_PLACE = "00000"
            break;
          default:
            this.ParamsHeadData.BUSINESS_PLACE = "00000"
            break;
        }
      }else{
        this.ParamsHeadData.BUSINESS_PLACE = "00000"
      }
    }


    ClearParamsHead (){
      this.ParamsHeadData = {
        DOCUMENT_TYPE : null,
        DOCUMENT_TIME : null,
        DOCUMENT_NO : null,
        DOCUMENT_DATE : this.ParamsHeadData.DOCUMENT_DATE,
        JOB_TYPE : null,
        REF_DOC_TYPE : null,
        REF_DOC_NO : null,
        REF_DOC_DATE : null,
        REF_INV_NO : null,
        REF_INV_DATE : null,
        CUSTOMER_CODE : null,
        CUSTOMER_NAME : null,
        TOTAL_AVG_AMT : null,
        TOTAL_STD_AMT : null,
        TOTAL_RETAIL_B : null,
        TOTAL_RETAIL_C : null,
        TOTAL_NET_B : null,
        TOTAL_DISCOUNT : null,
        TOTAL_VAT : null,
        VENDOR_CODE : '070',
        VENDOR_TYPE : null,
        CONFIRM_DATE : null,
        DEST_PORT : null,
        VAT_FLAG : null,
        VAT_RATE : null,
        ATTRIBUTE5 : '01',
        TOTAL_CASE : null,
        TOTAL_ITEM : null,
        TOTAL_QTY : null,
        REASON_CODE : '10',
        LAST_UPD_BY : null,
        LAST_UPD_DATE : null,
        TOTAL_OLD_AMT : null,
        BUSINESS_PLACE : null,
        VAT_DESC : null,
        TAX_FLAG : null,
        TAX_RATE : null,
        VENDOR_NAME : null,
        TOTAL_AMOUNT : null,
        TNAME : null,
        TMP_TOT_LOC : null, 
        TMP_TOT_IMP : null,
        INDENT_STATUS : null,
        DSP_DOC_NO : null,
        REF_INV_DATE_FORMAT : null,
        DOCUMENT_DATE_FORMAT : null,
        TMP_INV_NO : null,
        TMP_INV_DATE : null,
        C_TMP_ORDER_NO : null,
        D_TMP_ORDER_DATE : null,
        PAYMENT_TERM : null,
        BRANCH_CODE : null,
        BRANCH_NAME : null,
        SUM_ITEM_QTY : null,
        SELECT_DOC_TYPE : 'DO',
        LOCK_CUSTOMER : null,
         BRANCH_STATUS : null,
         WHT_AMOUNT : 0,
         BRANCH_DESC : null,
         REF_OTHER_DOC : null
     }
    }


    FormatDate(date) {

          let d = new Date(date);
          let Day = d.getDate().toString();
          let NewDay = Day.toString().length < 2 ? '0' + Day.toString() : Day.toString()
          let Month = d.getMonth() + 1;
          let NewMonth = Month.toString().length < 2 ? '0' + Month.toString() : Month.toString()
          let Year = d.getFullYear().toString();
          return Year + NewMonth + NewDay;
    }

    ClearParamData(){
      
    }
}
