import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { Globals } from 'src/app/core/global';
import { ModalService } from '../../../core/modal.service';

@Component({
  selector: 'SNPE032',
  templateUrl: './SNPE032.component.html',
  styleUrls: ['./SNPE032.component.css']
})



export class SNPE032Component implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    public global: Globals,
    private auth: AuthDecode,
    private viewref: ViewContainerRef,
    private modal: ModalService,
  ) { }


  public headerList: any;

  public data: any = {};

  public tableData: any = [];
  public MainDatatable: any;

  public displayedColumns: string[] = [];
  public isCustomContent: boolean = false;
  public SelectList: any;
  public IsSearch: any = true;
  public IsEdit: any = false;
  public IsAdd: any = false;
  public IsSaved = false;
  public IsSheleved = true;
  public SelectedInv = false;
  public IsCancel : boolean = true;
  public params: any = {
    DOCUMENT_NO: null,
    VENDOR_CODE: null,
    INVOICE_NO: null
  }

  public tempData : any = [];

  public ConfigDocNo: any = {
    ColName: "LOOKUP_DOC",
    PlaceholderText: "Select Document No",
    SourceController: "AC",
    SourceMethodName: "SNPE032_GetDoc",
    NoOfShowRecords: 30,
    MinLengthSearch: 5,
    UpperCase: false
  }

  public ConfigDocS: any = {
    ColName: "DOCUMENT_NO",
    PlaceholderText: "Select Document No",
    SourceController: "AC",
    SourceMethodName: "SNPE032_GetDoc",
    NoOfShowRecords: 30,
    MinLengthSearch: 5,
    UpperCase: true
  }

  public ConfigVendorS: any = {
    ColName: "LOOKUP_VENDOR",
    PlaceholderText: "Select Vendor Code",
    SourceController: "AC",
    SourceMethodName: "SNPE032_GetVendor",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigVendor: any = {
    ColName: "LOOKUP_VENDOR",
    PlaceholderText: "Select Vendor Code",
    SourceController: "AC",
    SourceMethodName: "SNPE032_GetVendor",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigInvS: any = {
    ColName: "INVOICE_NO",
    PlaceholderText: "Select Invoice No",
    SourceController: "AC",
    SourceMethodName: "SNPE032_GetInv",
    NoOfShowRecords: 30,
    MinLengthSearch: 3,
    UpperCase: false
  }

  public ConfigInv: any = {
    ColName: "INV_LOOKUP",
    PlaceholderText: "Select Invoice No",
    SourceController: "AC",
    SourceMethodName: "SNPE032_GetInv",
    NoOfShowRecords: 30,
    MinLengthSearch: 3,
    UpperCase: false
  }

  public ConfigCase: any = {
    ColName: "CASE_NO",
    PlaceholderText: "Select Case",
    SourceController: "AC",
    SourceMethodName: "SNPE032_GetCase",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      REF_INV_NO: null,
      VENDOR_CODE : null
    },

  }


  ngOnInit() {
    this.data = {};
    this.data.CREATE_DATE = new Date();
    this.data.LAST_UPD_DATE = new Date();
    this.data.UPDATE_BY_NAME = this.global.GetTokenDetail("ssNameEN");
    this.ConfigInv.SourceParams = { VENDOR_CODE: "" };
    this.ConfigInvS.SourceParams = { VENDOR_CODE: "" };
    this.data.DOCUMENT_DATE = new Date();
    this.data.TOT_ITEM = 0
    this.data.CASE_AMT = 0
    this.data.TOT_CASE = 0
  }

  VendorChanged() {
    this.http.get("AC", "SNPE032_GetVendor", this.data.VENDOR_CODE, "30")
      .subscribe(res => {
        if (res.Table[0].STATUS != "FAIL") {
          for (var i = 0; i < res.Table.length; i++) {
            if (res.Table[i].VENDOR_CODE === this.data.VENDOR_CODE) {
              this.data.VENDOR_CODE = res.Table[i].VENDOR_CODE;
              this.data.VENDOR_NAME = res.Table[i].VENDOR_NAME_TH;
              this.data.VENDOR_TYPE = res.Table[i].VENDOR_TYPE;
              this.ConfigCase.SourceParams.VENDOR_CODE = this.data.VENDOR_CODE ;
            }
          };
        }
      });
  }

  InvChanged(event,a) {
    //console.log('dada',this.data)
    //console.log('event',event)
    if(event.INVOICE_NO && this.data.VENDOR_CODE){
      //this.data.TOTAL_NET_B = 0
      this.http.post("AC", "SNPE032_GetInvP", this.data)
        .subscribe(res => {
          //console.log('res',res)
          if (res.Table.length > 0) {
            for (var i = 0; i < res.Table.length; i++) {
              if (res.Table[i].INVOICE_NO === this.data.REF_INV_NO) {
                this.data.REF_INV_NO = res.Table[i].INVOICE_NO;
                this.data.REF_INV_DATE = res.Table[i].INVOICE_DATE;
                this.data.INV_STATUS = res.Table[i].TYPE_NAME_EN;
                this.data.TOTAL_QTY = res.Table[i].TOT_QTY;
                this.data.TOTAL_NET_B = res.Table[i].TOT_AMT_IMPORT;
                this.data.FOUND_51_53 = res.Table[i].FOUND_51_53;
                this.ConfigCase.SourceParams.REF_INV_NO = res.Table[i].INVOICE_NO ;
                this.SelectedInv = true;
              }
            };
          }else{
            this.data.REF_INV_NO = null;
            //console.log('this.data.REF_INV_NO',this.data.REF_INV_NO)
          }
        });
    }else{
      this.data.REF_INV_NO = null;
      //console.log('this.data.REF_INV_NO',this.data.REF_INV_NO)
    }
  }

  Edit(P_data) {
    this.data = P_data;
    this.IsSearch = false;
    this.IsEdit = true;
    this.IsAdd = false;
    this.IsCancel = false;
    this.http.get("AC", "SNPE032_GetCaseG", this.data.DOCUMENT_NO, this.data.REF_INV_NO)
      .subscribe(res => {
        
        if (res.Table[0].STATUS != "FAIL") {
          this.tableData = res.Table;
          this.data.TOT_CASE = 0
          this.data.TOT_ITEM = 0
          this.data.CASE_AMT =0
          for (var i = 0; i < this.tableData.length; i++) {
            this.tableData[i].SEQ = i + 1;
            this.tableData[i].EDIT = 'DEL';
            this.data.TOT_CASE = i + 1;
            // this.data.TOT_ITEM = this.data.TOT_ITEM == undefined ? 0 : this.tableData[i].TOT_ITEM;
            // this.data.CASE_AMT = this.data.CASE_AMT == undefined ? 0 : this.tableData[i].CASE_AMT;
            this.data.TOT_ITEM = this.data.TOT_ITEM + this.tableData[i].COUNT_REC;
            this.data.CASE_AMT = this.data.CASE_AMT + this.tableData[i].QTY;
          };
        }
      });
  }
  AddNew() {
    this.IsSearch = false;
    this.IsEdit = false;
    this.IsAdd = true;
    this.IsSaved = false;
    this.IsSheleved = true;
    this.ngOnInit();
    this.tableData = [];
    this.tableData = [...this.tableData, { 'EDIT': 'ADD', 'SEQ': '' }];
  }

  GetCase(evt, data, index) {

    if(evt.CASE_NO){
      if(this.tableData.filter((v,i) => index != i && v.CASE_NO == evt.CASE_NO).length > 0) {
        data.CASE_NO = null
        this.modal.warning("Duplicate case no",this.viewref)
        return false;
      } else {
        this.tableData[index].CASE_NO = evt.CASE_NO;
        this.tableData[index].COUNT_REC = evt.COUNT_REC;
        this.tableData[index].QTY = evt.QTY;
        this.tableData[index].TOTOL_AMOUT = evt.TOTOL_AMOUT;

        this.data.TOT_CASE = this.tableData.filter(v => v.EDIT == 'DEL').length;
        this.data.TOT_ITEM = this.tableData.reduce((o,n) => o + (parseFloat(n.COUNT_REC) || 0),0);
        this.data.CASE_AMT = this.tableData.reduce((o,n) => o + (parseFloat(n.QTY) || 0),0);

        this.CheckDiff(evt);
      }

      // for (var i = 0; i < this.tableData.length; i++) {
      //   if(evt.CASE_NO == this.tableData[i].CASE_NO && evt.COUNT_REC == this.tableData[i].COUNT_REC){
      //     data.CASE_NO = null
      //     this.modal.warning("Duplicate case no",this.viewref)
      //     return false;
      //   }else{
      //     if (this.tableData[i].SEQ === data.SEQ) {
      //       this.tableData[i].CASE_NO = evt.CASE_NO;
      //       this.tableData[i].COUNT_REC = evt.COUNT_REC;
      //       this.tableData[i].QTY = evt.QTY;
      //       this.tableData[i].TOTOL_AMOUT = evt.TOTOL_AMOUT
      //       this.data.TOT_CASE = i + 1;
      //       this.data.TOT_ITEM = this.data.TOT_ITEM  + evt.COUNT_REC;
      //       this.data.CASE_AMT = this.data.CASE_AMT + evt.QTY;
  
      //       this.CheckDiff(evt)
      //       break;
      //     }
      //   }
    
      // }
    }else{
      data.CASE_NO = null
    }

  }


  CheckDiff(evt){

    this.http.get("AC","SNPE032_GetDiffCost",this.data.REF_INV_NO,evt.CASE_NO,this.data.VENDOR_CODE)
    .subscribe(res =>{
     
      let diff = 0
      if(res.Table.length > 0) diff = res.Table[0].DIFF_COST
      
      let find = this.tableData.some(x => x.DIFF_FLAG)
  
      if(!find){   
          let amt = this.global.Round(this.tableData[0].TOTOL_AMOUT + Number(diff),2)
          this.tableData[0].TOTOL_AMOUT = amt
          this.tableData[0].DIFF_FLAG = true;
          this.tableData = this.tableData.slice();
      }
    })
 

    //console.log('ttt',this.tableData)
}

  GetDocNo(evt, t) {
    if (t === "s") {
      this.params.DOCUMENT_NO = evt.DOCUMENT_NO;
    }
    if (t === "a") {
      this.data.DOCUMENT_NO = evt.DOCUMENT_NO;
      this.data.DOCUMENT_DATE = evt.DOCUMENT_DATE;
    }
  }
  GetVendor(evt, t) {
    console.log(evt)
    if (t === "s") {
      this.params.VENDOR_CODE = evt.VENDOR_CODE;
    }
    if (t === "a") {
      this.data.VENDOR_CODE = evt.VENDOR_CODE;
      this.data.VENDOR_NAME = evt.VENDOR_NAME_TH;
      this.data.VENDOR_TYPE = evt.VENDOR_TYPE;
     
    }
    this.ConfigInv.SourceParams = { VENDOR_CODE: evt.VENDOR_CODE };
    this.ConfigCase.SourceParams.VENDOR_CODE = evt.VENDOR_CODE ;
  }
  GetInv(evt, t) {
    console.log('evt',evt)
    if (t === "s") {
      this.params.INVOICE_NO = evt.INVOICE_NO;
    }
    if (t === "a") {
      //this.data.TOTAL_NET_B = 0
      //this.data.REF_INV_NO = evt.INVOICE_NO;
      // this.data.REF_INV_DATE = evt.INVOICE_DATE;
      // this.data.INV_STATUS = evt.TYPE_NAME_EN;
      // this.data.TOTAL_QTY = evt.TOT_QTY;
      // this.data.TOTAL_NET_B = evt.TOT_AMT_IMPORT;
      // this.ConfigCase.SourceParams.REF_INV_NO = evt.INVOICE_NO ;
      // this.data.FOUND_51_53 = evt.FOUND_51_53;
      // this.SelectedInv = true;
    }
  }
  AppendRow() {
    if (this.SelectedInv) {
      for (var i = 0; i < this.tableData.length; i++) {
        if (this.tableData[i].EDIT === "ADD") {
          this.tableData[i].EDIT = 'DEL';
          
          this.tableData[i].SEQ = this.tableData.length;
        }
      }
      this.tableData = [...this.tableData, { 'EDIT': 'ADD', 'SEQ': '' }];
    }
  }
  DeleteRow(Item) {
    this.data.TOT_ITEM = 0
    this.data.CASE_AMT = 0
    this.data.TOT_CASE = 0
    for (var i = 0; i < this.tableData.length; i++) {
      if (this.tableData[i].SEQ === Item) {
        this.tableData.splice(i, 1);
      }
      this.data.TOT_ITEM += (this.tableData[i].COUNT_REC||0);
      this.data.CASE_AMT += (this.tableData[i].QTY || 0);
    }

    this.data.TOT_CASE = this.tableData.filter(x => x.EDIT == 'DEL' && x.CASE_NO).length
    console.log(this.tableData)
    this.tableData = [...this.tableData];
  }

  Search() {
    this.http.post("AC", "SNPE032_GetList", this.params)
      .subscribe(res => {
        this.MainDatatable = res.Table;
      });

  }
  BackToGrid() {
    this.IsSearch = true;
  }

  Save() {
    if (this.data.VENDOR_CODE === null || this.data.VENDOR_CODE === "" || this.data.VENDOR_CODE === undefined) {
      this.modal.warning('Please select Vendor', this.viewref)
    } else if (this.data.REF_INV_NO === null || this.data.REF_INV_NO === "" || this.data.REF_INV_NO === undefined) {
      this.modal.warning('Please select Invoice', this.viewref)
    }
    else if (this.tableData.filter(x => x.EDIT == 'DEL' && x.CASE_NO).length < 1) {
      this.modal.warning('Please select at least a Case', this.viewref)
    }
    else {
      this.modal.confirm('Do you want to save change you have made?', this.viewref, this.ConfirmSave)
    }
  }

  ConfirmSave = () => {
    this.data.DOCUMENT_DATE = this.getDateParam(this.data.DOCUMENT_DATE);
    this.data.REF_INV_DATE = this.getDateParam(this.data.REF_INV_DATE);
    this.data.CREATE_DATE = new Date();
    this.data.LAST_UPD_DATE = new Date();
    this.data.TOT_RECIEVE_QTY = this.CalTotalQTY()
    this.data.TOT_RECIEVE_AMOUNT = this.CalTotalAmount()
    this.data.CASE_LIST = [];
    this.data.CASE_LIST = this.tableData;
    this.data.TOTAL_RECIEVE_QTY = this.CalTotalQTY()
    this.data.TOTAL_RECIEVE_AMOUNT = this.CalTotalAmount();
    this.http.post("AC", "SNPE032_Save_NewVersion", this.data)
      .subscribe(res => { 
          console.log('res',res)
        if(res.STATUS == 'DONE'){
          this.IsSaved = true;
          this.IsSheleved = true;
          this.data.DOCUMENT_NO = res.DOCUMENT_NO;
          //this.data.DOCUMENT_DATE = res.Table[0].DOCUMENT_DATE;
          this.data.LAST_UPD_DATE = new Date();
          this.data.UPDATE_BY_NAME = this.global.GetTokenDetail("ssNameEN");
          this.modal.info("Transaction complete: applied and saved.",this.viewref);
        }else if(res.STATUS == 'UNCONFIRM'){
          this.modal.warning("There is document no." + ' '+ res.DOCUMENT_NO +' ' +"waiting to confirm. Please confirm before shelving the rest.",this.viewref)
        }else if(res.STATUS == 'PRICE_ERROR'){
          let detailPrice = res.DOCUMENT_NO.split(",");
          this.modal.error('Not allow to recieve part !!. Recieve Qty : A not equal to Invoice Qty :B or Recieve Amount :A not equal to Invoice Amount :B, ' + ':A : '+ detailPrice[0] + ' , ' + detailPrice[1] + ',' +':B : ' + this.CalTotalQTY() + ' , ' + this.CalTotalAmount()
          , this.viewref,()=>{},{'width':'650px','height':'350px'});
        }
        },(err) => {
          this.modal.error("Process not complete",this.viewref);
          //console.log('error',err)
        })
    // this.data.CASE_LIST = [];
    // this.data.CASE_LIST = this.tableData;
    // this.http.post("AC", "SNPE032_ToShelve", this.data)
    //   .subscribe(res => {
    //     if (res.Table[0].STATUS == 'DONE') {
    //       this.modal.info('Transaction complete: 1 record parts to shaled', this.viewref);
    //       this.IsSheleved = true;
    //     }
    //     else {
    //       this.modal.warning(res.Table[0].MESSAGE, this.viewref);
    //       this.IsSheleved = false;
    //     }
    //   });
  }


  getDateParam(dt) {
    if (dt !== undefined) {
      dt = new Date(dt)
      let year = dt.getFullYear();
      let month = (1 + dt.getMonth()).toString().padStart(2, '0');
      let day = dt.getDate().toString().padStart(2, '0');
      var p_Date = year + '-' + month + '-' + day;
      return p_Date;
    }
  }

  ToShelve() {
    this.modal.confirm('Do you want to to shelve?', this.viewref, this.ConfirmToShelve)
  }

  ConfirmToShelve = () => {
    

  }

  Cancel() {
    this.modal.confirm('Do you want to to cancel?', this.viewref, this.ConfirmCancel)

  }

  ConfirmCancel = () => {
    this.data.LAST_UPD_PGM = 'SNPE032'
    this.http.post("AC", "SNPE031_M_Cancel", this.data)
      .subscribe(res => {
        if (res == 'DONE') {
          this.modal.info('Transaction complete: 1 record  Canceled', this.viewref);
          this.IsCancel = true;
          this.IsSheleved = true;
        }
        else if(res == 'CONFIRMED'){
          this.modal.warning("Can not cancel document because this document confirmed",this.viewref);
        }
        else {
          this.modal.error('Found an error, please contact support team', this.viewref);
        }
      },err =>{
        this.modal.error('Found an error, please contact support team', this.viewref);
      });
  }

  CheckCaseList(){
    let IsCase = true

    IsCase = this.tableData.filter(x => x.EDIT == 'DEL' && x.CASE_NO && x.COUNT_REC).length > 0 ? true : false;

     return IsCase
  }

  CheckValid(){
    let valid = (this.data.REF_INV_NO && this.data.REF_INV_NO && this.data.VENDOR_CODE) ? true : false;
     return valid
  }

  CalTotalQTY() {
    return this.tableData.reduce((prev, currObj) => prev + (currObj.EDIT !== 'ADD' ? (currObj.QTY||0) : 0), 0);
  }

  CalTotalAmount() {
    return this.tableData.reduce((prev, currObj) => prev + (currObj.EDIT !== 'ADD' ? (currObj.TOTOL_AMOUT|| 0) : 0), 0);
  }




}


