import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from 'src/app/core/modal.service';
import * as moment from 'moment';

@Component({
  selector: 'snpr025',
  templateUrl: './snpr025.component.html',
  styleUrls: ['./snpr025.component.css']
})



export class SNPR025Component implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private global : Globals,
    private modal : ModalService,
    private viewref : ViewContainerRef
  ) { }

  public ConfigDocNO: any = {
    ColName: "DOCUMENT_NO",
    ColValue: "DOCUMENT_NO",
    PlaceholderText: "Select Document No",
    SourceController: "AC",
    SourceMethodName: "SNPR025_GetDocNo",
    NoOfShowRecords: 100,
    MinLengthSearch: 5,
    UpperCase: true
  }

  public ConfigInvoiceNO: any = {
    ColName: "REF_INV_NO",
    ColValue: "REF_INV_NO",
    PlaceholderText: "Select Invoice No",
    SourceController: "AC",
    SourceMethodName: "SNPR025_GetInvoiceNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 3,
    UpperCase: false,
    SourceParams: {
      DOC_NO_START: null,
      DOC_NO_END: null,
      DOC_DATE_START : null,
      DOC_DATE_END : null
    }
  }

  public CustomerList: any = [];
  public Params = {
    DOCUMENT_NO_FROM : null,
    DOCUMENT_NO_TO : null,
    DOCUMENT_DATE_FROM : new Date(),
    DOCUMENT_DATE_TO : new Date(),
    INVOICE_NO_FROM : null,
    INVOICE_NO_TO : null,
    INVOICE_DATE_FROM : null,
    INVOICE_DATE_TO : null
  }


  ngOnInit() {

  }


  OpenReport(){

    //console.log(typeof this.global.GetTokenDetail("ssComCode"))

    if(this.Params.DOCUMENT_NO_FROM || this.Params.DOCUMENT_NO_FROM || this.Params.DOCUMENT_DATE_FROM || this.Params.DOCUMENT_DATE_FROM
      ||this.Params.DOCUMENT_DATE_FROM || this.Params.INVOICE_NO_FROM || this.Params.INVOICE_NO_FROM || this.Params.INVOICE_DATE_FROM || this.Params.INVOICE_DATE_FROM)
      {

        

          if(this.global.GetTokenDetail("ssComCode") == '01'){
            if(this.Params.DOCUMENT_NO_FROM || this.Params.DOCUMENT_NO_TO){
              let docfrom = this.Params.DOCUMENT_NO_FROM ? this.Params.DOCUMENT_NO_FROM.substring(0,2) : null
              let docto = this.Params.DOCUMENT_NO_TO ? this.Params.DOCUMENT_NO_TO.substring(0,2) : null

              if(docfrom == 'RL' || docto == 'RL'){
                this.global.GoToReport("PMS_RPT_ACC_SNPE019R1_NEW",
                {
                  P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
                  P_DOCUMENT_NO_FROM : this.Params.DOCUMENT_NO_FROM,
                  P_DOCUMENT_NO_TO : this.Params.DOCUMENT_NO_TO,
                  P_DOCUMENT_DATE_FROM : this.Params.DOCUMENT_DATE_FROM ? this.SetFormatDate(this.Params.DOCUMENT_DATE_FROM) : null,
                  P_DOCUMENT_DATE_TO : this.Params.DOCUMENT_DATE_TO ? this.SetFormatDate(this.Params.DOCUMENT_DATE_TO) : null,
                  P_INVOICE_NO_FROM : this.Params.INVOICE_NO_FROM,
                  P_INVOICE_NO_TO : this.Params.INVOICE_NO_TO,
                  P_INVOICE_DATE_FROM : this.Params.INVOICE_DATE_FROM ? this.SetFormatDate(this.Params.INVOICE_DATE_FROM) : null,
                  P_INVOICE_DATE_TO : this.Params.INVOICE_DATE_TO ?  this.SetFormatDate(this.Params.INVOICE_DATE_TO) : null,
  
                });
              }else{
                this.global.GoToReport("PMS_RPT_ACC_SNPR025_N_01_NEW",
                {
                  P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
                  P_DOCUMENT_NO_FROM : this.Params.DOCUMENT_NO_FROM,
                  P_DOCUMENT_NO_TO : this.Params.DOCUMENT_NO_TO,
                  P_DOCUMENT_DATE_FROM : this.Params.DOCUMENT_DATE_FROM ? this.SetFormatDate(this.Params.DOCUMENT_DATE_FROM) : null,
                  P_DOCUMENT_DATE_TO : this.Params.DOCUMENT_DATE_TO ? this.SetFormatDate(this.Params.DOCUMENT_DATE_TO) : null,
                  P_INVOICE_NO_FROM : this.Params.INVOICE_NO_FROM,
                  P_INVOICE_NO_TO : this.Params.INVOICE_NO_TO,
                  P_INVOICE_DATE_FROM : this.Params.INVOICE_DATE_FROM ? this.SetFormatDate(this.Params.INVOICE_DATE_FROM) : null,
                  P_INVOICE_DATE_TO : this.Params.INVOICE_DATE_TO ?  this.SetFormatDate(this.Params.INVOICE_DATE_TO) : null,
  
                });
              }
              
              
            }else{
              this.global.GoToReport("PMS_RPT_ACC_SNPR025_N_01_NEW",
              {
                P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
                P_DOCUMENT_NO_FROM : this.Params.DOCUMENT_NO_FROM,
                P_DOCUMENT_NO_TO : this.Params.DOCUMENT_NO_TO,
                P_DOCUMENT_DATE_FROM : this.Params.DOCUMENT_DATE_FROM ? this.SetFormatDate(this.Params.DOCUMENT_DATE_FROM) : null,
                P_DOCUMENT_DATE_TO : this.Params.DOCUMENT_DATE_TO ? this.SetFormatDate(this.Params.DOCUMENT_DATE_TO) : null,
                P_INVOICE_NO_FROM : this.Params.INVOICE_NO_FROM,
                P_INVOICE_NO_TO : this.Params.INVOICE_NO_TO,
                P_INVOICE_DATE_FROM : this.Params.INVOICE_DATE_FROM ? this.SetFormatDate(this.Params.INVOICE_DATE_FROM) : null,
                P_INVOICE_DATE_TO : this.Params.INVOICE_DATE_TO ?  this.SetFormatDate(this.Params.INVOICE_DATE_TO) : null,

              });

              this.global.GoToReport("PMS_RPT_ACC_SNPE019R1_NEW",
              {
                P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
                P_DOCUMENT_NO_FROM : this.Params.DOCUMENT_NO_FROM,
                P_DOCUMENT_NO_TO : this.Params.DOCUMENT_NO_TO,
                P_DOCUMENT_DATE_FROM : this.Params.DOCUMENT_DATE_FROM ? this.SetFormatDate(this.Params.DOCUMENT_DATE_FROM) : null,
                P_DOCUMENT_DATE_TO : this.Params.DOCUMENT_DATE_TO ? this.SetFormatDate(this.Params.DOCUMENT_DATE_TO) : null,
                P_INVOICE_NO_FROM : this.Params.INVOICE_NO_FROM,
                P_INVOICE_NO_TO : this.Params.INVOICE_NO_TO,
                P_INVOICE_DATE_FROM : this.Params.INVOICE_DATE_FROM ? this.SetFormatDate(this.Params.INVOICE_DATE_FROM) : null,
                P_INVOICE_DATE_TO : this.Params.INVOICE_DATE_TO ?  this.SetFormatDate(this.Params.INVOICE_DATE_TO) : null,

              });
            }
       
          }else{
                this.global.GoToReport("PMS_RPT_ACC_SNPR025_N_03_NEW",
                  {
                    P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
                    P_DOCUMENT_NO_FROM : this.Params.DOCUMENT_NO_FROM,
                    P_DOCUMENT_NO_TO : this.Params.DOCUMENT_NO_TO,
                    P_DOCUMENT_DATE_FROM : this.Params.DOCUMENT_DATE_FROM ? this.SetFormatDate(this.Params.DOCUMENT_DATE_FROM) : null,
                    P_DOCUMENT_DATE_TO : this.Params.DOCUMENT_DATE_TO ? this.SetFormatDate(this.Params.DOCUMENT_DATE_TO) : null,
                    P_INVOICE_NO_FROM : this.Params.INVOICE_NO_FROM,
                    P_INVOICE_NO_TO : this.Params.INVOICE_NO_TO,
                    P_INVOICE_DATE_FROM : this.Params.INVOICE_DATE_FROM ? this.SetFormatDate(this.Params.INVOICE_DATE_FROM) : null,
                    P_INVOICE_DATE_TO : this.Params.INVOICE_DATE_TO ?  this.SetFormatDate(this.Params.INVOICE_DATE_TO) : null,
                  
                  });

                  // this.global.GoToReport("PMS_RPT_ACC_SNPE019R1_NEW",
                  // {
                  //   P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
                  //   P_DOCUMENT_NO_FROM : this.Params.DOCUMENT_NO_FROM,
                  //   P_DOCUMENT_NO_TO : this.Params.DOCUMENT_NO_TO,
                  //   P_DOCUMENT_DATE_FROM : this.SetFormatDate(this.Params.DOCUMENT_DATE_FROM),
                  //   P_DOCUMENT_DATE_TO : this.SetFormatDate(this.Params.DOCUMENT_DATE_TO),
                  //   P_INVOICE_NO_FROM : this.Params.INVOICE_NO_FROM,
                  //   P_INVOICE_NO_TO : this.Params.INVOICE_NO_TO,
                  //   P_INVOICE_DATE_FROM : this.SetFormatDate(this.Params.INVOICE_DATE_FROM),
                  //   P_INVOICE_DATE_TO : this.SetFormatDate(this.Params.INVOICE_DATE_TO),
    
                  // });
          }

      }else
      {

        this.modal.warning("Please input 1 criteria",this.viewref);

      }

 
  
  }

  SetFormatDate(date) {

    let d = new Date(date);
    let day = d.getDate();
    let newDay = day.toString().length < 2 ? 0 + '' + day : day
    let year = d.getFullYear()
    let month = d.getMonth() + 1;
    let newMonth = month.toString().length < 2 ? 0 + '' + month : month
    return newDay  + '-' + newMonth + '-' + year;

}

}
