import { Component, OnInit, ViewContainerRef, ChangeDetectorRef, ViewChild, ElementRef } from '@angular/core'
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';
import { getuid } from 'process';
import { AutoCompleteQueryComponent } from 'src/app/components/shared/auto-complete-query/auto-complete-query.component';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { AutoTableHighlightComponent } from 'src/app/components/shared/auto-table-hl/auto-table-hl.component';

@Component({

  selector: 'snse041_M2',
  templateUrl: './SNSE041_M2.component.html',
  styleUrls: ['./SNSE041_M2.component.css']
})

export class SNSE041_M2Component implements OnInit {

  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private changeRef: ChangeDetectorRef,
    private global: Globals,
    private auth: AuthDecode,
  ) { }

  public CustomerList: any;
  public tableData: any = [];
  public ParamsHead: any = {};

  public ConfigRefRoNo: any = {
    ColName: "REF_RO_NO",
    ColValue: "",
    PlaceholderText: "Select Req. Return Order No.",
    SourceController: "AC",
    SourceMethodName: "SNSE041_M2_GetRequestPart",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      CUSTOMER_CODE: null
    }
  }

  public ConfigCustomer: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Customer Code",
    SourceController: "AC",
    SourceMethodName: "SNSE041_M_GetCustomer",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false,
  }


  public ConfigDocNo: any = {
    ColName: "DOCUMENT_NO",
    ColValue: "DOCUMENT_NO",
    PlaceholderText: "Select Document No",
    SourceController: "AC",
    SourceMethodName: "SNSE041_M2_GetDocNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 5,
    UpperCase: true
  }

  public ConfigRefDocNoSearch: any = {
    ColName: "REF_DOC_NO",
    ColValue: "REF_DOC_NO",
    PlaceholderText: "Select Ref Document No",
    SourceController: "AC",
    SourceMethodName: "SNSE041_M2_GetRefDoc",
    NoOfShowRecords: 50,
    MinLengthSearch: 5,
    UpperCase: true,
  }



  @ViewChild("doctypeauto", { static: true }) doctypeauto: AutoCompleteQueryComponent;
  //@ViewChild("test", { static: false }) test: AutoTableHighlightComponent
  public oldValue: any;
  public QtyOldValue: any;
  public DiscountOldValue: any;
  public tempTable: any = [];
  public Saved: boolean = false;
  public IsAdd: boolean = false;
  public ParamSearch: any = {};
  public tableSearch: any = [];
  public IsEdit: boolean = false;
  public IsSearch: boolean = true;
  public IsFind: boolean = false;
  public hideCols: Array<string> = []
  public data: any = {}
  public findOver: any = {}
  public tempDocDate: any;
  @ViewChild("inputCustomer") inputCustomer: ElementRef;
  
  ngOnInit() {
    //this.data.UPDATE_DATE = new Date();
    //this.CustomerList = [{ ID: 1, CUSTOMER_CODE: "AAA" }, { ID: 2, CUSTOMER_CODE: "BBB" }, { ID: 3, CUSTOMER_CODE: "CCC" }]
    //this.CreateDetailRow(0);
    this.ParamsHead = {}
    this.ParamSearch = {}
    this.tableData = []
    this.Saved = false
    this.IsAdd = true;
    this.IsEdit = false;
    this.IsSearch = false;
    this.IsFind = false;
    this.ParamsHead.DOCUMENT_NO = 'AUTO';
    this.ParamsHead.UPDATE_BY = this.global.GetTokenDetail("ssNameEN");
    this.ParamsHead.UPDATE_DATE = new Date();
    this.ParamsHead.ATTRIBUTE5 = '01'
    this.ParamsHead.DEST_PORT = 'GL'
    this.ParamsHead.RETURN_BAL = 0
    this.http.GetSystemDate()
      .subscribe(res => {
        this.tempDocDate = res;
        this.ParamsHead.DOCUMENT_DATE = this.tempDocDate
      })

    //this.ConfigRefRoNo.SourceParams.CUSTOMER_CODE = '55555555'
  }

  ngAfterViewInit(): void {

    setTimeout(() => {
      this.inputCustomer.nativeElement.select();
      this.inputCustomer.nativeElement.focus();
    }, 100);
    
  }

  Search() {

    let params = {
      DOCUMENT_NO : this.ParamSearch.DOCUMENT_NO,
      REF_DOC_NO : this.ParamSearch.REF_DOC_NO
    }

    this.http.post("AC", "SNSE041_M2_GetHeaderList", params)
      .subscribe(res => {
        //console.log(res)
        this.tableSearch = res.Table
      })
  }


  New() {
    this.ParamsHead = {}
    this.ParamSearch = {}
    this.tableData = []
    this.Saved = false
    this.IsAdd = true;
    this.IsEdit = false;
    this.IsSearch = false;
    this.IsFind = false;
    this.ParamsHead.DOCUMENT_NO = 'AUTO';
    this.ParamsHead.UPDATE_BY = this.global.GetTokenDetail("ssNameEN");
    this.ParamsHead.UPDATE_DATE = new Date();
    this.ParamsHead.DOCUMENT_DATE = this.tempDocDate
    this.ParamsHead.ATTRIBUTE5 = '01'
    this.ParamsHead.DEST_PORT = 'GL'

    setTimeout(() => {
      this.inputCustomer.nativeElement.select();
      this.inputCustomer.nativeElement.focus();
    }, 100);
    //this.CreateDetailRow(0);
  }

  Edit(data) {
    this.ParamsHead = data;
    this.IsEdit = true;
    this.IsSearch = false;
    this.IsAdd = false;
    // this.hideCols.push("DELETE")

    this.GetDetail2();
  }

  Back() {
    this.ParamsHead = {}
    this.tableData = []
    this.Saved = false
    this.IsAdd = true;
    this.IsEdit = false;
    this.IsSearch = false;
    this.IsFind = false;
    this.ParamsHead.DOCUMENT_NO = 'AUTO';
    this.ParamsHead.UPDATE_BY = this.global.GetTokenDetail("ssNameEN");
    this.ParamsHead.UPDATE_DATE = new Date();
    this.ParamsHead.ATTRIBUTE5 = '01'
    this.ParamsHead.DEST_PORT = 'GL'
    this.ParamsHead.RETURN_BAL = 0

    setTimeout(() => {
      this.inputCustomer.nativeElement.select();
      this.inputCustomer.nativeElement.focus();
    }, 100);
  }

  AdvanceSearch() {
    this.IsSearch = true;
    this.IsAdd = false;
    this.IsEdit = false;
    this.tableData = []
  }


  GetHeader(event) {
    this.tableData = [];
    this.IsFind = false;
    this.ParamsHead.REF_DOC_NO = event.DO_NO;
    this.ParamsHead.REQUEST_DATE = event.REQUEST_DATE;
    this.ParamsHead.ATTRIBUTE5 = '01';
    this.ParamsHead.DOCUMENT_NO = 'AUTO'

    this.http.get("AC", "SNSE041_M2_GetHeader", this.ParamsHead.REF_DOC_NO)
      .subscribe(res => {
        // console.log(res)
        // this.ParamsHead.REF_DOC_TYPE = res.Table[0].REF_DOC_TYPE
        // this.ParamsHead.REF_DOC_NO = res.Table[0].REF_DOC_NO
        // this.ParamsHead.REF_DOC_DATE = res.Table[0].REF_DOC_DATE
        // this.ParamsHead.REF_INV_NO = res.Table[0].REF_INV_NO
        this.ParamsHead.CUSTOMER_CODE = res.Table[0].CUSTOMER_CODE
        this.ParamsHead.CUST_NAME_TH = res.Table[0].CUST_NAME_TH
        this.ParamsHead.CUST_ADDR1 = res.Table[0].CUST_ADDR1
        this.ParamsHead.CUST_ADDR2 = res.Table[0].CUST_ADDR2
        this.ParamsHead.DEST_PORT = this.ParamsHead.DEST_PORT ? this.ParamsHead.DEST_PORT : 'GL'
        this.ParamsHead.VAT_FLAG = res.Table[0].VAT_FLAG
        this.ParamsHead.VAT_RATE = res.Table[0].VAT_RATE
        this.ParamsHead.BRANCH_CODE = res.Table[0].BRANCH_CODE
        this.ParamsHead.BRANCH_NAME_TH = res.Table[0].BRANCH_NAME_TH
        this.ParamsHead.REASON_CODE = res.Table[0].REASON_CODE
        // this.ParamsHead.TOTAL_OLD_AMT = res.Table[0].TOTAL_OLD_AMT
        this.ParamsHead.REASON_NAME_TH = res.Table[0].REASON_NAME_TH
        // this.ParamsHead.DIF_QTY = 0.00
        // this.ParamsHead.ATTRIBUTE5 = res.Table[0].ATTRIBUTE5
        // this.ParamsHead.RETURN_BAL = res.Table[0].TOTAL_QTY
        this.ParamsHead.LOCK_CUSTOMER = res.Table[0].LOCK_CUSTOMER
        this.ParamsHead.LOCK_BRANCH = res.Table[0].LOCK_BRANCH
      })
  }

  GetDetail() {
    this.tableData = [];
    this.http.get("AC", "SNSE041_M2_GetDetail", this.ParamsHead.REF_RO_NO, this.ParamsHead.REF_DOC_NO)
      .subscribe(res => {
        this.tableData = res.Table

        if (this.tableData.length > 0) {
          this.findOver = this.tableData.find(x => x.OVER_QTY == 'Y')
          if (this.findOver != undefined) {
            this.modal.warning('P# ' + this.findOver.ORDER_PART_NO + ' cannot be issued RO quantity over DO quantity, Please recheck!', this.viewref)
          }

          this.ParamsHead.REASON_CODE = this.tableData[0].REASON_CODE
          this.ParamsHead.REASON_NAME_TH = this.tableData[0].REASON_NAME
          this.IsFind = true;
        }

        //this.ConfigPartNo.SourceParams.DOCUMENT_TYPE = this.ParamsHead.REF_DOC_TYPE
        //this.ConfigPartNo.SourceParams.DOCUMENT_NO = this.ParamsHead.REF_DOC_NO

      })
  }

  GetDetail2() {
    this.http.get("AC", "SNSE041_M2_Getdetail2", this.ParamsHead.DOCUMENT_NO)
      .subscribe(res => {
        this.tableData = res.Table
      })
  }


  Save() {

    if (this.ParamsHead.LOCK_CUSTOMER !== 0 || this.ParamsHead.LOCK_BRANCH !== 0) {
      this.modal.warning("Customer or Branch Locked", this.viewref, this.BeforeSave)
    } else {
      this.BeforeSave();
    }



  }

  BeforeSave = () => {
    if (this.tableData.filter(x => x.ORDER_PART_NO).length == 0) {
      this.modal.warning("No detail data for save", this.viewref)
      return
    }

    this.modal.confirm("Do you want to save change you have made?", this.viewref, this.ConfirmSave)
  }


  ConfirmSave = () => {

    this.ParamsHead.Detail = this.tableData.filter(x => x.ORDER_PART_NO)
    this.http.post("AC", "SNSE041_M2Save", this.ParamsHead)
      .subscribe(res => {
        // console.log('rex',res)
        if (res.Table[0].STATUS == 'Done') {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.ParamsHead.DOCUMENT_NO = res.Table[0].DOCUMENT_NO
          //this.ParamsHead.DIF_QTY = res.Table[0].DIF_QTY
          this.Saved = true;
        } else {
          let message = res.Table[0].ERROR_MESSAGE.substring(10,res.Table[0].ERROR_MESSAGE.length)
          this.modal.error(message, this.viewref);
        }

      },err => {
        this.modal.warning("Found an error, please contact support team", this.viewref);
      })
  }


  Reject() {
    this.modal.confirm("Do you want to save change you have made?", this.viewref, this.ConfirmReject)

  }

  ConfirmReject = () => {
    this.http.get("AC", "SNSE041_M2_Reject", this.ParamsHead.REF_DOC_NO, this.ParamsHead.REF_RO_NO)
      .subscribe(res => {
        console.log('resssssss', res)
        if (res.Table[0].STATUS == 'Done') {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.Saved = true;
        } else {
          this.modal.warning("Found an error, please contact support team", this.viewref);
        }
      }, (err) => {
        this.modal.warning("Found an error, please contact support team", this.viewref);
      })
  }

  SelectedCustomer(event) {
    this.ParamsHead.CUSTOMER_CODE = event.CUSTOMER_CODE
    this.ParamsHead.CUST_NAME_TH = event.CUST_NAME_TH
    this.ParamsHead.CUST_ADDR1 = event.CUST_ADDR1
    this.ParamsHead.CUST_ADDR2 = event.CUST_ADDR2
    this.ParamsHead.LOCK_CUSTOMER = event.LOCK_CUSTOMER
    this.ConfigRefRoNo.SourceParams.CUSTOMER_CODE = event.CUSTOMER_CODE
    //this.ConfigBranch.SourceParams.CUSTOMER_CODE = event.CUSTOMER_CODE
  }

  VatChange(event) {
    if (event == null || event == "" || event == undefined) {
      this.ParamsHead.DEST_PORT = 'AP'
    }
  }


  SetNewPartNo(part: any, data: any, index: number) {

    let findPartIndex = this.tableData.findIndex(v => v.ORDER_PART_NO == part.ORDER_PART_NO);

    if (part?.ORDER_PART_NO && findPartIndex >= 0 && findPartIndex !== index) {
      this.modal.warning("Duplicate part number.", this.viewref);
      data.ORDER_PART_NO = null;

      return;
    }

    //console.log('daaaaaaaaaaaa',data);
    //this.tempData.Part = part;
    data.ITEM_NO = part.ITEM_NO
    data.ORDER_PART_NO = part.ORDER_PART_NO;
    data.PART_NAME = part.PART_NAME;
    data.ORDER_NO = part.ORDER_NO;
    data.ITEM_QTY = part.ITEM_QTY;
    data.RETAIL_PRICE_B = part.RETAIL_PRICE_B;
    data.DISCOUNT_RATE1 = part.DISCOUNT_RATE1;
    data.DISCOUNT_RATE2 = part.DISCOUNT_RATE2;
    data.DISCOUNT_RATE3 = part.DISCOUNT_RATE3;
    data.UNIT_PRICE_B = part.UNIT_PRICE_B;
    data.NET_AMT_B = part.NET_AMT_B;
    data.ORDER_ITEM_NO = part.ORDER_ITEM_NO;
    data.SUB_ITEM_NO = part.SUB_ITEM_NO;

    //this.ParamsHead.RETURN_BAL += part.ITEM_QTY;
    //this.ConfigOrder.SourceParams.ORDER_PART_NO = part.ORDER_PART_NO
    //this.tempTable = Object.assign({}, this.tableData);
  }

  QtyChange(oldvalue, data) {

    //console.log('tem',this.tempTable)

    if (this.ParamsHead.DOCUMENT_TYPE == 'RO' || this.ParamsHead.DOCUMENT_TYPE == 'RN') {

      if (data.ITEM_QTY > oldvalue) {
        this.modal.error("P# " + data.ORDER_PART_NO + " cannot be issued " + this.ParamsHead.DOCUMENT_TYPE + " quantity over " + this.ParamsHead.REF_DOC_TYPE + " quantity, Please recheck!", this.viewref)
        data.ITEM_QTY = oldvalue
      } else {

        data.NET_AMT_B = this.global.Round(data.ITEM_QTY * data.UNIT_PRICE_B, 2);
        //console.log(data.ITEM_QTY == oldvalue)
      }

    } else {
      data.NET_AMT_B = this.global.Round(data.ITEM_QTY * data.UNIT_PRICE_B, 2);
    }

  }

  UnitPriceChange(oldvalue, event, data) {

    data.NET_AMT_B = this.global.Round(data.ITEM_QTY * data.UNIT_PRICE_B, 2)

  }

  rowClick(event) {
    // console.log(event)
    this.ParamsHead.RETURN_BAL = event.ITEM_QTY
  }

  OperList(index) {
    //this.ConfigOrder.SourceParams.ORDER_PART_NO = this.tableData[index].ORDER_PART_NO
    //console.log("testttttttttttttttt",index)
  }


  OrderChange(event, data, index) {
    data.ORDER_NO = event.ORDER_NO;
    data.ITEM_QTY = event.ITEM_QTY;
    data.ORDER_ITEM_NO = event.ORDER_ITEM_NO;
    data.SUB_ITEM_NO = event.SUB_ITEM_NO;
  }

  DiscountChange(data, event, rate, oldvalue) {
    // console.log(data)

    if (event > 990.00) {
      this.modal.error("Field must be of from 990.00", this.viewref)
      switch (rate) {
        case 1:
          data.DISCOUNT_RATE1 = oldvalue
          break;
        case 2:
          data.DISCOUNT_RATE2 = oldvalue
          break;
        case 3:
          data.DISCOUNT_RATE3 = oldvalue
          break;
        default:
        // console.log("rate not macth")
      }
      return;
    }

    let NewUnitPrice = data.RETAIL_PRICE_B * ((100 - (data.DISCOUNT_RATE1 || 0)) / 100) * ((100 - (data.DISCOUNT_RATE2 || 0)) / 100) * ((100 - (data.DISCOUNT_RATE3 || 0))) / 100
    data.UNIT_PRICE_B = this.global.Round(NewUnitPrice, 2);

    data.NET_AMT_B = this.global.Round(data.ITEM_QTY * data.UNIT_PRICE_B, 2)

  }



  CheckActiveRow(tblIndex) {
    let valid: boolean = (this.ParamsHead.DOCUMENT_TYPE && this.ParamsHead.REF_DOC_TYPE && this.ParamsHead.REF_DOC_NO) ? true : false;

    if (valid) {
      valid = (!this.tableData[tblIndex].INVOICE_PROCESS || this.tableData[tblIndex].INVOICE_PROCESS === 'N');
    }

    if (valid && tblIndex > 0) {
      let prevRow = this.tableData[tblIndex - 1];

      valid = (prevRow.ORDER_PART_NO && prevRow.ITEM_QTY) ? true : false;
    }

    // if (valid) {
    //   this.CreateDetailRow(tblIndex);
    // }

    return valid;
  }


  CreateDetailRow(tblIndex) {
    let currentMaxRow: number = this.tableData.length || 0;
    let nextMaxRow: number = (Math.floor(currentMaxRow / 10) + 1) * 10;

    if (currentMaxRow - tblIndex <= 2) {
      for (let i = currentMaxRow; i < nextMaxRow; i++) {
        this.tableData.push({
          INVOICE_PROCESS: 'N'
        });
      }

      this.tableData = this.tableData.slice();
    }

    //console.log('ssssssss',this.tableData)

  }


  TotalQty() {
    if (!this.Saved) {
      return 0
    } else {
      return this.tableData.reduce((a, b) => a + (b.ITEM_QTY || 0), 0);
    }

  }

  TotalBal() {
    if (this.Saved) {
      return 0
    } else {
      return this.tableData.reduce((a, b) => a + (b.ITEM_QTY || 0), 0);
    }

  }

  TotalAmount() {
    return this.tableData.reduce((a, b) => a + (b.NET_AMT_B || 0), 0);
  }

  TotalVat() {
    return this.global.Round((this.TotalAmount() * (this.ParamsHead.VAT_RATE || 0)) / 100, 2)
  }

  TotalNetAmount() {
    return (this.TotalAmount() + this.TotalVat() || 0);
  }


  DeleteRow(index) {
    this.modal.confirm("Are you sure to remove this row?", this.viewref
      , () => {
        this.tableData.splice(index, 1);
        this.tableData = [...this.tableData];

      }, () => { })
  }


}
