import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'ntagz',
  templateUrl: './NTAG_Z.component.html',
  styleUrls: ['./NTAG_Z.component.css']
})

export class NTAGZComponent implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private global: Globals,
    private modal : ModalService,
    private viewlef : ViewContainerRef
  ) { }

  public currentDate: string;
  public params: any = [];

  ngOnInit() {
  }

  
  public PrintReport() {

    let floc = this.params.FLOC ? this.params.FLOC : 'A1A11';
    let tloc = this.params.TLOC ? this.params.TLOC : 'N1A99';

    this.http.get("SL","NTAG_Z_START_PROCESS",floc,tloc)
    .subscribe(res =>{
        if(res.STATUS == 'DONE'){
          this.global.GoToReport("PMS_RPT_SALES_NTAG_Z", {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
          })
        }else{
          this.modal.error("Found an error, please contract support team",this.viewlef);
        }
    })

    

  }

}

