import { Component, ElementRef, OnInit, ViewContainerRef } from '@angular/core';
import { Globals } from 'src/app/core/global';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';

@Component({
    selector: 'RUNBAT1_W',
    templateUrl: 'RUNBAT1_W.component.html',
    styleUrls: ['RUNBAT1_W.component.css']
})

export class RUNBAT1_WComponent implements OnInit {
    constructor(
        private http: HttpService,
        private modal: ModalService,
        private viewref: ViewContainerRef,
        private el: ElementRef,
        private global: Globals
    ) { }

    public TotalOrder: number;
    public TotalPart: number;
    public TotalAllocate: number;

    ngOnInit() { }

    BeginProcess() {
        this.modal.confirm("Confirm Run Allocate Afternoon?", this.viewref
            , () => {
                this.http.post("SL", "RUNBAT1_W_Process", null)
                    .subscribe(result => {
                        if(result.status == "Fail") {
                            this.modal.error(result.message, this.viewref);
                        } else {
                            this.TotalOrder = result.data.TotalOrder;
                            this.TotalPart = result.data.TotalPart;
                            this.TotalAllocate = result.data.TotalAllocate;
                            this.modal.info("Process complete....", this.viewref);
                        }
                    }, err => {
                        this.modal.error("Found eror, please contact support team.", this.viewref);
                    })
            }, () => { })
    }
}
