import { Component, ElementRef, Input, OnChanges, OnInit, SimpleChanges, ViewContainerRef } from '@angular/core';
import { Globals } from 'src/app/core/global';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';
import { SNSE004_AComponent } from '../SNSE004_A.component';

@Component({
    selector: 'bo_eo_list',
    templateUrl: 'SNSE004_A_BO.component.html',
    styleUrls: ['./../SNSE004_A.component.css']
})

export class SNSE004_A_BOComponent extends SNSE004_AComponent implements OnInit {
    constructor(
        protected http: HttpService,
        protected modal: ModalService,
        protected viewref: ViewContainerRef,
        protected el: ElementRef,
        protected global: Globals
    ) {
        super(
            http
            , modal
            , viewref
            , el
            , global
        );
    }

    public boList: Array<any> = [];
    public etpList: Array<any> = [];

    @Input("orderHeader") orderHeader: any;

    ngOnInit() {
        if(this.orderHeader){
            this.GetBOList();
            this.GetETPList();
        }
    }

    GetBOList() {
        this.http.get("SL", "SNSE004_GetBOList", this.orderHeader.CUSTOMER_CODE, this.orderHeader.BRANCH_CODE, this.orderHeader.ORDER_NO, this.global.ConvertDateToFormatSTD(this.orderHeader.ORDER_DATE))
            .subscribe(result => {
                this.boList = result.Table;
            })
    }

    GetETPList() {
        this.http.get("SL", "SNSE004_GetETPList", this.orderHeader.CUSTOMER_CODE, this.orderHeader.BRANCH_CODE, this.orderHeader.ORDER_NO, this.global.ConvertDateToFormatSTD(this.orderHeader.ORDER_DATE))
            .subscribe(result => {
                this.etpList = result.Table;
            })
    }
}
