import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from '../../../core/modal.service';



@Component({
  selector: 'snse219',
  templateUrl: './SNSE219.component.html',
  styleUrls: ['./SNSE219.component.css']
})

export class SNSE219Component implements OnInit {

  public params: any = {};

  constructor(
    private Http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  ngOnInit() {
    this.GetData();
  }

  ConfirmSave() {
    this.modal.confirm('Do you want to change status?', this.viewref, this.Save)
  }

  Save = () => {
    this.Http.post('SL', 'SNSE219_UpdateStatus', this.params)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Status Changed.', this.viewref);
          this.GetData();
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      }, (err) => {
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  private GetData() {
    this.Http.get('SL', 'SNSE219_GetData')
      .subscribe(res => {
        this.params = res.Table[0];
        console.log(this.params)
      }, (err) => {
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }
}
