import { Component, OnInit,  ViewContainerRef, ViewChild } from "@angular/core";
import * as moment from "moment";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "src/app/core/modal.service";
import { DialogTemplateComponent } from "src/app/components/shared/dialog-template/dialog-template.component";


@Component({
  selector: 'snse222',
  templateUrl: './SNSE222.component.html',
  styleUrls: ['./SNSE222.component.css']
})


export class SNSE222Component implements OnInit {

  constructor(
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private http: HttpService,
  ) { }

  public params: any = {};
  public invoiceData: any = {};
  private currentDate: moment.Moment = moment();
  public tableDataPick: any = [];
  public tableDataPickByCust: any = [];


  public tablePickByCustInComplete: any = [];
  public tablePickingByCust: any = [];
  public tablePickingByPicker: any = [];

  public tableDataCheck: any = [];
  public tableDataInvoice: any = [];
  public tableDataDetail: any = [];
  public iSelectTab: number = 0;
  public iShowBy: number = 0;
  public tabIndex: number = 0;


  public invoiceDetail: any = [];

  public sumInv: any[] = [
    {
      fieldName: 'PART_NAME',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'ITEM_QTY',
      show: true,
    },
    {
      fieldName: 'NET_AMT_B',
      show: true,
    },
  ];

  @ViewChild("InvoiceDialog") InvoiceDialog: DialogTemplateComponent;

  ngOnInit() {
    this.params.SEARCH_TYPE = '1';

    this.params.START_DATE = this.currentDate;
    this.params.END_DATE = this.currentDate;

    this.iSelectTab = 0;
    this.iShowBy = 1;

    this.Search();
  }


  public SetSelectedPickingListNo(value: any) {
    this.params.PICKING_LIST_NO = value.PICKING_LIST_NO;
  }


  public Search() {

    if (this.iSelectTab == 0) {

      this.http.post('SL', 'SNSE222_GetInvoiceList', this.params)
        .subscribe(res => {
          this.tableDataInvoice = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })
    } else if (this.iSelectTab == 1) { 


    } else if (this.iSelectTab == 2) {
       

    } else if (this.iSelectTab == 3) {
           

    } else if (this.iSelectTab == 4) {


    } else if (this.iSelectTab == 5) {

    }

  }


  public ViewBy1(i) {
    this.iShowBy = i;
    // this.Search();
  }

  public tabClick(tab: any) {
    this.iSelectTab = tab;
    this.Search();
  }

  public TabChange($event): void {
    //this.params = {};
  }

  public ViewInvoice(data: any) {

    this.InvoiceDialog.OpenDialog();
    this.invoiceData = data;

    this.http.post("WH", "SNWR023_GetInvoiceDetail", this.invoiceData).subscribe(
      (res) => {
        this.invoiceDetail = res.Table;
      },
      (err) => {
        console.log(err);
        this.modal.warning(
          "Found an error, please contact support team",
          this.viewRef
        );
      }
    );
  }


}
