import { Component, ElementRef, Input, OnChanges, OnInit, SimpleChanges, ViewContainerRef } from '@angular/core';
import { Globals } from 'src/app/core/global';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';
import { SNSE223Component } from '../SNSE223.component';

@Component({
  selector: 'bo_eo_list',
  templateUrl: 'SNSE223_BO.component.html',
  styleUrls: ['./../SNSE223.component.css']
})

export class SNSE223_BOComponent extends SNSE223Component implements OnInit {
  constructor(
    protected http: HttpService,
    protected modal: ModalService,
    protected viewref: ViewContainerRef,
    protected el: ElementRef,
    protected global: Globals
  ) {
    super(
      http
      , modal
      , viewref
      , el
      , global
    );
  }

  public boList: Array<any> = [];
  public etpList: Array<any> = [];

  @Input("orderHeader") orderHeader: any;

  ngOnInit() {
    if (this.orderHeader) {
      this.GetBOList();
      this.GetETPList();
    }
  }

  GetBOList() {
    this.http.get("SL", "SNSE004_GetBOList", this.orderHeader.CUSTOMER_CODE, this.orderHeader.BRANCH_CODE, this.orderHeader.ORDER_NO, this.global.ConvertDateToFormatSTD(this.orderHeader.ORDER_DATE))
      .subscribe(result => {
        this.boList = result.Table;
      })
  }

  GetETPList() {
    this.http.get("SL", "SNSE004_GetETPList", this.orderHeader.CUSTOMER_CODE, this.orderHeader.BRANCH_CODE, this.orderHeader.ORDER_NO, this.global.ConvertDateToFormatSTD(this.orderHeader.ORDER_DATE))
      .subscribe(result => {
        this.etpList = result.Table;
      })
  }
}
