import {
  Component,
  OnInit,
  ElementRef,
  ViewChild,
  ViewContainerRef,
  CUSTOM_ELEMENTS_SCHEMA,
} from "@angular/core";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "../../../core/modal.service";
import {
  DateAdapter,
  MAT_DATE_FORMATS,
  MAT_DATE_LOCALE,
} from "@angular/material/core";
import {
  MAT_MOMENT_DATE_ADAPTER_OPTIONS,
  MomentDateAdapter,
} from "@angular/material-moment-adapter";
import * as moment from "moment";
import { FormControl, Validators } from "@angular/forms";
import { Globals } from "src/app/core/global";

@Component({
  selector: "SNSE226",
  templateUrl: "./SNSE226.component.html",
  styleUrls: ["./SNSE226.component.css"],
})
export class SNSE226Component implements OnInit {
  @ViewChild("fileUpload") fileUpload: ElementRef;

  public filename: string = "";
  public extension: string = "";
  public file: any;

  public files: any = [];
  public tableUpload: any = [];
  public error_list: any = [];

  constructor(
    public http: HttpService,
    public modal: ModalService,
    public global: Globals,
    public viewRef: ViewContainerRef
  ) {}

  public param: any = {};

  public tableData: any = [];
  public tableSuccess: any = [];
  public tableSuccess1: any = [];
  public tableSuccess2: any = [];
  public params: any = {};

  public dataView: any = {};

  public todayDate: Date = new Date();
  public showSuccess: Boolean;
  public showList: Boolean;
  public showListDetail: Boolean;
  public editMode: any;
  public total_error: number = 0;
  public partNumber: string;
  public countMSG: number = 0;
  SetPartNoControl = new FormControl("", [Validators.required]);
  SetPartTypeControl = new FormControl("", [Validators.required]);
  public hideCols: Array<string> = [];
  CustomerCodeControl = new FormControl("", [Validators.required]);
  SEQControl = new FormControl("", [Validators.required]);

  @ViewChild("dialogAdd", { static: false }) dialogAdd: any;
  @ViewChild("dialogEdit", { static: false }) dialogEdit: any;
  @ViewChild("dialog", { static: false }) dialog: any;

  public ParamEdit: any = {};
  public ParamEdit_Ex: any = {};
  public ParamAdd: any = {};
  public Chkdis: any = {};
  public tabledataEdit: any = [];

  ngOnInit(): void {
    this.showSuccess = false;
    this.showList = true;
    this.showListDetail = false;
    this.Chkdis = false;
    // this.params.FROM_DATE = new Date("October 1, 2020 07:00:00");
    // this.params.TO_DATE = new Date();
  }



  public lookupBranchCodeAddConfig: any = {
    ColName: "LOOKUP_BRANCH_CODE",
    PlaceholderText: "Select Branch Code",
    SourceController: "wPMS",
    SourceMethodName: "SNM166_GetBranchCodeForAdd",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      CUSTOMER_CODE: "",
    },
    UpperCase: true,
  };

  public lookupBranchCodeConfig: any = {
    ColName: "LOOKUP_BRANCH_CODE",
    PlaceholderText: "Select Branch Code",
    SourceController: "wPMS",
    SourceMethodName: "SNSE226_GetBranchCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      CUSTOMER_CODE: "",
    },
    UpperCase: true,
  };

  public lookupCustomerCodeAddConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "wPMS",
    SourceMethodName: "SNM166_GetCustomerCodeForAdd",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
  };

  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "wPMS",
    SourceMethodName: "SNSE226_GetCustomerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
  };

  public SetSelectedCustomerCode(value: any) {
    this.params.CUSTOMER_CODE = value.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = value.CUSTOMER_NAME;
    // this.params.BRANCH_CODE = value.BRANCH_CODE;
    
    this.lookupBranchCodeConfig.SourceParams.CUSTOMER_CODE = value.CUSTOMER_CODE;
    this.ConfigOrderNo.SourceParams.CUSTOMER_CODE = value.CUSTOMER_CODE;
  }

  public SetSelectedCustomerCodeAdd(value: any) {
    this.ParamAdd.CUSTOMER_CODE = value.CUSTOMER_CODE;
    this.ParamAdd.CUSTOMER_NAME = value.CUSTOMER_NAME;
    this.lookupBranchCodeAddConfig.SourceParams.CUSTOMER_CODE =
      value.CUSTOMER_CODE;
  }
  public SetSelectedBranchCode(value: any) {
    this.params.BRANCH_CODE = value.BRANCH_CODE;
    this.params.BRANCH_NAME = value.BRANCH_NAME;
    this.ConfigOrderNo.SourceParams.CUSTOMER_CODE = this.params.CUSTOMER_CODE;
    this.ConfigOrderNo.SourceParams.BRANCH_CODE = value.BRANCH_CODE;
  }

  public SetSelectedBranchCodeAdd(value: any) {
    
    this.ParamAdd.BRANCH_CODE = value.BRANCH_CODE;
    this.ParamAdd.BRANCH_NAME = value.BRANCH_NAME;
    
  }

  public ConfigOrderNo: any = {
    ColName: "ORDER_NO",
    PlaceholderText: "Select Order No",
    SourceController: "wPMS",
    SourceMethodName: "SNSE226_GetOrderNo",
    NoOfShowRecords: 60,
    MinLengthSearch: 0,
    SourceParams: {
      CUSTOMER_CODE: "",
      BRANCH_CODE: "",
    },
    UpperCase: true
  }

  public SetSelectedOrderNo(value: any) {
    this.params.ORDER_NO = value.ORDER_NO;
    
  }



  public OpenFileBrowser() {
    this.filename = "";
    this.fileUpload.nativeElement.value = "";
    this.fileUpload.nativeElement.click();
  }



  public Upload() {
    let formData = new FormData();
    formData.append("file", this.files[0]);
    this.http.postFile("wPMS", "SNM166_Upload", formData).subscribe(
      (res) => {
        this.tableUpload = res.filter((x) => x.CUSTOMER_CODE);
      },
      (err) => {
        console.log(err, "err");
        this.modal.warning(
          "Found an error, please contact support team",
          this.viewRef
        );
      }
    );
  }

  public GetMasterDetail() {

    this.http.post("wPMS", "SNSE226_GetData_Master", this.params).subscribe(
      (res) => {
        this.tableData = res.Table;
      },
      (err) => {
        console.log(err, "err");
        this.modal.warning(
          "Found an error, please contact support team",
          this.viewRef
        );
        return;
      }
    );
  }

  public CancelEditModeSupplier() {
    this.params = {};
    this.editMode = false;
  }


  public BackToFirst() {
    this.showList = true;
    this.showListDetail = false;
    this.GetMasterDetail();
  }
  OpendatePopup(datepicker) {
    datepicker.open();
  }

  public EditRow(data) {
  

    this.http.post("wPMS", "SNSE226_GetView_Data", data).subscribe(
      (res) => {
        this.dataView = res.Table[0];
        this.dataView.CUSTOMER_CODE = data.CUSTOMER_CODE;
        this.dataView.CUSTOMER_NAME = data.CUSTOMER_NAME;
        this.dataView.BRANCH_CODE = data.BRANCH_CODE;
        this.dataView.BRANCH_NAME = data.BRANCH_NAME;
        this.dataView.CUSTOMER_TEXT = data.CUSTOMER_TEXT;
        this.dataView.ORDER_NO = data.ORDER_NO;
        this.dataView.ITEM_NO = data.ITEM_NO;
        this.dataView.SUB_ITEM_NO = data.SUB_ITEM_NO;
       //this.dataView.ORDER_PART_NO = data.ORDER_PART_NO;
        this.dataView.ORDER_CLASS = data.ORDER_CLASS;
       // this.dataView.ORDER_DATE = data.ORDER_DATE;
      
      },
      (err) => {
        console.log(err, "err");
        this.modal.warning(
          "Found an error, please contact support team",
          this.viewRef
        );
        return;
      }
    );


    this.SetPartNoControl.reset();
    this.dialogEdit.OpenDialog();
    this.tabledataEdit = [];
  }

  public CancelAdd() {
    this.dialogAdd.Close();
  }

  public CancleEdit() {
    this.dialogEdit.Close();
  }

  public Report() {
    this.global.GoToReport("PMS_RPT_CSI_SNSE226",
      {     
        P_FROM_DATE: this.global.ConvertDateToFormatSTD(this.params.FROM_DATE),
        P_TO_DATE: this.global.ConvertDateToFormatSTD(this.params.TO_DATE),
      }
    );
  }


  public Delete(data) {
    const dateparam = {
      CUSTOMER_CODE: data.CUSTOMER_CODE,
      BRANCH_CODE: data.BRANCH_CODE,
      START_DATE: moment(data.START_DATE).format("YYYY-MM-DD"),
      END_DATE: moment(data.END_DATE).format("YYYY-MM-DD"),
    };
    this.modal.confirm(
      "Do you want to delete this record?",
      this.viewRef,
      () => {
        this.http.post("wPMS", "SNM166_Delete", dateparam).subscribe((res) => {
          if (res.STATUS_MSG == "DONE") {
            this.modal.info(
              "Transaction complete: 1 record applied and deleted.",
              this.viewRef
            );
            this.GetMasterDetail();
          } else {
            this.modal.warning(
              "No change to save. Something went wrong.",
              this.viewRef
            );
          }
        });
      }
    );
  }

  public Clear() {
    this.params = {};
    this.tableData = [];
    this.GetMasterDetail();
  }
}
