import { async } from '@angular/core/testing';
//import { resolve } from 'dns';
//import { Subscription } from 'rxjs';
import { Component, OnInit, Input, Output, EventEmitter, ElementRef, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { ModalService } from '../../../core/modal.service';
import { Globals } from '../../../core/global';
import * as moment from 'moment';
import { MatTabGroup } from '@angular/material/tabs';
import { ActivatedRoute } from '@angular/router';
//import { error } from '@angular/compiler/src/util';
//import { promise } from 'protractor';
//import { rejects } from 'assert';

@Component({
  selector: 'snm123',
  templateUrl: './snm123.component.html',
  styleUrls: ['../exportbiz.component.css']
})


export class SNM123Component implements OnInit {

  @ViewChild("SNM124", { static: false }) SNM124: any;
  @ViewChild("SNM032E", { static: false }) SNM032E: any;

  public params: any = {};
  public params2: any = {};
  public params3: any = {};
  public params4: any = {};
  public dataEdit: any = {};

  public datatable: any = [];
  public groupList: any = [];
  public dataModel: any = [];
  public dataPrice: any = {};
  public dataEditModel: any = {};
  public dataUploadList: any = [];
  public currentDate: moment.Moment = moment();

  public data: any = {};
  public iShow: number = 1;

  public ListLog: any = [];
  public ListTrackLog: any = [];
  public files: any = [];
  public fileName: string = "";
  public isUpload: any = "";
  public dataUpload: any = [];
  public iTab: number = 1;

  public filesAnnual: any = [];
  public fileNameAnnual: string = "";
  public dataUploadAnnual: any = [];

  @ViewChild("fileUpload") fileUpload: ElementRef;
  @ViewChild("fileUploadExcel") fileUploadExcel: ElementRef;
  @ViewChild("dialog", { static: false }) dialog: any;

  public filePrice: string = "";
  public filePriceExcel: string = "";
  public file: any;
  public extension: string = "";

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private auth: AuthDecode,
    private global: Globals,
    private route: ActivatedRoute
  ) { }

  @ViewChild("dialogMain", { static: false }) dialogMain: any;
  @ViewChild("dialogEdit", { static: false }) dialogEdit: any;
  @ViewChild("dialogModel", { static: false }) dialogModel: any;
  @ViewChild("dialogLog", { static: false }) dialogLog: any;
  @ViewChild("dialogTrackLog", { static: false }) dialogTrackLog: any;
  @ViewChild("dialogEditModel", { static: false }) dialogEditModel: any;
  @ViewChild("mainTab", { static: false }) mainTab: MatTabGroup;

  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNM123_GetCustomer",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedCustomerCode(value: any) {
    this.params.CUSTOMER_CODE = value.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = value.CUSTOMER_NAME;
    this.params.CURRENCY_CODE = value.CURRENCY_CODE;
    this.Search();
  }

  public SetSelectedCustomerCode2(value: any) {
    this.params2.CUSTOMER_CODE = value.CUSTOMER_CODE;
    this.params2.CUSTOMER_NAME = value.CUSTOMER_NAME;
    this.params2.CURRENCY_CODE = value.CURRENCY_CODE;
  }

  public SetSelectedCustomerCode3(value: any) {
    this.params3.NON_CON_FLAG = 'N';
    this.params3.CUSTOMER_CODE = value.CUSTOMER_CODE;
    this.params3.CUSTOMER_NAME = value.CUSTOMER_NAME;
    this.params3.CURRENCY_CODE = value.CURRENCY_CODE;
    this.params3.CONSOLIDATE_FLAG = value.CONSOLIDATE_FLAG;
  }

  public SetSelectedCustomerCode3_SEARCH(value: any) {
    this.params3.CUSTOMER_CODE_SEARCH = value.CUSTOMER_CODE;
    // this.Init3();
  }
  public lookupPartNoConfig: any = {
    ColName: "LOOKUP_PART_NAME",
    PlaceholderText: "Select Part Code",
    SourceController: "SL",
    SourceMethodName: "SNM123_GetPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 3,
    UpperCase: true
  }

  public SetSelectedPartNo(value: any) {
    this.params2.PART_NO = value.PART_NO;
    this.params2.PART_NAME = value.PART_NAME;
  }

  public SetSelectedPartNo3(value: any) {
    this.params3.PART_NO = value.PART_NO;
    this.params3.PART_NAME = value.PART_NAME;
  }

  ngOnInit() {
    this.iTab = 1;
    this.params.NON_CON_FLAG = 'N';
    this.Init2();
    //this.Init3();
    this.Init4();
  }

  changeMatTab(index: number){
    const tabGroup = this.mainTab;
    if (!tabGroup || !(tabGroup instanceof MatTabGroup)) return;
    else tabGroup.selectedIndex = index;;
  }

  public Search = () => {
    this.iTab = 1;
    this.params.FILTER_NO = 1;
    this.http.post('SL', 'SNM123_GetData', this.params)
      .subscribe(res => {
        this.datatable = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public EditData(data) {
    data.RECAL_FLAG = 'N';
    this.dataEdit = data;
    this.dataEdit.EFFECTIVE_DATE = this.currentDate;
    this.ShowCalculation(data);
  }

  private ShowCalculation(data) {
    this.dataPrice = {};
    this.http.post('SL', 'SNM123_GetExportPriceInfo', data)
      .subscribe(res => {
        //console.log('ShowCalculation',res.Table);
        this.dataPrice = res.Table[0];
        const partType: string = this.dataPrice.PART_TYPE || "";
        const message: string = this.dataPrice.V_MSG || "";
      
        if (message != '' && message != null && message != "null") {
          const isCurrentFob = partType.toLowerCase().includes(('Current FOB P/N').toLowerCase());
          const isCalculatByExchange = message.toLowerCase().includes(('Calculate by exchange rate').toLowerCase());
          
          if(this.mainTab.selectedIndex == 1 && isCurrentFob){
            //do not return
          }
          else if(this.mainTab.selectedIndex == 2 && isCalculatByExchange){
            //do not return
          }
          else{
            this.modal.warning(this.dataPrice.V_MSG, this.viewRef);
            return;
          }
        } 
        
        if (this.dataPrice.CUSTOMER_TYPE == 'Consolidated NSC') {
          //-- Consolidated
          this.iShow = 1;
          this.dialogMain.OpenDialog();
        } else if (this.dataPrice.PART_TYPE == '' || this.dataPrice.PART_TYPE == null) {
          //-- Non Consolidated use GLP
          this.iShow = 2;
          this.dialogMain.OpenDialog();
        } else if (this.dataPrice.PART_TYPE.substring(0, 3) == 'Fix') {
          //-- Non Consolidated use Fix , FOB < ISC
          this.iShow = 3;
          this.dialogMain.OpenDialog();
        } else if (this.dataPrice.PART_TYPE.substring(0, 3) == 'xxxxx') {
          //-- Non Consolidated use Fix , FOB < ISC
          this.iShow = 3;
          this.dialogMain.OpenDialog();
        }else {
          //-- Non Consolidated use Part type
          if(this.mainTab.selectedIndex == 1){
            const newdata = {
              CURRENCY_CODE: this.dataPrice.CURRENCY_CODE,
              NEW_SETTING: this.dataPrice.NEW_SETTING,
            }
            const parms = {...data,...newdata};
            if(this.dataPrice.PART_TYPE == 'Current FOB P/N'){
              this.modal.confirm(this.dataPrice.V_MSG + ', do you want to make new setting?', this.viewRef
              ,() => {
                this.iTab = 22;
                parms.NEW_SETTING = 'Y';
                this.InsertSettingTemp(parms,data);
              }
              ,() => {
                this.iTab = 22;
                parms.NEW_SETTING = 'N';
                this.InsertSettingTemp(parms,data);
              });
            }
            else{
              this.iShow = 4;
              this.dialogMain.OpenDialog();
            }
          }
          else{
            this.iShow = 4;
            this.dialogMain.OpenDialog();
          }
        }
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning(err.error, this.viewRef);
      })
  }

  private InsertSettingTemp(parms,data){
    this.http.post('SL', 'SNM123_InsertSettingTemp', parms)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          //this.iShow = 4;
          //this.dialogMain.OpenDialog();
          this.ShowCalculation(data);
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public ConfirmSave() {
    this.modal.confirm('Do you want to confirm this price?', this.viewRef, this.Save)
  }

  private Save = () => {

    this.dataEdit.NEW_PRICE = this.dataPrice.NEW_PRICE;
    this.http.post('SL', 'SNM123_Save', this.dataEdit)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.dataPrice.FORMER_PRICE = this.dataPrice.NEW_PRICE;
          this.modal.info('Save successfully new price', this.viewRef);
          this.dialogMain.Close();
          this.Search();
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public Recalculate() {
    this.dataEdit.RECAL_FLAG = 'Y';

    this.dataEdit.CFG_ACCESSORIES = this.dataPrice.CFG_ACCESSORIES;
    this.dataEdit.CFG_COUNTERMESURE = this.dataPrice.CFG_COUNTERMESURE;
    this.dataEdit.CFG_PRODUCTION_COUNTRY = this.dataPrice.CFG_PRODUCTION_COUNTRY;
    this.dataEdit.CFG_LOGISTICS = this.dataPrice.CFG_LOGISTICS;
    this.dataEdit.CFG_PROCUREMENT = this.dataPrice.CFG_PROCUREMENT;
    this.dataEdit.CFG_FIX = this.dataPrice.CFG_FIX;

    this.http.post('SL', 'SNM123_GetExportPriceInfo', this.dataEdit)
      .subscribe(res => {
        this.dataPrice = res.Table[0];

      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  
  //#region ---------------- Tab 2 ------------------
  
  private Init2() {
    var dataParam = {};
    this.http.post('SL', 'SNM123_GetUploadData', dataParam)
      .subscribe(res => {
        this.dataUpload = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public SearchUpload(){
    this.Init2();
  }

  public ShowCalculate() {

    if (this.params2.CUSTOMER_CODE == '' || this.params2.CUSTOMER_CODE == null) {
      this.modal.warning("Please select Customer code", this.viewRef);
      return;
    }
    if (this.params2.PART_NO == '' || this.params2.PART_NO == null) {
      this.modal.warning("Please select Part no.", this.viewRef);
      return;
    }

    this.iTab = 20;

    this.params2.ORDER_DATE = this.currentDate;
    this.params2.RECAL_FLAG = 'N';

    this.dataEdit = this.params2;
    this.dataEdit.EFFECTIVE_DATE = this.currentDate;
    this.ShowCalculation(this.params2);

  }


  public OnFileSelect(fileInput) {
    this.files = fileInput.target.files;
    this.fileName = this.files[0].name;
    console.log('this.files', this.files);
  }

  public Upload() {
    this.modal.confirm('The new upload will clear the current data. Do you want to new upload?', this.viewRef, this.ActionUpload)
  }

  public ActionUpload = () => {

    if (this.files.length == 0) {
      this.modal.error('Please Open xlsx...', this.viewRef)
    } else {
      // this.data = []
      let formData = new FormData();


      formData.append('file', this.files[0]);

      this.http.postFile('SL', 'SNM123_Upload', formData)
        .subscribe(res => {
          this.http.get("wPMS", "GetTrackLog", 'TEMP', 'SP_NP_SNM123_EXPORT_PRICE_INFO')
            .subscribe(result => {
              console.log(result)
              if (result.Table.length > 0) {
                this.ListTrackLog = result.Table;
                this.dialogTrackLog.OpenDialog();
              } else {
                if (res.Error.length > 0) {
                  this.ListLog = res.Error;
                  this.dialogLog.OpenDialog();
                } else {
                  this.GetUploadDataSP();
                }
              }
            })
        }, (err) => {
          console.log('err', err)
          this.http.get("wPMS", "GetTrackLog", 'TEMP', 'SP_NP_SNM123_EXPORT_PRICE_INFO')
            .subscribe(result => {
              console.log(result)
              if (result.Table.length > 0) {
                this.ListTrackLog = result.Table;
                this.dialogTrackLog.OpenDialog();
              } else {
                this.modal.error("Upload error", this.viewRef);
              }
            })
        })
    }
  }

  private GetUploadDataSP() {
    this.http.post('SL', 'SNM123_GetUploadData', this.dataEdit)
      .subscribe(res => {
        this.dataUpload = res.Table;
        this.modal.info("Upload complete", this.viewRef)
        this.fileName = '';
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })

  }

  public SaveAdd() {

  }

  public CancelAdd() {
    this.dialogEdit.Close();
  }

  public EditUpload(data) {
    this.iTab = 21;
    this.dataEdit = data;
    //this.dataEdit.EFFECTIVE_DATE = this.currentDate;
    data.RECAL_FLAG = 'N';
    data.ORDER_DATE = this.currentDate;

    this.ShowCalculation(data);
  }


  public ConfirmDeleteUpload(data) {

    this.modal.confirm('Do you want to delete record?', this.viewRef, () => this.DeleteUpload(data))
  }

  private DeleteUpload = (data) => {
    this.http.post('SL', 'SNM123_DeleteUploadSP', data)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Transaction complete: applied and saved.', this.viewRef);
          this.http.post('SL', 'SNM123_GetUploadData', this.dataEdit)
            .subscribe(res => {
              this.dataUpload = res.Table;
            }, (err) => {
              console.log(err, 'err')
              this.modal.warning("Found an error, please contract support team", this.viewRef);
            })
        } else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewRef);
        }
      }, (err) => {
        console.log('err', err)
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }



  public EditTempSP() {
    this.modal.confirm('Do you want to edit this date?', this.viewRef, this.SaveToTemp)
  }

  public AddToTemp() {
    this.modal.confirm('Do you want to add this price to temp?', this.viewRef, this.SaveToTemp)
  }

  private SaveToTemp = () => {
    this.dataEdit.NEW_PRICE = this.dataPrice.NEW_PRICE;
    this.dataEdit.CFG_ACCESSORIES = this.dataPrice.CFG_ACCESSORIES;
    this.dataEdit.CFG_COUNTERMESURE = this.dataPrice.CFG_COUNTERMESURE;
    this.dataEdit.CFG_PRODUCTION_COUNTRY = this.dataPrice.CFG_PRODUCTION_COUNTRY;
    this.dataEdit.CFG_LOGISTICS = this.dataPrice.CFG_LOGISTICS;
    this.dataEdit.CFG_PROCUREMENT = this.dataPrice.CFG_PROCUREMENT;
    this.dataEdit.CFG_FIX = this.dataPrice.CFG_FIX;

    this.http.post('SL', 'SNM123_SaveToTemp', this.dataEdit)
      .subscribe(res => {
        if (res.Result == 'DONE') {
          this.Init2();
          this.modal.info('Save successfully', this.viewRef);
          this.dialogMain.Close();
          // if(this.mainTab.selectedIndex == 1){
          //   this.modal.info('Save successfully', this.viewRef);
          //   this.dialogMain.Close();
          // }
          // else{
          //   this.iTab = 21;
          //   this.changeMatTab(1);
          // }
        }
        else if (res.Result == 'DUPLICATE') {
          this.modal.warning("Duplicate part no and customer", this.viewRef);
        } else {

          this.modal.warning("Found an error, please contract support team", this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public ConfirmSP() {
    this.modal.confirm('Do you want to save the all new price?', this.viewRef, this.ConfirmSupplement)
  }

  private ConfirmSupplement = () => {
    var para: any = {};

    para.FILE_NAME = 'SP';

    this.http.post("SL", "SNM123_Save_Confirm", para)
      .subscribe(result => {
        if (result = 'DONE') {
          this.modal.info("Confirm upload price completed.", this.viewRef);
          this.http.post('SL', 'SNM123_GetUploadData', this.dataEdit)
            .subscribe(res => {
              this.dataUpload = res.Table;
            }, (err) => {
              console.log(err, 'err')
              this.modal.warning("Found an error, please contract support team", this.viewRef);
            })
        } else {
          this.modal.error("Found eror, please contact support team.", this.viewRef);
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      })
  }

  //#endregion


  //#region ---------------- Tab 3 ------------------
  
  private Init3() {
    var dataParam = {
      CUSTOMER_CODE: this.params3.CUSTOMER_CODE_SEARCH
    };
    //this.params3.NO_OF_MONTH = 24;

    //this.http.post('SL', 'SNM123_GetGroupList', dataParam)
    //  .subscribe(res => {
    //    this.groupList = res.Table;
    //  }, (err) => {
    //    console.log(err, 'err')
    //    this.modal.warning("Found an error, please contract support team", this.viewRef);
    //  })


    this.http.post('SL', 'SNM123_Annual_GetUploadData', dataParam)
      .subscribe(res => {
        this.dataUploadAnnual = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })

  }

  public SearchUploadAnnual(){
    this.Init3();
  }

  public ShowCalculate3() {

    if (this.params3.CUSTOMER_CODE == '' || this.params3.CUSTOMER_CODE == null) {
      this.modal.warning("Please select Customer code", this.viewRef);
      return;
    }
    if (this.params3.PART_NO == '' || this.params3.PART_NO == null) {
      this.modal.warning("Please select Part no.", this.viewRef);
      return;
    }

    this.iTab = 30
    this.params3.ORDER_DATE = this.currentDate;
    this.params3.RECAL_FLAG = 'N';

    this.dataEdit = this.params3;
    this.dataEdit.EFFECTIVE_DATE = this.currentDate;
    this.ShowCalculation(this.params3);

  }

  public OnFileSelectAnnual(fileInput) {
    this.filesAnnual = fileInput.target.files;
    this.fileNameAnnual = this.filesAnnual[0].name;
  }


  public UploadAnnual() {
    this.modal.confirm('The new upload will clear the current data. Do you want to new upload?', this.viewRef, this.ActionUploadAnnual)
  }

  public ActionUploadAnnual = () => {

    if (this.filesAnnual.length == 0) {
      this.modal.error('Please Open xlsx File First...', this.viewRef)
    } else {
      // this.data = []
      let formData = new FormData();
      formData.append('file', this.filesAnnual[0]);

      this.http.postFile('SL', 'SNM123_Annual_Upload', formData)
        .subscribe(res => {

          this.http.get("wPMS", "GetTrackLog", 'TEMP', 'SP_NP_SNM123_EXPORT_PRICE_INFO')
            .subscribe(result => {
              if (result.Table.length > 0) {
                this.ListTrackLog = result.Table;
                this.dialogTrackLog.OpenDialog();
              } else {
                this.GetUploadDataAN();
              }
            })
        }, (err) => {
          console.log('err', err)
          //this.http.get("wPMS", "GetTrackLog", 'TEMP', 'SP_NP_SNM123_EXPORT_PRICE_INFO')
          //  .subscribe(result => {
          //    console.log(result)
          //    if (result.Table.length > 0) {
          //      this.ListTrackLog = result.Table;
          //      this.dialogTrackLog.OpenDialog();
          //    } else {
          //      this.modal.error("Upload error", this.viewRef);
          //    }
          //  })
        })
    }
  }

  private GetUploadDataAN() {
    this.http.post('SL', 'SNM123_Annual_GetUploadData', this.dataEdit)
      .subscribe(res => {
        this.dataUploadAnnual = res.Table;
        this.fileNameAnnual = '';
        this.modal.info("Upload complete", this.viewRef)
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })

  }


  public CancelAddAnnual() {
    this.dialogEdit.Close();
  }

  public EditUploadAnnual(data) {
    this.iTab = 31;
    this.dataEdit = data;
    data.RECAL_FLAG = 'N';
    data.ORDER_DATE = data.EFFECTIVE_DATE;
    // this.dataEdit.EFFECTIVE_DATE = this.currentDate;
    
    const partType: string = this.data.PART_TYPE || "";
    if(data.Q_CONSOLIDATE == "N" && partType.toLowerCase().includes(('Current FOB P/N').toLowerCase())){
      const parms = {...data, ...{ NEW_SETTING: 'Y' }};
      this.InsertSettingTemp(parms, data);
    }
    else{
      this.ShowCalculation(data);
    }
  }

  public EditTempAN() {
    this.modal.confirm('Do you want to edit this date?', this.viewRef, this.SaveToTempAnnual)
  }

  public AddToTempAnnual() {
    this.modal.confirm('Do you want to add this price?', this.viewRef, this.SaveToTempAnnual)
  }


  private SaveToTempAnnual = () => {
    this.dataEdit.NEW_PRICE = this.dataPrice.NEW_PRICE;
    this.http.post('SL', 'SNM123_Annual_SaveToTemp', this.dataEdit)
      .subscribe(res => {
        if (res.Result == 'DONE') {
          //this.Init3();
          this.modal.info('Save successfully', this.viewRef);
          this.dialogMain.Close();
        } else {
          console.log('Error : ', res.Result);
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        }
      }, (err) => {
        console.log('Error : ', err)
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }


  public FetchData = () => {

    if (this.params3.CUSTOMER_CODE == null || this.params3.CUSTOMER_CODE == undefined) {
      this.modal.warning("Please input the Customer code", this.viewRef);
      return;
    }

    if (this.params3.EFFECTIVE_DATE == null || this.params3.EFFECTIVE_DATE == undefined) {
      this.modal.warning("Please input the Effective date", this.viewRef);
      return;
    }
    // this.modal.confirm('Are you sure to Fetch the new data?', this.viewRef, this.FetchStart);


    this.modal.confirm("Are you sure to Fetch the new data?", this.viewRef, () => {
      this.http.post('SL', 'SNM123_Annual_Fetch', this.params3)
        .subscribe(res => {
          if (res.Result == 'DONE') {
            this.params3.CUSTOMER_CODE_SEARCH = this.params3.CUSTOMER_CODE;
            this.Init3();
          } else {
            console.log(res.Result);
            this.modal.warning("Found an error, please contract support team", this.viewRef);
          }
        }, (err) => {
          console.log('err', err)
          //this.http.get("wPMS", "GetTrackLog", 'TEMP', 'SP_NP_SNM123_EXPORT_PRICE_INFO')
          //  .subscribe(result => {
          //    if (result.Table.length > 0) {
          //      this.ListTrackLog = result.Table;
          //      this.dialogTrackLog.OpenDialog();
          //    } else {
          //      this.modal.error("Upload error", this.viewRef);
          //    }
          //  })
        })
    });

  }

  public ClearData(){
    let message = "";
    
    if (this.params3.EFFECTIVE_DATE == null || this.params3.EFFECTIVE_DATE == undefined) {
      this.modal.warning("Please input the Effective date", this.viewRef);
      return;
    }
    
    // this.modal.confirm('Are you sure to Fetch the new data?', this.viewRef, this.FetchStart);
    if(this.params3.CUSTOMER_CODE == null || this.params3.CUSTOMER_CODE == undefined){
      message = "Are you sure to clear all the fetch data?" + "</br>Customer code : All";
    }else{
      message = "Are you sure to clear off the fetch data?" + "</br>Customer code : " + this.params3.CUSTOMER_CODE;
    }

    this.modal.confirm(message, this.viewRef, () => {
      this.http.post('SL', 'SNM123_Annual_Clear', this.params3)
        .subscribe(res => {
          if (res.Result == 'DONE') {
            this.params3.CUSTOMER_CODE_SEARCH = this.params3.CUSTOMER_CODE;
            this.Init3();
          } else {
            console.log(res.Result);
            this.modal.warning("Found an error, please contract support team", this.viewRef);
          }
        }, (err) => {
          console.log('err', err)
          //this.http.get("wPMS", "GetTrackLog", 'TEMP', 'SP_NP_SNM123_EXPORT_PRICE_INFO')
          //  .subscribe(result => {
          //    if (result.Table.length > 0) {
          //      this.ListTrackLog = result.Table;
          //      this.dialogTrackLog.OpenDialog();
          //    } else {
          //      this.modal.error("Upload error", this.viewRef);
          //    }
          //  })
        })
    });

  }


  public ConfirmAN() {
    this.modal.confirm('Do you want to save the all new price?', this.viewRef, this.ConfirmAnnual)
  }

  private ConfirmAnnual = () => {
    var para: any = {};

    para.FILE_NAME = 'AN';

    this.http.post("SL", "SNM123_PR_Confirm", para)
      .subscribe(result => {
        if (result = 'DONE') {
          this.modal.info("Confirm upload price completed.", this.viewRef);
          this.http.post('SL', 'SNM123_Annual_GetUploadData', this.dataEdit)
            .subscribe(res => {
              this.dataUploadAnnual = res.Table;
            }, (err) => {
              console.log(err, 'err')
              this.modal.warning("Found an error, please contract support team", this.viewRef);
            })
        } else {
          this.modal.error("Found eror, please contact support team.", this.viewRef);
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      })
  }


  public CheckOption(event) {
    if (event.checked) {
      this.params3.NON_CON_FLAG = 'Y';
    }
    else {
      this.params3.NON_CON_FLAG = 'N';
    }
  }


  //#endregion


  //#region ---------------- Tab 4 ------------------

  private Init4() {
    this.params4 = {};
    this.http.get('SL', 'SNM123_GetModelConfigure')
      .subscribe(res => {
        this.dataModel = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public SearchModel(){
    this.Init4();
  }

  public AddNewModel() {

    if (this.params4.MODEL_NAME == '' || this.params4.BASE_MODEL == '' || this.params4.ITP_TYPE == '') {
      this.modal.warning("Please input the Main model/Base model/Type", this.viewRef);
      return;
    }

    this.modal.confirm("Are you sure to add new model config?", this.viewRef, () => {
      this.http.post('SL', 'SNM123_Add_Model', this.params4)
        .subscribe(res => {
          if (res == 'DONE') {
            this.Init4();
            this.modal.info('Save successfully', this.viewRef);
          } else if (res == 'DUPLICATE') {
            this.modal.warning("This model :" + this.params4.MODEL_NAME + " is duplicated ", this.viewRef);
          } else {
            console.log(res);
            this.modal.warning("Found an error, please contract support team", this.viewRef);
          }
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })
    });

  }

  //#endregion


  //-----------------------------------------------
  public DownloadTemplate() {
    let link = "assets/templates/PMS_Price_Revision_template.xlsx"
    window.open(link, '_blank')
  }

  public DownloadTemplatePR() {
    let link = "assets/templates/PMS_Upload_Price_Template.xlsx"
    window.open(link, '_blank')
  }
  public GoToReport(pReportNo) {
    if (pReportNo == 2) {
      this.global.GoToReport("PMS_RPT_SALES_SNM123_SP", {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_CREATE_BY: this.global.GetTokenDetail("ssUserID")
      })

    } else if (pReportNo == 3) {
      this.global.GoToReport("PMS_RPT_SALES_SNM123_AN", {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_CUSTOMER_CODE: this.params3.CUSTOMER_CODE_SEARCH,
        P_CREATE_BY: this.global.GetTokenDetail("ssUserID")
      })
    }
    else if (pReportNo == 4) {
      this.global.GoToReport("PMS_RPT_SALES_SNM123_SP_UPLOAD", {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_CREATE_BY: this.global.GetTokenDetail("ssUserID")
      })
    } else if (pReportNo == 5) {
      this.global.GoToReport("PMS_RPT_SALES_SNM123_AN_UPLOAD", {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_CREATE_BY: this.global.GetTokenDetail("ssUserID")
      })
    }

  }
  //-----------------------------------------------


  //#region ---------------- Tab 7 ------------------

  public OpenFileBrowser() {
    this.filePrice = "";
    this.fileUpload.nativeElement.value = '';
    this.fileUpload.nativeElement.click();
  }

  public OpenFileBrowserExcel() {
    this.filePriceExcel = "";
    this.fileUploadExcel.nativeElement.value = '';
    this.fileUploadExcel.nativeElement.click();
  }

  public SelectFile(evt) {
    this.extension = null;
    var ext = evt.target.files[0].name
    this.extension = (ext.substr(ext.lastIndexOf('.') + 1))
    console.log(this.extension)
    this.file = null;
    let Files: Array<File> = evt.target.files;

    if (Files.length > 0) {
      //let File: File = Files[0];
      this.file = Files[0];
      this.filePrice = this.file.name;
    }
  }

  //#endregion


  Preview() {

    if (!this.filePrice) {
      this.modal.warning("Please open the file...", this.viewRef)
      return;
    }
    if (this.extension == 'txt') {
    let formData = new FormData();
    formData.append('file', this.file);
    //this.StartDate = +new Date;

    // console.log('this.filePrice', this.filePrice);
    this.http.postFile("SL", "SNSE123_UploadFile", formData)
      .subscribe(result => {

        this.dataUploadList = result.Table;
        //this.filePrice = '';
        this.modal.info("Upload " + this.filePrice + " completed.", this.viewRef);

      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      })
    }
    else if (this.extension == 'xlsx') {
      let formData = new FormData();
      formData.append('file', this.file);
      this.http.postFile("SL", "SNM123_PR_UploadExcel", formData)
        .subscribe(result => {
          this.modal.info("Upload " + this.filePrice + " completed.", this.viewRef);
          this.http.get("SL", "SNM123_PR_GetData")
            .subscribe(result => {
              this.isUpload = true;
              this.dataUploadList = result.Table;
              console.log("this.dataUploadList >> ",this.dataUploadList);
            })
        }, err => {
          console.log(err);
          this.modal.error("Found eror, please contact support team.", this.viewRef);
        })
    } else {
      this.modal.warning("Filename extension is invalid, Please check!", this.viewRef);
    }
  }

  public CheckErrMsg() {
    let foundErr = this.dataUploadList.some(x => x.ATTRIBUTE1)
    if (foundErr) {
      return true;
    }
    else {
      return false;
    }
  }


  public PriceConfirm() {
    this.modal.confirm('Do you want to save the new price?', this.viewRef, this.ConfirmUploadPrice)
  }

  private ConfirmUploadPrice = () => {
    const params: any = {
      FILE_NAME: this.filePrice
    };
    this.http.post("SL", "SNM123_PR_Confirm_Upload", params)
      .subscribe(result => {
        if (result = 'DONE') {
          this.modal.info("Confirm upload price completed.", this.viewRef);
          this.isUpload = false;
          this.GetDataPriceUpload();
        } else {
          this.modal.error("Found eror, please contact support team.", this.viewRef);
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      })
  }

  public PriceError() {
    this.isUpload == false;
    this.GetDataPriceUpload();
  }

  private GetDataPriceUpload() {
    const params = {
      FILE_NAME: this.filePrice,
    }

    this.http.post("SL", "SNM123_PR_GetData_Upload", params)
      .subscribe(result => {
        this.dataUploadList = result.Table;
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      })
  }

  public ChangeCurrentTab(tab) {
  }

  //------------Start Unit Price Fail(No Master)------------
  public OpenSNM124() {
    this.SNM124.OpenDialog();
  }

  public OpenSNM032E() {
    this.SNM032E.OpenDialog();
  }

  public OpenModel() {

    this.Init4();
  }

  public EditModel(row) {
    this.dataEditModel = row;
    this.dialogEditModel.OpenDialog();
  }

  public DeleteModel(row) {
    this.modal.confirm('Do you want to delete base model setting' + '<br>model: '+ row.MODEL_NAME + '<br>customer: ' + row.CUSTOMER_CODE,
      this.viewRef,
      () => {
        this.http.post('SL', 'SNM123_Delete_Model', row)
          .subscribe(res => {
            if (res.Table[0].STATUS == 'DONE') {
              this.modal.info('Transaction complete: deleted and saved.', this.viewRef);
              this.Init4();
            } else {
              this.modal.error('No change to save. Something went wrong.', this.viewRef);
            }
          }, (err) => {
            console.log(err, 'err');
            this.modal.warning("Found an error, please contact support team", this.viewRef);
          })
        }
    );
  }
  public SaveEdit() {
    this.modal.confirm('Do you want to save changed you have made?', this.viewRef, () => {
      this.http.post('SL', 'SNM123_Update_Model', this.dataEditModel)
        .subscribe(res => {
          if (res.Table[0].STATUS == 'DONE') {
            this.modal.info('Transaction complete: applied and saved.', this.viewRef);
            this.dialogEditModel.Close();
            this.Init4();
          } else {
            this.modal.error('No change to save. Something went wrong.', this.viewRef);
          }
        }, (err) => {
          console.log(err, 'err');
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        })
    });
  }

  public CancelEdit() {
    this.dialogEditModel.Close();
  }

  public SelectionGroup() {

  }

  public PRUploadExcel() {
    this.modal.confirm('The new upload will clear the current data. Do you want to new upload?', this.viewRef, this.ActionUploadPR)
  }

  public ActionUploadPR = () => {
    if (this.files.length == 0) {
      this.modal.error('Please Open xlsx...', this.viewRef)
    } else {
      // this.data = []
      let formData = new FormData();
      formData.append('file', this.files[0]);
      this.http.postFile('SL', 'SNM123_PR_UploadExcel', formData)
        .subscribe(res => {
          this.http.get("wPMS", "GetTrackLog", 'TEMP', 'SP_NP_SNM123_EXPORT_PRICE_INFO')
            .subscribe(result => {
              console.log(result)
              if (result.Table.length > 0) {
                this.ListTrackLog = result.Table;
                this.dialogTrackLog.OpenDialog();
              } else {
                if (res.Error.length > 0) {
                  this.ListLog = res.Error;
                  this.dialogLog.OpenDialog();
                } else {
                  this.GetUploadDataSP();
                }
              }
            })
        }, (err) => {
          console.log('err', err)
          this.http.get("wPMS", "GetTrackLog", 'TEMP', 'SP_NP_SNM123_EXPORT_PRICE_INFO')
            .subscribe(result => {
              console.log(result)
              if (result.Table.length > 0) {
                this.ListTrackLog = result.Table;
                this.dialogTrackLog.OpenDialog();
              } else {
                this.modal.error("Upload error", this.viewRef);
              }
            })
        })
    }
  }
}
