import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';


@Component({
  selector: 'snse199',
  templateUrl: './SNSE199.component.html',
  styleUrls: ['../exportbiz.component.css']
})


export class SNSE199Component implements OnInit {

  constructor(
    private Http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  public params: any = {};
  public TableData: any = [];

  ngOnInit() {
  }

  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSE199_GetCustomerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedCustomerCode(values: any) {
    this.params.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = values.CUST_NAME;
    this.Search();
  }

  Search = () => {
    this.TableData = [];
    this.Http.post('SL', 'SNSE199_ETD_Provide', this.params)
      .subscribe(res => {
        if (res.Table[0].STATUS = 'DONE') {
          this.Http.post('SL', 'SNSE199_getData', this.params)
            .subscribe(res => {
              this.TableData = res.Table;
            })
        }
      })
  }

  ExportExcel() {
    this.Http.Download('SL', 'SNSE199_Export', JSON.stringify(this.TableData))
      .subscribe(res => {
        if (res) {
          this.WriteContents(res)
        }
        else {
          this.modal.error('Download not complete', this.viewref)
        }
      })
  }

  WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "SNSE199.xlsx";
    a.click();
  }
}

