import { Component, OnInit, ElementRef, ViewChild, ViewContainerRef, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from '../../../core/modal.service';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'SNSE225',
  templateUrl: './SNSE225.component.html',
  styleUrls: ['./SNSE225.component.css'],
})

export class SNSE225Component implements OnInit {

 
  public error_list: any = []
  constructor(
    public http: HttpService,
    public modal: ModalService,
    public global: Globals,
    public viewRef: ViewContainerRef
  ) { }

  public filename: string = "";
  public param: any = {};
  public params: any = {};
  public paramSearch: any = {};
  public CustomerGroupList: any = [];
  public tableData_Search: any = [];


  // @ViewChild("dialogAdd", { static: false }) dialogAdd: any;
  @ViewChild("dialogEdit", { static: false }) dialogEdit: any;

  // public ParamAdd: any = {};
  public Chkdis: any = {};
  public Chkdis_Confirm: any = {};

  ngOnInit(): void {
    this.Chkdis = false
    this.Chkdis_Confirm = false
    this.params.INVOICE_TYPE = 'N'
    this.paramSearch.INVOICE_TYPE = 'N'
    this.GetMasterSearch();
  }

  public InvSearchConfig: any = {
    ColName: "LOOKUP_INVOICE_NO",
    PlaceholderText: "Select Invoice No.",
    SourceController: "SL",
    SourceMethodName: "SNSE225_GetSearchInv",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.paramSearch
    },
    UpperCase: true
  };
  SetInvoiceNo(value: any,cust: any) {
    this.paramSearch.INVOICE_NO = value.INVOICE_NO;
    this.paramSearch.INVOICE_DATE = value.INVOICE_DATE;
    if (cust == '1'){
      this.paramSearch.INVOICE_TYPE = 'N'
    }else{
      this.paramSearch.INVOICE_TYPE = 'Y'
    }
    
  }

  public ConfigSearchInvoiceMaster: any = {
    ColName: "LOOKUP_INVOICE_EXPORT_MASTER",
    PlaceholderText: "Select Customer Group",
    SourceController: "SL",
    SourceMethodName: "SNSE225_SearchInvoiceMaster",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public async SetSearchInvoiceMaster(values: any) {
   
    this.params.CUSTOMER_GROUP_CODE = values;
    await this.http.post("SL", "SNSE225_GetData_Master", this.params)
      .subscribe(res => {
        if (res.Table[0]){
          //console.log(res.Table[0],"22222222")
          this.params.COMPANY_CODE = res.Table[0].COMPANY_CODE;
          this.params.CUSTOMER_GROUP_CODE = res.Table[0].CUSTOMER_GROUP_CODE;
          this.params.CUSTOMER_GROUP_NAME = res.Table[0].CUSTOMER_GROUP_NAME;
          this.params.SHIPPER1 = res.Table[0].SHIPPER1;
          this.params.SHIPPER2 = res.Table[0].SHIPPER2;
          this.params.SHIPPER3 = res.Table[0].SHIPPER3;
          this.params.SHIPPER4 = res.Table[0].SHIPPER4;
          this.params.SHIPPER_TAX_ID = res.Table[0].SHIPPER_TAX_ID;
          this.params.CONSIGNED_MESSRS1 = res.Table[0].CONSIGNED_MESSRS1;
          this.params.CONSIGNED_MESSRS2 = res.Table[0].CONSIGNED_MESSRS2;
          this.params.CONSIGNED_MESSRS3 = res.Table[0].CONSIGNED_MESSRS3;
          this.params.CONSIGNED_MESSRS4 = res.Table[0].CONSIGNED_MESSRS4;
          this.params.NOTIFY_PARTY1 = res.Table[0].NOTIFY_PARTY1;
          this.params.NOTIFY_PARTY2 = res.Table[0].NOTIFY_PARTY2;
          this.params.NOTIFY_PARTY3 = res.Table[0].NOTIFY_PARTY3;
          this.params.NOTIFY_PARTY4 = res.Table[0].NOTIFY_PARTY4;
          this.params.NOTIFY_PARTY_TEL = res.Table[0].NOTIFY_PARTY_TEL;
          this.params.BANK_OF_NMT1 = res.Table[0].BANK_OF_NMT1;
          this.params.BANK_OF_NMT2 = res.Table[0].BANK_OF_NMT2;
          this.params.BANK_OF_NMT3 = res.Table[0].BANK_OF_NMT3;
          this.params.BANK_OF_NMT_TEL = res.Table[0].BANK_OF_NMT_TEL;
          this.params.BANK_OF_NMT_FAX = res.Table[0].BANK_OF_NMT_FAX;
          this.params.BANK_OF_NMT_SWIFT_CODE = res.Table[0].BANK_OF_NMT_SWIFT_CODE;
          this.params.BANK_OF_NMT_ACOUNT_ACCOUNT_NO = res.Table[0].BANK_OF_NMT_ACOUNT_ACCOUNT_NO;
          this.params.SHIPPED_PER = res.Table[0].SHIPPED_PER;
          this.params.PORT_OF_DISCHARGE = res.Table[0].PORT_OF_DISCHARGE;
          this.params.PORT_OF_LOADING = res.Table[0].PORT_OF_LOADING;
          this.params.FINAL_DESTINATION_FOR_REFERENCE_ONLY = res.Table[0].FINAL_DESTINATION_FOR_REFERENCE_ONLY;
          this.params.DESCRIPTION_OF_GOODS1 = res.Table[0].DESCRIPTION_OF_GOODS1;
          this.params.DESCRIPTION_OF_GOODS2 = res.Table[0].DESCRIPTION_OF_GOODS2;
          this.params.DESCRIPTION_OF_GOODS3 = res.Table[0].DESCRIPTION_OF_GOODS3;
          this.params.DESCRIPTION_OF_GOODS4 = res.Table[0].DESCRIPTION_OF_GOODS4;
          this.params.F_O_B = res.Table[0].F_O_B;
          this.params.COUNTRY_ORIGIN = res.Table[0].COUNTRY_ORIGIN;
          this.params.FREIGHT = res.Table[0].FREIGHT;
          this.params.SIGNATURE1 = res.Table[0].SIGNATURE1;
          this.params.SIGNATURE2 = res.Table[0].SIGNATURE2;
          this.params.SIGNATURE3 = res.Table[0].SIGNATURE3;
          this.params.PLACE = res.Table[0].PLACE;
          this.params.TERMS_METHOD_OF_PAYMENT = res.Table[0].TERMS_METHOD_OF_PAYMENT;
        }
      }, (err) => {
        console.log(err, "err")
        this.modal.warning("Found an error, please contact support team", this.viewRef);
        //return;
      })
    
    
  }

  public GetMasterSearch() {
    if (!this.paramSearch.INVOICE_TYPE){
      this.paramSearch.INVOICE_TYPE = 'N'
    }
    
    this.http.post("SL", "SNSE225_GetData", this.paramSearch)
      .subscribe(res => {
        this.tableData_Search = res.Table;
        
      }, (err) => {
        console.log(err, "err")
        this.modal.warning("Found an error, please contact support team", this.viewRef);
        return;
      })
  }

  public GetMasterDetailList() {
    if (!this.param.INVOICE_TYPE){
      this.param.INVOICE_TYPE = 'N'
    }
    this.http.post("SL", "SNSE225_GetData_Master_List", this.param)
      .subscribe(res => {
        this.params = {}
        this.params = res.Table[0];
        this.params.New = 'N'
        if(!this.params.CUSTOMER_GROUP_CODE){
          this.params.New = 'Y'
          this.SetSearchInvoiceMaster(this.CustomerGroupList[0].CUSTOMER_GROUP_CODE)
        }
        
        this.Chkdis = false
        this.params.INVOICE_TYPE = 'N'
        if (this.params.STATUS == 'Send'){
          this.params.INVOICE_TYPE = 'Y'
          // this.Chkdis = true
        }
        this.Chkdis_Confirm = false
        if (this.params.STATUS != 'On Process'){
          // this.Chkdis_Confirm = true
        }
      }, (err) => {
        console.log(err, "err")
        this.modal.warning("Found an error, please contact support team", this.viewRef);
        return;
      })
  }

  public GetDataMasterCustomerGroup() {
  
    this.param.ORDER_TYPE = this.param.DOCUMENT_TYPE == "FS" ? "S" : "A";
    this.http.post("SL", "SNSE225_GetData_Master_Customer_Group", this.param)
      .subscribe(res => {
        this.CustomerGroupList = res.Table;
        console.log(this.CustomerGroupList,"ccccccccccccccccc")
      }, (err) => {
        console.log(err, "err")
        this.modal.warning("Found an error, please contact support team", this.viewRef);
        return;
      })
  }

  // public SaveAdd() {
  //   this.modal.confirm('Do you want to save?', this.viewRef,
  //     () => {
  //       this.http.post("SL", "SNSE225_Insert_Invoice_Export", this.ParamAdd)
  //         .subscribe(res => {
  //           if (res.Table[0].STATUS == 'DONE') {
  //             this.modal.info("Save data complete!", this.viewRef);
  //             this.GetMasterDetailList();
  //             this.GetMasterSearch();
  //             this.ParamAdd = this.global.ClearObject(this.ParamAdd);
  //             // this.dialogAdd.Close();
  //           }
  //           else if (res.Table[0].ERROR_MSG != '') {
  //             this.modal.warning(res.Table[0].ERROR_MSG, this.viewRef);
  //           }
  //           else {
  //             console.log(res.Table[0].MESSAGE, "err")
  //             this.modal.warning("Found an error, please contact support team", this.viewRef);
  //           }
  //         }, (err) => {
  //           console.log(err, "err")
  //           this.modal.warning("Found an error, please contact support team", this.viewRef);
  //         });
  //     },
  //     () => { }
  //   )
  // }

  public SaveEdit() {
    if (!this.params.CUSTOMER_GROUP_CODE || this.params.CUSTOMER_GROUP_CODE == '') {
      this.modal.warning('Please select customer group', this.viewRef);
      return;
    }
    
    this.modal.confirm('Do you want to save?', this.viewRef,
      () => {
        this.http.post("SL", "SNSE225_Update_Invoice_Export", this.params)
          .subscribe(res => {
            if (res.STATUS_MSG == 'DONE') {
              this.modal.info("Save data complete!", this.viewRef);
              this.GetMasterDetailList();
              this.GetMasterSearch();
              // this.dialogEdit.Close();
            }
            else {
              console.log(res.STATUS_MSG, "err")
              this.modal.warning("Found an error, please contact support team", this.viewRef);
            }
          }, (err) => {
            console.log(err, "err")
            this.modal.warning("Found an error, please contact support team", this.viewRef);
          });
      },
      () => { }
    )
  }

  OpendatePopup(datepicker) {
    datepicker.open();
  }


  public EditRow(data) {
    this.param = data
    this.Chkdis = false
    this.param.INVOICE_TYPE = 'N'
    if (this.param.STATUS == 'Send'){
      this.param.INVOICE_TYPE = 'Y'
      // this.Chkdis = true
    }
    this.Chkdis_Confirm = false
    if (this.param.STATUS != 'On Process'){
      // this.Chkdis_Confirm = true
    }

    
    
    this.GetDataMasterCustomerGroup();
    this.GetMasterDetailList();
    this.dialogEdit.OpenDialog();
  }

  public CancleEdit() {
    this.dialogEdit.Close();
  }


  public Clear() {
    this.paramSearch.INVOICE_NO = '';
    this.GetMasterSearch() 
  }


  public async ConfirmProcessPrint() {
    if (!this.params.CUSTOMER_GROUP_CODE || this.params.CUSTOMER_GROUP_CODE == '') {
      this.modal.warning('Please select customer group', this.viewRef);
      return;
    }
    await this.modal.confirm("Do you want Confirm Print?", this.viewRef, this.ProcessPrint);
  }

  public ProcessPrint  = async () => {
    await this.http.post("SL", "SNSE225_Update_Invoice_Export", this.params)
      .subscribe(res => {
        if (res.STATUS_MSG == 'DONE') {
          this.GetMasterDetailList()
        }
      }, (err) => {
        console.log(err, "err")
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });

    await this.http.post("SL", "SNSE225_PROCESS_PRINT", this.params)
      .subscribe(res => {
        if (res.STATUS_MESSAGE == 'DONE') {
        }
        else {
          this.modal.error("Process incompleted!!", this.viewRef);
        }
      }, (err) => {
          this.modal.error('Found an error, please contact support team.', this.viewRef);
      });
    await this.OpenReport()
    await this.GetMasterSearch();

  }

  public CheckOriginChange(value) {
    if (value.checked == true) {
      this.params.TH_ONLY_FLAG = 'Y'
    }
    else {
      this.params.TH_ONLY_FLAG = 'N'
    }
  }

  public OpenReport() {
    var fileName = 'PMS_RPT_INVOICE_EXPORT_' + this.params.INVOICE_NO;
    
    if (this.params.DOCUMENT_TYPE == 'FS') {
      this.params.DOC_TYPE = 'SEA';
    } else if (this.params.DOCUMENT_TYPE == 'FA') {
      this.params.DOC_TYPE = 'AIR';
    }
    
    this.global.GoToExportName("PMS_RPT_INVOICE_EXPORT_" + this.params.DOC_TYPE + "_" + this.params.CUSTOMER_CODE ,
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_CUSTOMER_GROUP_CODE: this.params.CUSTOMER_GROUP_CODE,
        P_INVOICE_NO: this.params.INVOICE_NO
      }
      , fileName, 'EXCELOPENXML'
    );
  }


  public async Print(data) {
    this.params = data
    this.params.DOCUMENT_TYPE = this.params.INVOICE_NO.substring(0,2);
    if(!data.CUSTOMER_GROUP_CODE){
      data.ORDER_TYPE = this.params.DOCUMENT_TYPE == "FS" ? "S" : "A";
      this.http.post("SL", "SNSE225_GetData_Master_Customer_Group", data)
      .subscribe(async res => {
        this.params.New = 'Y'
        this.SetSearchInvoiceMasterNew(res.Table[0].CUSTOMER_GROUP_CODE)
       
      }, (err) => {
        console.log(err, "err")
        this.modal.warning("Found an error, please contact support team", this.viewRef);
        return;
      })
     
    }else{
      this.SetSearchInvoiceMasterNew(data.CUSTOMER_GROUP_CODE)
    }
   
  }


  public async SetSearchInvoiceMasterNew(values: any) {
   
    this.params.CUSTOMER_GROUP_CODE = values;
    await this.http.post("SL", "SNSE225_GetData_Master", this.params)
      .subscribe(res => {
        if (res.Table[0]){
          
          this.params.COMPANY_CODE = res.Table[0].COMPANY_CODE;
          this.params.CUSTOMER_GROUP_CODE = res.Table[0].CUSTOMER_GROUP_CODE;
          this.params.CUSTOMER_GROUP_NAME = res.Table[0].CUSTOMER_GROUP_NAME;
          this.params.SHIPPER1 = res.Table[0].SHIPPER1;
          this.params.SHIPPER2 = res.Table[0].SHIPPER2;
          this.params.SHIPPER3 = res.Table[0].SHIPPER3;
          this.params.SHIPPER4 = res.Table[0].SHIPPER4;
          this.params.SHIPPER_TAX_ID = res.Table[0].SHIPPER_TAX_ID;
          this.params.CONSIGNED_MESSRS1 = res.Table[0].CONSIGNED_MESSRS1;
          this.params.CONSIGNED_MESSRS2 = res.Table[0].CONSIGNED_MESSRS2;
          this.params.CONSIGNED_MESSRS3 = res.Table[0].CONSIGNED_MESSRS3;
          this.params.CONSIGNED_MESSRS4 = res.Table[0].CONSIGNED_MESSRS4;
          this.params.NOTIFY_PARTY1 = res.Table[0].NOTIFY_PARTY1;
          this.params.NOTIFY_PARTY2 = res.Table[0].NOTIFY_PARTY2;
          this.params.NOTIFY_PARTY3 = res.Table[0].NOTIFY_PARTY3;
          this.params.NOTIFY_PARTY4 = res.Table[0].NOTIFY_PARTY4;
          this.params.NOTIFY_PARTY_TEL = res.Table[0].NOTIFY_PARTY_TEL;
          this.params.BANK_OF_NMT1 = res.Table[0].BANK_OF_NMT1;
          this.params.BANK_OF_NMT2 = res.Table[0].BANK_OF_NMT2;
          this.params.BANK_OF_NMT3 = res.Table[0].BANK_OF_NMT3;
          this.params.BANK_OF_NMT_TEL = res.Table[0].BANK_OF_NMT_TEL;
          this.params.BANK_OF_NMT_FAX = res.Table[0].BANK_OF_NMT_FAX;
          this.params.BANK_OF_NMT_SWIFT_CODE = res.Table[0].BANK_OF_NMT_SWIFT_CODE;
          this.params.BANK_OF_NMT_ACOUNT_ACCOUNT_NO = res.Table[0].BANK_OF_NMT_ACOUNT_ACCOUNT_NO;
          this.params.SHIPPED_PER = res.Table[0].SHIPPED_PER;
          this.params.PORT_OF_DISCHARGE = res.Table[0].PORT_OF_DISCHARGE;
          this.params.PORT_OF_LOADING = res.Table[0].PORT_OF_LOADING;
          this.params.FINAL_DESTINATION_FOR_REFERENCE_ONLY = res.Table[0].FINAL_DESTINATION_FOR_REFERENCE_ONLY;
          this.params.DESCRIPTION_OF_GOODS1 = res.Table[0].DESCRIPTION_OF_GOODS1;
          this.params.DESCRIPTION_OF_GOODS2 = res.Table[0].DESCRIPTION_OF_GOODS2;
          this.params.DESCRIPTION_OF_GOODS3 = res.Table[0].DESCRIPTION_OF_GOODS3;
          this.params.DESCRIPTION_OF_GOODS4 = res.Table[0].DESCRIPTION_OF_GOODS4;
          this.params.F_O_B = res.Table[0].F_O_B;
          this.params.COUNTRY_ORIGIN = res.Table[0].COUNTRY_ORIGIN;
          this.params.FREIGHT = res.Table[0].FREIGHT;
          this.params.SIGNATURE1 = res.Table[0].SIGNATURE1;
          this.params.SIGNATURE2 = res.Table[0].SIGNATURE2;
          this.params.SIGNATURE3 = res.Table[0].SIGNATURE3;
          this.params.PLACE = res.Table[0].PLACE;
          this.params.TERMS_METHOD_OF_PAYMENT = res.Table[0].TERMS_METHOD_OF_PAYMENT;
          this.ProcessPrintNew()
        }
      }, (err) => {
        console.log(err, "err")
        this.modal.warning("Found an error, please contact support team", this.viewRef);
        //return;
      })
    
    
  }

  public async ProcessPrintNew() {
    await this.http.post("SL", "SNSE225_Update_Invoice_Export", this.params)
      .subscribe(res => {
        
      }, (err) => {
        console.log(err, "err")
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });

      await this.http.post("SL", "SNSE225_PROCESS_PRINT", this.params)
      .subscribe(res => {
        if (res.STATUS_MESSAGE == 'DONE') {
        }
        else {
          this.modal.error("Process incompleted!!", this.viewRef);
        }
      }, (err) => {
          this.modal.error('Found an error, please contact support team.', this.viewRef);
      });
    await this.OpenReport()
  }

}



