import { Component, OnInit, ViewChild, ViewContainerRef, EventEmitter } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';
import { SelectionModel } from '@angular/cdk/collections';

@Component({
  selector: 'snsq022',
  templateUrl: './SNSQ022.component.html',
  styleUrls: ['./SNSQ022.component.css']
})

export class SNSQ022Component implements OnInit {

  public params: any = {};
  public SNM123Sparams: any = {};
  public isCanUpdate: boolean = false;
  public IsSelectTab: number = 0;
  public dataOnClick: any = {};
  public dataSelected: any = [];

  public fromData: any = {};
  public tableData1: any = [];
  public tableData2: any = [];
  public tableData3: any = [];
  public tableData4: any = [];
  public tableData5: any = [];
  public tableData6: any = [];

  public tblFooterData1: any = [
    {
      fieldName: "CUSTOMER_NAME",
      value: "Total",
      show: true
    },
    {
      fieldName: "CNT_ORDER_NO",
      show: true
    },
    {
      fieldName: "SUM_ORDER_QTY",
      show: true
    },
    {
      fieldName: "SUM_ACCEPT_QTY",
      show: true
    },
    {
      fieldName: "SUM_NET_WEIGHT",
      show: true
    },
    {
      fieldName: "SUM_NET_DIMENSION",
      show: true
    },
    {
      fieldName: "SUM_AMOUNT",
      show: true
    }
  ]

  public tabIndex: number = 0;
  public selection = new SelectionModel<any>(true, []);

  @ViewChild("SNSQ01E_UPLOAD", { static: false }) SNSQ01E_UPLOAD: any;
  @ViewChild("SNM123S", { static: false }) SNM123S: any;

  constructor(
    public global: Globals,
    private Http: HttpService,
    private modal: ModalService,
    private viewRef: ViewContainerRef,

  ) { }

  ngOnInit() {
    this.params.FROM_DATE = new Date("2000-01-01"); // new Date(new Date().getFullYear(), 0, 1, 7);
    this.params.TO_DATE = new Date();
  }

  private InitData() {
    this.params.ORDER_NO = null;
    this.params.ORDER_PART_NO = null;
    this.params.ORDER_CLASS = null;
  }

  private InitTable() {
    this.tableData1 = [];
    this.tableData2 = [];
    this.tableData3 = [];
    this.tableData4 = [];
    this.tableData5 = [];
    this.tableData6 = [];
  }

  public tabClick(tab: any) {
    if (tab != 0) {
      this.IsSelectTab = tab
      this.tabIndex = tab
      this.fromData = null;
      this.isCanUpdate = false;
      this.SearchByCustomerCode()
    }
  }

  private SearchByCustomerCode = () => {
    if (this.IsSelectTab == 1) {
      this.Http.post('SL', 'SNSQ022_GetInComplete', this.params)
        .subscribe(res => {
          this.tableData2 = res.Table;
          if (this.tableData2.length > 0) {
            this.tableData2.forEach((e, index) => {
              e.V_SEQ = index + 1;
            });
          }
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })
    }
    else if (this.IsSelectTab == 2) {
      this.Http.post('SL', 'SNSQ022_GetComplete', this.params)
        .subscribe(res => {
          this.tableData3 = res.Table;
          if (this.tableData3.length > 0) {
            this.tableData3.forEach((e, index) => {
              e.V_SEQ = index + 1;
            });
          }
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })
    }
    else if (this.IsSelectTab == 3) {
      this.Http.post('SL', 'SNSQ022_GetUnitPrice', this.params)
        .subscribe(res => {
          this.tableData6 = res.Table;
          if (this.tableData6.length > 0) {
            this.tableData6.forEach((e, index) => {
              e.V_SEQ = index + 1;
            });
          }
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })
    }
    else if (this.IsSelectTab == 4) {
      this.tableData4 = [];
      this.dataSelected = [];
      this.selection.clear();
      this.Http.post('SL', 'SNSQ022_GetUnitPriceFail', this.params)
        .subscribe(res => {
          this.tableData4 = res.Table;
          if (this.tableData4.length > 0) {
            this.tableData4.forEach((e, index) => {
              e.V_SEQ = index + 1;
              //this.selection.select(e)
              //this.dataSelected.push(e)
            });
          }
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })
    }
    else if (this.IsSelectTab == 5) {
      this.Http.post('SL', 'SNSQ022_GetInCompleteTariff', this.params)
        .subscribe(res => {
          this.tableData5 = res.Table;
          if (this.tableData5.length > 0) {
            this.tableData5.forEach((e, index) => {
              e.V_SEQ = index + 1;
            });
          }
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })
    }
  }

  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSQ022_GetCustomer",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public lookupOrderNoConfig: any = {
    ColName: "LOOKUP_ORDER_NO",
    ColValue: "",
    PlaceholderText: "Select Order No",
    SourceController: "SL",
    SourceMethodName: "SNSQ022_GetOrderNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public lookupOrderPartNoConfig: any = {
    ColName: "LOOKUP_ORDER_PART_NO",
    ColValue: "",
    PlaceholderText: "Select Order Part No",
    SourceController: "SL",
    SourceMethodName: "SNSQ022_GetOrderPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public lookupOrderClassConfig: any = {
    ColName: "ORDER_CLASS_DESC",
    ColValue: "",
    PlaceholderText: "Select Order Class",
    SourceController: "SL",
    SourceMethodName: "SNSQ022_GetOrderClass",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedCustomerCode(values: any) {
    this.params.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = values.CUST_NAME_EN;
    this.InitData();
  }

  public SetSelectedOrderNo(value: any) {
    this.params.ORDER_NO = value.ORDER_NO;
  }

  public SetSelectedOrderPartNo(value: any) {
    this.params.ORDER_PART_NO = value.ORDER_PART_NO;
  }

  public SetSelectedOrderClass(value: any) {
    this.params.ORDER_CLASS = value.ORDER_CLASS;
  }

  public ExportExcel(tab: any) {
    var ctrName = "";
    var type = "";
    var data = [];
    if (tab == 'TAB1') {
      ctrName = "SNSQ022_ExportSummary";
      type = "SUMMARY";
      data = this.tableData1;
    }
    else if (tab == 'TAB2') {
      ctrName = "SNSQ022_ExportIncomplete";
      type = "INCOMPLETE";
      data = this.tableData2;
    }
    else if (tab == 'TAB3') {
      ctrName = "SNSQ022_ExportComplete";
      type = "COMPLETE";
      data = this.tableData3;
    }
    else if (tab == 'TAB4') {
      ctrName = "SNSQ022_ExportUnitPriceFail";
      type = "UNIT_PRICE_FAIL";
      data = this.tableData4;
    }
    else if (tab == 'TAB5_1') {
      ctrName = "SNSQ022_ExportIncompleteTariff";
      type = "INCOMPLETE_TARIFF";
      data = this.tableData5;
    }
    else if (tab == 'TAB5_2') {
      ctrName = "SNSQ022_ExportImproperMaster";
      type = "IMPROPER_MASTER";
      data = this.tableData5;
    }
    else if (tab == 'TAB6') {
      ctrName = "SNSQ022_ExportUnitPriceFail";
      type = "UNIT_PRICE";
      data = this.tableData6;
    }
    if (ctrName && type) {
      this.Http.Download('SL', ctrName, JSON.stringify(data))
        .subscribe(res => {
          if (res) {
            this.WriteContents(res, type)
          } else {
            this.modal.error('Download not complete', this.viewRef)
          }
        })
    }
  }

  private WriteContents(content, type) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ022_" + type + this.global.CurrentDate() + ".xlsx";
    a.click();
  }

  public ConfirmUTD(type: any) {
    if (type == 'update') {
      this.modal.confirm('Do you want to update on this data?', this.viewRef, this.UpdateUnitPriceFail);
    }
    else if (type == 'updateTariffCode') {
      this.modal.confirm('Do you want to update on this data?', this.viewRef, this.UpdateTariffCode)
    }
  }

  //------------Start Summary------------
  public Search = () => {

    //if (this.params.CUSTOMER_CODE == '' || this.params.CUSTOMER_CODE ==  null) {
    //  this.modal.warning("Please select the Customer Code", this.viewRef);
    //  return;
    //}

    this.params.DSP_CUSTOMER_CODE = null;
    this.dataOnClick = {};
    this.tabIndex = 0;
    this.InitTable();

    this.Http.post('SL', 'SNSQ022_GetSummary', this.params)
      .subscribe(res => {
        this.tableData1 = res.Table;
        if (this.params.CUSTOMER_CODE) {
          const filterRow = this.tableData1.filter(x => x.CUSTOMER_CODE == this.params.CUSTOMER_CODE);
          this.setRowClick(filterRow[0])
        }
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public compareRow(row1: any, row2: any) {
    return JSON.stringify(row1) === JSON.stringify(row2);
  }

  public setRowClick(row: any) {
    this.dataOnClick = row;
    this.dataOnClick.FROM_DATE = this.params.FROM_DATE;
    this.dataOnClick.TO_DATE = this.params.TO_DATE;
    this.params.DSP_CUSTOMER_CODE = this.dataOnClick.CUSTOMER_CODE;
    this.params.CUSTOMER_CODE = this.params.DSP_CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = this.dataOnClick.CUSTOMER_NAME

    if (this.params.ORDER_NO) {
      this.dataOnClick.ORDER_NO = this.params.ORDER_NO;
    }
    if (this.params.ORDER_PART_NO) {
      this.dataOnClick.ORDER_PART_NO = this.params.ORDER_PART_NO;
    }
    if (this.params.ORDER_CLASS) {
      this.dataOnClick.ORDER_CLASS = this.params.ORDER_CLASS;
    }
  }
  //------------End Summary------------





  //------------Start Incomplete------------
  //------------End Incomplete--------------





  //------------Start Complete------------
  //------------End Complete--------------





  //------------Start Unit Price Fail(No Master)------------
  public SetExportPrice(data) {
    this.SNM123Sparams.CUSTOMER_CODE = data.CUSTOMER_CODE;
    this.SNM123Sparams.ORDER_NO = data.ORDER_NO;
    this.SNM123Sparams.PART_NO = data.ACCEPT_PART_NO;
    this.SNM123S.OpenDialog();
    this.SearchByCustomerCode();
  }

  public OpenSNSE01E() {
    this.SNSQ01E_UPLOAD.OpenDialog();
  }

  public CallbackSNM123S(data: any) {
    //console.log('CallbackSNM123S');
    this.SearchByCustomerCode();
  }
  //------------End Unit Price Fail(No Master)--------------





  //------------Start Unit Price Fail(Diff Price)------------
  public isAllSelected() {
    const numSelected = this.selection.selected.length;
    const numRows = this.tableData4.length;
    return numSelected === numRows;
  }

  public Toggle() {
    if (this.isAllSelected()) {
      this.selection.clear()
      this.tableData4.map(x => {
        this.dataSelected = [];

      })
    } else {
      this.tableData4.forEach(row => this.selection.select(row));
      this.dataSelected = [];
      this.tableData4.map(x => {
        this.dataSelected.push(x);
      })
    }
  }

  public CheckToUpdate(event, data) {
    if (event.checked) {
      this.dataSelected.push(data);
    }
    else {
      this.dataSelected.splice(this.dataSelected.indexOf(data), 1);
    }
  }


  private UpdateUnitPriceFail = () => {
    this.Http.post('SL', 'SNSQ022_UpdateUnitPrice', this.dataSelected)
      .subscribe(res => {
        if (res == 'DONE') {
          this.modal.info("Update complete.", this.viewRef)
          this.SearchByCustomerCode();
          this.isCanUpdate = false;
        }
        else {
          this.modal.warning(res, this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }
  //------------End Unit Price Fail(Diff Price)--------------





  //------------Start Incomplete Tariff------------
  private UpdateTariffCode = () => {
    this.Http.post('SL', 'SNSQ022_UpdateTariffCode', this.tableData5)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Process was completed.', this.viewRef);
          this.SearchByCustomerCode();
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public Callback(data: any) {
    if (data == 'DONE') {
      this.SearchByCustomerCode();
    }
  }

  public IsSelectRow(data: any) {
    this.isCanUpdate = true;
    this.fromData = data;
    this.params.PART_NO = this.fromData.PART_NO;
    if (!this.fromData.UNIT_PRICE_MASTER) {
      this.isCanUpdate = false;
    }
  }
  //------------End Incomplete Tariff--------------
}


