import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';
import { SelectionModel } from '@angular/cdk/collections';

@Component({
  selector: 'snsq074e',
  templateUrl: './SNSQ074E.component.html',
  styleUrls: ['./SNSQ074E.component.css'],

})


export class SNSQ074EComponent implements OnInit {

  public params: any = {};

  constructor(
    private Http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  public tableData1: any = {};
  public tableSummary: any = [];
  public tableData2: any = [];
  public tableData3: any = [];
  public tableData4: any = [];

  public tblFooter2: any = [
    {
      fieldName: "CIF_CURRENCY",
      show: true
    },
    {
      fieldName: "CIF_BAHT",
      show: true
    },
    {
      fieldName: "CIF_MBAHT",
      show: true
    }
  ]

  public totalRecord2: any = 0;
  public totalRecord3: any = 0;

  public IsSelectTab: any = 0;

  public DataIsSelected: any;
  public DataIsSelected2: any;
  public selection = new SelectionModel<any>(true, []);
  public selection2 = new SelectionModel<any>(true, []);

  ngOnInit() {
    this.params.FROM_DATE = new Date(new Date().getFullYear(), new Date().getMonth(), 1, 7);
    this.params.TO_DATE = new Date();
    this.params.EFFECTIVE_DATE = new Date();
    this.params.DATA_MONTH = new Date();
    this.params.EXCHANGE_RATE = 0;
  }

  private initData() {
    this.tableData1 = {};
    this.tableSummary = [];
    this.tableData2 = [];
    this.tableData3 = [];
    this.totalRecord2 = 0;
    this.totalRecord3 = 0;
    this.DataIsSelected = [];
    this.DataIsSelected2 = [];
    this.selection.clear();
    this.selection2.clear();
  }

  public lookupBuyerCodeConfig: any = {
    ColName: "LOOKUP_BUYER_CODE",
    PlaceholderText: "Select Buyer Code",
    SourceController: "SL",
    SourceMethodName: "SNSQ074E_GetBuyerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  //public lookupBranchCodeConfig: any = {
  //  ColName: "LOOKUP_BRANCH_CODE",
  //  PlaceholderText: "Select Branch Code",
  //  SourceController: "SL",
  //  SourceMethodName: "SNSQ074E_GetBranchCode",
  //  NoOfShowRecords: 50,
  //  MinLengthSearch: 0,
  //  SourceParams: {
  //    DATA: this.params
  //  },
  //  UpperCase: true
  //}

  public SetSelectedBuyerCode(values: any) {
    this.params.BUYER_CODE = values.BUYER_CODE;
    this.params.BUYER_NAME = values.BUYER_NAME;
    this.params.BRANCH_CODE = values.BRANCH_CODE;
    this.params.BRANCH_NAME = values.BRANCH_NAME;
  }

  //public SetSelectedBranchCode(values: any) {
  //  this.params.BRANCH_CODE = values.BRANCH_CODE;
  //  this.params.BRANCH_NAME = values.BRANCH_NAME;
  //}

  public Search = () => {
    this.initData();
    this.Http.post('SL', 'SNSQ074E_GetInvoice', this.params)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.Http.get('SL', 'SNSQ074E_GetPickList')
            .subscribe(res => {
              if (res.Table[0].STATUS == 'DONE') {
                this.Http.post('SL', 'SNSQ074E_GetSummary', this.params)
                  .subscribe(res => {
                    this.tableData1 = res.Table[0];
                    this.tableSummary = res.Table;
                  }, (err) => {
                    console.log(err)
                    this.modal.warning("Found an error, please contact support team", this.viewref);
                  });
                this.Http.post('SL', 'SNSQ074E_GetInvoiceDetail', this.params)
                  .subscribe(res => {
                    this.tableData2 = res.Table;
                    if (this.tableData2.length > 0) {
                      this.totalRecord2 = this.tableData2.length;
                      this.tableData2.forEach((invoice) => {
                        this.selection.select(invoice)
                        this.DataIsSelected.push(invoice)
                      });
                    }
                  }, (err) => {
                    console.log(err)
                    this.modal.warning("Found an error, please contact support team", this.viewref);
                  });
                this.Http.post('SL', 'SNSQ074E_GetPickingDetail', this.params)
                  .subscribe(res => {
                    this.tableData3 = res.Table;
                    if (this.tableData3.length > 0) {
                      this.totalRecord3 = this.tableData3.length;
                      this.tableData3.forEach((picking) => {
                        this.selection2.select(picking)
                        this.DataIsSelected2.push(picking)
                      });
                    }
                  }, (err) => {
                    console.log(err)
                    this.modal.warning("Found an error, please contact support team", this.viewref);
                  });
              }
            }, (err) => {
              console.log(err)
              this.modal.warning("Found an error, please contact support team", this.viewref);
            });
        }
      }, (err) => {
        console.log(err)
        this.modal.warning("Found an error, please contact support team", this.viewref);
      });
  }

  public isAllSelected() {
    const numSelected = this.selection.selected.length;
    const numRows = this.tableData2.length;
    return numSelected === numRows;
  }

  public Toggle() {
    if (this.isAllSelected()) {
      this.selection.clear()
      this.tableData2.map(x => {
        this.DataIsSelected = [];

      })
    } else {
      this.tableData2.forEach(row => this.selection.select(row));
      this.DataIsSelected = [];
      this.tableData2.map(x => {
        this.DataIsSelected.push(x);
      })
    }
  }

  public CheckboxChange(event, data) {
    if (event.checked) {
      this.DataIsSelected.push(data);
    }
    else {
      this.DataIsSelected.splice(this.DataIsSelected.indexOf(data), 1);
    }
  }

  public isAllSelectedPick() {
    const numSelected = this.selection2.selected.length;
    const numRows = this.tableData3.length;
    return numSelected === numRows;
  }

  public TogglePick() {
    if (this.isAllSelectedPick()) {
      this.selection2.clear()
      this.tableData3.map(x => {
        this.DataIsSelected2 = [];

      })
    } else {
      this.tableData3.forEach(row => this.selection2.select(row));
      this.DataIsSelected2 = [];
      this.tableData3.map(x => {
        this.DataIsSelected2.push(x);
      })
    }
  }

  public CheckboxChangePick(event, data) {
    if (event.checked) {
      this.DataIsSelected2.push(data);
    }
    else {
      this.DataIsSelected2.splice(this.DataIsSelected2.indexOf(data), 1);
    }
  }

  public SearchExchange = () => {
    this.Http.post("SL", "SNSQ074E_GetExchangeRateDetail", this.params)
      .subscribe(res => {
        this.tableData4 = res.Table;
      }, (err) => {
        console.log(err)
        this.modal.warning("Found an error, please contact support team", this.viewref);
      });
  }

  public addExchangeRate() {
    if (this.params.CURRENCY && (this.params.EXCHANGE_RATE != null || this.params.EXCHANGE_RATE != '')) {
      if (this.params.EXCHANGE_RATE == 0) {
        this.modal.warning('Are you sure to add Exchange rate = 0.000?', this.viewref);
      } else {
        this.Http.post('SL', 'SNSQ074E_AddExchangeRate', this.params)
          .subscribe(res => {
            if (res.Table[0].STATUS === "DONE") {
              this.modal.info('Transaction complete: applied and saved.', this.viewref);
              this.SearchExchange();
            }
          }, (err) => {
            console.log(err)
            this.modal.warning("Found an error, please contact support team", this.viewref);
          });
      }
    }
    else {
      this.modal.warning('Please fill data', this.viewref);
    }
  }

  public tabClick(tab: any) {
    this.IsSelectTab = tab;
  }

  public ExportExcel() {
    var ctrName = "";
    var type = "";
    var data = [];
    if (this.IsSelectTab == 0) {
      if (this.tableSummary) {
        ctrName = "SNSQ074E_SummaryExport";
        type = "SUMMARY";
        data = this.tableSummary;
      }
      else {
        this.modal.warning('Cannot export to excel on empty value', this.viewref);
      }
    }
    else if (this.IsSelectTab == 1) {
      if (this.tableData2) {
        ctrName = "SNSQ074E_GetInvoiceExport";
        type = "INVOICE";
        data = this.params;
      }
      else {
        this.modal.warning('Cannot export to excel on empty value', this.viewref);
      }

    }
    else if (this.IsSelectTab == 2) {
      if (this.tableData3) {
        ctrName = "SNSQ074E_GetPickingExport";
        type = "PICKING";
        data = this.params;
      }
      else {
        this.modal.warning('Cannot export to excel on empty value', this.viewref);
      }
    }
    else if (this.IsSelectTab == 3) {
      if (this.tableData4) {
        ctrName = "SNSQ074E_ExchangeExport";
        type = "EXCHANGE";
        data = this.tableData4;
      }
      else {
        this.modal.warning('Cannot export to excel on empty value', this.viewref);
      }
    }
    if (ctrName && data) {
      this.Http.Download('SL', ctrName, JSON.stringify(data))
        .subscribe(res => {
          if (res) {
            this.WriteContents(res, type)
          } else {
            this.modal.error('Download not complete', this.viewref)
          }
        }, (err) => {
          console.log(err)
          this.modal.warning("Found an error, please contact support team", this.viewref);
        });
    }
  }

  private WriteContents(content, type) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type })
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ074E_" + type + ".csv";
    a.click();
  }

  public reCalculate() {

    var S_AC_QTY = 0;
    var S_AC_FOB = 0;
    var S_AC_SUM_CIF_CURRENCY = 0;
    var S_AC_SUM_CIF_BAHT = 0;
    var S_AC_SUM_CIF_MBAHT = 0;
    var S_AC_PART_SALE = 0;
    var S_AC_PART_THB = 0;
    var S_AC_PARTS_STD = 0;
    var S_AC_PARTS_STD_KTHB = 0;
    var S_AC_PARTS_GP = 0;
    var S_AC_ACC_SALE = 0;
    var S_AC_ACC_THB = 0;
    var S_AC_ACC_STD = 0;
    var S_AC_ACC_STD_KTHB = 0;
    var S_AC_ACC_GP = 0;

    this.DataIsSelected.forEach((invoice) => {
      S_AC_QTY = S_AC_QTY + invoice.QTY;
      S_AC_FOB = S_AC_FOB + invoice.FOB;
      S_AC_SUM_CIF_CURRENCY = S_AC_SUM_CIF_CURRENCY + invoice.CIF_CURRENCY;
      S_AC_SUM_CIF_BAHT = S_AC_SUM_CIF_BAHT + invoice.CIF_BAHT;
      S_AC_SUM_CIF_MBAHT = S_AC_SUM_CIF_MBAHT + invoice.CIF_MBAHT;
      S_AC_PART_SALE = S_AC_PART_SALE + invoice.PART_SALE;
      S_AC_PART_THB = S_AC_PART_THB + invoice.PART_THB;
      S_AC_PARTS_STD = S_AC_PARTS_STD + invoice.PARTS_STD;
      S_AC_PARTS_STD_KTHB = S_AC_PARTS_STD_KTHB + invoice.PARTS_STD_KTHB;
      S_AC_PARTS_GP = S_AC_PARTS_GP + invoice.PARTS_GP;
      S_AC_ACC_SALE = S_AC_ACC_SALE + invoice.ACC_SALE;
      S_AC_ACC_THB = S_AC_ACC_THB + invoice.ACC_THB;
      S_AC_ACC_STD = S_AC_ACC_STD + invoice.ACC_STD;
      S_AC_ACC_STD_KTHB = S_AC_ACC_STD_KTHB + invoice.ACC_STD_KTHB;
      S_AC_ACC_GP = S_AC_ACC_GP + invoice.ACC_GP;
    });

    //Actual
    this.tableData1.T_PART_SALE = S_AC_SUM_CIF_BAHT - (S_AC_ACC_THB * 1000);
    this.tableData1.T_PART_GP = S_AC_PARTS_GP * 1000;
    if (S_AC_SUM_CIF_BAHT - (S_AC_ACC_THB * 1000) != 0) {
      this.tableData1.T_GPR_PARTS_PERCENT = ((S_AC_PARTS_GP * 1000) / (S_AC_SUM_CIF_BAHT - (S_AC_ACC_THB * 1000))) * 100;
    } else {
      this.tableData1.T_GPR_PARTS_PERCENT = null;
    }

    this.tableData1.T_ACC_DLR_OPT_SALE = S_AC_ACC_THB * 1000;
    this.tableData1.T_ACC_DLR_OPT_SALE_GP = S_AC_ACC_GP * 1000;


    //----------------------------------------------------------------------------------------

    var S_OP_QTY = 0;
    var S_OP_FOB = 0;
    var S_OP_SUM_CIF_CURRENCY = 0;
    var S_OP_SUM_CIF_BAHT = 0;
    var S_OP_SUM_CIF_MBAHT = 0;
    var S_OP_PART_SALE = 0;
    var S_OP_PART_THB = 0;
    var S_OP_PARTS_STD = 0;
    var S_OP_PARTS_STD_KTHB = 0;
    var S_OP_PARTS_GP = 0;
    var S_OP_ACC_SALE = 0;
    var S_OP_ACC_THB = 0;
    var S_OP_ACC_STD = 0;
    var S_OP_ACC_STD_KTHB = 0;
    var S_OP_ACC_GP = 0;

    this.DataIsSelected2.forEach((picking) => {
      S_OP_QTY = S_OP_QTY + picking.QTY;
      S_OP_FOB = S_OP_FOB + picking.FOB;
      S_OP_SUM_CIF_CURRENCY = S_OP_SUM_CIF_CURRENCY + picking.CIF_CURRENCY;
      S_OP_SUM_CIF_BAHT = S_OP_SUM_CIF_BAHT + picking.CIF_BAHT;
      S_OP_SUM_CIF_MBAHT = S_OP_SUM_CIF_MBAHT + picking.CIF_MBAHT;
      S_OP_PART_SALE = S_OP_PART_SALE + picking.PART_SALE;
      S_OP_PART_THB = S_OP_PART_THB + picking.PART_THB;
      S_OP_PARTS_STD = S_OP_PARTS_STD + picking.PARTS_STD;
      S_OP_PARTS_STD_KTHB = S_OP_PARTS_STD_KTHB + picking.PARTS_STD_KTHB;
      S_OP_PARTS_GP = S_OP_PARTS_GP + picking.PARTS_GP;
      S_OP_ACC_SALE = S_OP_ACC_SALE + picking.ACC_SALE;
      S_OP_ACC_THB = S_OP_ACC_THB + picking.ACC_THB;
      S_OP_ACC_STD = S_OP_ACC_STD + picking.ACC_STD;
      S_OP_ACC_STD_KTHB = S_OP_ACC_STD_KTHB + picking.ACC_STD_KTHB;
      S_OP_ACC_GP = S_OP_ACC_GP + picking.ACC_GP;
    });

    //On process
    this.tableData1.OP_PART_SALE = S_OP_SUM_CIF_BAHT - (S_OP_ACC_THB * 1000);
    this.tableData1.OP_PART_GP = S_OP_PARTS_GP * 1000;
    if (S_OP_SUM_CIF_BAHT - (S_OP_ACC_THB * 1000) != 0) {
      this.tableData1.OP_GPR_PART_PERCENT = ((S_OP_PARTS_GP * 1000) / (S_OP_SUM_CIF_BAHT - (S_OP_ACC_THB * 1000))) * 100;
    } else {
      this.tableData1.OP_GPR_PART_PERCENT = null;
    }

    this.tableData1.OP_ACC_SALE = S_OP_ACC_THB * 1000;
    this.tableData1.OP_ACC_GP = S_OP_ACC_GP * 1000;

    //T
    this.tableData1.T_ACC_SALE = (this.tableData1.T_ACC_DLR_OPT_SALE || 0) + (this.tableData1.T_ACC_PDI_SALE || 0);
    this.tableData1.T_ACC_GP = (this.tableData1.T_ACC_DLR_OPT_SALE_GP || 0) + (this.tableData1.T_ACC_PDI_SALE_GP || 0);

    if (((this.tableData1.T_ACC_DLR_OPT_SALE_GP || 0) + (this.tableData1.T_ACC_PDI_SALE_GP || 0)) != 0) {
      this.tableData1.T_GPR_ACC_PERCENT = (((this.tableData1.T_ACC_DLR_OPT_SALE_GP || 0) + (this.tableData1.T_ACC_PDI_SALE_GP || 0)) / ((this.tableData1.T_ACC_DLR_OPT_SALE || 0) + (this.tableData1.T_ACC_PDI_SALE || 0))) * 100;
    }
    else {
      this.tableData1.T_GPR_ACC_PERCENT = null;
    };

    this.tableData1.T_EXP_SALES = (this.tableData1.T_PART_SALE || 0) + (this.tableData1.T_ACC_SALE || 0);
    this.tableData1.T_EXP_GP = (this.tableData1.T_PART_GP || 0) + (this.tableData1.T_ACC_GP || 0);

    if (((this.tableData1.T_PART_GP || 0) + (this.tableData1.T_ACC_GP || 0)) != 0) {
      this.tableData1.T_GPR_PERCENT = ((this.tableData1.T_PART_GP + this.tableData1.T_ACC_GP || 0) / (this.tableData1.T_PART_SALE + this.tableData1.T_ACC_SALE || 0)) * 100;
    }
    else {
      this.tableData1.T_GPR_PERCENT = null;
    };

    //On process
    if ((this.tableData1.OP_PART_SALE || 0) != 0) {
      this.tableData1.OP_GPR_PART_PERCENT = ((this.tableData1.OP_PART_GP || 0) / (this.tableData1.OP_PART_SALE || 0)) * 100;
    }
    else {
      this.tableData1.OP_GPR_PART_PERCENT = null;
    };

    if (this.tableData1.OP_ACC_SALE != 0) {
      this.tableData1.OP_GPR_ACC_PERCENT = ((this.tableData1.OP_ACC_GP || 0) / (this.tableData1.OP_ACC_SALE || 0)) * 100;
    }
    else {
      this.tableData1.OP_GPR_ACC_PERCENT = null;
    };

    this.tableData1.OP_EXP_SALES = (this.tableData1.OP_PART_SALE || 0) + (this.tableData1.OP_ACC_SALE || 0);
    this.tableData1.OP_EXP_GP = (this.tableData1.OP_PART_GP || 0) + (this.tableData1.OP_ACC_GP || 0);

    if (((this.tableData1.OP_PART_GP || 0) + (this.tableData1.OP_ACC_GP || 0)) != 0) {
      this.tableData1.OP_T_GPR_PERCENT = (((this.tableData1.OP_PART_GP || 0) + (this.tableData1.OP_ACC_GP || 0)) / ((this.tableData1.OP_PART_SALE || 0) + (this.tableData1.OP_ACC_SALE || 0))) * 100;
    }
    else {
      this.tableData1.OP_T_GPR_PERCENT = null;
    };

    //BP
    if ((this.tableData1.BP_PART_SALE || 0) != 0) {
      this.tableData1.BP_GPR_PART_PERCENT = ((this.tableData1.BP_PART_GP || 0) / (this.tableData1.BP_PART_SALE || 0)) * 100;
    }
    else {
      this.tableData1.BP_GPR_PART_PERCENT = null;
    };

    if ((this.tableData1.BP_ACC_SALE || 0) != 0) {
      this.tableData1.BP_GPR_ACC_PERCENT = ((this.tableData1.BP_ACC_GP || 0) / (this.tableData1.BP_ACC_SALE) || 0) * 100;
    }
    else {
      this.tableData1.BP_GPR_ACC_PERCENT = null;
    };

    this.tableData1.BP_EXP_SALES = (this.tableData1.BP_PART_SALE || 0) + (this.tableData1.BP_ACC_SALE || 0);
    this.tableData1.BP_EXP_GP = (this.tableData1.BP_PART_GP || 0) + (this.tableData1.BP_ACC_GP || 0);

    if (((this.tableData1.BP_PART_GP || 0) + (this.tableData1.OP_ACC_GP || 0)) != 0) {
      this.tableData1.BP_T_GPR_PERCENT = (((this.tableData1.BP_PART_GP || 0) + (this.tableData1.BP_ACC_GP || 0)) / ((this.tableData1.BP_PART_SALE || 0) + (this.tableData1.BP_ACC_SALE || 0))) * 100;
    }
    else {
      this.tableData1.BP_T_GPR_PERCENT = null;
    };

    //Att %
    if ((this.tableData1.BP_PART_SALE || 0) != 0) {
      this.tableData1.ATT_PART_SALE = (((this.tableData1.T_PART_SALE || 0) + (this.tableData1.OP_PART_SALE || 0)) / (this.tableData1.BP_PART_SALE || 0)) * 100;
    }
    else {
      this.tableData1.ATT_PART_SALE = null;
    };

    if ((this.tableData1.BP_PART_GP || 0) != 0) {
      this.tableData1.ATT_PART_GP = (((this.tableData1.T_PART_GP || 0) + (this.tableData1.OP_PART_GP || 0)) / (this.tableData1.BP_PART_GP || 0)) * 100;
    }
    else {
      this.tableData1.ATT_PART_GP = null;
    };

    if ((this.tableData1.BP_GPR_PART_PERCENT || 0) != 0) {
      this.tableData1.ATT_GPR_PART_PERCENT = (((this.tableData1.T_GPR_PARTS_PERCENT || 0) + (this.tableData1.OP_GPR_PART_PERCENT || 0)) / (this.tableData1.BP_GPR_PART_PERCENT || 0)) * 100;
    }
    else {
      this.tableData1.ATT_GPR_PART_PERCENT = null;
    };

    if ((this.tableData1.BP_ACC_SALE || 0) != 0) {
      this.tableData1.ATT_ACC_SALE = (((this.tableData1.T_ACC_SALE || 0) + (this.tableData1.OP_ACC_SALE || 0)) / (this.tableData1.BP_ACC_SALE || 0)) * 100;
    }
    else {
      this.tableData1.ATT_ACC_SALE = null;
    };

    if ((this.tableData1.BP_ACC_GP || 0) != 0) {
      this.tableData1.ATT_ACC_GP = (((this.tableData1.T_ACC_GP || 0) + (this.tableData1.OP_ACC_GP || 0)) / (this.tableData1.BP_ACC_GP || 0)) * 100;
    }
    else {
      this.tableData1.ATT_ACC_GP = null;
    };

    if ((this.tableData1.BP_GPR_ACC_PERCENT || 0) != 0) {
      this.tableData1.ATT_GPR_ACC_PERCENT = (((this.tableData1.T_GPR_ACC_PERCENT || 0) + (this.tableData1.OP_GPR_ACC_PERCENT || 0)) / (this.tableData1.BP_GPR_ACC_PERCENT || 0)) * 100;
    }
    else {
      this.tableData1.ATT_GPR_ACC_PERCENT = null;
    };


    if ((this.tableData1.BP_EXP_SALES || 0) != 0) {
      this.tableData1.ATT_EXP_SALES = (((this.tableData1.T_EXP_SALES || 0) + (this.tableData1.OP_EXP_SALES || 0)) / (this.tableData1.BP_EXP_SALES || 0)) * 100;
    }
    else {
      this.tableData1.ATT_EXP_SALES = null;
    };

    if ((this.tableData1.BP_EXP_GP || 0) != 0) {
      this.tableData1.ATT_EXP_GP = (((this.tableData1.T_EXP_GP || 0) + (this.tableData1.OP_EXP_GP || 0)) / (this.tableData1.BP_EXP_GP || 0)) * 100;
    }
    else {
      this.tableData1.ATT_EXP_GP = null;
    };

    if ((this.tableData1.BP_T_GPR_PERCENT || 0) != 0) {
      this.tableData1.ATT_T_GPR_PERCENT = (((this.tableData1.T_GPR_PERCENT || 0) + (this.tableData1.OP_T_GPR_PERCENT || 0)) / (this.tableData1.BP_T_GPR_PERCENT || 0)) * 100;
    }
    else {
      this.tableData1.ATT_T_GPR_PERCENT = null;
    };
  }






  //public ExportExcel() {

  //  if (this.tableData.length > 0) {
  //    this.Http.Download("SL", "SNSQ074E_GetInvoiceExport", JSON.stringify(this.params))
  //      .subscribe(result => {
  //        if (result) {
  //          this.download(result)
  //        }
  //      }, (err) => {
  //        console.log(err, 'err')
  //      })
  //  }
  //  else {
  //    this.modal.warning('No data for export to excel', this.viewref)
  //  }
  //}

  //private download(content) {
  //  const a = document.createElement('a');
  //  const file = new Blob([content], { type: content.type })
  //  a.href = URL.createObjectURL(file);
  //  a.download = "SNSQ023.csv"
  //  a.click()
  //}
}

