import { Component, ElementRef, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';
import * as moment from "moment";

@Component({
  selector: 'SNIC004',
  templateUrl: './SNIC004.component.html',
  styleUrls: ['./SNIC004.component.css']
})
export class SNIC004Component implements OnInit {
  constructor(
    private http: HttpService,
    private router: Router,
    private modal : ModalService,
    private viewref : ViewContainerRef,
    private global : Globals
  ) { }

  public tableData : any = []
  public params : any = {}
  ngOnInit() {
   this.params.DATE_SEARCH = moment();
  }

  public Search(){
    this.http.post("ICMS","SNIC004_GetData",this.params)
    .subscribe(res => {
      this.tableData = res.Table;
    })
  }

  public ExportExcel(){


    let Data = {
      Table : this.tableData,
    }
    this.http.Download("ICMS","SNIC004_Download",Data)
    .subscribe(res =>{
      this.writeContents(res);
    })
  }

  private writeContents(content) {
    var currentDate = moment().format('DD-MM-YYYY');
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "SNIC004_" + currentDate + ".xlsx" ;
    a.click();
  }

}
