import { Component, ElementRef, OnInit, ViewChild, ViewContainerRef } from "@angular/core";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "../../../core/modal.service";
import { SelectionModel } from "@angular/cdk/collections";

@Component({
  selector: "SNM144P",
  templateUrl: "./SNM144P.component.html",
})
export class SNM144PComponent implements OnInit {
  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
  ) { }

  public tableData: any = [];
  public tempData: any = [];
  public files: any = [];
  public error_list: any = [];
  public fileName: string = "";
  public duplicateParts: any;
  public total_error: number;
  public checkTariff: boolean = true;
  public checkDuty: boolean = true;
  public checkWeight: boolean = true;
  public selection = new SelectionModel<any>(true, []);

  @ViewChild("dialog", { static: false }) dialog: any;
  @ViewChild("file") fileSelect: ElementRef;

  ngOnInit() { }

  public DownLoadTemplate() {
    let link = "assets/templates/UPLOAD_TARIFF_TEMPLATE.xlsx";
    window.open(link, "_blank");
  }


  public FileChange(fileInput) {
    this.fileName = "";
    this.selection.clear();
    this.files = fileInput.target.files;
    this.fileName = this.files[0].name;

    if(this.fileName){
      this.UpLoad();
    }
    
  }

  public OpenFileBrowser() {
    this.fileSelect.nativeElement.value = "";
    this.fileSelect.nativeElement.click();
    //this.files = [];
    //this.fileName = "";
  }

  private UpLoad() {
    let formData = new FormData();
    formData.append("file", this.files[0]);

    this.http.postFile("IC", "SNM144P_UploadExcel", formData).subscribe(
      (res) => {
        this.total_error = 0;
        this.tableData = res.filter((x) => x.PART_NO);

        let countrow = 0;
        this.total_error = this.tableData.filter((x, i) => {
          if (x.ERR_FLAG == "Y") {
            countrow += 1;
            this.error_list.push({
              Records: i + 1,
            });
          }
        });
        this.total_error = countrow;

        //this.LSChange({checked : this.checkTariff})
        //this.LPChange({checked : this.checkDuty})
      },
      (err) => {
        this.modal.error("Upload error", this.viewRef);
      }
    );
  }


  public TariffChange(event) {
    if (this.tableData.length == 0) return;

    // let msg_err_reason = 'Does not exist Lock PO on @TPM_REASON_CODE!'
    let msg_err_invoice = 'Invoice number Not found!'

    if (event.checked) {
      this.tableData.map(x => {
        if (x.ERR_FLAG_INVOICE == 'Y') {
          x.MSG = msg_err_invoice
        } else if (x.ERR_FLAG_PART == 'Y') {
          x.MSG = x.ERR_MSG_PART
        }
        else if (x.ERR_FLAG_TARIFF == 'Y') {
          x.MSG = x.ERR_MSG_TARIFF
        }
      })
    } else {
      if (this.checkDuty && this.checkWeight) {
        this.tableData.map(x => {
          if (x.ERR_FLAG_INVOICE == 'Y') {
            x.MSG = msg_err_invoice
          } else if (x.ERR_FLAG_PART == 'Y') {
            x.MSG = x.ERR_MSG_PART
          } else if (x.ERR_FLAG_DUTY == 'Y') {
            x.MSG = x.ERR_MSG_DUTY
          } else if (x.ERR_FLAG_WEIGHT == 'Y') {
            x.MSG = x.ERR_MSG_WEIGHT
          } else if (x.ERR_FLAG_INVOICE != 'Y' && x.ERR_FLAG_DUTY != 'Y' && x.ERR_FLAG_WEIGHT != 'Y') {
            x.MSG = null
          }
        })
      } else if (this.checkDuty) {
        this.tableData.map(x => {
          if (x.ERR_FLAG_INVOICE == 'Y') {
            x.MSG = msg_err_invoice
          } else if (x.ERR_FLAG_PART == 'Y') {
            x.MSG = x.ERR_MSG_PART
          } else if (x.ERR_FLAG_DUTY == 'Y') {
            x.MSG = x.ERR_MSG_DUTY
          } else if (x.ERR_FLAG_INVOICE != 'Y' && x.ERR_FLAG_DUTY != 'Y') {
            x.MSG = null
          }
        })
      } else if (this.checkWeight) {
        this.tableData.map(x => {
          if (x.ERR_FLAG_INVOICE == 'Y') {
            x.MSG = msg_err_invoice
          } else if (x.ERR_FLAG_PART == 'Y') {
            x.MSG = x.ERR_MSG_PART
          } else if (x.ERR_FLAG_WEIGHT == 'Y') {
            x.MSG = x.ERR_MSG_WEIGHT
          } else if (x.ERR_FLAG_INVOICE != 'Y' && x.ERR_FLAG_WEIGHT != 'Y') {
            x.MSG = null
          }
        })
      } else {
        this.tableData.map(x => {
          x.MSG = null
        })
      }
    }

    this.tableData = this.tableData.slice();
    this.CheckSelect();
  }

  public DutyChange(event) {
    if (this.tableData.length == 0) return;

    // let msg_err_reason = 'Does not exist Lock Sales on @TPM_REASON_CODE!'
    let msg_err_invoice = 'Invoice number Not found!'

    if (event.checked) {
      this.tableData.map(x => {
        if (x.ERR_FLAG_INVOICE == 'Y') {
          x.MSG = msg_err_invoice
        } else if (x.ERR_FLAG_PART == 'Y') {
          x.MSG = x.ERR_MSG_PART
        } else if (x.ERR_FLAG_DUTY == 'Y') {
          x.MSG = x.ERR_MSG_DUTY
        }
      })
    } else {
      if (this.checkTariff && this.checkWeight) {
        this.tableData.map(x => {
          if (x.ERR_FLAG_INVOICE == 'Y') {
            x.MSG = msg_err_invoice
          } else if (x.ERR_FLAG_PART == 'Y') {
            x.MSG = x.ERR_MSG_PART
          } else if (x.ERR_FLAG_TARIFF == 'Y') {
            x.MSG = x.ERR_MSG_TARIFF
          } else if (x.ERR_FLAG_WEIGHT == 'Y') {
            x.MSG = x.ERR_MSG_WEIGHT
          }
          else if (x.ERR_FLAG_INVOICE != 'Y' && x.ERR_FLAG_TARIFF != 'Y' && x.ERR_FLAG_WEIGHT != 'Y') {
            x.MSG = null
          }
        })
      } else if (this.checkTariff) {
        this.tableData.map(x => {
          if (x.ERR_FLAG_INVOICE == 'Y') {
            x.MSG = msg_err_invoice
          } else if (x.ERR_FLAG_PART == 'Y') {
            x.MSG = x.ERR_MSG_PART
          } else if (x.ERR_FLAG_TARIFF == 'Y') {
            x.MSG = x.ERR_MSG_TARIFF
          } else if (x.ERR_FLAG_INVOICE != 'Y' && x.ERR_FLAG_TARIFF != 'Y') {
            x.MSG = null
          }
        })
      } else if (this.checkWeight) {
        this.tableData.map(x => {
          if (x.ERR_FLAG_INVOICE == 'Y') {
            x.MSG = msg_err_invoice
          } else if (x.ERR_FLAG_PART == 'Y') {
            x.MSG = x.ERR_MSG_PART
          } else if (x.ERR_FLAG_WEIGHT == 'Y') {
            x.MSG = x.ERR_MSG_WEIGHT
          } else if (x.ERR_FLAG_INVOICE != 'Y' && x.ERR_FLAG_WEIGHT != 'Y') {
            x.MSG = null
          }
        })
      } else {

        this.tableData.map(x => {
          x.MSG = null
        })
      }
    }

    this.tableData = this.tableData.slice();
    this.CheckSelect();
  }

  public NwChange(event) {
    if (this.tableData.length == 0) return;

    // let msg_err_reason = 'Does not exist Lock Sales on @TPM_REASON_CODE!'
    let msg_err_invoice = 'Invoice number Not found!'

    if (event.checked) {
      this.tableData.map(x => {
        if (x.ERR_FLAG_INVOICE == 'Y') {
          x.MSG = msg_err_invoice
        } else if (x.ERR_FLAG_PART == 'Y') {
          x.MSG = x.ERR_MSG_PART
        } else if (x.ERR_FLAG_WEIGHT == 'Y') {
          x.MSG = x.ERR_MSG_WEIGHT
        }
      })
    } else {
      if (this.checkTariff && this.checkDuty) {
        this.tableData.map(x => {
          if (x.ERR_FLAG_INVOICE == 'Y') {
            x.MSG = msg_err_invoice
          } else if (x.ERR_FLAG_PART == 'Y') {
            x.MSG = x.ERR_MSG_PART
          } else if (x.ERR_FLAG_TARIFF == 'Y') {
            x.MSG = x.ERR_MSG_TARIFF
          } else if (x.ERR_FLAG_DUTY == 'Y') {
            x.MSG = x.ERR_MSG_DUTY
          } else if (x.ERR_FLAG_INVOICE != 'Y' && x.ERR_FLAG_TARIFF != 'Y' && x.ERR_FLAG_DUTY != 'Y') {
            x.MSG = null
          }
        })
      } else if (this.checkTariff) {
        this.tableData.map(x => {
          if (x.ERR_FLAG_INVOICE == 'Y') {
            x.MSG = msg_err_invoice
          } else if (x.ERR_FLAG_PART == 'Y') {
            x.MSG = x.ERR_MSG_PART
          } else if (x.ERR_FLAG_TARIFF == 'Y') {
            x.MSG = x.ERR_MSG_TARIFF
          } else if (x.ERR_FLAG_INVOICE != 'Y' && x.ERR_FLAG_TARIFF != 'Y') {
            x.MSG = null
          }
        })
      } else if (this.checkDuty) {

        this.tableData.map(x => {
          if (x.ERR_FLAG_INVOICE == 'Y') {
            x.MSG = msg_err_invoice
          } else if (x.ERR_FLAG_PART == 'Y') {
            x.MSG = x.ERR_MSG_PART
          } else if (x.ERR_FLAG_DUTY == 'Y') {
            x.MSG = x.ERR_MSG_DUTY
          } else if (x.ERR_FLAG_INVOICE != 'Y' && x.ERR_FLAG_DUTY != 'Y') {
            x.MSG = null
          }
        })
      } else {

        this.tableData.map(x => {
          x.MSG = null
        })
      }
    }

    this.tableData = this.tableData.slice();
    this.CheckSelect();
  }

  public CheckErr() {
    return this.tableData.filter(x => x.ERR_FLAG == 'N').length
  }

  public CheckSelect() {

    if (!this.checkTariff && !this.checkDuty && !this.checkWeight) {
      this.selection.clear()
      this.total_error = 0;
    } else {
      if (this.selection.selected.length > 0) {
        this.tableData.forEach((row) => {
          if (row.MSG) {
            this.selection.deselect(row)
          }
        });
      }
    }
    this.total_error =  this.tableData.filter(x => x.MSG).length;
    //console.log(this.selection.selected)
  }

  isAllSelected() {
    const numSelected = this.selection.selected.length;
    const numRows = this.tableData.filter(x => !x.MSG).length;
    return numSelected === numRows;
  }


  Toggle() {

    this.isAllSelected()
      ? this.selection.clear()
      : this.tableData.forEach((row) => {
        if (!row.MSG) {
          this.selection.select(row)
        }
      });
  }

  public UpdateData() {
    this.modal.confirm(
      "Do you want to save change you have made?",
      this.viewRef,
      this.ConfirmUpdateData
    );
  }

  private ConfirmUpdateData = () => {
    let isTariff = this.checkTariff == true ? "Y" : "N";
    let isDuty = this.checkDuty == true ? "Y" : "N";
    let isWeight = this.checkWeight == true ? "Y" : "N";

    let data = {
      IS_TARIFF: isTariff,
      IS_DUTY: isDuty,
      IS_WEIGHT: isWeight,
      DETAIL: this.selection.selected,
    };

    this.http.post("IC", "SNM144P_UpdateData", data).subscribe(
      (res) => {
        if (res.STATUS == "DONE") {
          this.modal.info(
            'Transaction complete: ' + this.selection.selected.length + ' record applied and saved.',
            this.viewRef
          );
          this.selection.clear();
        } else {
          this.modal.error(
            "No change to save. Something went wrong.",
            this.viewRef
          );
        }
      },
      (err) => {
        this.modal.error(
          "No change to save. Something went wrong.",
          this.viewRef
        );
      }
    );
  };


  public ShowError(){
      this.total_error = 0;
      let countrow = 0;
      this.error_list = []
      this.total_error = this.tableData.filter((x, i) => {
        if (x.MSG) {
          countrow += 1;
          this.error_list.push({
            Records: i + 1,
          });
        }
      });
      this.total_error = countrow;
      this.dialog.OpenDialog();
  }


}
