import { Component, OnInit, ViewContainerRef } from "@angular/core";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "src/app/core/modal.service";
import * as moment from "moment";
@Component({
    selector: "snm173",
    templateUrl: "./snm173.component.html",
    styleUrls: ["./snm173.component.scss"],
})
export class SNM173Component implements OnInit {

    constructor(
        private modal : ModalService,
        private viewRef: ViewContainerRef,
        private http: HttpService
    ) { }

    public fyList: any = [];
    public paramSearch: any = {};
    public tableData: any = [];

    ngOnInit() {
        this.paramSearch.FY = moment().format("YY");    
        console.log(this.paramSearch,"ppp")
        this.http.get('IC', 'SNM173_GetFY')
        .subscribe(res => {
            this.fyList = res.Table;
            this.Search();
        },(err) => {
            console.log(err, 'err')
            this.modal.warning("Found an error, please contact support team", this.viewRef);
        });
     }

     public Search() {
        this.http.post('IC', 'SNM173_GetConfig', this.paramSearch)
        .subscribe(res => {
            this.tableData = res.Table;
        },(err) => {
            console.log(err, 'err')
            this.modal.warning("Found an error, please contact support team", this.viewRef);
        });
     }

     public Save() {
        this.modal.confirm("Do you want to save", this.viewRef, () => saveConfirm())

        let saveConfirm = () => {
            this.http.post('IC', 'SNM173_Save', this.tableData)
            .subscribe(res => {
                this.Search();
                this.modal.info("Save data complete", this.viewRef)
            },(err) => { 
                console.log(err, 'err')
                this.modal.warning("Found an error, please contact support team", this.viewRef);
            });
        }
       
     }
}