import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef, Inject } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { FormControl } from '@angular/forms';
import * as moment from 'moment';

import { ModalService } from 'src/app/core/modal.service';
import { MatDialog, MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';
import { DialogPoComponent } from '../../../components/shared/dialog-po/dialog-po.component';
import { Globals } from 'src/app/core/global';
//import { DialogData, DialogComponent } from 'src/app/components/shared/dialog-po/dialog-po.component';



@Component({
  selector: 'snpe005_m',
  templateUrl: './snpe005_m.component.html',
  styleUrls: ['./snpe005_m.component.css']
})



export class SNPE005_MComponent implements OnInit {
  name: any;
  animal: any;


  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    public dialog: MatDialog,
    private viewRef: ViewContainerRef,
    private route: ActivatedRoute,
    private global: Globals
  ) {

  }


  public data: any;
  public formName: string;
  public SelectList: any;
  public mainSection: any;

  public etdList: any = [];
  public formData: any = {};
  public dataNew: any = [];
  public dataNewList: any = [];
  public dataList: any = [];
  public dataDetail: any = {};
  public vendorData: any = {};
  public findPO: any;
  public section: any;
  public pageMode: any;
  public CustomerList: any = [];
  public data1Total: any = {};

  public mtStatusCode: any = [];
  public mtPoClass: any = [];
  public mtOrderType: any = [];

  public isDelete: boolean;

  public qVendorEnable: boolean;
  private iRow: number;

  public currentDate: Date = new Date();

  public tblFooter: any = [
    {
      fieldName: "ORDER_PART_NO",
      value: "Total",
      show: true
    },
    {
      fieldName: "ACCEPT_QTY",
      
      show: true
    },
    {
      fieldName: "NET_AMT_B",
      
      show: true
    }
  ]

  public lookupConfig: any = {
    ColName: "LOOKUP_VENDOR_NAME",
    PlaceholderText: "Select Vendor",
    SourceController: "wPMS",
    SourceMethodName: "GetVendorCode",
    NoOfShowRecords: 50,
    UpperCase: true
  }

  public PartNoLookupConfig: any = {
    ColName: "LOOKUP_PART_NAME",
    PlaceholderText: "Select Part No.",
    SourceController: "wPMS",
    SourceMethodName: "GetPartNo",
    NoOfShowRecords: 20,
    UpperCase: true,
    SourceParams: {
      VENDOR_CODE: "019A",
      GROUP_PART: "Y"
    }
  }

  public PoNoLookupConfig: any = {
    ColName: "PO_NO",
    PlaceholderText: "Select PO No.",
    SourceController: "wPMS",
    SourceMethodName: "GetPartNo",
    NoOfShowRecords: 20,
    UpperCase: true
  }

  ngOnInit() {
    this.findPO = ''; //'4R9PFM';
    this.mainSection = 1;
    this.section = 1;
    this.dataDetail = {};
    this.formData = {};

    this.pageMode = 'view';


    this.qVendorEnable = true;

    this.http.get("System", "GetFormName", "SNPE005_M")
      .subscribe(result => {
        //console.log('this.result', result)
        this.formName = result.FORM_NAME;

      })

    this.http.get("System", "QueryData", "SP_NP_MT_STATUS_CODE_LIST")
      .subscribe(result => {
        //console.log('this.result', result)
        this.mtStatusCode = result.Table;

      })

    this.http.get("System", "QueryData", "SP_NP_MT_PO_CLASS_LIST")
      .subscribe(result => {
        //console.log('this.result', result)
        this.mtPoClass = result.Table;

      })

    this.http.get("System", "QueryData", "SP_NP_MT_ORDER_TYPE_LIST")
      .subscribe(result => {
        //console.log('this.result', result)
        this.mtOrderType = result.Table;

      })

  }

  public MainSection_Change(pSection) {

    if (this.mainSection == 2 && pSection == 1 && this.dataNewList.length > 0) {
      this.modal.confirm("Are you sure for quit this screen without saving the data?", this.viewRef
        , () => {
          this.pageChange(pSection);
        }
        , () => { return; })

    } else {
      this.pageChange(pSection);
    }

  }

  private pageChange(pSection) {

    this.mainSection = pSection;

    if (pSection == 1) {
      this.section = 1;

    } else if (pSection == 2) {
      this.qVendorEnable = true;
      this.dataNew = [];
      this.dataNew.PO_NO = 'New PO';
      this.dataNew.PO_DATE = new Date();
      this.section = 1;
      this.dataNew.C_CHK_NEW_PO = 'N';
      this.iRow = 0;
      // this.dataNewList = {};
      this.dataNewList = [];

      this.tblFooter[1].value = 0;
      this.tblFooter[2].value = 0;
      this.tblFooter = this.tblFooter.slice();

    }
  }

  public openDialog(): void {
    const dialogRef = this.dialog.open(DialogPoComponent, {
      width: '500px',
      height: '450px',
      data: { data_type: 'PO_NO', data_name: 'PO No.', finding_word: this.findPO }
    });

    dialogRef.afterClosed().subscribe(result => {

      if (result == undefined) {
        this.findPO = '';
      } else {
        this.findPO = result;
      }
      this.Find();
    });
  }

  public Find() {
    //console.log('this.findPO', this.findPO);

    if (this.findPO.length == 6) {
      this.formData = {};
      this.dataList = [];
      this.http.get("IC", "GetIndenStatus", this.findPO)
        .subscribe(result => {

          if (result.Table[0] == undefined) {
            this.modal.warning("This PO No. is not exists", this.viewRef);
          } else {
            this.formData = result.Table[0];
            this.dataList = result.Table1;

            this.SummaryAmount();
            this.dataList = this.dataList.slice();

            if(this.formData.IS_SAME_DAY === 'Y') {
              this.SetEditablePO();
            }
          }

        })
    } else {

    }

  }

  private SetEditablePO () {

    this.PartNoLookupConfig.SourceParams.VENDOR_CODE = this.formData.VENDOR_CODE;

    this.formData.STATUS_CODE = 'N';
    if (this.formData.VENDOR_TYPE == 'J' || this.formData.VENDOR_TYPE == 'K') {
      if (this.formData.PO_CLASS == '1' || this.formData.PO_CLASS == '2') {
        this.formData.C_METHOD = 'AIR';
      } else {
        this.formData.C_METHOD = 'SEA';
      }
    } else if (this.formData.VENDOR_TYPE == 'L' || this.formData.VENDOR_TYPE == 'O') {
      this.formData.STATUS_CODE = 'B';
      this.formData.C_METHOD = 'LOCAL';
    }

    //Get max item_no
    const maxItemNo = this.dataList.reduce((maxItemNo, currItem) => {
      if(maxItemNo < currItem.ITEM_NO)
        return currItem.ITEM_NO;

      return maxItemNo;
    }, 0)

    this.formData.MaxItemNo = maxItemNo;

    this.dataList.push({
      itemType: "Add"
    })

    this.dataList = this.dataList.slice();
  }

  public onRequestCancelChange(e, row) {

    if (e.checked) {
      row._CancelRequest = 'Y';
      row.STATUS_CODE = 'C';
    } else {
      row._CancelRequest = '';
      row.STATUS_CODE = row.OLD_STATUS_CODE;
    }
    this.SummaryAmount();
    this.dataList = this.dataList.slice();
  }

  private SummaryAmount() {

    var iQTY: number;
    var iAmount: number;
    var iCountDelete: number;

    iQTY = 0;
    iAmount = 0;
    iCountDelete = 0;
    this.dataList.forEach((value) => {

      if (value.STATUS_CODE != 'C') {
        iQTY = iQTY + value.ACCEPT_QTY;
        iAmount = iAmount + value.NET_AMT_B;
      }

      if (value.STATUS_CODE == 'N' || value.STATUS_CODE == 'B') {
        iCountDelete = iCountDelete + 1;
      }


    });

    if (iCountDelete > 0) {
      this.isDelete = true;
    } else {
      this.isDelete = false;
    }

    this.tblFooter[1].value = iQTY;
    this.tblFooter[2].value = iAmount;
    this.tblFooter = this.tblFooter.slice();
  }

  public CheckEditableField(data: any, fieldName: string) {
    let returnBool: boolean = true;
    switch (fieldName) {
      case 'ACCEPT_QTY': returnBool = this.EditableMain(data);
        break;
      case 'STATUS_CODE': returnBool = this.EditableMain(data);
        break;
      case 'ETD_DATE': returnBool = this.EditableMain(data);
        break;
      case 'ETP_DATE': returnBool = this.EditableMain(data);
        break;
      default: break;
    }

    return returnBool;
  }

  public ETD_Change(data: any) {
    data.FLAG_CHANGE = 'Y';
  }

  public EditableMain(data: any) {
    if (data.OLD_STATUS_CODE == 'N' || data.OLD_STATUS_CODE == 'B') {
      return true;
    }

    return false;

  }

  public SaveData() {

    this.modal.confirm("Are you sure to save this record?", this.viewRef,
      () => {
        this.SaveChangePart();
      }, () => { })
  }

  public CancelPO() {

    var i: number = -1;

    // this.modal.confirm("Are you sure to set the cancel to all records?", this.viewRef,
    //   () => {
        var i: number = 0;
        this.dataList.forEach((value) => {

          if (value.STATUS_CODE == 'N' || value.STATUS_CODE == 'B') {
            value.STATUS_CODE = 'C';
            i++;
          }

        });

        if (i == 0) {
          this.modal.info("There is no record for cancel", this.viewRef);
        }

        this.dataList = this.dataList.slice();

      // }, () => { })

  }

  public SaveChangePart() {
    const sendData = this.dataList
      .filter(v => (!v.itemType && (v.STATUS_CODE != v.OLD_STATUS_CODE || v.FLAG_CHANGE == 'Y')) || v.itemType === 'New')
      .map((value) => {
        value.VENDOR_CODE = this.formData.VENDOR_CODE;
        value.PO_CLASS = this.formData.PO_CLASS;
        value.PO_NO = this.formData.PO_NO;
        value.PART_NO = value.ORDER_PART_NO;
        value.ORDER_TYPE = this.formData.ORDER_TYPE;
        value.PO_DATE = this.formData.PO_DATE;
        value.LAST_UPD_PGM = 'SNPE005_M';

        return value;
    });

    if (sendData.length === 0) {
      this.modal.info("There is no record change", this.viewRef)
      return;
    }

    console.log(sendData);
    

    this.http.post("IC", "SNPE005_M_EditPart", JSON.stringify(sendData))
      .subscribe(async result => {
        if (result != "Error") {
          this.Find();
          this.modal.info("Saved data successfully : " + result, this.viewRef);
          // this.ViewItem(this.vendorData);
        }
      }, (err) => {
        console.log(err, 'err')
      })

  }

  //---------------- Page : Add new -----------------------------//

  public AddPart() {

    if (!this.dataNew.PO_CLASS) {
      this.modal.warning("Please select PO Class before add part!", this.viewRef);
      return;
    }

    if (!this.dataNew.ORDER_TYPE) {
      this.modal.warning("Please select Order type before add part!", this.viewRef);
      return;
    }

    if (!this.dataNew.VENDOR_CODE) {
      this.modal.warning("Please select Vendor code before add part!", this.viewRef);
      return;
    }
    this.qVendorEnable = false;
    this.AddMoreRow();
  }

  private AddMoreRow() {

    var iRow: number = 0;

    iRow = this.iRow;

    while (iRow < this.iRow + 10) {
      // code block to be executed

      this.dataNewList[iRow] = {};
      this.dataNewList[iRow].ITEM_NO = iRow + 1;
      this.dataNewList[iRow].SUB_ITEM_NO = '00';
      this.dataNewList[iRow].ORDER_PART_NO = '';
      this.dataNewList[iRow].ORDER_PART_NAME_EN = '';
      this.dataNewList[iRow].ACCEPT_QTY = 0;
      this.dataNewList[iRow].UNIT_PRICE = '';
      this.dataNewList[iRow].NET_AMT_B = '';

      this.dataNewList[iRow].STATUS_CODE = 'N';
      this.dataNewList[iRow].C_CHK_NEW = 'Y';

      this.dataNewList[iRow].DSP_ITEM_NO = iRow + 1 + '00';
      iRow = iRow + 1;
    }

    this.iRow = iRow;
    this.dataNewList = this.dataNewList.slice();
  }

  public OrderClassChanged(evt) {

    this.DataHeaderChanged();

    if (this.dataNew.PO_CLASS == 1 || this.dataNew.PO_CLASS == 2) {
      this.dataNew.ORDER_TYPE = 1;
    } else if (this.dataNew.PO_CLASS == 4) {
      this.dataNew.ORDER_TYPE = 3;
    } else if (this.dataNew.PO_CLASS == 3) {
      this.dataNew.ORDER_TYPE = 3;
    } else if (this.dataNew.PO_CLASS == 5) {
      this.dataNew.ORDER_TYPE = 4;
    } else if (this.dataNew.PO_CLASS == 7) {
      this.dataNew.ORDER_TYPE = 6;
    }


  }

  //----- Vendor change -------
  public SetVendorCodeLookup(value) {
    this.dataNew.VENDOR_CODE = value.VENDOR_CODE;
    this.dataNew.VENDOR_NAME = value.LOOKUP_VENDOR_NAME;

    this.PartNoLookupConfig.SourceParams.VENDOR_CODE = this.dataNew.VENDOR_CODE;
    this.DataHeaderChanged();

  }

  public DataHeaderChanged() {

    //--- Oracle Program unit : PU_PO_FIND_METHOD_STATUS_CODE

    // { PO_NO } /{PO_DATE}/{ PO_CLASS } /{VENDOR_CODE}
    var dPOdate = this.DateToString(this.dataNew.PO_DATE);

    if (this.dataNew.VENDOR_CODE != null && this.dataNew.PO_CLASS != null && this.dataNew.VENDOR_CODE != '' && this.dataNew.PO_CLASS != '') {
      this.http.get("IC", "GetVendorInfoSNP005", this.dataNew.PO_NO, dPOdate, this.dataNew.PO_CLASS, this.dataNew.VENDOR_CODE)
        .subscribe(result => {
          // this.HeaderData = result.Table[0];

          if (result.Table != null) {
            this.dataNew.VENDOR_TYPE = result.Table[0].VENDOR_TYPE;
            this.dataNew.TMP_TOP_ITEM = result.Table[0].TMP_TOP_ITEM;
            this.dataNew.OVERSEA_FLAG = result.Table[0].OVERSEA_FLAG;
            //  this.dataNew.ORDER_TYPE = result.Table[0].ORDER_TYPE;
            this.dataNew.TEMP_COUNT = result.Table[0].TEMP_COUNT;
            this.dataNew.MAX_SEQ = result.Table[0].MAX_SEQ;

            if (this.dataNew.MAX_SEQ == 0) {
              this.dataDetail = [{}];
            } else {
              this.Find();
            }

            this.dataNew.STATUS_CODE = 'N';
            if (this.dataNew.VENDOR_TYPE == 'J' || this.dataNew.VENDOR_TYPE == 'K') {
              if (this.dataNew.PO_CLASS == '1' || this.dataNew.PO_CLASS == '2') {
                this.dataNew.C_METHOD = 'AIR';
              } else {
                this.dataNew.C_METHOD = 'SEA';
              }
            } else if (this.dataNew.VENDOR_TYPE == 'L' || this.dataNew.VENDOR_TYPE == 'O') {
              this.dataNew.STATUS_CODE = 'B';
              this.dataNew.C_METHOD = 'LOCAL';
            }
          }
          //this.dataNew.TMP_MAX_SEQ = '';
        })
    }

  }

  public ClearPart(data) {
    data.ORDER_PART_NO = data.OLD_ORDER_PART_NO;
  }

  public SetPartLookup(value, data, dataList, dataHeader) {

    if (!value) {
      data.ORDER_PART_NAME_EN = null;
      data.ACCEPT_QTY = 0;
      data.UNIT_PRICE = null;
      data.NET_AMT_B = null;
      data.ORDER_PART_NO = null;
      data.ORDER_PART_NAME_EN = null;

      return;
    }

    // data.OLD_ORDER_PART_NO = value.PART_NO;
    data.ORDER_PART_NO = value.PART_NO;
    data.ORDER_PART_NAME_EN = value.PART_NAME_EN;
    data.ACCEPT_QTY = 0;

    //{PART_NO}/{PO_DATE}/{C_METHOD}/{VENDOR_TYPE}/{VENDOR_CODE}

    var dPOdate = this.DateToString(dataHeader.PO_DATE);
    this.http.get("IC", "GetETD_SNP005", data.ORDER_PART_NO, dPOdate, dataHeader.C_METHOD, dataHeader.VENDOR_TYPE, dataHeader.VENDOR_CODE)
      .subscribe(result => {

        if (result.Table != null) {
          data.LOCK_PO = result.Table[0].LOCK_PO;
          if (data.LOCK_PO != 0) {
            this.modal.warning("This part is Lock PO [" + data.LOCK_PO + "]. Please Check.", this.viewRef);
          }
          data.PO_PACKAGE = result.Table[0].PO_PACKAGE;
          data.UNIT_PRICE = result.Table[0].UNIT_PRICE;
          data.ETD_DATE = result.Table[0].ETD_DATE;
          data.ETA_EO_BKK_DATE = result.Table[0].ETA_EO_BKK_DATE;
          data.ETA_EO_UPC_DATE = result.Table[0].ETA_EO_UPC_DATE;
          data.ETA_RO_BKK_DATE = result.Table[0].ETA_RO_BKK_DATE;
          data.ETA_RO_UPC_DATE = result.Table[0].ETA_RO_UPC_DATE;
          data.FIRAT_ETD_DATE = result.Table[0].FIRAT_ETD_DATE;

          data.AVERAGE_AMT = result.Table[0].AVG_COST * this.dataDetail.ACCEPT_QTY;
          data.STANDARD_AMT = result.Table[0].STD_COST * this.dataDetail.ACCEPT_QTY;

          this.Part_Change(data, dataList);
        }
      })

  }

  public Part_Change(data, dataList) {

    if (data.ORDER_PART_NO == '') {
      data.ORDER_PART_NAME_EN = '';
      data.ACCEPT_QTY = 0;
      data.UNIT_PRICE = '';
      data.NET_AMT_B = '';
      return;
    }
    
    if(dataList.find(value => value.ORDER_PART_NO != '' && value.ORDER_PART_NAME_EN != '' && data.ORDER_PART_NO == value.ORDER_PART_NO && data.DSP_ITEM_NO != value.DSP_ITEM_NO)){
        this.modal.warning("There is the duplicate part no, please check again", this.viewRef);
        data.ORDER_PART_NO = '';
        data.ORDER_PART_NAME_EN = '';
        data.ACCEPT_QTY = 0;
        data.UNIT_PRICE = '';
        data.NET_AMT_B = '';
        return;
    } else {
      data.OLD_ORDER_PART_NO = data.ORDER_PART_NAME_EN;
    }

  }

  public ViewAddItem(data) {

    this.iRow = data.ITEM_NO - 1;
    this.dataDetail = data;
    this.section = 2;
  }

  public CloseTemp() {
    this.section = 1;
  }

  public QTY_Changed(event, data) {
    if (!event.target.validity.valid) {
      this.modal.warning("The QTY must more than 0 but not more than 9,999,999", this.viewRef);
      data.ACCEPT_QTY = 0;
    } else {
      if (data.ACCEPT_QTY % data.PO_PACKAGE > 0) {
        this.modal.warning("Invalid value number, Please check. The PO package is " + data.PO_PACKAGE + " .", this.viewRef);
      }
    }

    data.NET_AMT_B = data.ACCEPT_QTY * data.UNIT_PRICE;
    data.NET_AMT = data.ACCEPT_QTY * data.UNIT_PRICE;
  }

  public SavePO_Click() {
    this.modal.confirm("Are you sure to save this record?", this.viewRef,
      () => {

        this.SavePO();

      }, () => { })
  }

  public DeleteRow(e, data, index) {

    this.modal.confirm("Are you sure to delete this records?", this.viewRef,
      () => {

        this.dataNewList = this.dataNewList.filter(obj => obj !== data);
        this.iRow = this.iRow - 1;

        var iMax = this.dataNewList.length;
        for (let i = 0; i < iMax; i++) {
          this.dataNewList[i].ITEM_NO = i + 1;
          this.dataNewList[i].DSP_ITEM_NO = i + 1 + '00';
        }


      }, () => { })

  }

  private SavePO() {

    //--- Confirm to save data
    var sendData: any = [];
    var i: number = 0;
    var qFlagExit: boolean;


    qFlagExit = false;
    //---- Get only inputed data -----
    this.dataNewList.forEach((value) => {

      if (value.ORDER_PART_NO != '' && value.ORDER_PART_NAME_EN != '') {

        //---------- validate data before save ----------------------
        sendData.forEach((tmpData) => {
          if (tmpData.PART_NO == value.ORDER_PART_NO) {
            this.modal.warning("There is the duplicate part no, please check again", this.viewRef);
            qFlagExit = true;
            return;
          }
        });
        if (value.ACCEPT_QTY == 0) {
          this.modal.warning("Do not allow the order QTY as 0, please input again ", this.viewRef);
          qFlagExit = true;
          return;
        }
        sendData[i] = {};

        sendData[i].VENDOR_CODE = this.dataNew.VENDOR_CODE;
        sendData[i].PO_CLASS = this.dataNew.PO_CLASS;
        sendData[i].PO_NO = this.dataNew.PO_NO;
        sendData[i].ORDER_TYPE = this.dataNew.ORDER_TYPE;
        sendData[i].PO_DATE = this.dataNew.PO_DATE;

        sendData[i].ITEM_NO = i + 1;
        sendData[i].SUB_ITEM_NO = value.SUB_ITEM_NO;
        sendData[i].PART_NO = value.ORDER_PART_NO;
        sendData[i].ACCEPT_QTY = value.ACCEPT_QTY;

        sendData[i].ETD_DATE = value.ETD_DATE;
        sendData[i].STATUS_CODE = value.STATUS_CODE;
        i = i + 1;

      }

    });


    if (qFlagExit) {
      return;
    }
    //------ Sum total -------
    this.dataNew.TOTAL_QTY = 0;
    this.dataNew.TOTAL_AMT = 0;
    this.dataNew.TOTAL_AVERAGE_AMT = 0;
    this.dataNew.TOTAL_STANDARD_AMT = 0;
    this.dataNew.COUNT_ITEM = 0;


    sendData.forEach((value) => {
      //console.log(value.RS_UNIT);
      this.dataNew.TOTAL_QTY = this.dataNew.TOTAL_QTY + value.ACCEPT_QTY;
      this.dataNew.TOTAL_AMT = this.dataNew.TOTAL_AMT + value.NET_AMT_B;

      this.dataNew.TOTAL_AVERAGE_AMT = this.dataNew.TOTAL_AVERAGE_AMT + value.AVERAGE_AMT;;
      this.dataNew.TOTAL_STANDARD_AMT = this.dataNew.TOTAL_STANDARD_AMT + value.STANDARD_AMT;;
      this.dataNew.COUNT_ITEM = this.dataNew.COUNT_ITEM + 1;
    });


    sendData[0].OVERSEA_FLAG = this.dataNew.OVERSEA_FLAG;
    sendData[0].TMP_TOP_ITEM = this.dataNew.TMP_TOP_ITEM;
    sendData[0].TEMP_COUNT = this.dataNew.TEMP_COUNT;
    sendData[0].MAX_SEQ = this.dataNew.MAX_SEQ;
    sendData[0].C_METHOD = this.dataNew.C_METHOD;


    sendData[0].TOTAL_QTY = this.dataNew.TOTAL_QTY;
    sendData[0].TOTAL_AMT = this.dataNew.TOTAL_AMT;
    sendData[0].TOTAL_AVERAGE_AMT = this.dataNew.TOTAL_AVERAGE_AMT;
    sendData[0].TOTAL_STANDARD_AMT = this.dataNew.TOTAL_STANDARD_AMT;
    sendData[0].COUNT_ITEM = this.dataNew.COUNT_ITEM;
    sendData[0].LAST_UPD_PGM = 'SNPE005_M';

    this.http.post("IC", "SavePOWithPartNo", JSON.stringify(sendData))
      .subscribe(result => {

        // console.log('Result : ' + result.substring(0, 4));
        if (result.substring(0, 5) != "Error") {
          this.modal.info("Saved data successfully : ", this.viewRef);

          this.findPO = result;
          this.mainSection = 1;
          this.section = 1;
          this.Find();
        } else {
          this.modal.error(result, this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err')
      })

    this.dataDetail.PO_NO = this.dataNew.PO_NO;

    // }
  }

  public ViewItem(data) {

    this.dataDetail = data;
    this.section = 2;
  }



  public EditETD(data) {

    this.vendorData = data;

  }

  public DateToString(pDate) {
    if(!(pDate instanceof Date))
      pDate = new Date(pDate);

    let iDay = pDate.getDate();
    let iYear = pDate.getFullYear()
    let iMonth = pDate.getMonth() + 1;
    return iDay + '-' + iMonth + '-' + iYear;

  }

  public OpenReport() {
    //"ssComCode" is JWT detail that insert company code is "01", that selected on log in.
    this.global.GoToReport("PMS_RPT_IC_SNPE005",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_PO_NO: this.formData.PO_NO
      }
    );
  }

  public AddNewPart() {
    this.dataList.pop();
    
    this.dataList.push({
      itemType: "New",
      STATUS_CODE: this.formData.STATUS_CODE
    })
    this.dataList.push({
      itemType: "Add"
    })

    this.ReCalItem();

    this.dataList = this.dataList.slice();
  }

  public ReCalItem() {
    let count = this.formData.MaxItemNo;
    
    this.dataList.filter(v => v.itemType === "New")
      .forEach(v => {
        count++;
        v.ITEM_NO = count;
        v.SUB_ITEM_NO = '00';
        v.DSP_ITEM_NO = count + '00';
      })
  }

  public RemoveNewPart(index: number){
    this.dataList.splice(index, 1);
    this.ReCalItem();

    this.dataList = this.dataList.slice();
  }
}

