import { Component, OnInit, ViewContainerRef, ViewChild, ElementRef } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from '../../../core/modal.service';


@Component({
  selector: 'snpe048',
  templateUrl: './SNPE048.component.html',
  styleUrls: ['./SNPE048.component.css']
})

export class SNPE048Component implements OnInit {

  constructor(
    private Http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  public params: any = {};
  public dataListImport: any = [];
  public dataListLocal: any = [];

  public file: any;
  public fileName: any;
  public countMSG: number = 0;
  public error_list: any = [];
  public total_error: number = 0;
  public param: any = {};
  @ViewChild("dialogError", { static: false }) dialogError: any;

  @ViewChild("fileUpload") fileUpload: ElementRef;

  ngOnInit() {
    this.params.TYPE = null;
  }

  public DownloadTemplate() {
    let link = "assets/templates/PMS_Upload_Suggest_Template.xlsx"
    window.open(link, '_blank')
  }

  public OpenFileBrowser() {
    this.dataListImport = [];
    this.param.REJECT = "";
    this.fileName = "";
    this.fileUpload.nativeElement.value = '';
    this.fileUpload.nativeElement.click();
  }

  public SelectFile(evt) {
    this.file = null;
    let Files: Array<File> = evt.target.files;

    if (Files.length > 0) {
      this.file = Files[0];
      this.fileName = this.file.name;
    }
  }

  public PreviewExcel() {
    if (!this.fileName) {
      this.modal.warning("Please open the file...", this.viewref)
      return;
    }

    let formData = new FormData();
    formData.append('file', this.file);
    formData.append('type', this.params.TYPE);
    this.Http.postFile("IC", "SNPE048_Upload_Suggest", formData)
      .subscribe(result => {
        this.Http.post("IC", "SNPE048_GetTempData", this.params)
          .subscribe(result => {
            // this.dataListImport = result.Table;
            this.error_list = [];
            let countrow = 0;
            this.dataListImport = result.Table.filter((x) => x.GROUP_PART_NO);
            
            this.countMSG = 0
            this.dataListImport.map((data, index) => {
              if (data.MESSAGE != null) {
                countrow += 1;
                this.error_list.push({
                  Records: + index + 1 + " Part No : "+ data.GROUP_PART_NO + " Error: " + data.MESSAGE,
                });
              }
              this.total_error = countrow;
              
            });
            if (this.total_error > 0){
              this.param.REJECT = this.total_error;
              // this.modal.warning(this.error_list, this.viewref);
              // return;
              this.dialogError.OpenDialog()
            }
            
            
          })
      }, err => {
        console.log(err);
        this.modal.error("Found error, please contact support team.", this.viewref);
      })
  }

  public Confirm() {
    let foundErr = null;

    foundErr = this.dataListImport.some(x => x.MESSAGE)
    if (this.dataListImport.length <= 0) {
      this.modal.warning('There is no data for confirm suggest!!', this.viewref)
      return;
    }
    if (foundErr) {
      this.modal.warning('Found error message, please check!!' + foundErr , this.viewref)
      return;
    }
    this.modal.confirm('Do you want to confirm suggest?', this.viewref, this.ConfirmSuggest)
  }

  private ConfirmSuggest = () => {
    this.Http.post("IC", "SNPE048_ConfirmSuggest", this.params)
      .subscribe(result => {
        if (result.Table[0].STATUS = 'DONE') {
          this.modal.info("Confirm Suggest Completed.", this.viewref);
          this.Http.post("IC", "SNPE048_ClearTemp", this.params)
            .subscribe(result => {
              this.dataListImport = [];
            }, err => {
              console.log(err);
              this.modal.error("Found error, please contact support team.", this.viewref);
            })
        }
      }, err => {
        console.log(err);
        this.modal.error("Found error, please contact support team.", this.viewref);
      })
  }
}
