import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'snpj006_d1',
  templateUrl: './snpj006_d1.component.html',
  styleUrls: ['./snpj006_d1.component.css']
})



export class SNPJ006_D1Component implements OnInit {

  public filePath1: string;
  public filePath2: string;
  public fileList: any = {};

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private route: ActivatedRoute,
    public global: Globals
  ) { 

  }

  ngOnInit() {
    this.GetFilePath();
  }

  GetFilePath() {
    this.http.get("IC", "SNPJ006_D1_GetFilePath")
      .subscribe((result: any) => {
        this.filePath1 = result.Table[0]["FM_FILE_NAME"].toString();
        this.filePath2 = result.Table[0]["TO_FILE_NAME"].toString();
      })
  }

  BeginProcess() {
    this.modal.confirm("Are you sure to begin the process?", this.viewref,
      () => {
        this.http.post("IC", "SNPJ006_D1_BeginProcess", {})
          .subscribe(result => {
            if (result.status === "Done") {
              this.modal.info(result.message, this.viewref);
            } else {
              this.modal.error(result.message, this.viewref);
            }

          }, err => {
            this.modal.warning(
              "Found an error, please contact support team",
              this.viewref
            );
          })
      }, () => { })
  }
}

