import { Component, Input, OnChanges, OnInit, SimpleChanges, ViewChild, ViewContainerRef } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';
import { ActivatedRoute } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { SelectionModel } from "@angular/cdk/collections";
import { MatTableDataSource } from "@angular/material/table";
import { MatPaginator } from "@angular/material/paginator";



@Component({
  selector: 'snpp204po',
  templateUrl: './snpp204po.component.html',
  styleUrls: ['./snpp204po.component.css']
})
export class SNPP204POComponent implements OnChanges {

  constructor(
    private http: HttpService,
    public modal: ModalService,
    public viewref: ViewContainerRef,
    private route: ActivatedRoute,
    private global: Globals
  ) {}

  @Input("tableDataPO") tableData: Array<any> = [];
  @Input("tableHeaderPO") tableHeaderPO: Array<any> = [];


  public tableDetail: any = [];
  public selection = new SelectionModel<any>(true, []);
  public columnsToDisplayPO = [];
  public headerList: Array<any> = [];
  @ViewChild("paginatorPO", { static: true }) paginatorPO: MatPaginator;
  public dataList: any = [];

  ngOnInit() {
      this.headerList = this.tableHeaderPO;
      this.ArrangeShowColumn(this.headerList);

   }

   ngOnChanges(changes: SimpleChanges): void {
    if (!changes["tableData"].isFirstChange() && this.tableData) {
      // if (this.tableDataPO.length === 0) {
      
      // }
    }
    this.tableDetail = new MatTableDataSource<any>(this.tableData || []);
    this.tableDetail.paginator = this.paginatorPO;
    this.ArrangeShowColumn(this.headerList);

  }


  ArrangeShowColumn(data) {
    // console.log(data,'cccccccccccccccc')
    this.columnsToDisplayPO = data.map(v => v.FIELD_NAME);
  }

}
