import { Component, Input, OnChanges, OnInit, SimpleChanges, ViewChild, ViewContainerRef } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';
import { ActivatedRoute } from '@angular/router';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'snpp206po',
  templateUrl: './SNPP206PO.component.html',
  styleUrls: ['./SNPP206PO.component.css']
})
export class SNPP206POComponent implements OnChanges {

  constructor(
    private http: HttpService,
    public modal: ModalService,
    public viewref: ViewContainerRef,
    private route: ActivatedRoute,
    private global: Globals
  ) {}

  @Input("tableName") tableName: String;
  @Input("tableData") tableData: Array<any> = [];

  public name: String;

  ngOnInit() {
    this.name = this.tableName;
  }

  ngOnChanges(changes: SimpleChanges): void {
    if (!changes["tableData"].isFirstChange() && this.tableData) {
      if (this.tableData.length === 0) {
        this.name = this.tableName;
      }
      else{
        this.name = this.tableName;
      }
    }
  }
}
