import { Component, ElementRef, OnInit, ViewContainerRef } from '@angular/core';
import { Globals } from 'src/app/core/global';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';

@Component({
    selector: 'snpp211',
    templateUrl: './snpp211.component.html',
    styleUrls: ['./snpp211.component.css']
  })
  export class SNPP211Component implements OnInit {
    constructor(
        private http: HttpService,
        private modal: ModalService,
        private viewref: ViewContainerRef,
        private el: ElementRef,
        private global: Globals
    ) { }


    ngOnInit() { }

    BeginProcess() {
        this.modal.confirm("Confirm Run Allocate", this.viewref
            , () => {
                this.http.post("IC", "SNPP211_Run_Allocate_Process", null)
                    .subscribe(result => {
                        if(result.status == "Done") {
                            this.modal.info("Process complete....", this.viewref);
                        }
                    }, (err) => {
                        console.log("err", err)
                        this.modal.error("Found eror, please contact support team.", this.viewref);
                    })
            }, () => { })
    }
}