import { MatInput, } from '@angular/material/input';
import { Component, ElementRef, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from 'src/app/core/modal.service';
import { MatSelect } from '@angular/material/select';

@Component({
    selector: 'SNM152',
    templateUrl: 'SNM152.component.html',
    styleUrls: ['SNM152.component.css']
})

export class SNM152Component implements OnInit {
    constructor(
        private http: HttpService,
        private router: Router,
        private global: Globals,
        private modal: ModalService,
        private viewref: ViewContainerRef
  ) { }

  @ViewChild('optioncode') optioncode: ElementRef;
  @ViewChild('optiontype') optiontype: MatSelect;
  @ViewChild('completePartno') completePartno: ElementRef;
  @ViewChild('wipPartno') wipPartno: ElementRef;
  @ViewChild('installLocation') installLocation: ElementRef;

  @ViewChild("dialogAction", { static: false }) dialogAction: any;
  @ViewChild("fileInput") fileInput: ElementRef;
  @ViewChild("dialogUpload", { static: false }) dialogUpload: any;

  public activityOption: any = {};

  public paramSearch: any = {};
  public formData: any = {};
  public tableData: Array<any> = [];

  //Upload File
  public FileName: string = "";
  private File : any;
  public tableUpload = []
  public tableUploadFilter = []
  public total_error :number = 0;
  public error_list = []
  
  public lookupCompletePartNoConfig: any = {
    ColName: "LOOKUP_COMPLETE_PART_NO",
    PlaceholderText: "Select complete part no",
    SourceController: "K9",
    SourceMethodName: "SNM152_GetCompletePartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedCompletePartNoDialog(val: any) {
    if(val){
      this.formData.COMPLETE_PART_NO = val.COMPLETE_PART_NO;
      this.formData.COMPLETE_PART_NAME_EN = val.COMPLETE_PART_NAME_EN;
      this.formData.COMPLETE_PART_NAME_TH = val.COMPLETE_PART_NAME_TH;
      this.formData.COMPLETE_PART_NO_TEMP = val.COMPLETE_PART_NO;
      this.formData.COMPLETE_PART_NAME_EN_TEMP = val.COMPLETE_PART_NAME_EN;
      this.formData.COMPLETE_PART_NAME_TH_TEMP = val.COMPLETE_PART_NAME_TH;
    }else{
      this.formData.COMPLETE_PART_NO = null;
      this.formData.COMPLETE_PART_NAME_EN = null;
      this.formData.COMPLETE_PART_NAME_TH = null;
      this.formData.COMPLETE_PART_NO_TEMP = this.formData.COMPLETE_PART_NO;
      this.formData.COMPLETE_PART_NAME_EN_TEMP = null;
      this.formData.COMPLETE_PART_NAME_TH_TEMP = null;
    }
  }

  public SetCancelCompletePartNoDialog(val: any) {
    this.formData.COMPLETE_PART_NO = this.formData.COMPLETE_PART_NO_TEMP ? this.formData.COMPLETE_PART_NO_TEMP : null ;
    this.formData.COMPLETE_PART_NAME_EN = this.formData.COMPLETE_PART_NAME_EN_TEMP ? this.formData.COMPLETE_PART_NAME_EN_TEMP : null ;
    this.formData.COMPLETE_PART_NAME_TH = this.formData.COMPLETE_PART_NAME_TH_TEMP ? this.formData.COMPLETE_PART_NAME_TH_TEMP : null ;
  }
  
  public lookupWIPPartNoConfig: any = {
    ColName: "LOOKUP_WIP_PART_NO",
    PlaceholderText: "Select work in progress part no",
    SourceController: "K9",
    SourceMethodName: "SNM152_GetWIPPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedWIPPartNoDialog(val: any) {
    if(val){
      this.formData.WIP_PART_NO = val.WIP_PART_NO;
      this.formData.WIP_PART_NAME_EN = val.WIP_PART_NAME_EN;
      this.formData.WIP_PART_NAME_TH = val.WIP_PART_NAME_TH;
      this.formData.WIP_PART_NO_TEMP = val.WIP_PART_NO;
      this.formData.WIP_PART_NAME_EN_TEMP = val.WIP_PART_NAME_EN;
      this.formData.WIP_PART_NAME_TH_TEMP = val.WIP_PART_NAME_TH;
    }else{
      this.formData.WIP_PART_NO = null;
      this.formData.WIP_PART_NAME_EN = null;
      this.formData.WIP_PART_NAME_TH = null;
      this.formData.WIP_PART_NO_TEMP = this.formData.WIP_PART_NO;
      this.formData.WIP_PART_NAME_EN_TEMP = null;
      this.formData.WIP_PART_NAME_TH_TEMP = null;
    }
  }

  public SetCancelWIPPartNoDialog(val: any) {
    this.formData.WIP_PART_NO = this.formData.WIP_PART_NO_TEMP ? this.formData.WIP_PART_NO_TEMP : null ;
    this.formData.WIP_PART_NAME_EN = this.formData.WIP_PART_NAME_EN_TEMP ? this.formData.WIP_PART_NAME_EN_TEMP : null ;
    this.formData.WIP_PART_NAME_TH = this.formData.WIP_PART_NAME_TH_TEMP ? this.formData.WIP_PART_NAME_TH_TEMP : null ;
  }
  
  public lookupInstallLocationCodeConfig: any = {
    ColName: "LOOKUP_LOCATION_CODE",
    PlaceholderText: "Select install location code",
    SourceController: "K9",
    SourceMethodName: "SNM152_GetInstallLocationCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedInstallLocationCodeDialog(val: any) {
    if(val){
      this.formData.INSTALL_LOCATION_CODE = val.INSTALL_LOCATION_CODE;
      this.formData.INSTALL_LOCATION_CODE_TEMP = val.INSTALL_LOCATION_CODE;
    }else{
      this.formData.INSTALL_LOCATION_CODE = null;
      this.formData.INSTALL_LOCATION_CODE_TEMP = this.formData.INSTALL_LOCATION_CODE;
    }
  }

  public SetCancelInstallLocationCodeDialog(val: any) {
    this.formData.INSTALL_LOCATION_CODE = this.formData.INSTALL_LOCATION_CODE_TEMP ? this.formData.INSTALL_LOCATION_CODE_TEMP : null ;
  }
  public lookupBaseModelConfig: any = {
    ColName: "LOOKUP_BASE_MODEL",
    PlaceholderText: "Select Base Model",
    SourceController: "K9",
    SourceMethodName: "SNM152_GetBaseModel",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }
  public SetSelectedBaseModelDialog(val: any) {
    if(val){
      this.formData.BASE_MODEL = val.BASE_MODEL;
      this.formData.BASE_MODEL_TEMP = val.BASE_MODEL;
    }else{
      this.formData.BASE_MODEL = null;
      this.formData.BASE_MODEL_TEMP = this.formData.BASE_MODEL;
    }
  }
  public SetCancelBaseModelDialog(val: any) {
    this.formData.BASE_MODEL = this.formData.BASE_MODEL_TEMP ? this.formData.BASE_MODEL_TEMP : null ;
  }

  ngOnInit() {
    this.GetDataMaster();
    this.Search();
  }

  public GetDataMaster(){
    this.http.get("K9", 'SNM152_GetActivityMaster')
    .subscribe(res => {
        this.activityOption = res.set.Table;
    },(err) => {
      console.log(err, 'err')
      this.modal.warning("Found an error, please contract support team", this.viewref);
    });
  }

  public Search() {
    const optioncode = this.global.EscapeCharacter(this.paramSearch.OPTION_CODE ? this.paramSearch.OPTION_CODE : "NULL");
    const completePartno = this.global.EscapeCharacter(this.paramSearch.COMPLETE_PART_NO ? this.paramSearch.COMPLETE_PART_NO : "NULL");
    const wipPartno = this.global.EscapeCharacter(this.paramSearch.WIP_PART_NO ? this.paramSearch.WIP_PART_NO : "NULL");
    this.http.get("K9", 'SNM152_GetData', optioncode, completePartno, wipPartno)
    .subscribe(res => {
        this.tableData = res.set.Table;
    },(err) => {
      console.log(err, 'err')
      this.modal.warning("Found an error, please contract support team", this.viewref);
    });
  }
  
  public Add() {
    this.formData = {}
    this.formData.TYPE = "ADD";
    this.dialogAction.width = "800px" 
    this.dialogAction.height = "675px" 
    this.dialogAction.title = "Add PDI K9 Option header" 
    this.dialogAction.OpenDialog();
  }

  public Edit(data) {
    this.formData = { ...data }
    this.formData.INSTALL_LOCATION_CODE_TEMP = this.formData.INSTALL_LOCATION_CODE;
    this.formData.BASE_MODEL_TEMP = this.formData.BASE_MODEL;
    this.formData.TYPE = "EDIT";
    this.dialogAction.width = "800px" 
    this.dialogAction.height = "700px" 
    this.dialogAction.title = "Edit PDI K9 Option header" 
    this.dialogAction.OpenDialog();
  }

  public Delete(data) {
    this.modal.confirm("Do you want to delete record"
                        + "<br>Option code: " + data.OPTION_CODE
                        //+ "<br>Base model: "  + data.BASE_MODEL
                      , this.viewref
                      , () => ConfirmDelete())

    let ConfirmDelete = () => {
      const params = { BASE_MODEL : data.BASE_MODEL, OPTION_CODE : data.OPTION_CODE }
      this.http.post("K9", "SNM152_Delete", params)
      .subscribe(res =>{
        if (res.status == 'DONE') {
          this.Search();
          this.modal.info(res.message, this.viewref);
        } else {
          this.modal.error(res.message, this.viewref);
        }
      },err =>{
        console.log(err, 'err')
        this.modal.error('Found an error, please contract support team.', this.viewref);
      })
    }
  }

  public SaveAdd(){
    if(this.ValidateNotNullField() === false){
      return;
    }
    this.modal.confirm("Do you want to save change you have made?", this.viewref, () => ConfirmAdd());

    let ConfirmAdd = () =>  {
      this.http.post("K9", 'SNM152_Insert', this.formData)
      .subscribe(res => {
        if (res.status == 'DONE') {
          this.Search();
          this.dialogAction.Close();
          this.modal.info(res.message, this.viewref);
        }  
        else {
          this.modal.error(res.message, this.viewref);
        }
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewref);
      })
    }
  }

  public CancelAdd() {
    this.dialogAction.Close();
  }

  public SaveEdit() {
    if(this.ValidateNotNullField() === false){
      return;
    }
    this.modal.confirm("Do you want to save change you have made?", this.viewref, () => ConfirmEdit());

    let ConfirmEdit = () => {
      this.http.post("K9", 'SNM152_Update', this.formData)
      .subscribe(res => {
        if (res.status == 'DONE') {
          this.Search();
          this.dialogAction.Close();
          this.modal.info(res.message, this.viewref);
        } else {
          this.modal.error(res.message, this.viewref);
        }
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewref);
      });
    }
  }

  public CancleEdit() {
    this.dialogAction.Close();
  }

  public ValidateNotNullField(): boolean{
   if(!this.formData.OPTION_CODE){
      this.modal.warning("Please fill Option code.",this.viewref,() => {this.optioncode.nativeElement.focus()});
      return false;
    }
    else if(!this.formData.OPTION_TYPE){
      this.modal.warning("Please select Option type.",this.viewref,() => {this.optiontype.toggle()});
      return false;
    }
    else if(!this.formData.COMPLETE_PART_NO){
      this.modal.warning("Please select Completed part no.",this.viewref,() => {this.completePartno.nativeElement.focus()});
      return false;
    }
    else if(!this.formData.WIP_PART_NO){
      this.modal.warning("Please select Work in progress part no.",this.viewref,() => {this.wipPartno.nativeElement.focus()});
      return false;
    }
    else if(!this.formData.INSTALL_LOCATION_CODE){
      this.modal.warning("Please select Install Location Code.",this.viewref,() => {this.installLocation.nativeElement.focus()});
      return false;
    }

    return true;
  }

  public OpenReport(report: number){
    switch(report){
      case 1:
          this.global.GoToReport("PMS_RPT_PDI_SNM152_EXCEL_REPORT",
          {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_OPTION_CODE: this.paramSearch.OPTION_CODE,
            P_COMPLETE_PART_NO: this.paramSearch.COMPLETE_PART_NO,
            P_WIP_PART_NO: this.paramSearch.WIP_PART_NO,
          });
        break;
    }
  }

  public OpenUpload(){
    this.total_error = 0;
    this.FileName = "";
    this.error_list = [];
    this.tableUpload = [];
    this.tableUploadFilter = [];
    this.dialogUpload.width="1350px";
    this.dialogUpload.height="725px";
    this.dialogUpload.title = "Upload PDI K9 Option header";
    this.dialogUpload.OpenDialog()
  }

  public DownloadTemplate(){
    this.global.GoToExport("PMS_RPT_PDI_SNM152_UPLOAD_TEMPLATE",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      }, true, "EXCELOPENXML")
  }
  
  public openFileBrowser() {
    this.FileName = "";
    this.fileInput.nativeElement.value = '';
    this.fileInput.nativeElement.click();
  }

  public selectFile(evt) {
    let Files: Array<File> = evt.target.files;
    if (Files.length > 0) {
      this.File = Files[0];
      this.FileName = this.File.name;
    }
  }

  public PreView() {
    if (!this.FileName) {
      this.modal.warning("Please Open File First...", this.viewref)
      return;
    }
    
    let formData = new FormData();
    formData.append('file', this.File);

    this.tableUpload = []
    this.error_list = []
    this.http.postFile("K9", "SNM152_UploadFile", formData)
      .subscribe(result => {
        this.tableUpload = result.set.Table;
        this.tableUploadFilter = this.tableUpload.filter(x => x.ERR_FLAG == 'N')
        let countrow = 0;
        this.tableUpload.map((x,i) => {
          if(x.ERR_FLAG == 'Y'){
              countrow += 1;
              this.error_list.push({
                  record : i + 1,
                  message : x.ERR_MSG
              })
          } 
          this.total_error = countrow;
      })
    }, err => {
      console.log(err, 'err')
      this.modal.error('Found an error, please contract support team.', this.viewref);
    })
  }

  public SaveUpload(){
    this.modal.confirm("Do you want to save change you have made?",this.viewref,() => ConfirmSave())

    let ConfirmSave = () => {
      const params = {}
      this.http.post("K9", "SNM152_SaveByUpload", params)
      .subscribe(res => {
        if(res.status == "DONE"){
          this.Search();
          this.dialogUpload.Close();
          this.modal.info(res.message,this.viewref);
        }else{
          this.modal.error(res.message,this.viewref)
        }
      },err => {
        console.log(err, 'err')
        this.modal.error('Found an error, please contract support team.', this.viewref);
      })
    }
  }
}


function isNumber(str: string): boolean{
  return !Number.isNaN(Number(str));
}

function isDecimal(str: string): boolean{
  if(!isNumber){
    return false;
  }

  var number = Number(str);
  if (number !== Math.floor(number)) {
    return true;
 } else {
  return false;
 }
}