import { Component, ElementRef, Input, OnChanges, OnInit, SimpleChanges, ViewChild, ViewContainerRef } from '@angular/core';
import { DialogTemplateComponent } from 'src/app/components/shared/dialog-template/dialog-template.component';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';


@Component({
    selector: 'SNPE051_ASSEMBLE',
    templateUrl: 'SNPE051_ASSEMBLE.component.html',
    styleUrls: ['../SNPE051.component.css', '../../k9.component.css']
})

export class SNPE051AssembleComponent implements OnChanges {
    constructor(
        private http: HttpService,
        private modal: ModalService,
        private viewref: ViewContainerRef,
        private global: Globals) { }

     public ConfigPart: any = {
        ColName: "LOOKUP_PART",
        PlaceholderText: "Select Part No.",
        SourceController: "AC",
        SourceMethodName: "SNPE051_GetPart",
        MinLengthSearch: 3,
        NoOfShowRecords: 30
      }

    public paramsSearch : any = {};
    public tableData : any =[];
    public data : any ={};
    public showSearch : boolean = true;
    public isSave : boolean = false;
    public tableDetail : any = []
    @Input("tabChange") tabChange: string = '';
    @ViewChild("dialog") dialog: DialogTemplateComponent;
    @ViewChild("fileInput") fileInput: ElementRef;

    public tableDataUpload: any = [];
    public correctData: any = [];
    private file: any;
    public fileNameInput: string = "";
   
    ngOnChanges(changes: SimpleChanges): void {
        if(this.tableData.length > 0){
            this.tableData = []
            this.tableDataUpload = []
        }
        
    }
    ngOnInit(){

    }
    public OpendialogUpload() {
        //this.dialogUpload.OpenDialog();
        this.fileNameInput = "";
        //this.fileInput.nativeElement.value = '';
        this.tableDataUpload = []
        this.correctData = []
      }
    
      public OpenFileBrowser() {
        this.fileNameInput = "";
        this.fileInput.nativeElement.value = '';
        this.fileInput.nativeElement.click();
      }
      public SelectFile(evt) {
        let Files: Array<File> = evt.target.files;
        if (Files.length > 0) {
          //let File: File = Files[0];
          this.file = Files[0];
          this.fileNameInput = this.file.name;
        }
      }
    
      public PreView() {
        if (!this.fileNameInput) {
          this.modal.warning("Please Open File First...", this.viewref)
          return;
        }
        let formData = new FormData();
        formData.append('file', this.file);
        this.tableDataUpload = []
    
        this.http.postFile("K9", "SNPE051_UploadFileAssemble", formData)
        .subscribe(result => {
          this.tableDataUpload = result.Table;
        }, err => {
          this.modal.error('Found an error, please contract support team.', this.viewref);
        })
        
      }
      
      public ConfirmProcess(){
        if(!this.fileNameInput || this.tableDataUpload.length == 0){
            this.modal.warning("Please upload file first",this.viewref)
            return
        }

        this.modal.confirm("Do you want to start process",this.viewref,() => Confirm())

        let Confirm = () => {
            this.http.get("K9","SNPE051_ProcessAssemble")
            .subscribe(res =>{
                console.log('resssssssssssss',res)
              if(res.STATUS == "DONE"){
                this.modal.info("Process complete",this.viewref);
              }else{
                this.modal.warning("Process not complete, please contact support team",this.viewref)
              }
            },err =>{
              this.modal.warning("Process not complete, please contact support team",this.viewref)
            })
        }
        
      }

      public DownLoadTemplate(){
        let link = "assets/templates/K9_Assemble_Template.xlsx"
        window.open(link,'_blank')
      }

}