import { Component, OnInit, ViewContainerRef, ViewChild, ElementRef } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from '../../../core/modal.service';
import { SelectionModel } from '@angular/cdk/collections';
import { Globals } from "src/app/core/global";


@Component({
  selector: 'snpp207',
  templateUrl: './SNPP207.component.html',
  styleUrls: ['./SNPP207.component.css']
})

export class SNPP207Component implements OnInit {

  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global : Globals
  ) { }

  public ConfigVin: any = {
    ColName: "VIN",
    ColValue: "VIN",
    PlaceholderText: "Select Vin.",
    SourceController: "K9",
    SourceMethodName: "SNPP207_GetVin",
    NoOfShowRecords: 60,
    MinLengthSearch: 4
  }

  public ConfigEndItem: any = {
    ColName: "END_ITEM_18",
    ColValue: "END_ITEM_18",
    PlaceholderText: "Select End ITem 18",
    SourceController: "K9",
    SourceMethodName: "SNPP207_GetEndItem18",
    NoOfShowRecords: 60,
    MinLengthSearch: 3,
    SourceParams: {
      VIN: null
    },
  }

  public ConfigDestination: any = {
    ColName: "DESTINATION_CODE",
    ColValue: "DESTINATION_CODE",
    PlaceholderText: "Select Destination Code",
    SourceController: "K9",
    SourceMethodName: "SNPP207_GetDestinationCode",
    NoOfShowRecords: 60,
    MinLengthSearch: 0,
    SourceParams: {
      END_ITEM_18: null
    },
  }

  public paramSearch : any = {}
  public tableDetail : Array<any> = []
  public paramsData : any = {};
  public tableAllocate : Array<any> = []
  public selectionAllocate = new SelectionModel<any>(true, []);
  public isAllocate : boolean = false;
  ngOnInit() {
   
  }
  
  public Search(){
   
    this.http.post("K9","SNPP207_GetData",this.paramSearch)
    .subscribe(res => {
      console.log(res)
      this.selectionAllocate.clear()
      this.tableAllocate = res.Table
    })
    
  }

  public Allocate(){
    this.modal.confirm("Do you want to allocate order",this.viewref,this.ConfirmAllocate)
    
  }

  private ConfirmAllocate = () =>{

    this.http.post("K9","SNPP207_Allocate",this.selectionAllocate.selected)
    .subscribe(res =>{
      
      if(res.STATUS == "DONE"){
        this.selectionAllocate.clear()
        //this.isAllocate = true;
        this.modal.info("Allocate complete",this.viewref)
        this.Search();
        
      }else{
        this.modal.error("Allocate fail, please contact support team",this.viewref)
      }
     
    },err =>{
      this.modal.error("Allocate fail, please contact support team",this.viewref)
    })
  }

  public SelectedEndItem(event){
    this.paramSearch.END_ITEM_18 = event
    this.ConfigDestination.SourceParams.END_ITEM_18 = event
  }


  public isAllSelected() {
    const numSelected = this.selectionAllocate.selected.length;
    const numRows = this.tableAllocate.length;
    return numSelected === numRows;
  }

  public Toggle() {
    this.isAllSelected() ?
      this.selectionAllocate.clear() :
      this.tableAllocate.forEach(row => this.selectionAllocate.select(row));
  }

}
