import { Component, ElementRef, OnInit, ViewChild, ViewContainerRef } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';
import { ActivatedRoute } from '@angular/router';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'SNPP208',
  templateUrl: './SNPP208.component.html',
  styleUrls: ['./SNPP208.component.css']
})
export class SNPP208Component implements OnInit {

  constructor(
    private http: HttpService,
    public modal: ModalService,
    public viewref: ViewContainerRef,
    private route: ActivatedRoute,
    private global: Globals
  ) {}


  public param : any = {}
  public tableData: any = [];
  @ViewChild("fileInput") fileInput: ElementRef;
  public tableDataUpload: any = [];
  public correctData: any = [];
  private file: any;
  public fileNameInput: string = "";

  ngOnInit() {
   
  }


  public ConfirmProcess(){
    
    this.modal.confirm("Do you want to Allocate",this.viewref,() => ConfirmSave())

    let ConfirmSave = () =>{
      this.http.post("K9","SNPP208_Process",this.tableDataUpload)
      .subscribe(res =>{
        if(res.STATUS == "DONE"){
          this.modal.info("Process complete",this.viewref);
          this.tableDataUpload = []
        }else{
          this.modal.error("Found error please contact support team",this.viewref);
        }
      }, err =>{
        this.modal.error("Found error please contact support team",this.viewref);
      })
    }
  }

  public OpenFileBrowser() {
    this.fileNameInput = "";
    this.fileInput.nativeElement.value = '';
    this.fileInput.nativeElement.click();
  }
  public SelectFile(evt) {
    let Files: Array<File> = evt.target.files;
    if (Files.length > 0) {
      //let File: File = Files[0];
      this.file = Files[0];
      this.fileNameInput = this.file.name;
    }
  }

  public PreView() {
    if (!this.fileInput) {
      this.modal.warning("Please Open File First...", this.viewref)
      return;
    }
    let formData = new FormData();
    formData.append('file', this.file);
    this.tableDataUpload = []

    this.http.postFile("K9", "SNPP208_UploadExcel", formData)
    .subscribe(result => {
      console.log(result)
      this.tableDataUpload = result;
    }, err => {
      this.modal.error('Found an error, please contact support team.', this.viewref);
    })
    
  }

  public DownloadTemplate() {
    let link = "assets/templates/SNPP208_UPLOAD_TEMPLATE.xlsx"
    window.open(link, '_blank')
 }
}
