
import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';


import { ModalService } from 'src/app/core/modal.service';
import { MatDialog, MAT_DIALOG_DATA } from '@angular/material/dialog';


@Component({
  selector: 'snm001p_m',
  templateUrl: './snm001p_m.component.html',
  styleUrls: ['./snm001p_m.component.css']
})

export class SNM001P_MComponent implements OnInit {

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    public dialog: MatDialog,
  ) { }

  public PageTitle: string;
  public info: any = {};
  public partData: any = {};
  public ExiseTax: any = {};
  public PartOption: any = {};
  public stockData: any = {};
  public dataList: any = [];
  public dataDetail: any = {};

  public dataListETP: any = [];
  public dataListBackOrder: any = [];
  public dataListChainPart: any = [];

  public dataListSuspTF: any = [];
  public dataListSusp: any = {};
  public dataListTF: any = {};

  private vendorETD: any = {};
  public findPO: any;
  public CustomerList: any;
  public tableData: any;
  public filter: any = [];
  public iActiveTab: number = 0;

  public partNumber: string;
  public listReasonCode: any = {};

  private oldLockSales: string;
  public permissionList : any = []
  public permissionObject : any = {}
  public isAdd : boolean = false;
  public isEdit : boolean = true;

  @ViewChild("ShowDetail", { static: false }) dialogDetail;

  public lookupConfig: any = {
    ColName: "LOOKUP_PART_VALUE",
    PlaceholderText: "Select Part",
    SourceController: "IC",
    SourceMethodName: "SNSQ005_GetPart",
    NoOfShowRecords: 50,
    UpperCase: true
  }

  public ConfigReasonCode: any = {
    ColName: "LOOKUP_REASON",
    ColValue: "",
    PlaceholderText: "Select Reason Code",
    SourceController: "wPMS",
    SourceMethodName: "GetReasonCodeByJobType",
    NoOfShowRecords: 500,
    MinLengthSearch: 0,
    SourceParams: {
      JOB_TYPE : 0
    },
    UpperCase: true
  }

  ngOnInit() {

    var jobType = '0';
   

    this.http.get("wPMS", "GetReasonCodeList", jobType)
      .subscribe(result => {
        this.listReasonCode = result.Table[0];
        console.log('this.listReasonCode', this.listReasonCode);
      })


      this.GetPermissionList();

  }

  public SetSelectedPart(value: any) {
    this.partData.PART_NO = value.PART_NO;
    this.partNumber = value.PART_NO

    this.GetDataTab1();
    //this.SetActiveTab();
  }


  public SetReasonCode(event) {
    this.partData.LOCK_SALES = event.REASON_CODE;
    this.partData.REASON_NAME = event.REASON_NAME_EN;
  }


  private GetDataTab1() {

    this.stockData = {};
    this.info = {};
    if (this.partData.PART_NO.length >= 3) {
      this.http.get("IC", "SNSQ005_GetPartInfo", this.partData.PART_NO)
        .subscribe(result => {
          this.partData = result.Table[0];
          this.oldLockSales = this.partData.LOCK_SALES;
          this.stockData = result.Table1[0];
          this.info = result.Table2[0];
        })

      this.http.get("IC", "SNSQ005_GetPartInfo_G2", this.partData.PART_NO)
        .subscribe(result => {
          this.ExiseTax = result.Table[0] || {};
          this.PartOption = result.Table1[0] || {};
        })


    } else {

    }
  }

  //private GetDataTab3() {
  //  this.http.get("IC", "SNSQ005_GetPartInfo_G3", this.partData.PART_NO)
  //    .subscribe(result => {
  //      this.dataListBackOrder = result.Table; // Tab 3 : Back order
  //    })
  //}

  //private GetDataTab5() {
  //  this.http.get("IC", "SNSQ005_GetPartInfo_G5", this.partData.PART_NO)
  //    .subscribe(result => {
  //      this.dataListETP = result.Table; // Tab 5 : ETP
  //    })

  //}

  //private GetDataTab6() {
  //  this.http.get("IC", "SNSQ005_GetPartInfo_G6", this.partData.PART_NO)
  //    .subscribe(result => {
  //      this.dataListChainPart = result.Table; // Tab 6 : dataListChainPart
  //    })
  //}


  public OpenSuspend() {
    this.dataListSuspTF = [];
    if (this.stockData.SUSPEND_QTY == 0) {
      return;
    }
    this.http.get("IC", "SNSQ005_GetPartInfo_SUS", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListSuspTF = result.Table;
      })
    this.dialogDetail.OpenDialog();

  }

  public OpenTransafer() {
    this.dataListSuspTF = [];
    if (this.stockData.TRANSFER_QTY == 0) {
      return;
    }
    this.http.get("IC", "SNSQ005_GetPartInfo_TF", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListSuspTF = result.Table;
      })
    this.dialogDetail.OpenDialog();
  }


  public SaveData() {

    //console.log('this.oldLockSales', this.oldLockSales);
    //console.log('this.partData.LOCK_SALES', this.partData.LOCK_SALES);
    if (this.oldLockSales == this.partData.LOCK_SALES) {
      this.modal.info("No data change.", this.viewRef);
      return;
    }

    this.modal.confirm("Are you sure to save this record?", this.viewRef,
      () => {
        this.ConfirmSave();
      }, () => { });
  }


  private ConfirmSave() {
     
    this.http.post("wPMS", "SNM001P_SavePartMasterDomestic", this.partData)
      .subscribe(result => {
        if (result != "Error") {
          this.oldLockSales = this.partData.LOCK_SALES;
          this.modal.info("Saved data successfully", this.viewRef);     
        }
      }, (err) => {
        console.log(err, 'err')
      })


  }


  private GetPermissionList(){
    this.http.get("wPMS", "GetPermissionPartsMaster")
      .subscribe(result => {
        this.permissionList = result.Table; 
        this.generatePermissionObject() 
      })
  }

  private generatePermissionObject(){

    let keyName = "";
    if(this.isAdd){
       keyName = "CREATABLE_FLAG"
    }else{
       keyName = "UPDATABLE_FLAG"
    }

    this.permissionList.forEach((value, index) => {
      this.permissionObject[value.FIELD_NAME] = value[keyName];
    });
    
  }

}
