import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';


import { ModalService } from 'src/app/core/modal.service';
import { MatDialog, MAT_DIALOG_DATA } from '@angular/material/dialog';
import { AutoCompletePartComponent } from 'src/app/components/shared/auto-complete-part/auto-complete-part.component';
import { AutoCompleteQueryComponent } from 'src/app/components/shared/auto-complete-query/auto-complete-query.component';
import { Globals } from 'src/app/core/global';
import { FormControl, Validators } from '@angular/forms';


@Component({
  selector: 'snm001p_m_mc',
  templateUrl: './snm001p_m_mc.component.html',
  styleUrls: ['./snm001p_m_mc.component.css']
})

export class SNM001P_M_MCComponent implements OnInit {

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    public dialog: MatDialog,
    private global : Globals
  ) { }

  public PageTitle: string;
  public info: any = {};
  public partData: any = {};
  public ExiseTax: any = {};
  public PartOption: any = {};
  public stockData: any = {};
  public dataList: any = [];
  public dataDetail: any = {};

  public dataListETP: any = [];
  public dataListBackOrder: any = [];
  public dataListChainPart: any = [];

  public dataListSuspTF: any = [];
  public dataListSusp: any = {};
  public dataListTF: any = {};

  private vendorETD: any = {};
  public findPO: any;
  public CustomerList: any;
  public tableData: any;
  public filter: any = [];
  public iActiveTab: number = 0;

  public partNumber: string;
  public SPPSCode: string;
  public DesignNote: string;
  public listReasonCode: any = {};

  private oldPricingCode: string;
  public designNoteList : any = [];
  public tempDataDesignNote : any =[];
  public permissionList : any = []
  public permissionObject : any = {}
  public isAdd : boolean = true;
  public isEdit : boolean = false;
  public partDataAdd: any = {};

  @ViewChild("ShowDetail", { static: false }) dialogDetail;
  @ViewChild("dialogDN", { static: false }) dialogDN;
  @ViewChild("dialogAdd", { static: false }) dialogAdd;
  @ViewChild("autoCompletePart", { static: false }) autoCompletePart: AutoCompletePartComponent;
  @ViewChild("autoCompletepricing", { static: false }) autoCompletepricing: AutoCompleteQueryComponent;
  @ViewChild("autoCompleteparttype", {static : false}) autoCompleteparttype : AutoCompleteQueryComponent;

  public lookupConfig: any = {
    ColName: "LOOKUP_PART_VALUE",
    PlaceholderText: "Select Part",
    SourceController: "IC",
    SourceMethodName: "SNSQ005_GetPart",
    NoOfShowRecords: 50,
    UpperCase: true
  }

  public ConfigReasonCode: any = {
    ColName: "LOOKUP_REASON",
    ColValue: "",
    PlaceholderText: "Select Reason Code",
    SourceController: "wPMS",
    SourceMethodName: "GetReasonCodeByJobType",
    NoOfShowRecords: 500,
    MinLengthSearch: 0,
    SourceParams: {
      JOB_TYPE: 0
    },
    UpperCase: true
  }

  public lookupSPPSConfig: any = {
    ColName: "SPPS_CODE",
    ColValue: "SPPS_CODE",
    PlaceholderText: "Select SPPS No.",
    SourceController: "wPMS",
    SourceMethodName: "SNM001P_M_MC_GetSPPSCode",
    NoOfShowRecords: 50
  }

  public lookupDedignNoteConfig: any = {
    ColName: "DESIGN_NOTE_NUMBER",
    ColValue: "",
    PlaceholderText: "Select Design Note No.",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_LookupDesignNote",
    MinLengthSearch: 0,
    NoOfShowRecords: 50
  }

  public ConfigFormatPart: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Format Part",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_Format_Part",
    MinLengthSearch: 0,
    NoOfShowRecords: 50
  }

  public ConfigLocation: any = {
    ColName: "LOCATION_NO",
    ColValue: "",
    PlaceholderText: "Select Location",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_Location",
    MinLengthSearch: 3,
    NoOfShowRecords: 50
  }

  public ConfigTariff: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Tariff Code",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_Tariff",
    MinLengthSearch: 0,
    NoOfShowRecords: 50
  }

  public ConfigVendor: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Vendor Code",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_Vendor",
    MinLengthSearch: 1,
    NoOfShowRecords: 50
  }

  public ConfigCurrency: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Currency Code",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_Currency",
    MinLengthSearch: 0,
    NoOfShowRecords: 50
  }

  public ConfigCategory: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Category Code",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_Category",
    MinLengthSearch: 0,
    NoOfShowRecords: 50
  }

  public ConfigPricing: any = {
    ColName: "PRICING_CODE",
    ColValue: "",
    PlaceholderText: "Select Pricing Code",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_Pricing",
    MinLengthSearch: 0,
    NoOfShowRecords: 50
  }

  public ConfigProduct: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Product Code",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_Product",
    MinLengthSearch: 0,
    NoOfShowRecords: 50
  }

  public ConfigMainmodel: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Main Model",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_MainModel",
    MinLengthSearch: 0,
    NoOfShowRecords: 50
  }

  public ConfigPartCode: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Part Code",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_PartCode", 
    NoOfShowRecords: 50
  }

  public ConfigDescript: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Descript Code",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_Descript", 
    MinLengthSearch: 0,
    NoOfShowRecords: 50
  }

  public ConfigSalesClass: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Sales Class",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_Salesclass", 
    MinLengthSearch: 0,
    NoOfShowRecords: 50
  }


  public ConfigEDC: any = {
    ColName: "EDC_CODE",
    ColValue: "",
    PlaceholderText: "Select EDC",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_EDC", 
    MinLengthSearch: 0,
    NoOfShowRecords: 50
  }


  public ConfigADC: any = {
    ColName: "ADC_CODE",
    ColValue: "",
    PlaceholderText: "Select ADC",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_ADC",
    NoOfShowRecords: 100,
    MinLengthSearch: 0,
    SourceParams: {
      EDC: null
    }    
  }

  public ConfigFormerPart: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Former Part",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_FormerPart",
    NoOfShowRecords: 100, 
    SourceParams: {
      PART_NO: null,
      NEW_PART_NO : null,
      GROUP_PART_NO : null
    }    
  }

  public ConfigNewPart: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select New Part",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_NewPart",
    NoOfShowRecords: 100, 
    SourceParams: {
      PART_NO: null,
      FORMER_PART : null,
      GROUP_PART_NO : null
    }    
  }

  public ConfigGroupPart: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Group Part",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_GroupPart", 
    NoOfShowRecords: 50
  }

  public ConfigFamily: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Family",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_Family", 
    MinLengthSearch: 0,
    NoOfShowRecords: 50
  }

  public ConfigLockPO: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Lock PO",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_LockPO", 
    MinLengthSearch: 0,
    NoOfShowRecords: 50
  }

  public Configorigin: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Origin Code",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_Origin", 
    MinLengthSearch: 0,
    NoOfShowRecords: 50
  }

  public ConfigLRPart: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select LR Part",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_LRPart",
    NoOfShowRecords: 100, 
    SourceParams: {
      PART_NO: null 
    }    
  }

  public Configparttype: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Part Type",
    SourceController: "TI",
    SourceMethodName: "SNM001P_M_MC_Part_Type", 
    MinLengthSearch: 0,
    NoOfShowRecords: 50,
    UpperCase  : true
  }


  public rateControl : any;
  private TEMP_LOCATION : string = "";

  ngOnInit() {

    this.rateControl = new FormControl("", [Validators.max(100), Validators.min(0)])
    var jobType = '0';


    this.http.get("wPMS", "GetReasonCodeList", jobType)
      .subscribe(result => {
        this.listReasonCode = result.Table[0];
        //console.log('this.listReasonCode', this.listReasonCode);
      })

      this.GetPermissionList();

  }

  public SetSelectedPart(value: any) {
    this.partData.PART_NO = value.PART_NO;
    this.partNumber = value.PART_NO  
    this.GetDataTab1();
    //this.SetActiveTab();
  }

  public SetSelectedSPPSCode(value: any) {
    this.partData.SPPS_NO = value;
    this.SPPSCode = value
  }


  public SetSelectedDesignNote(value: any) {
    this.partData.DESIGN_NOTE_NUMBER = value;
    this.DesignNote = value
  }

 

  public AddParts(){
    this.isAdd = true;
    this.isEdit = false;
    this.GetPermissionList();
  }

  public EditParts(){
    this.isEdit = true;
    this.isAdd = false;
    this.GetPermissionList();
  }

  private GetPermissionList(){
    this.http.get("wPMS", "GetPermissionPartsMaster")
      .subscribe(result => {
        this.permissionList = result.Table; 
        this.generatePermissionObject() 
      })
  }


  private GetDataTab1() {

    this.stockData = {};
    this.info = {};
    if (this.partData.PART_NO.length >= 3) {
      this.isEdit = true;
       this.isAdd = false
       this.GetPermissionList();
      this.http.get("IC", "SNSQ005_GetPartInfo", this.partData.PART_NO)
        .subscribe(result => {

          //console.log(result)
          this.partData = result.Table[0];
          this.oldPricingCode = this.partData.PRICING_CODE;
          this.stockData = result.Table1[0];
          this.info = result.Table2[0];
          this.TEMP_LOCATION = this.partData.LOCATION_NO;

          this.ConfigFormerPart.SourceParams.PART_NO = this.partData.PART_NO
          this.ConfigNewPart.SourceParams.PART_NO = this.partData.PART_NO
          this.ConfigLRPart.SourceParams.PART_NO = this.partData.PART_NO

          setTimeout(() => {
            this.http.get("TI","SNM001P_M_MC_Part_Type_Old",this.global.EscapeCharacter(this.partData.PART_TYPE),'20')
            .subscribe(res =>{
              if(res.Table.length > 0){
                this.partData.PART_TYPE = res.Table[0].PART_TYPE 
                this.partData.PART_TYPE_SHOW = res.Table[0].LOOKUP        
              }
            })
          }, 500);
          
        })

      this.http.get("IC", "SNSQ005_GetPartInfo_G2", this.partData.PART_NO)
        .subscribe(result => {
          this.ExiseTax = result.Table[0] || {};
          this.PartOption = result.Table1[0] || {};
        })
        
       

    } else {

    }
  }

  public ClearData(){
    this.partNumber = ""
    this.partData = {};
    this.stockData = {};
    this.info = {};
    this.tempDataDesignNote =[]
    this.designNoteList = []
    this.isEdit = false;
    this.isAdd = true;
    this.GetPermissionList()
    //location.reload();
  }

  //private GetDataTab3() {
  //  this.http.get("IC", "SNSQ005_GetPartInfo_G3", this.partData.PART_NO)
  //    .subscribe(result => {
  //      this.dataListBackOrder = result.Table; // Tab 3 : Back order
  //    })
  //}

  //private GetDataTab5() {
  //  this.http.get("IC", "SNSQ005_GetPartInfo_G5", this.partData.PART_NO)
  //    .subscribe(result => {
  //      this.dataListETP = result.Table; // Tab 5 : ETP
  //    })

  //}

  //private GetDataTab6() {
  //  this.http.get("IC", "SNSQ005_GetPartInfo_G6", this.partData.PART_NO)
  //    .subscribe(result => {
  //      this.dataListChainPart = result.Table; // Tab 6 : dataListChainPart
  //    })
  //}


  public Setpricing(event,data,action){

    if(action == "select"){
      if(event){
        this.partData.PRICING_CODE = event.PRICING_CODE
      }else{
        this.modal.warning("Pricing Code not found in data base",this.viewRef)
        this.partData.PRICING_CODE = null
      }
    }
    else if(action == "cancel"){
     
        if (!data){
          //this.modal.warning("Pricing Code is not null",this.viewRef)
          this.partData.PRICING_CODE = null;
          return;
        }

      this.http.get("TI","SNM001P_M_MC_Pricing",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.PRICING_CODE = res.Table[0].PRICING_CODE
        }else{
          //this.modal.warning("Pricing Code not found in data base",this.viewRef)
          this.partData.PRICING_CODE = null;
        }
      })

    }
  }

  public SetTariff(event,data,action){

    if(action == "select"){
      if(event){
        this.partData.TARIFF_CODE = event.TARIFF_CODE
      }else{
        this.modal.warning("Tariff Code not found in data base",this.viewRef)
        this.partData.TARIFF_CODE = null
      }
    }
    else if(action == "cancel"){
     
        if (!data){
          this.partData.TARIFF_CODE = null;
          return;
        }

      this.http.get("TI","SNM001P_M_MC_Tariff",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        
        if(res.Table.length > 0){
          this.partData.TARIFF_CODE = res.Table[0].TARIFF_CODE
        }else{
          this.modal.warning("Tariff Code not found in data base",this.viewRef)
          this.partData.TARIFF_CODE = null;
        }
      })

    }
  }

  public SetMainmodel(event,data,action){

    if(action == "select"){
      if(event){
        this.partData.MAIN_MODEL = event.MAIN_MODEL
      }else{
        this.modal.warning("Main Model not found in data base",this.viewRef)
        this.partData.MAIN_MODEL = null
      }
    }
    else if(action == "cancel"){
     
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.MAIN_MODEL = null;
          return;
        }

      this.http.get("TI","SNM001P_M_MC_MainModel",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.MAIN_MODEL = res.Table[0].MAIN_MODEL
        }else{
          //this.modal.warning("Tariff Code not found in data base",this.viewRef)
          this.partData.MAIN_MODEL = null;
        }
      })

    }
  }

  public SetPartCode(event,data,action){

    if(action == "select"){
      if(event){
        this.partData.PART_CODE = event.PART_CODE
      }else{
        this.modal.warning("Part Code not found in data base",this.viewRef)
        this.partData.PART_CODE = null
      }
    }
    else if(action == "cancel"){
     
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.PART_CODE = null;
          return;
        }

      this.http.get("TI","SNM001P_M_MC_PartCode",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.PART_CODE = res.Table[0].PART_CODE
        }else{
          // this.modal.warning("Part Code not found in data base",this.viewRef)
          this.partData.PART_CODE = null;
        }
      })

    }
  }

  public SetProductCode(event,data,action){

    if(action == "select"){
      if(event){
        this.partData.PRODUCT_CODE = event.PRODUCT_CODE
      }else{
        this.modal.warning("Product Code not found in data base",this.viewRef)
        this.partData.PRODUCT_CODE = null
      }
    }
    else if(action == "cancel"){
     
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.PRODUCT_CODE = null;
          return;
        }

      this.http.get("TI","SNM001P_M_MC_Product",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.PRODUCT_CODE = res.Table[0].PRODUCT_CODE
        }else{
          // this.modal.warning("Product Code not found in data base",this.viewRef)
          this.partData.PRODUCT_CODE = null;
        }
      })

    }
  }

  public SetDescriptCode(event,data,action){

    if(action == "select"){
      if(event){
        this.partData.DESCRIPT = event.DESCRIPT
        this.partData.SALES_CLASS = event.SALES_CLASS
      }else{
        this.modal.warning("Descript Code not found in data base",this.viewRef)
        this.partData.DESCRIPT = null
        this.partData.SALES_CLASS = null
      }
    }
    else if(action == "cancel"){
     
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.DESCRIPT_CODE = null;
          this.partData.SALES_CLASS = null
          return;
        }

      this.http.get("TI","SNM001P_M_MC_Descript",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.DESCRIPT_CODE = res.Table[0].DESCRIPT_CODE
          this.partData.SALES_CLASS = res.Table[0].SALES_CLASS
        }else{
          // this.modal.warning("Descript Code not found in data base",this.viewRef)
          this.partData.DESCRIPT_CODE = null;
          this.partData.SALES_CLASS = null
        }
      })

    }
  }

  public SetSalseClass(event,data,action){

    if(action == "select"){
      if(event){
        this.partData.SALES_CLASS = event.SALES_CLASS
      }else{
        this.modal.warning("SALES_CLASS not found in data base",this.viewRef)
        this.partData.SALES_CLASS = null
      }
    }
    else if(action == "cancel"){
     
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.SALES_CLASS = null;
          return;
        }

      this.http.get("TI","SNM001P_M_MC_Salesclass",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.SALES_CLASS = res.Table[0].SALES_CLASS
        }else{
          //this.modal.warning("Sales Class not found in data base",this.viewRef)
          this.partData.SALES_CLASS = null;
        }
      })

    }
  }

  public SetEDC(event,data,action){

    if(action == "select"){
      
      if(event){
        this.partData.EDC_CODE = event.EDC_CODE
        this.ConfigADC.SourceParams.EDC = event.EDC_CODE
      }else{
        this.modal.warning("EDC Code not found in data base",this.viewRef)
        this.partData.EDC_CODE = null
        this.ConfigADC.SourceParams.EDC = null
      }
    }
    else if(action == "cancel"){
     
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.EDC_CODE = null;
          this.ConfigADC.SourceParams.EDC = null  
          return;
        }

      this.http.get("TI","SNM001P_M_MC_EDC",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.EDC_CODE = res.Table[0].EDC_CODE
          this.ConfigADC.SourceParams.EDC = res.Table[0].EDC_CODE
        }else{
          //this.modal.warning("Edc Code not found in data base",this.viewRef) 
          this.partData.EDC_CODE = null;
          this.ConfigADC.SourceParams.EDC = null   
        }
      })

    }
  }

  public SetADC(event,data,action){

    if(action == "select"){
      
      if(event){
        this.partData.ADC_CODE = event.ADC_CODE
      }else{
        this.modal.warning("ADC Code not found in data base",this.viewRef)
        this.partData.ADC_CODE = null
      }
    }
    else if(action == "cancel"){
     
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.ADC_CODE = null;
          return;
        }

      this.http.post("TI",["SNM001P_M_MC_ADC",this.global.EscapeCharacter(data),'20'],this.ConfigADC.SourceParams)
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.ADC_CODE = res.Table[0].ADC_CODE
        }else{
          //this.modal.warning("ADC Code not found in data base",this.viewRef)
          this.partData.ADC_CODE = null
        }
      })

    }
  }


  public SetFormerPart(event,data,action){

    if(action == "select"){
      
      if(event){
        this.partData.FORMER_PART_NO = event.PART_NO
        this.ConfigNewPart.SourceParams.FORMER_PART = event.PART_NO;
        this.partData.FORMER_ICA = 'Y'
      }else{
        this.modal.warning("Part No not found in data base",this.viewRef)
        this.partData.FORMER_PART_NO = null
        this.ConfigNewPart.SourceParams.FORMER_PART = null;
        this.partData.FORMER_ICA = null
      }
    }
    else if(action == "cancel"){
     
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.FORMER_PART_NO = null;
          this.ConfigNewPart.SourceParams.FORMER_PART = null;
          this.partData.FORMER_ICA = null
          return;
        }
      this.http.post("TI",["SNM001P_M_MC_FormerPart",this.global.EscapeCharacter(data),'20'],this.ConfigFormerPart.SourceParams)
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.FORMER_PART_NO = res.Table[0].PART_NO
          this.ConfigNewPart.SourceParams.FORMER_PART = res.Table[0].PART_NO;
          this.partData.FORMER_ICA = 'Y'
        }else{
         // this.modal.warning("Part No not found in data base",this.viewRef)
          this.partData.FORMER_PART_NO = null;
          this.ConfigNewPart.SourceParams.FORMER_PART = null;
          this.partData.FORMER_ICA = null
        }
      })

    }
  }

  public SetNewPart(event,data,action){

    if(action == "select"){
      if(event){
        this.partData.NEW_PART_NO = event.PART_NO
        this.ConfigFormerPart.SourceParams.NEW_PART_NO = event.PART_NO;
        this.partData.NEW_ICA = 'Y'
      }else{
        this.modal.warning("Part No not found in data base",this.viewRef)
        this.partData.NEW_PART_NO = null
        this.ConfigFormerPart.SourceParams.NEW_PART_NO = null;
        this.partData.NEW_ICA = null
      }
      
    }
    else if(action == "cancel"){
     
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.NEW_PART_NO = null;
          this.ConfigFormerPart.SourceParams.NEW_PART_NO = null;
          this.partData.NEW_ICA = null
          return;
        }
      this.http.post("TI",["SNM001P_M_MC_NewPart",this.global.EscapeCharacter(data),'20'],this.ConfigNewPart.SourceParams)
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.NEW_PART_NO = res.Table[0].PART_NO
          this.ConfigFormerPart.SourceParams.NEW_PART_NO = res.Table[0].PART_NO;
          this.partData.NEW_ICA = 'Y'
        }else{
         // this.modal.warning("Part No not found in data base",this.viewRef)
          this.partData.NEW_PART_NO = null;
          this.ConfigFormerPart.SourceParams.NEW_PART_NO = null;
          this.partData.NEW_ICA = null
        }
      })

    }
  }

  public SetCurrency(event,data,action){

    if(action == "select"){
      if(event){
        this.partData.CURRENCY_CODE = event.CURRENCY_CODE
      }else{
        this.modal.warning("Currency Code not found in data base",this.viewRef)
        this.partData.CURRENCY_CODE = null
      }
    }
    else if(action == "cancel"){
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.CURRENCY_CODE = null;
          return;
        }
      this.http.get("TI","SNM001P_M_MC_Currency",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.CURRENCY_CODE = res.Table[0].CURRENCY_CODE
          
        }else{
         // this.modal.warning("Currency Code not found in data base",this.viewRef)
          this.partData.CURRENCY_CODE = null;
         
        }
      })
    }
  }

  public SetPartFamily(event,data,action){

    if(action == "select"){
      if(event){
        this.info.DSP_PARTS_FAMILY = event.LOOKUP
        this.partData.FAMILY_CODE = event.FAMILY_CODE
      }else{
        this.modal.warning("Family Code not found in data base",this.viewRef)
        this.info.DSP_PARTS_FAMILY =null
        this.partData.FAMILY_CODE = null
      }
    }
    else if(action == "cancel"){
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.info.DSP_PARTS_FAMILY = null;
          this.partData.FAMILY_CODE = null
          return;
        }
      this.http.get("TI","SNM001P_M_MC_Family",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.info.DSP_PARTS_FAMILY = res.Table[0].LOOKUP
          this.partData.FAMILY_CODE = res.Table[0].FAMILY_CODE
        }else{
          //this.modal.warning("Family Code not found in data base",this.viewRef)
          this.info.DSP_PARTS_FAMILY = null;
          this.partData.FAMILY_CODE = null;
         
        }
      })
    }
  }

  public SetGroupPart(event,data,action){

    if(action == "select"){
      
      if(event){
        this.partData.GROUP_PART_NO = event.PART_NO;
        this.ConfigFormerPart.SourceParams.GROUP_PART_NO = event.PART_NO;
        this.ConfigNewPart.SourceParams.GROUP_PART_NO = event.PART_NO
      }else{
        this.modal.warning("Part No not found in data base",this.viewRef)
        this.partData.GROUP_PART_NO = null;
        this.ConfigFormerPart.SourceParams.GROUP_PART_NO = null;
        this.ConfigNewPart.SourceParams.GROUP_PART_NO = null
      }
      
    }
    else if(action == "cancel"){
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.GROUP_PART_NO = null;
          this.ConfigFormerPart.SourceParams.GROUP_PART_NO = null;
          this.ConfigNewPart.SourceParams.GROUP_PART_NO = null
          return;
        }
      this.http.get("TI","SNM001P_M_MC_GroupPart",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.GROUP_PART_NO = res.Table[0].PART_NO;
          this.ConfigFormerPart.SourceParams.GROUP_PART_NO = res.Table[0].PART_NO;
          this.ConfigNewPart.SourceParams.GROUP_PART_NO = res.Table[0].PART_NO
          
        }else{
          //this.modal.warning("Part No not found in data base",this.viewRef)
          this.partData.GROUP_PART_NO = null;
          this.ConfigFormerPart.SourceParams.GROUP_PART_NO = null;
          this.ConfigNewPart.SourceParams.GROUP_PART_NO = null
         
        }
      })
    }
  }

  public SetPartCat(event,data,action){

    if(action == "select"){    
      if(event){
        this.partData.PART_CATEGORY = event.PART_CATEGORY
      }else{
        this.modal.warning("Category Code not found in data base",this.viewRef)
        this.partData.PART_CATEGORY = null
      }
    }
    else if(action == "cancel"){
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.PART_CATEGORY = null;
          return;
        }
      this.http.get("TI","SNM001P_M_MC_Category",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.PART_CATEGORY = res.Table[0].PART_CATEGORY
          
        }else{
          this.modal.warning("Catagory Code not found in data base",this.viewRef)
          this.partData.PART_CATEGORY = null;
         
        }
      })
    }
  }

  public SetVendor(event,data,action){

    if(action == "select"){
      
      if(event){
        this.partData.VENDOR_CODE = event.VENDOR_CODE;
        this.info.VENDOR_FULL_NAME = event.LOOKUP;
        this.partData.CURRENCY_CODE = event.CURRENCY_CODE;
        this.partData.VENDOR_TYPE = event.VENDOR_TYPE
      }else{
        this.modal.warning("Vendor Code not found in data base",this.viewRef)
        this.partData.VENDOR_CODE = null;
        this.info.VENDOR_FULL_NAME = null
        this.partData.CURRENCY_CODE = null
        this.partData.VENDOR_TYPE = null
      }
    }
    else if(action == "cancel"){
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.VENDOR_CODE = null;
          this.info.VENDOR_FULL_NAME = null;
          this.partData.CURRENCY_CODE = null;
          this.partData.VENDOR_TYPE = null
          return;
        }
      this.http.get("TI","SNM001P_M_MC_Vendor",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.VENDOR_CODE = res.Table[0].VENDOR_CODE;
          this.info.VENDOR_FULL_NAME = res.Table[0].LOOKUP;
          this.partData.CURRENCY_CODE = res.Table[0].CURRENCY_CODE;
          this.partData.VENDOR_TYPE = res.Table[0].VENDOR_TYPE
          
        }else{
          //this.modal.warning("Vendor Code not found in data base",this.viewRef)
          this.partData.VENDOR_CODE = null;
          this.info.VENDOR_FULL_NAME = null;
          this.partData.CURRENCY_CODE = null;
          this.partData.VENDOR_TYPE = null;        
        }
      })
    }
  }

  public SetFormatPart(event,data,action){

    if(action == "select"){
      
      if(event){
        this.partData.PRN_PART_FORMAT = event.PRN_PART_FORMAT
      }else{
        this.modal.warning("Part format not found in data base",this.viewRef)
        this.partData.PRN_PART_FORMAT = null
      }
    }
    else if(action == "cancel"){
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.PRN_PART_FORMAT = null;
          return;
        }
      this.http.get("TI","SNM001P_M_MC_Format_Part",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.PRN_PART_FORMAT = res.Table[0].PRN_PART_FORMAT         
        }else{
          //this.modal.warning("Format Part not found in data base",this.viewRef)
          this.partData.PRN_PART_FORMAT = null;        
        }
      })
    }
  }


  public SetLocation(event,data,action){

    
    if(action == "select"){

      // console.log(this.partData.TOTAL_QTY,"qqqqqqqqqqqq")

      if(this.partData.TOTAL_QTY > 0){
        this.modal.warning("ไม่สามารถย้ายโลเคชั่นได้ เนื่องจากอยู่ระหว่าง รับเข้าสินค้า จัดสินค้าหรือแพ็คสินค้า",this.viewRef)
        this.partData.LOCATION_NO = this.partData.TEMP_LOCATION_NO
        return;
      }
    
      if(event){
        if (event.LOCATION_STATUS !== 'N' && event.LOCATION_NO) {
          let message = "Cannot select Locatio No : " + event.LOCATION_NO + ", due Location No : " + event.LOCATION_NO +   " in process re-location"
          this.modal.warning(message,this.viewRef,() => {},{width : '700px'})
          this.partData.LOCATION_NO = this.partData.TEMP_LOCATION_NO
          return;
        }
        else if (event.PART_STATUS != 'N' && event.LOCATION_NO && event.PART_STATUS != this.partData.PART_NO) {
          let message = "<h4>Cannot select this locatoin, due this location used by Part No : " +event.PART_STATUS + " !!!!</h4>" 
          let colormessage = message.fontcolor("red");
          this.modal.warning(colormessage,this.viewRef,() => {},{width : '700px'})
          this.partData.LOCATION_NO = this.partData.TEMP_LOCATION_NO
          return;
        }
        this.partData.LOCATION_NO = event.LOCATION_NO
      }else{
        this.modal.warning("Location not found in data base",this.viewRef)
        this.partData.LOCATION_NO = null
      }
    }
    else if(action == "cancel"){
        this.partData.LOCATION_NO = this.partData.TEMP_LOCATION_NO
      //   if (!data){
      //     this.partData.LOCATION_NO = null;
      //     return;
      //   }
      // this.http.get("TI","SNM001P_M_MC_Location",this.global.EscapeCharacter(data),'20')
      // .subscribe(res =>{
      //   if(res.Table.length > 0){
      //     this.partData.LOCATION_NO = res.Table[0].LOCATION_NO         
      //   }else{
         
      //     this.partData.LOCATION_NO = null;        
      //   }
      // })
    }
  }

  public SetLockPO(event,data,action){

    if(action == "select"){
      if(event){
        this.partData.LOCK_PO = event.REASON_CODE
      }else{
        this.modal.warning("Lock PO not found in data base",this.viewRef)
        this.partData.LOCK_PO = null
      }
    }
    else if(action == "cancel"){
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.LOCK_PO = null;
          return;
        }
      this.http.get("TI","SNM001P_M_MC_LockPO",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.LOCK_PO = res.Table[0].REASON_CODE         
        }else{
          //this.modal.warning("Lock PO not found in data base",this.viewRef)
          this.partData.LOCK_PO = null;        
        }
      })
    }
  }

  public SetReasonCode(event,data,action) {
    if(action == "select"){      
      if(event && data){
        this.partData.LOCK_SALES = event.REASON_CODE
      }else{
        //this.modal.warning("Lock Sales not found in data base",this.viewRef)
        this.partData.LOCK_SALES = "0"
      }
    }
    else if(action == "cancel"){
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.LOCK_SALES = "0";
          return;
        }

        if(data == 0){
          this.partData.LOCK_SALES = "0";
          return;
        }
      this.http.post("wPMS",["GetReasonCodeByJobType",this.global.EscapeCharacter(data),'20'],this.ConfigReasonCode.SourceParams)
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.LOCK_SALES = res.Table[0].REASON_CODE         
        }else{
          //this.modal.warning("Lock Sales not found in data base",this.viewRef)
          this.partData.LOCK_SALES = "0";        
        }
      })
    }
  }

  public SetOriginCode(event,data,action) {
    if(action == "select"){
      
      if(event){
        this.stockData.ATTRIBUTE5 = event.ORIGIN_CODE
      }else{
        this.modal.warning("Origin Code not found in data base",this.viewRef)
        this.stockData.ATTRIBUTE5 = null
      }
    }
    else if(action == "cancel"){
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.stockData.ATTRIBUTE5 = null;
          return;
        }
      this.http.post("TI",["SNM001P_M_MC_Origin",this.global.EscapeCharacter(data),'20'],this.ConfigReasonCode.SourceParams)
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.stockData.ATTRIBUTE5 = res.Table[0].ORIGIN_CODE         
        }else{
          //this.modal.warning("Origin Code not found in data base",this.viewRef)
          this.stockData.ATTRIBUTE5 = null;        
        }
      })
    }
  }

  public SetLRPart(event,data,action) {
    if(action == "select"){
      
      if(event){
        this.partData.LR_PART_NO = event.PART_NO
      }else{
        this.modal.warning("Part No not found in data base",this.viewRef)
        this.partData.LR_PART_NO = null
      }
    }
    else if(action == "cancel"){
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.LR_PART_NO = null;
          return;
        }
      this.http.post("TI",["SNM001P_M_MC_LRPart",this.global.EscapeCharacter(data),'20'],this.ConfigLRPart.SourceParams)
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.LR_PART_NO = res.Table[0].PART_NO         
        }else{
          //this.modal.warning("Part No not found in data base",this.viewRef)
          this.partData.LR_PART_NO = null;        
        }
      })
    }
  }


  public SetPartType(event,data,action) {
    if(action == "select"){
      
      if(event){
        this.partData.PART_TYPE = event.PART_TYPE
        this.partData.PART_TYPE_SHOW = event.LOOKUP
      }else{
        this.modal.warning("Part Type not found in data base",this.viewRef)
        this.partData.PART_TYPE = null
        this.partData.PART_TYPE_SHOW = null
      }
    }
    else if(action == "cancel"){
        if (!data){
          //this.modal.warning("Main Model is not null",this.viewRef)
          this.partData.PART_TYPE = null;
          this.partData.PART_TYPE_SHOW = null;
          return;
        }
        this.http.get("TI","SNM001P_M_MC_Part_Type",this.global.EscapeCharacter(data),'20')
      .subscribe(res =>{
        if(res.Table.length > 0){
          this.partData.PART_TYPE = res.Table[0].PART_TYPE 
          this.partData.PART_TYPE_SHOW = res.Table[0].LOOKUP        
        }else{
          //this.modal.warning("Part No not found in data base",this.viewRef)
          this.partData.PART_TYPE = null;  
          this.partData.PART_TYPE_SHOW = null      
        }
      })
    }
  }

  public OpenSuspend() {
    this.dataListSuspTF = [];
    if (this.stockData.SUSPEND_QTY == 0) {
      return;
    }
    this.http.get("IC", "SNSQ005_GetPartInfo_SUS", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListSuspTF = result.Table;
      })
    this.dialogDetail.OpenDialog();

  }

  public OpenTransafer() {
    this.dataListSuspTF = [];
    if (this.stockData.TRANSFER_QTY == 0) {
      return;
    }
    this.http.get("IC", "SNSQ005_GetPartInfo_TF", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListSuspTF = result.Table;
      })
    this.dialogDetail.OpenDialog();
  }


  public SaveData() {

    let message
    ////Check characters non ASCII Table | Siwakorn Y. 22-MAY-2023
    var ascii = /^[ -~]+$/;
    if (!ascii.test(this.partData.PART_NAME_EN)) {
      this.modal.warning("Found special character on Part name EN", this.viewRef)
      return;
    }
    if (this.partData.PO_PACKAGE <= 0){
      this.modal.warning("Cannot set PO package = 0",this.viewRef)
      return;
    }
    if(!this.partData.VENDOR_CODE){
        this.modal.warning("Vendor Code is not null",this.viewRef)
        return;
    }

        
    if (!this.partData.PRICING_CODE && this.partData.PRICING_CODE !== 0){
        this.modal.warning("Pricing Code is not null",this.viewRef)
        return;
    }
    
    if (!this.partData.ONLINE_FLAG){
      this.modal.warning("Online flag is not null",this.viewRef)
      return;
    }

    if (!this.partData.PRODUCT_CODE){
      this.modal.warning("Product Code is not null",this.viewRef)
      return;
    }

    if (!this.partData.PART_CODE){
      this.modal.warning("Part Code is not null",this.viewRef)
      return;
    }

    if (!this.partData.MAIN_MODEL){
      this.modal.warning("Main Model is not null",this.viewRef)
      return;
    }

    if (!this.partData.DESCRIPT_CODE){
      this.modal.warning("Descript Code is not null",this.viewRef)
      return;
    }

    
    if (!this.partData.SALES_CLASS && this.partData.SALES_CLASS !== 0){
      this.modal.warning("Sales class is not null",this.viewRef)
      return;
    }

    if (this.partData.RETAIL_PRICE <= 0){
      this.modal.warning("Retail price  is not zeroes",this.viewRef)
      return;
    }

    if (!this.partData.SALES_OPTION){
      this.modal.warning("Sales_option is not null",this.viewRef)
      return;
    }

    if(!this.partData.PART_TYPE){
      this.modal.warning("Part Type is not null",this.viewRef)
      return;
    }
    if (!this.stockData.ATTRIBUTE5){
      message = "Origin Code is null<br>"
      // this.modal.warning("Origin Code is not null",this.viewRef)
      // return;
    }

    if(!this.partData.PRN_PART_FORMAT){
      this.modal.warning("Format(Print) is not null",this.viewRef);
      return
    }

    if(this.stockData.OH_QTY > 0 || this.stockData.UNPACK_QTY > 0 || this.stockData.SHELVE_QTY > 0){
      if(this.TEMP_LOCATION && !this.partData.LOCATION_NO){
        this.modal.warning("Cannot delete location due to Stock more than 0",this.viewRef);
        return;
      }
    }
    if(!this.partData.FAMILY_CODE){
      message = message ? message + "Part Family is null<br>" :  "Part Family is null<br>"
      // this.modal.warning("Part Family is not null",this.viewRef)
      // return;
    }

    message = message ? message + "Are you sure to save this record?" : "Are you sure to save this record?"

    this.modal.confirm(message, this.viewRef,
      () => {
        this.ConfirmSave();
      }, () => { });
  }


  private ConfirmSave() {

   
    this.partData.STANDARD_COST = this.stockData.STANDARD_COST
    this.partData.ATTRIBUTE5 = this.stockData.ATTRIBUTE5
    this.partData.LAST_SALES_DATE = this.stockData.LAST_SALES_DATE
    this.partData.LAST_PO_DATE = this.stockData.LAST_PO_DATE
    //this.partData.FAMILY_CODE = this.info.DSP_PARTS_FAMILY

    this.http.post("TI", "SNM001P_M_MC_UpdatePartMasterTI", this.partData)
      .subscribe(result => {
        //console.log(result)
        if (result.Table[0].STATUS == "DONE") {
          //this.oldPricingCode = this.partData.PRICING_CODE;
          this.GetDataTab1()
          this.modal.info("Saved data successfully", this.viewRef);
        }else{
          this.modal.info("Saved data not complete", this.viewRef);
        }
      }, (err) => {
        this.modal.info("Saved data not complete", this.viewRef);
      })


  }

  public UpdateNetWeight(){
    this.modal.confirm("Do you want to save change you have made?",this.viewRef,() => ConfirmUpdate())

    let ConfirmUpdate = () =>{
      this.http.post("TI","SNM001P_M_MC_UpdateNetWeight",this.partData)
      .subscribe(res =>{
          if(res.STATUS_MSG == 'COMPLETE'){
            this.modal.info("Update complete",this.viewRef)
          }else{
            this.modal.error("Update not complete",this.viewRef)
          }
      },err =>{
        this.modal.info("Update not complete",this.viewRef)
      })
    }
  }

  public SaveDesignNote(){

        if(this.tempDataDesignNote.length == 0){
          this.modal.warning("No data for save",this.viewRef);
          return;
        }

        this.modal.confirm("Do you want to save change you have made?",this.viewRef,() => ConfirmSave())

        let ConfirmSave = () =>{
          let params : any = {}

          params.PART_NO = this.partData.PART_NO
          params.PART_NAME_EN = this.partData.PART_NAME_EN
          params.PART_NAME_TH = this.partData.PART_NAME_TH
          params.Detail = this.tempDataDesignNote

          //console.log('this.tempDataDesignNote',this.tempDataDesignNote)
  
          this.http.post("TI","SNM001P_M_MC_SaveDesignNote",params)
          .subscribe(res => {
            if (res.STATUS_MSG == 'DONE') {
              this.tempDataDesignNote = [];
              this.modal.info('Transaction complete: applied and saved.', this.viewRef);
              this.OpenDesignNote('U');
            } else {
                this.modal.error('No change to save. Save fail.', this.viewRef);
            }
          },err =>{
            this.modal.error('No change to save. Save fail.', this.viewRef);
          })
        }      
  }


  public OpenDesignNote(action : string){

    this.http.get("TI", "SNM001P_M_MC_GetDesignNote", this.partData.PART_NO)
      .subscribe(result => {
        //console.log(result)
        this.designNoteList = result.Table

        this.designNoteList.push({
          'EDIT': 'ADD',
        'DESIGN_NOTE_NUMBER' : null,
        'FILE_NAME' : null,                                     
        });

        if(action === 'N'){
          this.dialogDN.OpenDialog();
        }
        
         
      })
    

         
  }


  public SelectDesignNote(event,data,index){

      let filter = this.designNoteList.filter((x,i) => x.DESIGN_NOTE_NUMBER == event.DESIGN_NOTE_NUMBER && index != i)
      if(filter.length > 0){
        this.modal.warning("Dupplicate design note",this.viewRef)
        return;
      }
    

      let ind = this.tempDataDesignNote.findIndex(x => x.DESIGN_NOTE_NUMBER == data.DESIGN_NOTE_NUMBER && data.FLAG == 'D')
      if(ind > -1){
        this.tempDataDesignNote.splice(ind, 1);
      }

      data.FLAG = 'A'
      data.DESIGN_NOTE_NUMBER = event.DESIGN_NOTE_NUMBER
      data.FILE_NAME = event.FILE_NAME

      this.tempDataDesignNote.push(data)
      this.designNoteList = this.designNoteList.slice();
    
  }



  public AppendRow() {
    for (var i = 0; i < this.designNoteList.length; i++) {
      if (this.designNoteList[i].EDIT === "ADD") {
        this.designNoteList[i].EDIT = 'DEL';
      }
    }
    this.designNoteList.push({
      'EDIT': 'ADD',
          'DESIGN_NOTE_NUMBER' : null,
          'FILE_NAME' : null,                                     
    });

    this.designNoteList = this.designNoteList.slice();

    
  }

  public DeleteRow(index,data) {

  
      let ind = this.tempDataDesignNote.findIndex(x => x.DESIGN_NOTE_NUMBER == data.DESIGN_NOTE_NUMBER && data.FLAG == 'A')
      if(ind > -1){
        this.tempDataDesignNote.splice(ind, 1);
      }
      data.FLAG = 'D'
      this.tempDataDesignNote.push(data)
 

      //let index = this.tableDataDetail.findIndex(x => x == Item)
      this.designNoteList.splice(index, 1);
      this.designNoteList = this.designNoteList.slice();
 
    }

    public DownloadDesignNote(data) {
      if (!data.FILE_NAME) {
        this.modal.warning("File not found!", this.viewRef)
        return
      }
      this.http.Download('TI', 'SNM131P_Download',{filename : data.FILE_NAME})
          .subscribe(res => {
              if (res) {
                this.writeContents(res,data.FILE_NAME)     
              }              
          },err => {
            this.modal.warning("File not found",this.viewRef)
          })
    }

    public DownloadSpps() {

      this.http.Download('TI', 'SNM130P_Download',{filename : this.partData.FILE_NAME})
          .subscribe(res => {
              if (res) {
                this.writeContents(res,this.partData.FILE_NAME)     
              }              
          })
    }
  
    public writeContents(content,filename) {
      
      const a = document.createElement('a');
      const file = new Blob([content], { type: content.type });
      a.href = URL.createObjectURL(file);
      a.download = filename;
      a.click();
    }

    private generatePermissionObject(){

      let keyName = "";
      if(this.isAdd){
         keyName = "CREATABLE_FLAG"
      }else{
         keyName = "UPDATABLE_FLAG"
      }

      this.permissionList.forEach((value, index) => {
        this.permissionObject[value.FIELD_NAME] = value[keyName];
      });
      
    }

   
  
    public OpenDialogAdd(){
      this.partDataAdd = {};
      this.isAdd = true;
      this.isEdit = false;
      this.GetPermissionList()
      this.dialogAdd.OpenDialog();
    }

    public ValidatePart(event){

      
      //console.log(this.partDataAdd)

      this.http.post("TI","SNM001P_M_MC_ValidateParts",this.partDataAdd)
      .subscribe(res =>{
          if(res.STATUS_MSG == 'PASS'){
              this.partDataAdd.DIMENSION_MAX = 0
              this.partDataAdd.DIMENSION_MID = 0
              this.partDataAdd.DIMENSION_MIN = 0
              this.partDataAdd.NET_WEIGHT = 0
              this.partDataAdd.AVERAGE_DEMAND = 0
              this.partDataAdd.RETAIL_PRICE_E = 0
              this.partDataAdd.KEY_DES_FLAG = 'N'
              this.partDataAdd.KIT_FLAG = 'N'
              this.partDataAdd.PART_APPLY_DATE = new Date()
              this.ConfigLRPart.SourceParams.PART_NO = this.partDataAdd.PART_NO
          }else{
            this.modal.warning(" Invalid value character, Please check",this.viewRef)
            this.partDataAdd = {};
            this.ConfigLRPart.SourceParams = null
          }
      },err => {
          this.modal.warning(" Invalid value character, Please check",this.viewRef)
          this.partDataAdd = {};
      })
      
    }

    public InsertPartMaster(){

 
    let message
      ////Check characters non ASCII Table | Siwakorn Y. 22-MAY-2023
      var ascii = /^[ -~]+$/;
      if (!ascii.test(this.partDataAdd.PART_NAME_EN)) {
        this.modal.warning("Found special character on Part name EN", this.viewRef)
        return;
      }
	  	  
	  if (!this.partDataAdd.PRICING_CODE && this.partDataAdd.PRICING_CODE !== 0){
        this.modal.warning("Pricing Code is not null",this.viewRef)
        return;
    }
	   
    if (!this.partDataAdd.ONLINE_FLAG){
      this.modal.warning("Online flag is not null",this.viewRef)
      return;
    }

    if (!this.partDataAdd.PRODUCT_CODE){
      this.modal.warning("Product Code is not null",this.viewRef)
      return;
    }

    if (!this.partDataAdd.PART_CODE){
      this.modal.warning("Part Code is not null",this.viewRef)
      return;
    }

    if (!this.partDataAdd.MAIN_MODEL){
      this.modal.warning("Main Model is not null",this.viewRef)
      return;
    }

    if (!this.partDataAdd.DESCRIPT_CODE){
      this.modal.warning("Descript Code is not null",this.viewRef)
      return;
    }

    
    if (!this.partDataAdd.SALES_CLASS && this.partDataAdd.SALES_CLASS !== 0){
      this.modal.warning("Sales class is not null",this.viewRef)
      return;
    }

    if (this.partDataAdd.RETAIL_PRICE <= 0){
      this.modal.warning("Retail price  is not zeroes",this.viewRef)
      return;
    }

    if (!this.partDataAdd.SALES_OPTION){
      this.modal.warning("Sales_option is not null",this.viewRef)
      return;
    }

    if (!this.partDataAdd.ATTRIBUTE5){
      // this.modal.warning("Origin Code is not null",this.viewRef)
      // return;
      message = "Origin Code is null<br>"
    }

    if(!this.partDataAdd.VENDOR_CODE){
      this.modal.warning("Vendor Code is not null",this.viewRef)
      return;
    }

    if(!this.partDataAdd.FAMILY_CODE){
      // this.modal.warning("Part Family is not null",this.viewRef)
      // return;
      message = message ? message + "Part Family is null<br>" :  "Part Family is null<br>"
    }

    if(!this.partDataAdd.PART_TYPE){
      this.modal.warning("Part Type is not null",this.viewRef)
      return;
    }

    message = message ? message + "Are you sure to save this record?" : "Are you sure to save this record?"
      this.modal.confirm(message,this.viewRef,() => ConfirmSave())

      let ConfirmSave = () =>{
        this.http.post("TI","SNM001P_M_MC_InsertPartMasterTI",this.partDataAdd)
        .subscribe(res =>{
          if(res.STATUS_MSG == 'DONE'){
            this.modal.info('Transaction complete: applied and saved.', this.viewRef);
            this.dialogAdd.Close();
            this.isEdit = true;
            this.isAdd = false;
            this.SetSelectedPart({PART_NO : this.partDataAdd.PART_NO.toUpperCase()});
            //this.partData.PART_NO = this.partDataAdd.PART_NO
            //this.GetDataTab1()
          }
          else if(res.STATUS_MSG == 'DUPPLICATE'){
            this.modal.info('No change to save. found dupplicate record.', this.viewRef);
          }
          else if(res.STATUS_MSG == 'PART_OVER_LENGTH'){
            this.modal.info('No change to save. Save fail (part characters > 12)', this.viewRef);
          }else{
            this.modal.error('No change to save. Save fail.', this.viewRef);
          }
        },err =>{
          this.modal.error('No change to save. Save fail.', this.viewRef);
        })
      }
    }




    public SetpricingAdd(event,data,action){

      if(action == "select"){
        if(event){
          this.partDataAdd.PRICING_CODE = event.PRICING_CODE
        }else{
          this.modal.warning("Pricing Code not found in data base",this.viewRef)
          this.partDataAdd.PRICING_CODE = null
        }
      }
      else if(action == "cancel"){
       
          if (!data){
            //this.modal.warning("Pricing Code is not null",this.viewRef)
            this.partDataAdd.PRICING_CODE = null;
            return;
          }
  
        this.http.get("TI","SNM001P_M_MC_Pricing",this.global.EscapeCharacter(data),'20')
        .subscribe(res =>{
          if(res.Table.length > 0){
            this.partDataAdd.PRICING_CODE = res.Table[0].PRICING_CODE
          }else{
            //this.modal.warning("Pricing Code not found in data base",this.viewRef)
            this.partDataAdd.PRICING_CODE = null;
          }
        })
  
      }

      //console.log(this.partDataAdd.PRICING_CODE)
    }
  
  public SetProductCodeAdd(event,data,action){
  
      if(action == "select"){
        if(event){
          this.partDataAdd.PRODUCT_CODE = event.PRODUCT_CODE
        }else{
          this.modal.warning("Product Code not found in data base",this.viewRef)
          this.partDataAdd.PRODUCT_CODE = null
        }
      }
      else if(action == "cancel"){
       
          if (!data){
            //this.modal.warning("Main Model is not null",this.viewRef)
            this.partDataAdd.PRODUCT_CODE = null;
            return;
          }
  
        this.http.get("TI","SNM001P_M_MC_Product",this.global.EscapeCharacter(data),'20')
        .subscribe(res =>{
          if(res.Table.length > 0){
            this.partDataAdd.PRODUCT_CODE = res.Table[0].PRODUCT_CODE
          }else{
            //this.modal.warning("Product Code not found in data base",this.viewRef)
            this.partDataAdd.PRODUCT_CODE = null;
          }
        })
  
      }
    }
  
  public SetPartCodeAdd(event,data,action){
  
      if(action == "select"){
        if(event){
          this.partDataAdd.PART_CODE = event.PART_CODE
        }else{
          this.modal.warning("Part Code not found in data base",this.viewRef)
          this.partDataAdd.PART_CODE = null
        }
      }
      else if(action == "cancel"){
       
          if (!data){
            //this.modal.warning("Main Model is not null",this.viewRef)
            this.partDataAdd.PART_CODE = null;
            return;
          }
  
        this.http.get("TI","SNM001P_M_MC_PartCode",this.global.EscapeCharacter(data),'20')
        .subscribe(res =>{
          if(res.Table.length > 0){
            this.partDataAdd.PART_CODE = res.Table[0].PART_CODE
          }else{
            //this.modal.warning("Part Code not found in data base",this.viewRef)
            this.partDataAdd.PART_CODE = null;
          }
        })
  
      }
    }
  
  public SetLocationAdd(event,data,action){
  
      if(action == "select"){
        if(event){
        if (event.LOCATION_STATUS !== 'N' && event.LOCATION_NO) {
            let message = "Cannot select Locatio No : " + event.LOCATION_NO + ", due Location No : " + event.LOCATION_NO +   " in process re-location"
            this.modal.warning(message,this.viewRef,() => {},{width : '700px'})
            this.partDataAdd.LOCATION_NO = this.partDataAdd.TEMP_LOCATION_NO
            return;
          }
        else if (event.PART_STATUS != 'N' && event.LOCATION_NO) {
            let message = "<h4>Cannot select this locatoin, due this location used by Part No : " +event.PART_STATUS + " !!!!</h4>" 
            let colormessage = message.fontcolor("red");
            this.modal.warning(colormessage,this.viewRef,() => {},{width : '700px'})
            this.partDataAdd.LOCATION_NO = this.partDataAdd.TEMP_LOCATION_NO
            return;
          }
          this.partDataAdd.LOCATION_NO = event.LOCATION_NO
        }else{
          this.modal.warning("Location No not found in data base",this.viewRef)
          this.partDataAdd.LOCATION_NO = null
        }
      }
      else if(action == "cancel"){
        this.partDataAdd.LOCATION_NO = this.partDataAdd.TEMP_LOCATION_NO
        //   if (!data){
        //     this.partDataAdd.LOCATION_NO = null;
        //     return;
        //   }
        // this.http.get("TI","SNM001P_M_MC_Location",this.global.EscapeCharacter(data),'20')
        // .subscribe(res =>{
        //   if(res.Table.length > 0){
        //     this.partDataAdd.LOCATION_NO = res.Table[0].LOCATION_NO         
        //   }else{
        //     this.partDataAdd.LOCATION_NO = null;        
        //   }
        // })
      }
    }
  
  public SetMainmodelAdd(event,data,action){
  
      if(action == "select"){
        if(event){
          this.partDataAdd.MAIN_MODEL = event.MAIN_MODEL
        }else{
          this.modal.warning("Main Model not found in data base",this.viewRef)
          this.partDataAdd.MAIN_MODEL = null
        }
      }
      else if(action == "cancel"){
       
          if (!data){
            //this.modal.warning("Main Model is not null",this.viewRef)
            this.partDataAdd.MAIN_MODEL = null;
            return;
          }
  
        this.http.get("TI","SNM001P_M_MC_MainModel",this.global.EscapeCharacter(data),'20')
        .subscribe(res =>{
          if(res.Table.length > 0){
            this.partDataAdd.MAIN_MODEL = res.Table[0].MAIN_MODEL
          }else{
            //this.modal.warning("Tariff Code not found in data base",this.viewRef)
            this.partDataAdd.MAIN_MODEL = null;
          }
        })
  
      }
    }
  
  public SetDescriptCodeAdd(event,data,action){
  
      if(action == "select"){
        if(event){
          this.partDataAdd.DESCRIPT_CODE = event.DESCRIPT_CODE
          this.partDataAdd.SALES_CLASS = event.SALES_CLASS
        }else{
          this.modal.warning("Descript Code not found in data base",this.viewRef)
          this.partDataAdd.DESCRIPT_CODE = null
          this.partDataAdd.SALES_CLASS = null
        }
      }
      else if(action == "cancel"){
       
          if (!data){
            //this.modal.warning("Main Model is not null",this.viewRef)
            this.partDataAdd.DESCRIPT_CODE = null;
            this.partDataAdd.SALES_CLASS = null
            return;
          }
  
        this.http.get("TI","SNM001P_M_MC_Descript",this.global.EscapeCharacter(data),'20')
        .subscribe(res =>{
          if(res.Table.length > 0){
            this.partDataAdd.DESCRIPT_CODE = res.Table[0].DESCRIPT_CODE
            this.partDataAdd.SALES_CLASS = res.Table[0].SALES_CLASS
          }else{
            //this.modal.warning("Descript Code not found in data base",this.viewRef)
            this.partDataAdd.DESCRIPT_CODE = null;
            this.partDataAdd.SALES_CLASS = null
          }
        })
  
      }
    }
  
    public SetSalseClassAdd(event,data,action){
  
      if(action == "select"){
        if(event){
          this.partDataAdd.SALES_CLASS = event.SALES_CLASS
        }else{
          this.modal.warning("Sales Class not found in data base",this.viewRef)
          this.partDataAdd.SALES_CLASS = null
        }
      }
      else if(action == "cancel"){
       
          if (!data){
            //this.modal.warning("Main Model is not null",this.viewRef)
            this.partDataAdd.SALES_CLASS = null;
            return;
          }
  
        this.http.get("TI","SNM001P_M_MC_Salesclass",this.global.EscapeCharacter(data),'20')
        .subscribe(res =>{
          if(res.Table.length > 0){
            this.partDataAdd.SALES_CLASS = res.Table[0].SALES_CLASS
          }else{
            //this.modal.warning("Sales Class not found in data base",this.viewRef)
            this.partDataAdd.SALES_CLASS = null;
          }
        })
  
      }
    }
  
  public SetEDCAdd(event,data,action){
  
      if(action == "select"){
        
        if(event){
          this.partDataAdd.EDC_CODE = event.EDC_CODE
          this.ConfigADC.SourceParams.EDC = event.EDC_CODE
        }else{
          this.partDataAdd.EDC_CODE = null
          this.ConfigADC.SourceParams.EDC = null
        }
      }
      else if(action == "cancel"){
       
          if (!data){
            //this.modal.warning("Main Model is not null",this.viewRef)
            this.partDataAdd.EDC_CODE = null;
            this.ConfigADC.SourceParams.EDC = null  
            return;
          }
  
        this.http.get("TI","SNM001P_M_MC_EDC",this.global.EscapeCharacter(data),'20')
        .subscribe(res =>{
          if(res.Table.length > 0){
            this.partDataAdd.EDC_CODE = res.Table[0].EDC_CODE
            this.ConfigADC.SourceParams.EDC = res.Table[0].EDC_CODE
          }else{
            //this.modal.warning("Edc Code not found in data base",this.viewRef) 
            this.partDataAdd.EDC_CODE = null;
            this.ConfigADC.SourceParams.EDC = null   
          }
        })
  
      }
    }
  
    public SetADCAdd(event,data,action){
  
      if(action == "select"){
        if(event){
          this.partDataAdd.ADC_CODE = event.ADC_CODE
        }else{
          this.partDataAdd.ADC_CODE = null
        }
      }
      else if(action == "cancel"){
       
          if (!data){
            //this.modal.warning("Main Model is not null",this.viewRef)
            this.partDataAdd.ADC_CODE = null;
            return;
          }
  
        this.http.post("TI",["SNM001P_M_MC_ADC",this.global.EscapeCharacter(data),'20'],this.ConfigADC.SourceParams)
        .subscribe(res =>{
          if(res.Table.length > 0){
            this.partDataAdd.ADC_CODE = res.Table[0].ADC_CODE
          }else{
            //this.modal.warning("ADC Code not found in data base",this.viewRef)
            this.partDataAdd.ADC_CODE = null
          }
        })
  
      }
    }
  
  
  public SetOriginCodeAdd(event,data,action) {
      if(action == "select"){
        if(event){
          this.partDataAdd.ATTRIBUTE5 = event.ORIGIN_CODE
        }else{
          this.partDataAdd.ATTRIBUTE5 = null
        }
      }
      else if(action == "cancel"){
          if (!data){
            //this.modal.warning("Main Model is not null",this.viewRef)
            this.partDataAdd.ATTRIBUTE5 = null;
            return;
          }
        this.http.post("TI",["SNM001P_M_MC_Origin",this.global.EscapeCharacter(data),'20'],this.ConfigReasonCode.SourceParams)
        .subscribe(res =>{
          if(res.Table.length > 0){
            this.partDataAdd.ATTRIBUTE5 = res.Table[0].ORIGIN_CODE         
          }else{
            //this.modal.warning("Origin Code not found in data base",this.viewRef)
            this.partDataAdd.ATTRIBUTE5 = null;        
          }
        })
      }
    }
  
  public SetVendorAdd(event,data,action){
  
      if(action == "select"){
        if(event){
          this.partDataAdd.VENDOR_CODE = event.VENDOR_CODE;
          this.partDataAdd.VENDOR_FULL_NAME = event.LOOKUP;
          this.partDataAdd.CURRENCY_CODE = event.CURRENCY_CODE;
          this.partDataAdd.VENDOR_TYPE = event.VENDOR_TYPE
        }else{
          this.partDataAdd.VENDOR_CODE = null;
          this.partDataAdd.VENDOR_FULL_NAME = null;
          this.partDataAdd.CURRENCY_CODE = null;
          this.partDataAdd.VENDOR_TYPE = null
        }
      }
      else if(action == "cancel"){
          if (!data){
            //this.modal.warning("Main Model is not null",this.viewRef)
            this.partDataAdd.VENDOR_CODE = null;
            this.partDataAdd.VENDOR_FULL_NAME = null;
            this.partDataAdd.CURRENCY_CODE = null;
            this.partDataAdd.VENDOR_TYPE = null
            return;
          }
        this.http.get("TI","SNM001P_M_MC_Vendor",this.global.EscapeCharacter(data),'20')
        .subscribe(res =>{
          if(res.Table.length > 0){
            this.partDataAdd.VENDOR_CODE = res.Table[0].VENDOR_CODE;
            this.partDataAdd.VENDOR_FULL_NAME = res.Table[0].LOOKUP;
            this.partDataAdd.CURRENCY_CODE = res.Table[0].CURRENCY_CODE;
            this.partDataAdd.VENDOR_TYPE = res.Table[0].VENDOR_TYPE
            
          }else{
            //this.modal.warning("Vendor Code not found in data base",this.viewRef)
            this.partDataAdd.VENDOR_CODE = null;
            this.partDataAdd.VENDOR_FULL_NAME = null;
            this.partDataAdd.CURRENCY_CODE = null;
            this.partDataAdd.VENDOR_TYPE = null;        
          }
        })
      }
    }
  
   public SetPartFamilyAdd(event,data,action){
  
      if(action == "select"){
        if(event){
          this.partDataAdd.FAMILY_CODE = event.FAMILY_CODE
        }else{
          this.partDataAdd.FAMILY_CODE = null
        }
      }
      else if(action == "cancel"){
          if (!data){
            //this.modal.warning("Main Model is not null",this.viewRef)
            this.partDataAdd.FAMILY_CODE = null;
            return;
          }
        this.http.get("TI","SNM001P_M_MC_Family",this.global.EscapeCharacter(data),'20')
        .subscribe(res =>{
          if(res.Table.length > 0){
            this.partDataAdd.FAMILY_CODE = res.Table[0].FAMILY_CODE
            
          }else{
            //this.modal.warning("Family Code not found in data base",this.viewRef)
            this.partDataAdd.FAMILY_CODE = null;
           
          }
        })
      }
    }
  
   public SetLRPartAdd(event,data,action) {
      if(action == "select"){
        if(event){
          this.partDataAdd.LR_PART_NO = event.PART_NO
        }else{
          this.partDataAdd.LR_PART_NO = null
        }
      }
      else if(action == "cancel"){
          if (!data){
            //this.modal.warning("Main Model is not null",this.viewRef)
            this.partDataAdd.LR_PART_NO = null;
            return;
          }
        this.http.post("TI",["SNM001P_M_MC_LRPart",this.global.EscapeCharacter(data),'20'],this.ConfigLRPart.SourceParams)
        .subscribe(res =>{
          if(res.Table.length > 0){
            this.partDataAdd.LR_PART_NO = res.Table[0].PART_NO         
          }else{
            //this.modal.warning("Part No not found in data base",this.viewRef)
            this.partDataAdd.LR_PART_NO = null;        
          }
        })
      }
    }

    public SetPartTypeAdd(event,data,action) {
      if(action == "select"){
        
        if(event){
          this.partDataAdd.PART_TYPE = event.PART_TYPE
          this.partDataAdd.PART_TYPE_SHOW = event.LOOKUP
        }else{
          this.modal.warning("Part Type not found in data base",this.viewRef)
          this.partDataAdd.PART_TYPE = null
          this.partDataAdd.PART_TYPE_SHOW = null
        }
      }
      else if(action == "cancel"){
          if (!data){
            //this.modal.warning("Main Model is not null",this.viewRef)
            this.partDataAdd.PART_TYPE = null;
            this.partDataAdd.PART_TYPE_SHOW = null;
            return;
          }
          this.http.get("TI","SNM001P_M_MC_Part_Type",this.global.EscapeCharacter(data),'20')
        .subscribe(res =>{
          if(res.Table.length > 0){
            this.partDataAdd.PART_TYPE = res.Table[0].PART_TYPE 
            this.partDataAdd.PART_TYPE_SHOW = res.Table[0].LOOKUP        
          }else{
            //this.modal.warning("Part No not found in data base",this.viewRef)
            this.partDataAdd.PART_TYPE = null;  
            this.partDataAdd.PART_TYPE_SHOW = null      
          }
        })
      }
    }
  

}
