import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';
import { FormControl, NgForm, Validators } from '@angular/forms';

@Component({
  selector: 'snm005p',
  templateUrl: './snm005p.component.html',
  styleUrls: ['./snm005p.component.css']
})



export class SNM005PComponent implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private global: Globals,
    private viewref: ViewContainerRef
  ) { }

  @ViewChild("dialogAdd", { static: false }) dialogAdd: any;
  @ViewChild("dialogEdit", { static: false }) dialogEdit: any;
  @ViewChild("addForm") addForm: NgForm;
  @ViewChild("editForm") editForm: NgForm;

  public ConfigCustomer: any = {
    ColName: "CODE_NAME",
    ColValue: "",
    PlaceholderText: "Select Customer",
    SourceController: "wPMS",
    SourceMethodName: "GetCustomerCode",
    NoOfShowRecords: 25,
    MinLengthSearch: 1,
    UpperCase: true
  }


  public ConfigBranch: any = {
    ColName: "BRANCH_CODE",
    ColValue: "BRANCH_CODE",
    PlaceholderText: "Select Branch",
    SourceController: "AC",
    SourceMethodName: "GetBranch",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }


  public ConfigRouteCode: any = {
    ColName: "LOOK_UP",
    ColValue: "ROUTE_CODE",
    PlaceholderText: "Select Route Code",
    SourceController: "AC",
    SourceMethodName: "GetRouteCode",
    NoOfShowRecords: 40,
    MinLengthSearch: 2,
    UpperCase: true
  }

  public ConfigTransport: any = {
    ColName: "LOOK_UP",
    ColValue: "TRANSPORT_CODE",
    PlaceholderText: "Select Transport Code",
    SourceController: "AC",
    SourceMethodName: "GetTransportCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigBranchStatus: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Branch Status",
    SourceController: "AC",
    SourceMethodName: "GetBranchStatus",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigBranchAr: any = {
    ColName: "BRANCH_CODE_SAP",
    ColValue: "BRANCH_CODE_SAP",
    PlaceholderText: "Select Branch AR(sap)",
    SourceController: "AC",
    SourceMethodName: "GetBranchAR",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }

  public ConfigZoneArea: any = {
    ColName: "LOOKUP_ZONE_AREA_CODE_VALUE",
    PlaceholderText: "Select Zone Area",
    SourceController: "AC",
    SourceMethodName: "SNM005P_ZONE_AREA",
    NoOfShowRecords: 30,
    MinLengthSearch: 0
  }
  public Params = {
    CUSTOMER_CODE: null,
    BRANCH_NAME: null,
    BRANCH_CODE: null,
    BRANCH_AR: null
  }

  public ParamsAdd = {
    CUSTOMER_CODE: null,
    CUST_NAME_EN: null,
    BRANCH_CODE: null,
    BRANCH_NAME_EN: null,
    BRANCH_NAME_TH: null,
    BRANCH_ADDR1: null,
    BRANCH_ADDR2: null,
    BRANCH_ADDR3: null,
    BRANCH_ADDR4: null,
    ATTRIBUTE5: 'N',
    BRANCH_CONTACT: null,
    CUSTOMER_TAX_ID: null,
    BRANCH_CODE_SAP: null,
    BUSINESS_PLACE: '00000',
    ROUTE_CODE_EO: null,
    TRANSPORT_EO: null,
    ROUTE_CODE_RO: null,
    TRANSPORT_RO: null,
    ATTRIBUTE1: null,
    ATTRIBUTE2: null,
    ATTRIBUTE4: null,
    BRANCH_STATUS: null,
    BRANCH_STATUS_SHOW: null,
    CUST_NAME_TH: null,
    ZONE_AREA_CODE: null,
    ZONE_AREA_EN: null,
    ZONE_AREA_TH: null,
    REGION_CODE: null,
    REGION_NAME_EN: null,
    REGION_NAME_TH: null,
    SALESMAN_NAME: null,
    POST_CODE: null,
    EMAIL: null
  }

  public ParamsEdit = {
    CUSTOMER_CODE: null,
    CUST_NAME_EN: null,
    BRANCH_CODE: null,
    BRANCH_NAME_EN: null,
    BRANCH_NAME_TH: null,
    BRANCH_ADDR1: null,
    BRANCH_ADDR2: null,
    BRANCH_ADDR3: null,
    BRANCH_ADDR4: null,
    ATTRIBUTE5: null,
    BRANCH_CONTACT: null,
    CUSTOMER_TAX_ID: null,
    BRANCH_CODE_SAP: null,
    BUSINESS_PLACE: null,
    ROUTE_CODE_EO: null,
    TRANSPORT_EO: null,
    ROUTE_CODE_RO: null,
    TRANSPORT_RO: null,
    ATTRIBUTE1: null,
    ATTRIBUTE2: null,
    ATTRIBUTE4: null,
    LAST_UPD_BY_NAME: null,
    LAST_UPD_DATE: null,
    BRANCH_STATUS: null,
    BRANCH_STATUS_SHOW: null,
    CUST_NAME_TH: null,
    ZONE_AREA_CODE: null,
    ZONE_AREA_EN: null,
    ZONE_AREA_TH: null,
    REGION_CODE: null,
    REGION_NAME_EN: null,
    REGION_NAME_TH: null,
    SALESMAN_NAME: null,
    POST_CODE: null,
    EMAIL: null

  }

  public click: boolean = false;
  public RoleCHG: boolean = false;
  public hideCols: Array<string> = []
  public tableData: any = [];
  public BusinessList: any = [];
  public requiredBusinessPlace: boolean = true;

  ngOnInit() {

    let i = 0;
    while (i < 131) {
      if (i.toString().length == 1) {
        this.BusinessList.push('0000' + i)
      } else if (i.toString().length == 2) {
        this.BusinessList.push('000' + i)
      } else if (i.toString().length == 3) {
        this.BusinessList.push('00' + i)
      }
      i++
    }
    this.global.GetRoleDetail().CHG === "N" ? this.RoleCHG = false : this.RoleCHG = true;
    this.global.GetRoleDetail().DEL === "N" ? this.hideCols.push("DELETE") : null;
  }

  Search() {

    this.http.post('AC', 'SNM005P_GetData', this.Params)
      .subscribe(res => {
        this.tableData = res.Table;
      })

  }
  public SetSelectedZoneAreaAdd(value: any, data, action) {
    if (action == "select") {
      if (value) {
        this.ParamsAdd.ZONE_AREA_CODE = value.ZONE_AREA_CODE;
        this.ParamsAdd.ZONE_AREA_EN = value.ZONE_AREA_EN;
        this.ParamsAdd.ZONE_AREA_TH = value.ZONE_AREA_TH;
        this.ParamsAdd.REGION_CODE = value.REGION_CODE;
        this.ParamsAdd.REGION_NAME_EN = value.REGION_NAME_EN;
        this.ParamsAdd.REGION_NAME_TH = value.REGION_NAME_TH;
        this.ParamsAdd.SALESMAN_NAME = value.SALESMAN_NAME;
      } else {
        this.modal.warning("Region not found in data base", this.viewref)
        this.ParamsAdd.ZONE_AREA_CODE = null;
        this.ParamsAdd.ZONE_AREA_EN = null;
        this.ParamsAdd.ZONE_AREA_TH = null;
        this.ParamsAdd.REGION_CODE = null;
        this.ParamsAdd.REGION_NAME_EN = null;
        this.ParamsAdd.REGION_NAME_TH = null;
        this.ParamsAdd.SALESMAN_NAME = null;
      }
    }
    else if (action == "cancel") {
      if (!data) {
        this.ParamsAdd.ZONE_AREA_CODE = null;
        return;
      }
      this.http.get("AC", "GetZoneArea", this.global.EscapeCharacter(data), '50')
        .subscribe(res => {
          if (res.Table.length > 0) {
            this.ParamsAdd.ZONE_AREA_CODE = res.Table[0].ZONE_AREA_CODE;
            this.ParamsAdd.ZONE_AREA_EN = res.Table[0].ZONE_AREA_EN;
            this.ParamsAdd.ZONE_AREA_TH = res.Table[0].ZONE_AREA_TH;
            this.ParamsAdd.REGION_CODE = res.Table[0].REGION_CODE;
            this.ParamsAdd.REGION_NAME_EN = res.Table[0].REGION_NAME_EN;
            this.ParamsAdd.REGION_NAME_TH = res.Table[0].REGION_NAME_TH;
            this.ParamsAdd.SALESMAN_NAME = res.Table[0].SALESMAN_NAME;
          } else {
            this.ParamsAdd.ZONE_AREA_CODE = null;
            this.ParamsAdd.ZONE_AREA_EN = null;
            this.ParamsAdd.ZONE_AREA_TH = null;
            this.ParamsAdd.REGION_CODE = null;
            this.ParamsAdd.REGION_NAME_EN = null;
            this.ParamsAdd.REGION_NAME_TH = null;
            this.ParamsAdd.SALESMAN_NAME = null;
          }
        })
    }
  }
  public SetSelectedZoneAreaEdit(value: any, data, action) {
    if (action == "select") {
      if (value) {
        this.ParamsEdit.ZONE_AREA_CODE = value.ZONE_AREA_CODE;
        this.ParamsEdit.ZONE_AREA_EN = value.ZONE_AREA_EN;
        this.ParamsEdit.ZONE_AREA_TH = value.ZONE_AREA_TH;
        this.ParamsEdit.REGION_CODE = value.REGION_CODE;
        this.ParamsEdit.REGION_NAME_EN = value.REGION_NAME_EN;
        this.ParamsEdit.REGION_NAME_TH = value.REGION_NAME_TH;
        this.ParamsEdit.SALESMAN_NAME = value.SALESMAN_NAME;
      } else {
        this.modal.warning("Region not found in data base", this.viewref)
        this.ParamsEdit.ZONE_AREA_CODE = null;
        this.ParamsEdit.ZONE_AREA_EN = null;
        this.ParamsEdit.ZONE_AREA_TH = null;
        this.ParamsEdit.REGION_CODE = null;
        this.ParamsEdit.REGION_NAME_EN = null;
        this.ParamsEdit.REGION_NAME_TH = null;
        this.ParamsEdit.SALESMAN_NAME = null;
      }
    }
    else if (action == "cancel") {
      if (!data) {
        this.ParamsEdit.ZONE_AREA_CODE = null;
        return;
      }
      this.http.get("AC", "GetZoneArea", this.global.EscapeCharacter(data), '50')
        .subscribe(res => {
          if (res.Table.length > 0) {
            this.ParamsEdit.ZONE_AREA_CODE = res.Table[0].ZONE_AREA_CODE;
            this.ParamsEdit.ZONE_AREA_EN = res.Table[0].ZONE_AREA_EN;
            this.ParamsEdit.ZONE_AREA_TH = res.Table[0].ZONE_AREA_TH;
            this.ParamsEdit.REGION_CODE = res.Table[0].REGION_CODE;
            this.ParamsEdit.REGION_NAME_EN = res.Table[0].REGION_NAME_EN;
            this.ParamsEdit.REGION_NAME_TH = res.Table[0].REGION_NAME_TH;
            this.ParamsEdit.SALESMAN_NAME = res.Table[0].SALESMAN_NAME;
          } else {
            this.ParamsAdd.ZONE_AREA_CODE = null;
            this.ParamsAdd.ZONE_AREA_EN = null;
            this.ParamsAdd.ZONE_AREA_TH = null;
            this.ParamsEdit.REGION_CODE = null;
            this.ParamsAdd.REGION_NAME_EN = null;
            this.ParamsAdd.REGION_NAME_TH = null;
            this.ParamsAdd.SALESMAN_NAME = null;
          }
        })
    }
  }

  ValidateCustomer(element) {
    if (element.textInput.length > 0) {
      this.http.get("AC", "GetValidateCustomer", element.textInput.toUpperCase())
        .subscribe(res => {
          if (res.Table.length > 0) {
            this.ParamsAdd.CUSTOMER_CODE = element.textInput.toUpperCase()
            this.ParamsAdd.CUST_NAME_TH = res.Table[0].CUST_NAME_TH
            this.ParamsAdd.CUST_NAME_EN = res.Table[0].CUST_NAME_EN
            this.ParamsAdd.BRANCH_NAME_EN = res.Table[0].CUST_NAME_TH

            if (res.Table[0].OVERSEA_FLAG !== 'D') {
              this.requiredBusinessPlace = false;
              this.ParamsAdd.BUSINESS_PLACE = null;
              this.ParamsAdd.ATTRIBUTE5 = null;
              this.ParamsEdit.BUSINESS_PLACE = null;
              this.ParamsEdit.ATTRIBUTE5 = null;
            } else {
              this.requiredBusinessPlace = true;
              this.ParamsAdd.BUSINESS_PLACE = '00000';
              this.ParamsAdd.ATTRIBUTE5 = 'N';
              this.ParamsEdit.BUSINESS_PLACE = '00000';
              this.ParamsEdit.ATTRIBUTE5 = 'N';
            }
          } else {
            this.modal.warning("Customer " + element.textInput + " not found", this.viewref, () => {
              this.ParamsAdd.CUSTOMER_CODE = null
              this.ParamsAdd.CUST_NAME_TH = null
              // this.ParamsAdd.BRANCH_NAME_EN = null
            })

          }
        })
    } else {
      this.ParamsAdd.CUST_NAME_EN = null;
    }
  }


  openDialog() {
    this.ParamsAdd = this.global.ClearObject(this.ParamsAdd);
    this.ParamsAdd.ATTRIBUTE5 = 'N'
    this.ParamsAdd.BUSINESS_PLACE = '00000'
    this.dialogAdd.OpenDialog();
    this.requiredBusinessPlace = true;
  }

  SaveAdd() {

    if(!this.ParamsAdd.EMAIL || !this.ParamsAdd.POST_CODE){
      this.modal.warning("Please input email and post code",this.viewref)
      return
    }

    if (this.addForm.form.valid) {
      this.modal.confirm("Do you want to save change you have made?", this.viewref, this.ConfirmSaveAdd)
    } else {
      this.modal.warning("Please fill all required fields.", this.viewref);
    }
  }

  ConfirmSaveAdd = () => {


    this.http.post("AC", "SNM005P_Insert", this.ParamsAdd)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'Done') {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.ParamsAdd = this.global.ClearObject(this.ParamsAdd)
          this.Search();
          this.dialogAdd.Close();

        } else if (res.Table[0].STATUS == 'Duplicate') {
          this.modal.warning('No change to save. Found duplicate record.', this.viewref);
        }
        else {
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      },err => {
        this.modal.error('Found an error, please contact support team', this.viewref);
      })
  }

  CancelAdd() {
    this.dialogAdd.Close()
  }

  Edit(data) {
    this.ParamsEdit = data
    this.requiredBusinessPlace = data.OVERSEA_FLAG === 'D';
    this.dialogEdit.OpenDialog();
  }

  SaveEdit() {
    if(!this.ParamsEdit.EMAIL || !this.ParamsEdit.POST_CODE){
      this.modal.warning("Please input email and post code",this.viewref)
      return
    }

    if (this.editForm.form.valid) {
      this.modal.confirm("Do you want to save change you have made?", this.viewref, this.ConfirmEdit)
    } else {
      this.modal.warning("Please fill all required fields.", this.viewref);
    }
  }

  ConfirmEdit = () => {
    this.http.post("AC", "SNM005P_Update", this.ParamsEdit)
      .subscribe(res => {

        if (res.Table[0].STATUS == 'Done') {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.dialogEdit.Close();
          this.Search();

        }
        else {
          console.log('r', res)
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })
  }

  CancelEdit() {
    this.dialogEdit.Close()
  }

  Delete(data) {
    this.modal.confirm("Do you want to delete record?", this.viewref, () => this.ConfirmDelete(data))
  }

  ConfirmDelete(data) {

    this.http.post("AC", "SNM005P_Delete", data)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'Done') {
          this.modal.info('Transaction complete: 1 record applied and deleted.', this.viewref);
          this.Search();
        }
        else {
          console.log(res)
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })
  }


  PrintChange(Mode, event) {
    switch (Mode) {
      case 'A':
        if (event == 'N') {
          this.ParamsAdd.BUSINESS_PLACE = '00000'
        }
        else {
          this.ParamsAdd.BUSINESS_PLACE = null
        }
        break;
      case 'E':
        if (event == 'N') {
          this.ParamsEdit.BUSINESS_PLACE = '00000'
        }
        else {
          this.ParamsEdit.BUSINESS_PLACE = null
        }
        break;
      default:
        console.log("Mode Not Macth!")
        break;
    }
  }

  SetCustomer(evt) {

    this.ParamsAdd.CUSTOMER_CODE = evt.CUSTOMER_CODE;
    this.ParamsAdd.CUST_NAME_TH = evt.CUST_NAME_TH;
    this.ParamsAdd.CUST_NAME_EN = evt.CUST_NAME_EN
    this.ParamsAdd.BRANCH_NAME_EN = evt.CUST_NAME_TH
  }


  public SetSelectedRouteAddEO(value: any, data, action) {

    if (action == "select") {
      if (value) {
        this.ParamsAdd.ROUTE_CODE_EO = value
       
      } else {
        this.modal.warning("Route Code not found in data base", this.viewref)
        this.ParamsAdd.ROUTE_CODE_EO = null
       
      }
    }
    else if (action == "cancel") {

      if (!data) {
        this.ParamsAdd.ROUTE_CODE_EO = null;
        
        return;
      }

      this.http.get("AC", "GetRouteCode", this.global.EscapeCharacter(data), '50')
        .subscribe(res => {

          if (res.Table.length > 0) {
            this.ParamsAdd.ROUTE_CODE_EO = res.Table[0].ROUTE_CODE
            
          } else {
            //this.modal.warning("Route Code not found in data base", this.viewref)
            this.ParamsAdd.ROUTE_CODE_EO = null;
            
          }
        })

    }
  }



  public SetSelectedRouteAddRO(value: any, data, action) {

    if (action == "select") {
      if (value) {
        this.ParamsAdd.ROUTE_CODE_RO = value
       
      } else {
        this.modal.warning("Route Code not found in data base", this.viewref)
        this.ParamsAdd.ROUTE_CODE_RO = null
       
      }
    }
    else if (action == "cancel") {

      if (!data) {
        this.ParamsAdd.ROUTE_CODE_RO = null;
        
        return;
      }

      this.http.get("AC", "GetRouteCode", this.global.EscapeCharacter(data), '50')
        .subscribe(res => {

          if (res.Table.length > 0) {
            this.ParamsAdd.ROUTE_CODE_RO = res.Table[0].ROUTE_CODE
            
          } else {
            //this.modal.warning("Route Code not found in data base", this.viewref)
            this.ParamsAdd.ROUTE_CODE_RO = null;
            
          }
        })

    }
  }


  public SetSelectedRouteEditEO(value: any, data, action) {
    console.log('vvvvv',value)
    if (action == "select") {
      if (value) {
        this.ParamsEdit.ROUTE_CODE_EO = value
       
      } else {
        this.modal.warning("Route Code not found in data base", this.viewref)
        this.ParamsEdit.ROUTE_CODE_EO = null
       
      }
    }
    else if (action == "cancel") {

      if (!data) {
        this.ParamsEdit.ROUTE_CODE_EO = null;
        
        return;
      }

      this.http.get("AC", "GetRouteCode", this.global.EscapeCharacter(data), '50')
        .subscribe(res => {

          if (res.Table.length > 0) {
            this.ParamsEdit.ROUTE_CODE_EO = res.Table[0].ROUTE_CODE
            
          } else {
            //this.modal.warning("Route Code not found in data base", this.viewref)
            this.ParamsEdit.ROUTE_CODE_EO = null;
            
          }
        })

    }
  }



  public SetSelectedRouteEditRO(value: any, data, action) {

    if (action == "select") {
      if (value) {
        this.ParamsEdit.ROUTE_CODE_RO = value
       
      } else {
        this.modal.warning("Route Code not found in data base", this.viewref)
        this.ParamsEdit.ROUTE_CODE_RO = null
       
      }
    }
    else if (action == "cancel") {

      if (!data) {
        this.ParamsEdit.ROUTE_CODE_RO = null;
        
        return;
      }

      this.http.get("AC", "GetTransportCode", this.global.EscapeCharacter(data), '50')
        .subscribe(res => {

          if (res.Table.length > 0) {
            this.ParamsEdit.ROUTE_CODE_RO = res.Table[0].ROUTE_CODE
            
          } else {
            //this.modal.warning("Route Code not found in data base", this.viewref)
            this.ParamsEdit.ROUTE_CODE_RO = null;
            
          }
        })

    }
  }


  public SetSelectedTransportAddEO(value: any, data, action) {
  
    if (action == "select") {
      if (value) {
        this.ParamsAdd.TRANSPORT_EO = value
       
      } else {
        this.modal.warning("Transport Code not found in data base", this.viewref)
        this.ParamsAdd.TRANSPORT_EO = null
       
      }
    }
    else if (action == "cancel") {

      if (!data) {
        this.ParamsAdd.TRANSPORT_EO = null;
        
        return;
      }

      this.http.get("AC", "GetTransportCode", this.global.EscapeCharacter(data), '50')
        .subscribe(res => {

          if (res.Table.length > 0) {
            this.ParamsAdd.TRANSPORT_EO = res.Table[0].TRANSPORT_CODE
            
          } else {
            //this.modal.warning("Route Code not found in data base", this.viewref)
            this.ParamsAdd.TRANSPORT_EO = null;
            
          }
        })

    }
  }



  public SetSelectedTransportEditRO(value: any, data, action) {
  
    if (action == "select") {
      if (value) {
        this.ParamsEdit.TRANSPORT_RO = value
       
      } else {
        this.modal.warning("Transaport Code not found in data base", this.viewref)
        this.ParamsEdit.TRANSPORT_RO = null
       
      }
    }
    else if (action == "cancel") {
     
      if (!data) {
        this.ParamsEdit.TRANSPORT_RO = null;
        
        return;
      }

      this.http.get("AC", "GetRouteCode", this.global.EscapeCharacter(data), '50')
        .subscribe(res => {

          if (res.Table.length > 0) {
            this.ParamsEdit.TRANSPORT_RO = res.Table[0].TRANSPORT_CODE
            
          } else {
            //this.modal.warning("Route Code not found in data base", this.viewref)
            this.ParamsEdit.TRANSPORT_RO = null;
            
          }
        })

    }
  }


  public SetSelectedTransportAddRO(value: any, data, action) {
  
    if (action == "select") {
      if (value) {
        this.ParamsAdd.TRANSPORT_RO = value
       
      } else {
        this.modal.warning("Transport Code not found in data base", this.viewref)
        this.ParamsAdd.TRANSPORT_RO = null
       
      }
    }
    else if (action == "cancel") {

      if (!data) {
        this.ParamsAdd.TRANSPORT_RO = null;
        
        return;
      }

      this.http.get("AC", "GetRouteCode", this.global.EscapeCharacter(data), '50')
        .subscribe(res => {

          if (res.Table.length > 0) {
            this.ParamsAdd.TRANSPORT_RO = res.Table[0].TRANSPORT_CODE
            
          } else {
            //this.modal.warning("Route Code not found in data base", this.viewref)
            this.ParamsAdd.TRANSPORT_RO = null;
            
          }
        })

    }
  }



  public SetSelectedTransportEditEO(value: any, data, action) {
  
    if (action == "select") {
      if (value) {
        this.ParamsEdit.TRANSPORT_EO = value
       
      } else {
        this.modal.warning("Transaport Code not found in data base", this.viewref)
        this.ParamsEdit.TRANSPORT_EO = null
       
      }
    }
    else if (action == "cancel") {

      if (!data) {
        this.ParamsEdit.TRANSPORT_EO = null;
        
        return;
      }

      this.http.get("AC", "GetRouteCode", this.global.EscapeCharacter(data), '50')
        .subscribe(res => {

          if (res.Table.length > 0) {
            this.ParamsEdit.TRANSPORT_EO = res.Table[0].TRANSPORT_CODE
            
          } else {
            //this.modal.warning("Route Code not found in data base", this.viewref)
            this.ParamsEdit.TRANSPORT_EO = null;
            
          }
        })

    }
  }



  Download() {
    this.http.Download('AC', 'SNM005P_Download',this.Params)
      .subscribe(res => {
        if (res) {
          this.WriteContents(res)
        } else {
          this.modal.error('Export file not complete', this.viewref)
        }
      },err => {
        this.modal.error('Export file not complete', this.viewref)
      })
  }

  WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "BranchInfo.xlsx";
    a.click();
  }

}

