import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from '../../../core/modal.service';
import { Globals } from '../../../core/global';
import { SelectionModel } from '@angular/cdk/collections';
import * as moment from 'moment';
import { __values } from 'tslib';

enum PageAction {
  Search = 0,
  Detail,
  Retrive
}

@Component({
  selector: 'snm114p',
  templateUrl: './snm114p.component.html',
  styleUrls: ['./snm114p.component.css']
})



export class SNM114PComponent implements OnInit {

  public params: any = {};
  public data: any = {};
  public formData: any = [];

  public oldTableData_List1: any = [];
  public oldTableData_List2: any = [];
  public oldTableData_List3: any = [];
  public oldTableData_List4_1: any = [];
  public oldTableData_List4_2: any = [];
  public oldTableData_List5_1: any = [];
  public oldTableData_List5_2: any = [];

  public tableData_List1: any = [];
  public tableData_List2: any = [];
  public tableData_List3: any = [];
  public tableData_List4_1: any = [];
  public tableData_List4_2: any = [];
  public tableData_List5_1: any = [];
  public tableData_List5_2: any = [];

  public dataIsSelected1: any = [];
  public dataIsSelected2: any = [];
  public dataUploadIsSelected: any = [];

  public selection1 = new SelectionModel<any>(true, []);
  public selection2 = new SelectionModel<any>(true, []);
  public selectionUpload = new SelectionModel<any>(true, []);

  public PageAction: number;
  public tabIndex: number = 0;

  public currentDate: moment.Moment = moment();

  public DataUploadList: any = [];
  public files: any = [];
  public FileName: string = "";
  public ListLog: any = [];
  public paramsUpload: any = {};
  public DSP_PART_NAME: string = "";

  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals
  ) { }

  @ViewChild("dialogCreate", { static: false }) dialogCreate: any;
  @ViewChild("dialogUpload", { static: false }) dialogUpload: any;
  @ViewChild("dialogLog", { static: false }) dialogLog: any;

  public lookupCampaignIDConfig: any = {
    ColName: "LOOKUP_CAMPAIGN_ID",
    PlaceholderText: "Select Campaign ID",
    SourceController: "TI",
    SourceMethodName: "SNM114P_GetCampaignID",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedCampaignID(value: any) {
    this.InitData();
    this.params.CAMPAIGN_ID = value.CAMPAIGN_ID;
    this.params.CAMPAIGN_NAME = value.CAMPAIGN_NAME;
    this.params.EFFECTIVE_DATE = value.EFFECTIVE_DATE;
    this.params.DISABLE_DATE = value.DISABLE_DATE;
    this.params.DSP_STATUS = value.DSP_STATUS;
    this.params.STATUS = value.STATUS;
    this.params.DISCOUNT_TYPE = value.DISCOUNT_TYPE;
  }

  public lookupOrderClassConfig: any = {
    ColName: "LOOKUP_ORDER_CLASS",
    PlaceholderText: "Select Order Class",
    SourceController: "TI",
    SourceMethodName: "SNM114P_GetOrderClass",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedOrderClass(value, data) {
    data.ORDER_CLASS = value.ORDER_CLASS;
    data.DSP_ORDER_CLASS = value.LOOKUP_ORDER_CLASS;
  }


  ngOnInit() {
    this.params.CHK_DEL_ORD_COUNT = 0;
    this.params.CHK_DEL_ORD_COUNT_2 = 0;
    this.params.DISCOUNT_TYPE = 'D';
  }

  private InitData() {
    this.tableData_List1 = [];
    this.tableData_List2 = [];
    this.tableData_List3 = [];
    this.tableData_List4_1 = [];
    this.tableData_List4_2 = [];
    this.tableData_List5_1 = [];
    this.tableData_List5_2 = [];
    this.selection1.clear();
    this.selection2.clear();
    this.dataIsSelected1 = [];
    this.dataIsSelected2 = [];
    this.formData = [];
    this.params.CHK_DEL_ORD_COUNT = 0;
    this.params.CHK_DEL_ORD_COUNT_2 = 0;
  }

  public Search() {
    if (this.params.CAMPAIGN_ID) {
      this.InitData();
      this.oldTableData_List1 = [];
      this.oldTableData_List2 = [];
      this.http.post('TI', 'SNM114P_GetOrderFactor', this.params)
        .subscribe(res => {
          this.tableData_List1 = res.Table;
          this.tableData_List1.push({
            'EDIT': 'ADD',
            'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
            'ORDER_CLASS': null,
            'ORDER_PREFIX': null,
            'LAST_UPD_BY': null,
            'LAST_UPD_DATE': null,
            'CHECK': null
          });
          this.tableData_List1 = this.tableData_List1.slice();
          this.PageAction = PageAction.Retrive;

          this.oldTableData_List1 = JSON.parse(JSON.stringify(this.tableData_List1));
        })

      this.http.post('TI', 'SNM114P_GetCustomerFactor', this.params)
        .subscribe(res => {
          this.tableData_List2 = res.Table;
          this.tableData_List2.push({
            'EDIT': 'ADD',
            'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
            'SALES_CHANNEL': null,
            'CUSTOMER_CODE': null,
            'BRANCH_CODE': null,
            'DSP_CUSTOMER_NAME': null,
            'CHECK': null
          });
          this.tableData_List2 = this.tableData_List2.slice();
          this.PageAction = PageAction.Retrive;

          this.oldTableData_List2 = JSON.parse(JSON.stringify(this.tableData_List2));
        })
      if (this.params.DISCOUNT_TYPE == 'D') {
        this.oldTableData_List3 = [];
        this.http.post('TI', 'SNM114P_GetDiscountDefault', this.params)
          .subscribe(res => {
            this.tableData_List3 = res.Table;
            this.tableData_List3.push({
              'EDIT': 'ADD',
              'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
              'PART_NO': null,
              'DSP_PART_NAME': null,
              'DSP_RETAIL_PRICE': null,
              'DISCOUNT_RATE1': null,
              'DISCOUNT_RATE2': null,
              'DISCOUNT_RATE3': null,
              'NET_PRICE': null,
              'CHECK': null
            });
            this.tableData_List3 = this.tableData_List3.slice();
            this.PageAction = PageAction.Retrive;

            this.oldTableData_List3 = JSON.parse(JSON.stringify(this.tableData_List3));
          })
      }
      else if (this.params.DISCOUNT_TYPE == 'V') {
        this.oldTableData_List4_1 = [];
        this.http.post('TI', 'SNM114P_GetDiscountVolumeHeader', this.params)
          .subscribe(res => {
            this.tableData_List4_1 = res.Table;
            if (this.tableData_List4_1.length > 0) {
              this.RowClick(this.tableData_List4_1[0], 4)
            }
            this.tableData_List4_1.push({
              'EDIT': 'ADD',
              'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
              'PART_NO': null,
              'CHECK': null
            });
            this.tableData_List4_1 = this.tableData_List4_1.slice();
            this.PageAction = PageAction.Retrive;

            this.oldTableData_List4_1 = JSON.parse(JSON.stringify(this.tableData_List4_1));
          })
      }
      else if (this.params.DISCOUNT_TYPE == 'P') {
        this.oldTableData_List5_1 = [];
        this.http.post('TI', 'SNM114P_GetDiscountPackageHeader', this.params)
          .subscribe(res => {
            this.tableData_List5_1 = res.Table;
            if (this.tableData_List5_1.length > 0) {
              this.RowClick(this.tableData_List5_1[0], 5)
            }
            this.tableData_List5_1.push({
              'EDIT': 'ADD',
              'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
              'PACKAGE_ID': null,
              'PACKAGE_NAME': null,
              'CHECK': null
            });
            this.tableData_List5_1 = this.tableData_List5_1.slice();
            this.PageAction = PageAction.Retrive;

            this.oldTableData_List5_1 = JSON.parse(JSON.stringify(this.tableData_List5_1));
          })
      }

    }
  }

  public RowClick(data, tab) {
    if (tab == 4 && !data.EDIT) {
      this.tableData_List4_2 = [];
      this.oldTableData_List4_2 = [];
      this.http.post('TI', 'SNM114P_GetDiscountVolumeDetail', data)
        .subscribe(res => {
          this.tableData_List4_2 = res.Table;
          this.tableData_List4_2.push({
            'EDIT': 'ADD',
            'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
            'PART_NO': data.PART_NO,
            'MAX_VOLUME': null,
            'DISCOUNT_RATE1': null,
            'DISCOUNT_RATE2': null,
            'DISCOUNT_RATE3': null,
            'NET_PRICE': null,
            'CHECK': null
          });
          this.tableData_List4_2 = this.tableData_List4_2.slice();
          this.PageAction = PageAction.Retrive;

          this.oldTableData_List4_2 = JSON.parse(JSON.stringify(this.tableData_List4_2));
        })


    }
    if (tab == 5 && !data.EDIT) {
      this.DSP_PART_NAME = null;
      this.tableData_List5_2 = [];
      this.oldTableData_List5_2 = [];
      this.http.post('TI', 'SNM114P_GetDiscountPackageDetail', data)
        .subscribe(res => {
          this.tableData_List5_2 = res.Table;
          this.tableData_List5_2.push({
            'EDIT': 'ADD',
            'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
            'PACKAGE_ID': data.PACKAGE_ID,
            'PART_NO': null,
            'DISCOUNT_RATE1': null,
            'DISCOUNT_RATE2': null,
            'DISCOUNT_RATE3': null,
            'NET_PRICE': null,
            'CHECK': null
          });
          this.tableData_List5_2 = this.tableData_List5_2.slice();
          this.PageAction = PageAction.Retrive;

          this.oldTableData_List5_2 = JSON.parse(JSON.stringify(this.tableData_List5_2));
        })
    }

  }



  public IsAllSelected1(tab) {
    var table = [];
    if (tab == 1) {
      table = this.tableData_List1
    }
    else if (tab == 2) {
      table = this.tableData_List2
    }
    else if (tab == 3) {
      table = this.tableData_List3
    }
    else if (tab == 4) {
      table = this.tableData_List4_1
    }
    else if (tab == 5) {
      table = this.tableData_List5_1
    }

    const numSelected = this.selection1.selected.length;
    const numRows = table.length - 1;
    return numSelected === numRows;
  }

  public Toggle1(tab) {
    var table = [];
    if (tab == 1) {
      table = this.tableData_List1
    }
    else if (tab == 2) {
      table = this.tableData_List2
    }
    else if (tab == 3) {
      table = this.tableData_List3
    }
    else if (tab == 4) {
      table = this.tableData_List4_1
    }
    else if (tab == 5) {
      table = this.tableData_List5_1
    }

    if (this.IsAllSelected1(tab)) {
      this.selection1.clear()
      table.map(x => {
        this.dataIsSelected1 = [];
      })
    } else {
      table.forEach((row) => {
        if (row.EDIT != 'ADD') {
          this.selection1.select(row)
        }
      });
      this.dataIsSelected1 = [];
      table.map(x => {
        if (x.EDIT != 'ADD') {
          this.dataIsSelected1.push(x);
        }
      })
    }
    this.params.CHK_DEL_ORD_COUNT = this.dataIsSelected1.length;
  }

  public CheckboxChange1(event, data) {
    if (event.checked) {
      this.dataIsSelected1.push(data);
    }
    else {
      this.dataIsSelected1.splice(this.dataIsSelected1.indexOf(data), 1);
    }
    this.params.CHK_DEL_ORD_COUNT = this.dataIsSelected1.length;
  }


  public IsAllSelected2(tab) {
    var table = [];
    if (tab == 4) {
      table = this.tableData_List4_2
    }
    else if (tab == 5) {
      table = this.tableData_List5_2
    }

    const numSelected = this.selection2.selected.length;
    const numRows = table.length - 1;
    return numSelected === numRows;

  }

  public Toggle2(tab) {
    var table = [];
    if (tab == 4) {
      table = this.tableData_List4_2
    }
    else if (tab == 5) {
      table = this.tableData_List5_2
    }

    if (this.IsAllSelected2(tab)) {
      this.selection2.clear()
      table.map(x => {
        this.dataIsSelected2 = [];
      })
    } else {
      table.forEach((row) => {
        if (row.EDIT != 'ADD') {
          this.selection2.select(row)
        }
      });
      this.dataIsSelected2 = [];
      table.map(x => {
        if (x.EDIT != 'ADD') {
          this.dataIsSelected2.push(x);
        }
      })
    }
    this.params.CHK_DEL_ORD_COUNT_2 = this.dataIsSelected2.length;
  }

  public CheckboxChange2(event, data) {
    if (event.checked) {
      this.dataIsSelected2.push(data);
    }
    else {
      this.dataIsSelected2.splice(this.dataIsSelected2.indexOf(data), 1);
    }
    this.params.CHK_DEL_ORD_COUNT_2 = this.dataIsSelected2.length;
  }



  ///---------------upload----------
  public IsAllSelectedUpload() {
    const numSelected = this.selectionUpload.selected.length;
    const numRows = this.DataUploadList.length;
    return numSelected === numRows;
  }


  public ToggleUpload() {
    if (this.IsAllSelectedUpload()) {
      this.selectionUpload.clear()
      this.DataUploadList.map(x => {
        this.dataUploadIsSelected = [];
      })
    } else {
      this.DataUploadList.forEach((row) => {
        this.selectionUpload.select(row)
      });
      this.dataUploadIsSelected = [];
      this.DataUploadList.map(x => {
        this.dataUploadIsSelected.push(x);
      })
    }
    this.paramsUpload.UPL_TOTAL_SEL = this.dataUploadIsSelected.length;
  }

  public CheckboxChangeUpload(event, data) {
    if (event.checked) {
      this.dataUploadIsSelected.push(data);
    }
    else {
      this.dataUploadIsSelected.splice(this.dataUploadIsSelected.indexOf(data), 1);
    }
    this.paramsUpload.UPL_TOTAL_SEL = this.dataUploadIsSelected.length;
  }


  public AppendRow(data, tab) {
    if (tab == 1) {
      for (var i = 0; i < this.tableData_List1.length; i++) {
        if (this.tableData_List1[i].EDIT === "ADD") {
          this.tableData_List1[i].EDIT = 'DEL';
        }
      }
      this.tableData_List1.push({
        'EDIT': 'ADD',
        'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
        'ORDER_CLASS': null,
        'ORDER_PREFIX': null,
        'LAST_UPD_BY': null,
        'LAST_UPD_DATE': null,
        'CHECK': null
      });
      this.tableData_List1 = this.tableData_List1.slice();
    }

    else if (tab == 2) {
      for (var i = 0; i < this.tableData_List2.length; i++) {
        if (this.tableData_List2[i].EDIT === "ADD") {
          this.tableData_List2[i].EDIT = 'DEL';
        }
      }

      this.tableData_List2.push({
        'EDIT': 'ADD',
        'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
        'SALES_CHANNEL': null,
        'CUSTOMER_CODE': null,
        'BRANCH_CODE': null,
        'DSP_CUSTOMER_NAME': null,
        'LAST_UPD_BY': null,
        'LAST_UPD_DATE': null,
        'CHECK': null
      });
      this.tableData_List2 = this.tableData_List2.slice();
    }

    else if (tab == 3) {
      for (var i = 0; i < this.tableData_List3.length; i++) {
        if (this.tableData_List3[i].EDIT === "ADD") {
          this.tableData_List3[i].EDIT = 'DEL';
        }
      }

      this.tableData_List3.push({
        'EDIT': 'ADD',
        'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
        'PART_NO': null,
        'DSP_PART_NAME': null,
        'DSP_RETAIL_PRICE': null,
        'DISCOUNT_RATE1': null,
        'DISCOUNT_RATE2': null,
        'DISCOUNT_RATE3': null,
        'NET_PRICE': null,
        'CHECK': null
      });
      this.tableData_List3 = this.tableData_List3.slice();
    }

    else if (tab == 41) {
      for (var i = 0; i < this.tableData_List4_1.length; i++) {
        if (this.tableData_List4_1[i].EDIT === "ADD") {
          this.tableData_List4_1[i].EDIT = 'DEL';
        }
      }

      this.tableData_List4_1.push({
        'EDIT': 'ADD',
        'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
        'PART_NO': null,
        'CHECK': null
      });
      this.tableData_List4_1 = this.tableData_List4_1.slice();
    }

    else if (tab == 42) {
      for (var i = 0; i < this.tableData_List4_2.length; i++) {
        if (this.tableData_List4_2[i].EDIT === "ADD") {
          this.tableData_List4_2[i].EDIT = 'DEL';
        }
      }

      this.tableData_List4_2.push({
        'EDIT': 'ADD',
        'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
        'PART_NO': data.PART_NO,
        'MAX_VOLUME': null,
        'DISCOUNT_RATE1': null,
        'DISCOUNT_RATE2': null,
        'DISCOUNT_RATE3': null,
        'NET_PRICE': null,
        'CHECK': null
      });
      this.tableData_List4_2 = this.tableData_List4_2.slice();
    }

    else if (tab == 51) {
      for (var i = 0; i < this.tableData_List5_1.length; i++) {
        if (this.tableData_List5_1[i].EDIT === "ADD") {
          this.tableData_List5_1[i].EDIT = 'DEL';
        }
      }

      this.tableData_List5_1.push({
        'EDIT': 'ADD',
        'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
        'PACKAGE_ID': null,
        'PACKAGE_NAME': null,
        'CHECK': null
      });
      this.tableData_List5_1 = this.tableData_List5_1.slice();
    }

    else if (tab == 52) {
      for (var i = 0; i < this.tableData_List5_2.length; i++) {
        if (this.tableData_List5_2[i].EDIT === "ADD") {
          this.tableData_List5_2[i].EDIT = 'DEL';
        }
      }

      this.tableData_List5_2.push({
        'EDIT': 'ADD',
        'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
        'PACKAGE_ID': data.PACKAGE_ID,
        'PART_NO': null,
        'DISCOUNT_RATE1': null,
        'DISCOUNT_RATE2': null,
        'DISCOUNT_RATE3': null,
        'NET_PRICE': null,
        'CHECK': null
      });
      this.tableData_List5_2 = this.tableData_List5_2.slice();
    }




    else if (tab == 'UPLOAD') {
      for (var i = 0; i < this.tableData_List3.length; i++) {
        if (this.tableData_List3[i].EDIT === "ADD") {
          this.tableData_List3[i].EDIT = 'DEL';
          this.tableData_List3[i].PART_NO = data.PART_NO;
          this.tableData_List3[i].DSP_PART_NAME = data.PART_NAME;
          this.tableData_List3[i].DSP_RETAIL_PRICE = data.RETAIL_PRICE;
          this.tableData_List3[i].DISCOUNT_RATE1 = data.DISCOUNT_RATE1;
          this.tableData_List3[i].DISCOUNT_RATE2 = data.DISCOUNT_RATE2;
          this.tableData_List3[i].DISCOUNT_RATE3 = data.DISCOUNT_RATE3;
          this.tableData_List3[i].NET_PRICE = data.NET_PRICE;
        }
      }


      this.tableData_List3.push({
        'EDIT': 'ADD',
        'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
        'PART_NO': null,
        'DSP_PART_NAME': null,
        'DSP_RETAIL_PRICE': null,
        'DISCOUNT_RATE1': null,
        'DISCOUNT_RATE2': null,
        'DISCOUNT_RATE3': null,
        'NET_PRICE': null,
        'CHECK': null
      });
      this.tableData_List3 = this.tableData_List3.slice();
    }
  }

  public DeleteRow(Item, tab) {
    if (tab == 1) {
      if (this.PageAction == PageAction.Retrive) {
        let index = this.tableData_List1.findIndex(x => x == Item)
        this.tableData_List1.splice(index, 1);
        if (this.tableData_List1.find(e => e.EDIT === 'ADD') == undefined) {
          this.tableData_List1.push({
            'EDIT': 'ADD',
            'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
            'ORDER_CLASS': null,
            'ORDER_PREFIX': null,
            'LAST_UPD_BY': null,
            'LAST_UPD_DATE': null,
            'CHECK': null
          });
        }
        this.tableData_List1 = this.tableData_List1.slice();
      }
    }
    else if (tab == 2) {
      if (this.PageAction == PageAction.Retrive) {
        let index = this.tableData_List2.findIndex(x => x == Item)
        this.tableData_List2.splice(index, 1);
        if (this.tableData_List2.find(e => e.EDIT === 'ADD') == undefined) {
          this.tableData_List2.push({
            'EDIT': 'ADD',
            'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
            'SALES_CHANNEL': null,
            'CUSTOMER_CODE': null,
            'BRANCH_CODE': null,
            'DSP_CUSTOMER_NAME': null,
            'LAST_UPD_BY': null,
            'LAST_UPD_DATE': null,
            'CHECK': null
          });
        }
        this.tableData_List2 = this.tableData_List2.slice();
      }
    }
    else if (tab == 3) {
      if (this.PageAction == PageAction.Retrive) {
        let index = this.tableData_List3.findIndex(x => x == Item)
        this.tableData_List3.splice(index, 1);
        if (this.tableData_List3.find(e => e.EDIT === 'ADD') == undefined) {
          this.tableData_List3.push({
            'EDIT': 'ADD',
            'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
            'PART_NO': null,
            'DSP_PART_NAME': null,
            'DSP_RETAIL_PRICE': null,
            'DISCOUNT_RATE1': null,
            'DISCOUNT_RATE2': null,
            'DISCOUNT_RATE3': null,
            'NET_PRICE': null,
            'CHECK': null
          });
        }
        this.tableData_List3 = this.tableData_List3.slice();
      }
    }

    else if (tab == 41) {
      if (this.PageAction == PageAction.Retrive) {
        let index = this.tableData_List4_1.findIndex(x => x == Item)
        this.tableData_List4_1.splice(index, 1);
        if (this.tableData_List4_1.find(e => e.EDIT === 'ADD') == undefined) {
          this.tableData_List4_1.push({
            'EDIT': 'ADD',
            'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
            'PART_NO': null,
            'CHECK': null
          });
        }
        this.tableData_List4_1 = this.tableData_List4_1.slice();
      }
    }

    else if (tab == 42) {
      if (this.PageAction == PageAction.Retrive) {
        let index = this.tableData_List4_2.findIndex(x => x == Item)
        this.tableData_List4_2.splice(index, 1);
        if (this.tableData_List4_2.find(e => e.EDIT === 'ADD') == undefined) {
          this.tableData_List4_2.push({
            'EDIT': 'ADD',
            'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
            'PART_NO': Item.PART_NO,
            'MAX_VOLUME': null,
            'DISCOUNT_RATE1': null,
            'DISCOUNT_RATE2': null,
            'DISCOUNT_RATE3': null,
            'NET_PRICE': null,
            'CHECK': null
          });
        }
        this.tableData_List4_2 = this.tableData_List4_2.slice();
      }
    }


    else if (tab == 51) {
      if (this.PageAction == PageAction.Retrive) {
        let index = this.tableData_List5_1.findIndex(x => x == Item)
        this.tableData_List5_1.splice(index, 1);
        if (this.tableData_List5_1.find(e => e.EDIT === 'ADD') == undefined) {
          this.tableData_List5_1.push({
            'EDIT': 'ADD',
            'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
            'PACKAGE_ID': null,
            'PACKAGE_NAME': null,
            'CHECK': null
          });
        }
        this.tableData_List5_1 = this.tableData_List5_1.slice();
      }
    }

    else if (tab == 52) {
      if (this.PageAction == PageAction.Retrive) {
        let index = this.tableData_List5_2.findIndex(x => x == Item)
        this.tableData_List5_2.splice(index, 1);
        if (this.tableData_List5_2.find(e => e.EDIT === 'ADD') == undefined) {
          this.tableData_List5_2.push({
            'EDIT': 'ADD',
            'CAMPAIGN_ID': this.params.CAMPAIGN_ID,
            'PACKAGE_ID': Item.PACKAGE_ID,
            'PART_NO': null,
            'DISCOUNT_RATE1': null,
            'DISCOUNT_RATE2': null,
            'DISCOUNT_RATE3': null,
            'NET_PRICE': null,
            'CHECK': null
          });
        }
        this.tableData_List5_2 = this.tableData_List5_2.slice();
      }
    }
  }

  public ValidateData(data, indexData) {
    if (!data.ORDER_CLASS) {
      this.modal.warning("Please input Order Class!", this.viewref);
    }
    else if (!data.ORDER_PREFIX) {
      this.modal.warning("Please input Order Prefix!", this.viewref);
    }
    else {
      if (data.ORDER_CLASS == '*') {
        if (data.ORDER_PREFIX != '*') {
          this.modal.warning("Order prefix cannot be set with * of order class!", this.viewref);
          return;
        }
        if (data.SEQ != 1 && data.ORDER_PREFIX == '*') {
          this.modal.warning("Cannot set * of order class with other specification!", this.viewref);
          return;
        }
      }
      else {
        let found = 0;
        this.tableData_List1.forEach((e, index) => {
          if (e.ORDER_CLASS == '*' && index != indexData) {
            found++;
          }
        });
        if (found > 0) {
          this.modal.warning('Cannot set order class ' + data.ORDER_CLASS + ' because already have order class * please check!', this.viewref);
          return;
        }
      }
      if (data.ORDER_PREFIX != '*') {
        if (data.ORDER_PREFIX.length != 2) {
          this.modal.warning('Order prefix must be 2 digits!', this.viewref);
          return;
        }
        else if (data.ORDER_PREFIX.substring(0, 1) != data.ORDER_CLASS) {
          this.modal.warning('First digit of order prefix must be the same as order class!', this.viewref);
          data.ORDER_PREFIX = null;
          return;
        }
      }
      //else {
      //  if (CONTROL.SUM_ORDER_FOUND > 0) {
      //    this.modal.warning('Cannot set other specification with * of order class!', this.viewref);
      //    return;
      //  }

      //}


      //: CONTROL.FIND_ORD_UNQ := : data.ORDER_CLASS || '*';
      //if( CONTROL.SUM_ORD_UNQ_FOUND > 0 ) {

      //V_MSG:= 'Cannot set prefix ' || : data.ORDER_PREFIX ||
      //  ' because already have * prefix on the same order class, please check!';
      //}

      //else--Else of block check order prefix
      //: CONTROL.FIND_ORDER := : data.ORDER_CLASS;
      //if( CONTROL.SUM_ORDER_FOUND > 1 ) {

      //V_MSG:= 'Cannot set prefix * because already have other prefix on the same order class, please check!';
      //}

      //}

      //}


      let found = 0;
      this.tableData_List1.forEach((e, index) => {
        if (e.ORDER_CLASS == data.ORDER_CLASS && e.ORDER_PREFIX == data.ORDER_PREFIX && index != indexData) {
          found++;
        }
      });
      if (found > 0) {
        this.modal.warning('Duplicate order class ' + data.ORDER_CLASS + ' prefix ' + data.ORDER_PREFIX + ' please check!', this.viewref);
        data.ORDER_PREFIX = null;
        return;
      }
    }
  }


  //Delete
  public ConfirmDelete(tab) {
    if (tab == 1) {
      if (this.dataIsSelected1.length > 0) {
        this.modal.confirm('Do you want to delete this item?', this.viewref, this.DeleteTab1)
      }
      else {
        this.modal.warning('There is no data selected!', this.viewref)
      }
    }
    else if (tab == 2) {
      if (this.dataIsSelected1.length > 0) {
        this.modal.confirm('Do you want to delete this item?', this.viewref, this.DeleteTab2)
      }
      else {
        this.modal.warning('There is no data selected!', this.viewref)
      }
    }
    else if (tab == 3) {
      if (this.dataIsSelected1.length > 0) {
        this.modal.confirm('Do you want to delete this item?', this.viewref, this.DeleteTab3)
      }
      else {
        this.modal.warning('There is no data selected!', this.viewref)
      }
    }
    else if (tab == 41) {
      if (this.dataIsSelected1.length > 0) {
        this.modal.confirm('Do you want to delete this item?', this.viewref, this.DeleteTab4_1)
      }
      else {
        this.modal.warning('There is no data selected!', this.viewref)
      }
    }
    else if (tab == 42) {
      if (this.dataIsSelected2.length > 0) {
        this.modal.confirm('Do you want to delete this item?', this.viewref, this.DeleteTab4_2)
      }
      else {
        this.modal.warning('There is no data selected!', this.viewref)
      }
    }
    else if (tab == 51) {
      if (this.dataIsSelected1.length > 0) {
        this.modal.confirm('Do you want to delete this item?', this.viewref, this.DeleteTab5_1)
      }
      else {
        this.modal.warning('There is no data selected!', this.viewref)
      }
    }
    else if (tab == 52) {
      if (this.dataIsSelected2.length > 0) {
        this.modal.confirm('Do you want to delete this item?', this.viewref, this.DeleteTab5_2)
      }
      else {
        this.modal.warning('There is no data selected!', this.viewref)
      }
    }
  }

  private DeleteTab1 = () => {
    this.http.post('TI', 'SNM114P_DeleteOrderFactor', this.dataIsSelected1)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Delete Successful.', this.viewref);
          this.ChangeStatusAfterSave();
          this.Search()
          this.dataIsSelected1 = [];
          this.selection1.clear();
        } else {
          this.modal.error('No change to delete. Something went wrong.', this.viewref);
        }
      })
  }

  private DeleteTab2 = () => {
    this.http.post('TI', 'SNM114P_DeleteCustomerFactor', this.dataIsSelected1)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Delete Successful.', this.viewref);
          this.ChangeStatusAfterSave();
          this.Search()
          this.dataIsSelected1 = [];
          this.selection1.clear();
        } else {
          this.modal.error('No change to delete. Something went wrong.', this.viewref);
        }
      })
  }

  private DeleteTab3 = () => {
    this.http.post('TI', 'SNM114P_DeleteDiscountDefault', this.dataIsSelected1)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Delete Successful.', this.viewref);
          this.ChangeStatusAfterSave();
          this.Search()
        } else {
          this.modal.error('No change to delete. Something went wrong.', this.viewref);
        }
      })
  }

  private DeleteTab4_1 = () => {
    this.http.post('TI', 'SNM114P_DeleteDiscountVolumeHead', this.dataIsSelected1)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Delete Successful.', this.viewref);
          this.ChangeStatusAfterSave();
          this.Search()
        } else {
          this.modal.error('No change to delete. Something went wrong.', this.viewref);
        }
      })
  }

  private DeleteTab4_2 = () => {
    this.http.post('TI', 'SNM114P_DeleteDiscountVolumeDetail', this.dataIsSelected2)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Delete Successful.', this.viewref);
          this.ChangeStatusAfterSave();
          this.Search()
        } else {
          this.modal.error('No change to delete. Something went wrong.', this.viewref);
        }
      })
  }

  private DeleteTab5_1 = () => {
    this.http.post('TI', 'SNM114P_DeleteDiscountPackageHead', this.dataIsSelected1)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Delete Successful.', this.viewref);
          this.ChangeStatusAfterSave();
          this.Search()
        } else {
          this.modal.error('No change to delete. Something went wrong.', this.viewref);
        }
      })
  }

  private DeleteTab5_2 = () => {
    this.http.post('TI', 'SNM114P_DeleteDiscountPackageDetail', this.dataIsSelected2)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Delete Successful.', this.viewref);
          this.ChangeStatusAfterSave();
          this.Search()
        } else {
          this.modal.error('No change to delete. Something went wrong.', this.viewref);
        }
      })
  }


  //Save
  public ConfirmSave(tab) {
    if (tab == 1) {
      let notchange = (JSON.stringify(this.oldTableData_List1) == JSON.stringify(this.tableData_List1))
      if (notchange) {
        this.modal.warning('There is no data change.', this.viewref)
        return;
      }
      else {
        let found = this.tableData_List1.some(e => (e.ORDER_CLASS || e.ORDER_PREFIX) && e.EDIT == 'DEL')
        if (found) {
          let err = this.tableData_List1.some(e => (!e.ORDER_CLASS && e.ORDER_PREFIX) && e.EDIT == 'DEL')
          if (err) {
            this.modal.warning('Order Class cannot empty.', this.viewref)
            return;
          }
          else {
            let err = this.tableData_List1.some(e => (e.ORDER_CLASS && !e.ORDER_PREFIX) && e.EDIT == 'DEL')
            if (err) {
              this.modal.warning('Order Prefix cannot empty.', this.viewref);
              return;
            }
            else {
              this.formData = [];
              this.tableData_List1.forEach((e) => {
                if (e.ORDER_CLASS && e.ORDER_PREFIX && e.EDIT == 'DEL') {
                  this.formData.push(e);
                }
              })
              if (this.formData.length > 0) {
                this.modal.confirm('Do you want to save on this data?', this.viewref, this.SaveTab1)
              }
              else {
                this.modal.warning('Please complete all required fields!', this.viewref)
              }

            }
          }
        } else {
          this.modal.warning('There is no data change.', this.viewref)
          return;
        }
      }
    }

    else if (tab == 2) {
      let notchange = (JSON.stringify(this.oldTableData_List2) == JSON.stringify(this.tableData_List2))
      if (notchange) {
        this.modal.warning('There is no data change.', this.viewref)
        return;
      }
      else {
        let found = this.tableData_List2.some(e => (e.SALES_CHANNEL || e.CUSTOMER_CODE || e.BRANCH_CODE) && e.EDIT == 'DEL')
        if (found) {
          let err = this.tableData_List2.some(e => (!e.SALES_CHANNEL && e.CUSTOMER_CODE && e.BRANCH_CODE) && e.EDIT == 'DEL')
          if (err) {
            this.modal.warning('Sales channel cannot empty.', this.viewref)
            return;
          }
          else {
            let err = this.tableData_List2.some(e => (e.SALES_CHANNEL && !e.CUSTOMER_CODE && !e.BRANCH_CODE) && e.EDIT == 'DEL')
            if (err) {
              this.modal.warning('Customer code cannot empty.', this.viewref);
              return;
            }
            else {
              let err = this.tableData_List2.some(e => (e.SALES_CHANNEL && e.CUSTOMER_CODE && !e.BRANCH_CODE) && e.EDIT == 'DEL')
              if (err) {
                this.modal.warning('Branch code cannot empty.', this.viewref);
                return;
              }
              else {
                this.formData = [];
                this.tableData_List2.forEach((e) => {
                  if (e.SALES_CHANNEL && e.CUSTOMER_CODE && e.BRANCH_CODE && e.EDIT == 'DEL') {
                    this.formData.push(e);
                  }
                })
                if (this.formData.length > 0) {
                  this.modal.confirm('Do you want to save on this data?', this.viewref, this.SaveTab2)
                }
                else {
                  this.modal.warning('Please complete all required fields!', this.viewref)
                }
              }
            }
          }
        } else {
          this.modal.warning('There is no data change.', this.viewref)
          return;
        }
      }
    }

    else if (tab == 3) {
      let notchange = (JSON.stringify(this.oldTableData_List3) == JSON.stringify(this.tableData_List3))
      if (notchange) {
        this.modal.warning('There is no data change.', this.viewref)
        return;
      }
      else {
        let found = this.tableData_List3.some(e => (e.PART_NO || e.DISCOUNT_RATE1 || e.DISCOUNT_RATE2 || e.DISCOUNT_RATE3 || e.NET_PRICE) && e.EDIT == 'DEL')
        if (found) {
          this.formData = [];
          this.tableData_List3.forEach((e) => {
           
            if (e.PART_NO && e.DISCOUNT_RATE1 != null && e.DISCOUNT_RATE2 != null  && e.DISCOUNT_RATE3 != null && e.NET_PRICE != null && e.EDIT == 'DEL') {         
              this.formData.push(e);
            }
          })
          if (this.formData.length > 0) {
            this.modal.confirm('Do you want to save on this data?', this.viewref, this.SaveTab3)
          }
          else {
            this.modal.warning('Please complete all data fields!', this.viewref)
          }
        }
        else {
          this.modal.warning('There is no data change.', this.viewref)
          return;
        }
      }
    }

    else if (tab == 41) {
      let notchange = (JSON.stringify(this.oldTableData_List4_1) == JSON.stringify(this.tableData_List4_1))
      if (notchange) {
        this.modal.warning('There is no data change.', this.viewref)
        return;
      }
      else {
        let found = this.tableData_List4_1.some(e => (e.PART_NO) && e.EDIT == 'DEL')
        if (found) {
          this.formData = [];
          this.tableData_List4_1.forEach((e) => {
            if (e.PART_NO && e.EDIT == 'DEL') {
              this.formData.push(e);
            }
          })
          if (this.formData.length > 0) {
            this.modal.confirm('Do you want to save on this data?', this.viewref, this.SaveTab4_1)
          }
          else {
            this.modal.warning('Please complete all data fields!', this.viewref)
          }
        }
        else {
          this.modal.warning('There is no data change.', this.viewref)
          return;
        }
      }
    }

    else if (tab == 42) {
      let notchange = (JSON.stringify(this.oldTableData_List4_2) == JSON.stringify(this.tableData_List4_2))
      if (notchange) {
        this.modal.warning('There is no data change.', this.viewref)
        return;
      }
      else {
        let found = this.tableData_List4_2.some(e => (e.MAX_VOLUME || e.DISCOUNT_RATE1 || e.DISCOUNT_RATE2 || e.DISCOUNT_RATE3 || e.NET_PRICE) && e.EDIT == 'DEL')
        if (found) {
          this.formData = [];
          this.tableData_List4_2.forEach((e) => {
            if (e.MAX_VOLUME && e.DISCOUNT_RATE1 != null && e.DISCOUNT_RATE2 != null && e.DISCOUNT_RATE3 != null && e.NET_PRICE != null && e.EDIT == 'DEL') {
              this.formData.push(e);
            }
          })
          if (this.formData.length > 0) {
            this.modal.confirm('Do you want to save on this data?', this.viewref, this.SaveTab4_2)
          }
          else {
            this.modal.warning('Please complete all data fields!', this.viewref)
          }
        }
        else {
          this.modal.warning('There is no data change.', this.viewref)
          return;
        }
      }
    }

    else if (tab == 51) {
      let notchange = (JSON.stringify(this.oldTableData_List5_1) == JSON.stringify(this.tableData_List5_1))
      if (notchange) {
        this.modal.warning('There is no data change.', this.viewref)
        return;
      }
      else {
        let found = this.tableData_List5_1.some(e => (e.PACKAGE_ID || e.PACKAGE_NAME) && e.EDIT == 'DEL')
        if (found) {
          this.formData = [];
          this.tableData_List5_1.forEach((e) => {
            if (e.PACKAGE_ID && e.PACKAGE_NAME && e.EDIT == 'DEL') {
              this.formData.push(e);
            }
          })
          if (this.formData.length > 0) {
            this.modal.confirm('Do you want to save on this data?', this.viewref, this.SaveTab5_1)
          }
          else {
            this.modal.warning('Please complete all data fields!', this.viewref)
          }
        }
        else {
          this.modal.warning('There is no data change.', this.viewref)
          return;
        }
      }
    }

    else if (tab == 52) {
      let notchange = (JSON.stringify(this.oldTableData_List5_2) == JSON.stringify(this.tableData_List5_2))
      if (notchange) {
        this.modal.warning('There is no data change.', this.viewref)
        return;
      }
      else {
        let found = this.tableData_List5_2.some(e => (e.PART_NO || e.DISCOUNT_RATE1 || e.DISCOUNT_RATE2 || e.DISCOUNT_RATE3 || e.NET_PRICE) && e.EDIT == 'DEL')
        if (found) {
          this.formData = [];
          this.tableData_List5_2.forEach((e) => {
            if (e.PART_NO && e.DISCOUNT_RATE1 && e.DISCOUNT_RATE2 && e.DISCOUNT_RATE3 && e.NET_PRICE && e.EDIT == 'DEL') {
              this.formData.push(e);
            }
          })
          if (this.formData.length > 0) {
            this.modal.confirm('Do you want to save on this data?', this.viewref, this.SaveTab5_2)
          }
          else {
            this.modal.warning('Please complete all data fields!', this.viewref)
          }
        }
        else {
          this.modal.warning('There is no data change.', this.viewref)
          return;
        }
      }
    }

    else if (tab == 'Create') {
      if (this.data.CAMPAIGN_ID && this.data.CAMPAIGN_NAME && this.data.EFFECTIVE_DATE && this.data.DISABLE_DATE && this.data.DISCOUNT_TYPE) {
        this.modal.confirm('Do you want to save on this data?', this.viewref, this.SaveCreate)
      }
      else {
        this.modal.warning('Please complete all data fields!', this.viewref)
      }
    }

    else if (tab == 'Upload') {
      if (this.DataUploadList.length > 0) {
        if (this.dataUploadIsSelected.length > 0) {
          let err = this.dataUploadIsSelected.some(e => (e.ERROR_MSG));
          if (err) {
            this.modal.warning('Data is selected has error message, Please check!', this.viewref);
            return;
          }
          else {
            this.modal.confirm('Do you want to insert this data to table?', this.viewref, this.SaveUpload)
          }
        }
        else {
          this.modal.warning('You have to select less than 1 record before click [Accept] button!', this.viewref)
        }
      }
      else {
        this.modal.warning('There is no data!', this.viewref)
      }
    }
  }

  public ChangeStatusAfterSave() {
    if (this.params.STATUS == 'Y') {
      this.params.STATUS = 'N';
      this.params.DSP_STATUS = 'Inactive'
      this.modal.info('Please note that every saving campaign, the status will be inactive. Please validate and activate on Campaign Master Activation screen!', this.viewref);
    }
  }

  private SaveTab1 = () => {
    this.http.post('TI', 'SNM114P_SaveOrderFactor', this.formData)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Save Successful.', this.viewref);
          this.ChangeStatusAfterSave();
          this.Search()
        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })
  }

  private SaveTab2 = () => {
    this.http.post('TI', 'SNM114P_SaveCustomerFactor', this.formData)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Save Successful.', this.viewref);
          this.ChangeStatusAfterSave();
          this.Search();
        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })
  }

  private SaveTab3 = () => {
    this.http.post('TI', 'SNM114P_SaveDiscountDefault', this.formData)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Save Successful.', this.viewref);
          this.ChangeStatusAfterSave();
          this.Search()
        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })
  }

  private SaveTab4_1 = () => {
    this.http.post('TI', 'SNM114P_SaveDiscountVolumeHead', this.formData)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Save Successful.', this.viewref);
          this.ChangeStatusAfterSave();
          this.Search()
        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })
  }

  private SaveTab4_2 = () => {
    this.http.post('TI', 'SNM114P_SaveDiscountVolumeDetail', this.formData)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Save Successful.', this.viewref);
          this.ChangeStatusAfterSave();
          this.Search()
        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })
  }

  private SaveTab5_1 = () => {
    this.http.post('TI', 'SNM114P_SaveDiscountPackageHead', this.formData)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Save Successful.', this.viewref);
          this.ChangeStatusAfterSave();
          this.Search()
        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })
  }

  private SaveTab5_2 = () => {
    this.http.post('TI', 'SNM114P_SaveDiscountPackageDetail', this.formData)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Save Successful.', this.viewref);
          this.ChangeStatusAfterSave();
          this.Search()
        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })
  }

  private SaveCreate = () => {
    this.http.post('TI', 'SNM114P_InsertCampaignMaster', this.data)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Save Successful.', this.viewref);
          this.params.CAMPAIGN_ID = this.data.CAMPAIGN_ID;
          this.params.CAMPAIGN_NAME = this.data.CAMPAIGN_NAME;
          this.params.EFFECTIVE_DATE = this.data.EFFECTIVE_DATE;
          this.params.DISABLE_DATE = this.data.DISABLE_DATE;
          this.params.DISCOUNT_TYPE = this.data.DISCOUNT_TYPE;
          this.params.STATUS = this.data.STATUS;
          this.params.DSP_STATUS = this.data.DSP_STATUS;
          this.CloseDialog();
          this.Search()
        }
        else if (res.Table[0].STATUS == 'DUP') {
          this.modal.warning('This campaign ID is duplicated.', this.viewref);
        }
        else {
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })
  }

  private SaveUpload = () => {
    this.dialogUpload.Close();
    this.dataUploadIsSelected.forEach((e, index) => {
      let dup = this.tableData_List3.some(data => data.PART_NO == e.PART_NO)
      if (dup) {
        this.ListLog.push('Part No. ' + e.PART_NO + ' is duplicated, Please check!');
      }
      else {
      this.AppendRow(e, 'UPLOAD')
      }
    });
    if (this.ListLog.length > 0) {
      this.dialogLog.OpenDialog();


    }
  }

  public tabClick(tab: any) {
    this.dataIsSelected1 = [];
    this.dataIsSelected2 = [];
    this.selection1.clear();
    this.selection2.clear();
    this.params.CHK_DEL_ORD_COUNT = 0;
    this.params.CHK_DEL_ORD_COUNT_2 = 0;
  }


  //Tab2
  public lookupSalesChannelConfig: any = {
    ColName: "LOOKUP_SALES_CHANNEL",
    PlaceholderText: "Select Sales Channel",
    SourceController: "TI",
    SourceMethodName: "SNM114P_GetSalesChannel",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedSalesChannel(value, data, row) {
    data.SALES_CHANNEL = value.SALES_CHANNEL;
    this.lookupCustomerCodeConfig.SourceParams.SALES_CHANNEL = value.SALES_CHANNEL;
  }

  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "TI",
    SourceMethodName: "SNM114P_GetCustomerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
    SourceParams: {
      SALES_CHANNEL: null
    },
  }

  public SetSelecteCustomerCode(value, data, row) {
    data.CUSTOMER_CODE = value.CUSTOMER_CODE;
    data.DSP_CUSTOMER_NAME = value.CUSTOMER_NAME;
    this.lookupBranchCodeConfig.SourceParams.CUSTOMER_CODE = value.CUSTOMER_CODE;
  }

  public lookupBranchCodeConfig: any = {
    ColName: "LOOKUP_BRANCH_CODE",
    PlaceholderText: "Select Branch Code",
    SourceController: "TI",
    SourceMethodName: "SNM114P_GetBranchCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
    SourceParams: {
      CUSTOMER_CODE: null
    },
  }

  public SetSelectedBranchCode(value, data, indexData) {
    var err = 0;
    this.tableData_List2.forEach((e, index) => {
      if (e.SALES_CHANNEL == '*' && e.CUSTOMER_CODE == '*' && e.BRANCH_CODE == '*' && index != indexData) {
        err = 1;
        return;
      }
      else if (e.SALES_CHANNEL != '*' && data.SALES_CHANNEL == '*' && data.CUSTOMER_CODE == '*' && value.BRANCH_CODE == '*' && index != indexData) {
        err = 2;
        return;
      }
      else if (e.SALES_CHANNEL == data.SALES_CHANNEL && data.CUSTOMER_CODE == '*' && index != indexData) {
        err = 3;
        return;
      }
      else if (e.SALES_CHANNEL == data.SALES_CHANNEL && e.CUSTOMER_CODE == data.CUSTOMER_CODE && e.BRANCH_CODE == value.BRANCH_CODE && index != indexData) {
        err = 4;
        return;
      }
      else if (e.SALES_CHANNEL == data.SALES_CHANNEL && e.CUSTOMER_CODE == data.CUSTOMER_CODE && e.BRANCH_CODE == '*' && index != indexData) {
        err = 5;
        return;
      }
      else if (e.SALES_CHANNEL == data.SALES_CHANNEL && e.CUSTOMER_CODE == data.CUSTOMER_CODE && e.BRANCH_CODE != '*' && value.BRANCH_CODE == '*' && index != indexData) {
        err = 6;
        return;
      }
    });

    if (err == 1) {
      this.modal.warning('Cannot set branch ' + value.BRANCH_CODE + ' because already have * of branch and * of customer and * of sales channel!', this.viewref);
    } else if (err == 2) {
      this.modal.warning('Cannot set sales channel * with other specific sales channel!', this.viewref);
    } else if (err == 3) {
      this.modal.warning('Cannot set customer  * because already have other customer on the same channel!', this.viewref);
    } else if (err == 4) {
      this.modal.warning('Duplicate sales channel ' + data.SALES_CHANNEL + ' customer code ' + data.CUSTOMER_CODE + ' ' + value.BRANCH_CODE + ' please check!', this.viewref);
    } else if (err == 5) {
      this.modal.warning('Duplicate branch ' + value.BRANCH_CODE + ' because already have * of branch on the same customer!', this.viewref);
    } else if (err == 6) {
      this.modal.warning('Cannot set branch ' + value.BRANCH_CODE + ' because already have other branch on the same customer and channel!', this.viewref);
    };


    if (err == 0) {
      data.BRANCH_CODE = value.BRANCH_CODE;
    } else {
      data.BRANCH_CODE = null;
    }
  }


  //Tab3
  public lookupPartDefConfig: any = {
    ColName: "LOOKUP_PART_NO",
    PlaceholderText: "Select Part No",
    SourceController: "TI",
    SourceMethodName: "SNM114P_GetPartDef",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedPartNoDefault(value, data,indexData) {
    var err = 0;

    this.tableData_List3.forEach((e,index) => {
      if (e.PART_NO == value.PART_NO && index != indexData) {
        err = 1;
        return;
      }
      else if (e.PART_NO != '*' && value.PART_NO == '*' && index != indexData) {
        err = 2;
        return;
      }

    });

    if (err == 1) {
      this.modal.warning('Duplicate part no. ' + value.PART_NO + ' please check!', this.viewref);
    } else if (err == 2) {
      this.modal.warning('Cannot set ' + value.PART_NO + ' with other specific part!', this.viewref);
    }


    if (err == 0) {
      data.PART_NO = value.PART_NO
      data.DSP_PART_NAME = value.PART_NAME_EN
      data.PART_NAME = value.PART_NAME_EN
      data.DSP_RETAIL_PRICE = value.RETAIL_PRICE
    } else {
      data.PART_NO = null;
      data.DSP_PART_NAME = null;
      data.PART_NAME = null;
      data.DSP_RETAIL_PRICE = null;
      data.DISCOUNT_RATE1 = null;
      data.DISCOUNT_RATE1 = null;
      data.DISCOUNT_RATE1 = null;
      data.NET_PRICE = null;
    }
  }


  public lookupPartNoConfig: any = {
    ColName: "LOOKUP_PART_NO",
    PlaceholderText: "Select Part No",
    SourceController: "TI",
    SourceMethodName: "SNM114P_GetPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedPartNo(value, data, tab) {
    var table = []
    if (tab == 'DEF') {
      table = this.tableData_List3
    }
    else if (tab == 'VOL') {
      table = this.tableData_List4_1
    }
    else if (tab == 'PAC') {
      table = this.tableData_List5_2
    }
    let dup = table.some(e => e.PART_NO == value.PART_NO)
    if (dup) {
      data.PART_NO = null;
      data.DSP_PART_NAME = null;
      data.PART_NAME = null;
      data.DSP_RETAIL_PRICE = null;
      data.DISCOUNT_RATE1 = null;
      data.DISCOUNT_RATE1 = null;
      data.DISCOUNT_RATE1 = null;
      data.NET_PRICE = null;
      this.modal.warning('Duplicate part no. ' + value.PART_NO + ' please check!', this.viewref);
    } else {
      data.PART_NO = value.PART_NO
      data.DSP_PART_NAME = value.PART_NAME_EN
      data.PART_NAME = value.PART_NAME_EN
      data.DSP_RETAIL_PRICE = value.RETAIL_PRICE
    }
  }

  //Tab4
  public CreateClick() {
    this.data.DSP_STATUS = 'Inactive';
    this.data.STATUS = 'N';
    this.data.EFFECTIVE_DATE = new Date();
    this.dialogCreate.OpenDialog();
  }

  public CloseDialog() {
    this.data = {};
    this.dialogCreate.Close();
  }

  public CheckDate() {
    var dToDate = moment().locale("en").startOf('day');
    if (this.data.EFFECTIVE_DATE < dToDate) {
      this.modal.warning('Effective date must be today or the future day!', this.viewref)
      this.data.EFFECTIVE_DATE = new Date();
      return;
    }
    if (this.data.DISABLE_DATE < this.data.EFFECTIVE_DATE) {
      this.modal.warning('Disable date should more than effective date, please check!', this.viewref)
      this.data.DISABLE_DATE = new Date();
      return;
    }
    if (this.data.DISABLE_DATE < dToDate) {
      this.modal.warning('Disable date should more than today!', this.viewref)
      this.data.DISABLE_DATE = new Date();
      return;
    }
  }

  public onKey(evt, data) {
    evt.target.value = evt.target.value.toUpperCase()
    data.ORDER_PREFIX = data.ORDER_PREFIX.toUpperCase()
  }

  public onKeyCampID(evt, data) {
    evt.target.value = evt.target.value.toUpperCase()
    data.CAMPAIGN_ID = data.CAMPAIGN_ID.toUpperCase()
  }
  public OpenDialogUpload() {
    this.paramsUpload.UPL_TOTAL_REC = 0;
    this.paramsUpload.UPL_TOTAL_ERR = 0;
    this.paramsUpload.UPL_TOTAL_SEL = 0;
    this.selectionUpload.clear();
    this.dataUploadIsSelected = []
    this.DataUploadList = [];
    this.FileName = null;
    this.dialogUpload.OpenDialog();
  }

  public CloseDialogUpload() {
    this.DataUploadList = [];
    this.files = [];
    this.FileName = null;
    this.dialogUpload.Close();
  }

  public OnFileSelect(fileInput) {
    this.files = fileInput.target.files;
    this.FileName = this.files[0].name;
  }

  public UpLoad() {
    this.paramsUpload.UPL_TOTAL_REC = 0;
    this.paramsUpload.UPL_TOTAL_ERR = 0;
    this.paramsUpload.UPL_TOTAL_SEL = 0;
    this.DataUploadList = [];
    if (this.files.length == 0) {
      this.modal.error('Please Open xlsx File First...', this.viewref)
    } else {
      let formData = new FormData();
      formData.append('file', this.files[0]);
      this.http.postFile('TI', 'SNM114P_Upload', formData)
        .subscribe(res => {
          this.DataUploadList = [];
          this.http.get('TI', 'SNM114P_GetTempData')
            .subscribe(res => {
              this.DataUploadList = res.Table;


              if (this.DataUploadList.length > 0) {
                var err = 0;

                this.DataUploadList.forEach((e, index) => {
                  e.SEQ = index + 1;
                  if (e.ERROR_MSG) {
                    err++;
                  }
                });

                this.paramsUpload.UPL_TOTAL_REC = this.DataUploadList.length
                this.paramsUpload.UPL_TOTAL_ERR = err;
              }
            });
        }, (err) => {
          this.modal.error("Upload error! Please check file or data for upload.", this.viewref);

        });
    }
  }

  public ExportExcel() {
    this.http.Download('TI', "SNM114P_ExportExcel", JSON.stringify(this.DataUploadList))
      .subscribe(res => {
        if (res) {
          this.WriteContents(res)
        } else {
          this.modal.error('Download not complete', this.viewref)
        }
      })
  }

  private WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "SNM114P" + ".xlsx";
    a.click();
  }

  public DownloadTemplate() {
    let link = "assets/templates/DiscountDefault_Upload_Template.xlsx"
    window.open(link, '_blank')
  }


  //Tab 5

  public ValidatePackageID(data, row) {
    data.PACKAGE_ID = data.PACKAGE_ID.trim().toUpperCase()
    let dup = false;
    this.tableData_List5_1.forEach((e, index) => {
      if (e.PACKAGE_ID == data.PACKAGE_ID && index != row) {
        dup = true;
        return;
      }
    });
    if (dup) {
      this.modal.warning('Duplicate package ' + data.PACKAGE_ID + ' please check!', this.viewref);
      data.PACKAGE_ID = null;
    }
  }

  public ValidateNetPrice(data) {
    this.http.post('TI', 'SNM114P_ValidateNetPrice', data)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'FAIL') {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
          data.NET_PRICE = null;
        }
      })
  }
  public RowClickPackage(data) {
    this.DSP_PART_NAME = data.PART_NAME;
  } 
}
