import { __values } from 'tslib';
import {
  Component,
  OnInit,
  ElementRef,
  ViewChild,
  ViewContainerRef,
  CUSTOM_ELEMENTS_SCHEMA,
} from "@angular/core";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "../../../core/modal.service";
import {
  DateAdapter,
  MAT_DATE_FORMATS,
  MAT_DATE_LOCALE,
} from "@angular/material/core";
import {
  MAT_MOMENT_DATE_ADAPTER_OPTIONS,
  MomentDateAdapter,
} from "@angular/material-moment-adapter";
import * as moment from "moment";
import { FormControl, Validators } from "@angular/forms";
import { Globals } from "src/app/core/global";

@Component({
  selector: "SNM166",
  templateUrl: "./SNM166.component.html",
  styleUrls: ["./SNM166.component.css"],
})
export class SNM166Component implements OnInit {
  @ViewChild("fileUpload") fileUpload: ElementRef;

  public filename: string = "";
  public extension: string = "";
  public file: any;

  public files: any = [];
  public tableUpload: any = [];
  public error_list: any = [];

  constructor(
    public http: HttpService,
    public modal: ModalService,
    public global: Globals,
    public viewRef: ViewContainerRef
  ) {}

  public param: any = {};

  public tableData: any = [];
  public tableSuccess: any = [];
  public tableSuccess1: any = [];
  public tableSuccess2: any = [];
  public params: any = {};
  public paramSearch: any = {};

  public todayDate: Date = new Date();
  public showSuccess: Boolean;
  public showList: Boolean;
  public showListDetail: Boolean;
  public editMode: any;
  public total_error: number = 0;
  public partNumber: string;
  public countMSG: number = 0;
  SetPartNoControl = new FormControl("", [Validators.required]);
  SetPartTypeControl = new FormControl("", [Validators.required]);
  public hideCols: Array<string> = [];
  DiscountGroupControl = new FormControl('', [Validators.required]);
  CustomerCodeControl = new FormControl("", [Validators.required]);
  SEQControl = new FormControl("", [Validators.required]);

  @ViewChild("dialogAdd", { static: false }) dialogAdd: any;
  @ViewChild("dialogEdit", { static: false }) dialogEdit: any;
  @ViewChild("dialog", { static: false }) dialog: any;

  public ParamEdit: any = {};
  public ParamEdit_Ex: any = {};
  public ParamAdd: any = {};
  public Chkdis: any = {};
  public tabledataEdit: any = [];
  public BranchCodeList: any = [];
  public DiscountGroupList: any = [];

  ngOnInit(): void {
    this.showSuccess = false;
    this.showList = true;
    this.showListDetail = false;
    this.Chkdis = false;
    this.GetDataMasterDiscountGroup();
  }

  public ConfigCustomer: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Customer Code",
    SourceController: "wPMS",
    SourceMethodName: "SNM166_GetCustomerAutoComplete",
    NoOfShowRecords: 50,
    MinLengthSearch: 3,
    UpperCase: false,
  };
  public ConfigCustomerMaster: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Customer Code",
    SourceController: "wPMS",
    SourceMethodName: "SNM166_GetCustomerMasterAutoComplete",
    NoOfShowRecords: 50,
    MinLengthSearch: 3,
    UpperCase: false,
  };

  public lookupBranchCodeAddConfig: any = {
    ColName: "LOOKUP_BRANCH_CODE",
    PlaceholderText: "Select Branch Code",
    SourceController: "wPMS",
    SourceMethodName: "SNM166_GetBranchCodeForAdd",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      CUSTOMER_CODE: "",
    },
    UpperCase: true,
  };

  public lookupBranchCodeConfig: any = {
    ColName: "LOOKUP_BRANCH_CODE",
    PlaceholderText: "Select Branch Code",
    SourceController: "wPMS",
    SourceMethodName: "SNM166_GetBranchCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      CUSTOMER_CODE: "",
    },
    UpperCase: true,
  };

  public lookupCustomerCodeAddConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "wPMS",
    SourceMethodName: "SNM166_GetCustomerCodeForAdd",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
  };

  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "wPMS",
    SourceMethodName: "SNM166_GetCustomerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
  };

  public SetSelectedCustomerCode(value: any) {
    this.paramSearch.CUSTOMER_CODE = value.CUSTOMER_CODE;
    this.paramSearch.CUSTOMER_NAME = value.CUSTOMER_NAME;
    
    // this.params.BRANCH_CODE = value.BRANCH_CODE;
    // this.lookupBranchCodeConfig.SourceParams.CUSTOMER_CODE = value.CUSTOMER_CODE;
    // this.Search();
  }

  public SetSelectedCustomerCodeAdd(value: any) {
    this.ParamAdd.CUSTOMER_CODE = value.CUSTOMER_CODE;
    this.ParamAdd.CUSTOMER_NAME = value.CUSTOMER_NAME;
    this.ParamAdd.BRANCH_CODE = '';
    this.lookupBranchCodeAddConfig.SourceParams.CUSTOMER_CODE =
      value.CUSTOMER_CODE;
      this.GetDataMasterBranchCode();
    
  }
  public SetSelectedBranchCode(value: any) {
    this.paramSearch.BRANCH_CODE = value.BRANCH_CODE;
    // this.Search();
  }

  public SetSelectedBranchCodeAdd(value: any) {
    console.log("value",value);
    
    this.ParamAdd.BRANCH_CODE = value.BRANCH_CODE;
    this.ParamAdd.BRANCH_NAME = value.BRANCH_NAME;
  }

  public ConfigSearchDiscountGroupAdd: any = {
    ColName: "LOOKUP_DISCOUNT_GROUP",
    PlaceholderText: "Select Discount Group",
    SourceController: "wPMS",
    SourceMethodName: "SNM166_SearchDiscountGroupAdd",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSearchDiscountGroupAdd(values: any) {
    this.ParamAdd.DISCOUNT_GROUP = values.DISCOUNT_GROUP;
    this.ParamAdd.DISCOUNT_NAME = values.DISCOUNT_NAME;
  }

  //#region Upload templates
  public DownLoadTemplate() {
    let link = "assets/templates/SNM166_Upload_Template.xlsx";
    window.open(link, "_blank");
  }

  public OpenFileBrowser() {
    this.filename = "";
    this.tableSuccess = [];
    this.tableSuccess1 = [];
    this.tableSuccess2 = [];
    this.param.TOTAL_RECORD = "";
    this.param.COMPLETE = "";
    this.param.REJECT = "";
    this.param.UPLOAD_TIME = "";
    this.fileUpload.nativeElement.value = "";
    this.fileUpload.nativeElement.click();
  }

  public SelectFile(evt) {
    this.extension = null;
    var ext = evt.target.files[0].name;
    this.extension = ext.substr(ext.lastIndexOf(".") + 1);
    this.file = null;
    let Files: Array<File> = evt.target.files;

    if (Files.length > 0) {
      this.file = Files[0];
      this.filename = this.file.name;
    }
  }

  public FileChange(fileInput) {
    this.filename = "";
    this.files = fileInput.target.files;
    this.filename = this.files[0].name;

    if (this.filename) {
      this.Upload();
    }
  }

  public Upload() {
    let formData = new FormData();
    formData.append("file", this.files[0]);
    this.http.postFile("wPMS", "SNM166_Upload", formData).subscribe(
      (res) => {
        this.tableUpload = res.filter((x) => x.CUSTOMER_CODE);
      },
      (err) => {
        console.log(err, "err");
        this.modal.warning(
          "Found an error, please contact support team",
          this.viewRef
        );
      }
    );
  }

  public UploadScore() {
    this.http.post("wPMS", "SNM166_Save_Upload", this.tableUpload).subscribe(
      (res) => {
        if (res.STATUS_MSG == "DONE") {
          this.tableUpload = [];
          this.filename = "";
          this.GetData_Upload();
        } else if (res.STATUS_MSG == "FAIL") {
          this.modal.warning("Invalid upload data", this.viewRef);
        } else {
          this.modal.warning(
            "Found an error, please contact support team",
            this.viewRef
          );
        }
      },
      (err) => {
        console.log(err, "err");
        this.modal.warning(
          "Found an error, please contact support team",
          this.viewRef
        );
        return;
      }
    );
  }

  public GetData_Upload() {
    this.showSuccess = true;
    this.tableSuccess = [];
    this.tableSuccess2 = [];
    this.http.post("wPMS", "SNM166_GetData_Upload", this.params).subscribe(
      (res) => {
        console.log("res.Table",res.Table);
        
        this.tableSuccess = res.Table;
        this.error_list = [];
        let countrow = 0;
        this.tableSuccess.map((data, index) => {
          let find = this.tableSuccess.some(
            (x, i) =>
              x.CUSTOMER_CODE == data.CUSTOMER_CODE &&
              x.BRANCH_CODE == data.BRANCH_CODE &&
              x.DISCOUNT_GROUP == data.DISCOUNT_GROUP &&
              x.START_DATE == data.START_DATE &&
              x.END_DATE == data.END_DATE &&
              i != index
          );
          let find1 = this.tableSuccess.some(
            (x, i) =>
              x.CUSTOMER_CODE == data.CUSTOMER_CODE &&
              x.BRANCH_CODE == data.BRANCH_CODE &&
              x.DISCOUNT_GROUP == data.DISCOUNT_GROUP &&
              x.START_DATE < data.START_DATE &&
              x.END_DATE  > data.START_DATE &&
              i != index
          );
          let find2 = this.tableSuccess.some(
            (x, i) =>
              x.CUSTOMER_CODE == data.CUSTOMER_CODE &&
              x.BRANCH_CODE == data.BRANCH_CODE &&
              x.DISCOUNT_GROUP == data.DISCOUNT_GROUP &&
              x.START_DATE < data.END_DATE &&
              x.END_DATE  > data.END_DATE &&
              i != index
          );
          data.REMARKS_TEMP = ''
          if (find) {
              if (data.REMARKS != null) {
                data.REMARKS_TEMP = data.REMARKS + ", Found the duplicate data in upload file." ;
              }else{
                data.REMARKS_TEMP = 'Customer Code '+ data.CUSTOMER_CODE + ' Branch Code '+ data.BRANCH_CODE + " Found the duplicate data in upload file." ;
              }
          }
          else if (find1 && find2) {
              if (data.REMARKS != null) {
                data.REMARKS_TEMP = data.REMARKS + ",  Found the duplicate start-end date in upload file." ;
              }else{
                data.REMARKS_TEMP = 'Customer Code '+ data.CUSTOMER_CODE + ' Branch Code '+ data.BRANCH_CODE + " Found the duplicate start-end date in upload file." ;
              }
          }
          else if (find1) {
            if (data.REMARKS != null) {
              data.REMARKS_TEMP = data.REMARKS + ", Found the duplicate start date in upload file." ;
            }else{
              data.REMARKS_TEMP = 'Customer Code '+ data.CUSTOMER_CODE + ' Branch Code '+ data.BRANCH_CODE + " Found the duplicate start date in upload file." ;
            }
          }
          else if (find2) {
            if (data.REMARKS != null) {
              data.REMARKS_TEMP = data.REMARKS + ", Found the duplicate end date in upload file." ;
            }else{
              data.REMARKS_TEMP = 'Customer Code '+ data.CUSTOMER_CODE + ' Branch Code '+ data.BRANCH_CODE + " Found the duplicate end date in upload file." ;
            }
          }
          if (data.REMARKS_TEMP != '') {
            data.REMARKS =  data.REMARKS_TEMP 
          }
          if (data.REMARKS != null) {
            countrow += 1;
            this.error_list.push({
              Records: index + 1 + " REMARK : " + data.REMARKS,
            });
          }
        });
        this.total_error = countrow;

        this.tableSuccess1 = this.tableSuccess;

        this.tableSuccess2 = res.Table1;
        if (res.Table1.length > 0) {
          this.param.TOTAL_RECORD = this.tableSuccess2[0].TOTAL ;
          this.param.COMPLETE = this.tableSuccess2[0].TOTAL - this.total_error;
          this.param.REJECT = this.total_error;
          this.param.UPLOAD_TIME = this.todayDate;
        }
      },
      (err) => {
        console.log(err, "err");
        this.modal.warning(
          "Found an error, please contact support team",
          this.viewRef
        );
      }
    );
  }

  public ConfirmSaveUpload() {
    this.modal.confirm("Do you want to save?", this.viewRef, () =>
      SaveUpload()
    );
    let SaveUpload = () => {
      this.http.post("wPMS", "SNM166_Confirm_Upload", this.params).subscribe(
        (result) => {
          if (result.Table[0].STATUS == "DONE") {
            this.modal.info("Upload complete", this.viewRef);
            this.tableSuccess = [];
            this.tableSuccess1 = [];
            this.tableSuccess2 = [];
            this.param.TOTAL_RECORD = "";
            this.param.COMPLETE = "";
            this.param.REJECT = "";
            this.param.UPLOAD_TIME = "";
          } else if (result.status == "Fail") {
            this.modal.warning(result.message, this.viewRef);
            return;
          } else {
            this.modal.warning(
              "Found an error, please contact support team",
              this.viewRef
            );
          }
        },
        (err) => {
          console.log(err, "err");
          this.modal.warning(
            "Found an error, please contact support team",
            this.viewRef
          );
        }
      );
    };
  }

  public GetMasterDetail() {
    const param = {
      CUSTOMER_CODE: this.paramSearch.CUSTOMER_CODE,
    };
    this.http.post("wPMS", "SNM166_GetData_Master", param).subscribe(
      (res) => {
        this.tableData = res.Table;
        this.tableData.forEach((x) => {
          let d = new Date();
          let s = new Date(x.START_DATE);
          x.CHKSHOWDIS = false;
          if (s < d) {
            x.CHKSHOWDIS = true;
          }
        });
      },
      (err) => {
        console.log(err, "err");
        this.modal.warning(
          "Found an error, please contact support team",
          this.viewRef
        );
        return;
      }
    );
  }

  public CancelEditModeSupplier() {
    this.params = {};
    this.editMode = false;
  }

  public SaveAdd() {
    
    if (!this.ParamAdd.CUSTOMER_CODE) {
      this.modal.warning("Please enter the customer code information.",this.viewRef);
      return;
    }
    if (!this.ParamAdd.BRANCH_CODE) {
      this.modal.warning("Please specify branch code.", this.viewRef);
      return;
    }
    if (!this.ParamAdd.DISCOUNT_GROUP ) {
      this.modal.warning('Please specify discount group.', this.viewRef);
      return;
    }
    if (!this.ParamAdd.START_DATE) {
      this.modal.warning("Please specify start date", this.viewRef);
      return;
    }
    if (!this.ParamAdd.END_DATE) {
      this.modal.warning("Please specify end date", this.viewRef);
      return;
    }
    
    if (!this.ParamAdd.END_DATE) {
      this.modal.warning("Please specify end date", this.viewRef);
      return;
    }
    let d = new Date();
    let s = new Date(this.ParamAdd.START_DATE);
    if (s < d) {
      this.modal.warning("The start date must be more than the current date.", this.viewRef);
      return;
    }
    this.ParamAdd.START_DATE = moment(this.ParamAdd.START_DATE).format(
      "YYYY-MM-DD"
    );
    this.ParamAdd.END_DATE = moment(this.ParamAdd.END_DATE).format(
      "YYYY-MM-DD"
    );

    this.modal.confirm(
      "Do you want to save?",
      this.viewRef,
      () => {

        this.http
          .post("wPMS", "SNM166_Insert_Customer_Discount", this.ParamAdd)
          .subscribe(
            (res) => {
              if (res.Table[0].STATUS == "DONE") {
                this.modal.info("Save data complete", this.viewRef);
                this.params = {};
                this.GetMasterDetail();
                this.ParamAdd = this.global.ClearObject(this.ParamAdd);
                this.dialogAdd.Close();
              } else if (res.Table[0].ERROR_MSG != "") {
                this.modal.warning(res.Table[0].ERROR_MSG, this.viewRef);
              } else {
                console.log(res.Table[0].MESSAGE, "err");
                this.modal.warning(
                  "Found an error, please contact support team",
                  this.viewRef
                );
              }
            },
            (err) => {
              console.log(err, "err");
              this.modal.warning(
                "Found an error, please contact support team",
                this.viewRef
              );
            }
          );
      },
      () => {}
    );
  }

  public SaveEdit() {
    if (!this.params.CUSTOMER_CODE) {
      this.modal.warning("Please enter the customer code information.",this.viewRef);
      return;
    }
    if (!this.params.BRANCH_CODE) {
      this.modal.warning("Please specify branch code", this.viewRef);
      return;
    }
    if (!this.params.DISCOUNT_GROUP) {
      this.modal.warning("Please specify discount group Code", this.viewRef);
      return;
    }
    if (!this.params.START_DATE) {
      this.modal.warning("Please specify start date", this.viewRef);
      return;
    }
    if (!this.params.END_DATE) {
      this.modal.warning("Please specify end date", this.viewRef);
      return;
    }

    let d = new Date();
    let s = new Date(this.params.START_DATE);
    if (s < d) {
      this.modal.warning("The start date must be more than the current date.", this.viewRef);
      return;
    }

    this.params.START_DATE = moment(this.params.START_DATE).format(
      "YYYY-MM-DD"
    );
    this.params.END_DATE = moment(this.params.END_DATE).format("YYYY-MM-DD");

    this.modal.confirm(
      "Do you want to save?",
      this.viewRef,
      () => {
        this.http
          .post("wPMS", "SNM166_Update_Customer_Discount", this.params)
          .subscribe(
            (res) => {
              if (res.Table[0].STATUS == "DONE") {
                this.modal.info("Save data complete", this.viewRef);
                this.GetMasterDetail();
                this.dialogEdit.Close();
              } else if (res.Table[0].ERROR_MSG != "") {
                this.modal.warning(res.Table[0].ERROR_MSG, this.viewRef);
              } else {
                console.log(res.Table[0].MESSAGE, "err");
                this.modal.warning(
                  "Found an error, please contact support team",
                  this.viewRef
                );
              }
            },
            (err) => {
              console.log(err, "err");
              this.modal.warning(
                "Found an error, please contact support team",
                this.viewRef
              );
            }
          );
      },
      () => {}
    );
  }
  public BackToFirst() {
    this.showList = true;
    this.showListDetail = false;
    this.GetMasterDetail();
  }
  OpendatePopup(datepicker) {
    datepicker.open();
  }

  public EditRow(data1) {
    let data = {...data1}
    this.params = data;
    let d = new Date();
    let s = new Date(data.START_DATE);
    this.Chkdis = false;
    if (s < d) {
      this.Chkdis = true;
    }
    this.params.START_DATE_TEMP = moment(data.START_DATE).format("YYYY-MM-DD");
    this.params.START_DATE = moment(data.START_DATE).format("YYYY-MM-DD");
    this.params.END_DATE_TEMP = moment(data.END_DATE).format("YYYY-MM-DD");
    this.params.END_DATE = moment(data.END_DATE).format("YYYY-MM-DD");

    this.SetPartNoControl.reset();
    this.dialogEdit.OpenDialog();
    this.tabledataEdit = [];
  }

  public CancelAdd() {
    this.dialogAdd.Close();
  }

  public CancleEdit() {
    this.dialogEdit.Close();
  }

  openDialog() {
    this.CustomerCodeControl.reset();
    this.SEQControl.reset();
    this.ParamAdd = this.global.ClearObject(this.ParamAdd);
    this.ParamAdd.CUSTOMER_CODE = null;
    this.ParamAdd.BRANCH_CODE = null;
    this.ParamAdd.DISCOUNT_GROUP = null;
    this.BranchCodeList = []
    // this.ParamAdd.START_DATE = new Date();
    // this.ParamAdd.END_DATE = new Date();
    this.dialogAdd.OpenDialog();
  }

  public Delete(data) {
    const dateparam = {
      CUSTOMER_CODE: data.CUSTOMER_CODE,
      BRANCH_CODE: data.BRANCH_CODE,
      DISCOUNT_GROUP: data.DISCOUNT_GROUP,
      START_DATE: moment(data.START_DATE).format("YYYY-MM-DD"),
      END_DATE: moment(data.END_DATE).format("YYYY-MM-DD"),
    };
    this.modal.confirm(
      "Do you want to delete this record?",
      this.viewRef,
      () => {
        this.http.post("wPMS", "SNM166_Delete", dateparam).subscribe((res) => {
          if (res.STATUS_MSG == "DONE") {
            this.modal.info(
              "Transaction complete: 1 record applied and deleted.",
              this.viewRef
            );
            this.GetMasterDetail();
          } else {
            this.modal.warning(
              "No change to save. Something went wrong.",
              this.viewRef
            );
          }
        });
      }
    );
  }

  public Clear() {
    this.paramSearch.CUSTOMER_CODE = "";
    this.paramSearch.CUSTOMER_NAME = "";
    this.tableData = [];
    this.GetMasterDetail();
  }

  public GetDataMasterBranchCode() {
    this.http.post("wPMS", "SNM166_GetData_Master_Branch_Code", this.ParamAdd)
      .subscribe(res => {
        console.log("res",res);
        this.BranchCodeList = res.Table;
        
      }, (err) => {
        console.log(err, "err")
        this.modal.warning("Found an error, please contact support team", this.viewRef);
        return;
      })
  }
  public GetDataMasterDiscountGroup() {
    this.http.post("wPMS", "SNM166_GetData_Master_Discount_Group", this.ParamAdd)
      .subscribe(res => {
        console.log("res",res);
        this.DiscountGroupList = res.Table;
        
      }, (err) => {
        console.log(err, "err")
        this.modal.warning("Found an error, please contact support team", this.viewRef);
        return;
      })
  }

  public SetSearchBranchCodeMaster(event) {
    this.ParamAdd.BRANCH_CODE = event.value;
  }
  public SetSearchDiscountGroupMaster(event: any) {
    this.ParamAdd.DISCOUNT_GROUP = event.value;
  }
}
