import { Component, OnInit, ElementRef, ViewChild, ViewContainerRef, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from '../../../core/modal.service';
import { DateAdapter, MAT_DATE_FORMATS, MAT_DATE_LOCALE } from '@angular/material/core';
import { MAT_MOMENT_DATE_ADAPTER_OPTIONS, MomentDateAdapter } from '@angular/material-moment-adapter';
import * as moment from 'moment';
import { FormControl, Validators } from '@angular/forms';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'SNM167',
  templateUrl: './SNM167.component.html',
  styleUrls: ['./SNM167.component.css'],
})


export class SNM167Component implements OnInit {


  @ViewChild("fileUpload") fileUpload: ElementRef;

  public filename: string = "";
  public extension: string = "";
  public file: any;

  public files: any = [];
  public tableUpload: any = []
  public error_list: any = []

  constructor(
    public http: HttpService,
    public modal: ModalService,
    public global: Globals,
    public viewRef: ViewContainerRef
  ) { }

  public param: any = {};
  public paramSearch: any = {};


  public tableData: any = [];
  public tableSuccess: any = [];
  public tableSuccess1: any = [];
  public tableSuccess2: any = [];
  public params: any = {};

  public todayDate: Date = new Date();
  public showSuccess: Boolean;
  public showList: Boolean;
  public showListDetail: Boolean;
  public editMode: any;
  public total_error :number = 0;
  public partNumber: string;
  SetPartNoControl = new FormControl('', [Validators.required])
  SetPartTypeControl = new FormControl('', [Validators.required])
  public hideCols: Array<string> = []
    DiscountGroupControl = new FormControl('', [Validators.required]);
    SEQControl = new FormControl('', [Validators.required]);

  @ViewChild("dialogAdd", { static: false }) dialogAdd: any;
  @ViewChild("dialogEdit", { static: false }) dialogEdit: any;
  @ViewChild("dialog", { static: false }) dialog: any;

  public ParamEdit: any = {};
  public ParamEdit_Ex: any = {};
  public ParamAdd: any = {};
  public Chkdis: any = {};
  public tabledataEdit: any = [];
  public FamilyCodeList: any = [];

  ngOnInit(): void {
    this.showSuccess = false;
    this.showList = true
    this.showListDetail = false
    this.Chkdis = false
    this.GetDataMasterFamilyCode();
  }

  
  public ConfigSearchDiscountGroup: any = {
    ColName: "LOOKUP_DISCOUNT_GROUP",
    PlaceholderText: "Select Discount Group",
    SourceController: "wPMS",
    SourceMethodName: "SNM167_SearchDiscountGroup",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSearchDiscountGroup(values: any) {
    this.paramSearch.DISCOUNT_GROUP = values.DISCOUNT_GROUP;
    this.paramSearch.DISCOUNT_NAME = values.DISCOUNT_NAME;
  }


  public ConfigSearchOrderClass: any = {
    ColName: "LOOKUP_ORDER_CLASS",
    PlaceholderText: "Select Order Class",
    SourceController: "wPMS",
    SourceMethodName: "SNM167_SearchOrderClass",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public SetSearchOrderClass(values: any) {
    this.paramSearch.ORDER_CLASS = values.ORDER_CLASS;
    this.paramSearch.ORDER_DESCRIPT = values.ORDER_DESCRIPT;
  }

  public ConfigSearchFamilyCode: any = {
    ColName: "LOOKUP_FAMILY_CODE",
    PlaceholderText: "Select Family Code",
    SourceController: "wPMS",
    SourceMethodName: "SNM167_SearchFamilyCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
  }

  public SetSearchFamilyCode(values: any) {
    this.paramSearch.DISCOUNT_FAMILY = values.FAMILY_CODE;
    this.paramSearch.FAMILY_NAME = values.FAMILY_NAME;
  }


  //////////////////////
  
  public ConfigSearchDiscountGroupAdd: any = {
    ColName: "LOOKUP_DISCOUNT_GROUP",
    PlaceholderText: "Select Discount Group",
    SourceController: "wPMS",
    SourceMethodName: "SNM167_SearchDiscountGroupAdd",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSearchDiscountGroupAdd(values: any) {
    this.ParamAdd.DISCOUNT_GROUP = values.DISCOUNT_GROUP;
    this.ParamAdd.DISCOUNT_NAME = values.DISCOUNT_NAME;
  }

  public ConfigSearchOrderClassAdd: any = {
    ColName: "LOOKUP_ORDER_CLASS",
    PlaceholderText: "Select Order Class",
    SourceController: "wPMS",
    SourceMethodName: "SNM167_SearchOrderClassAdd",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public SetSearchOrderClassAdd(values: any) {
    this.ParamAdd.ORDER_CLASS = values.ORDER_CLASS;
    this.ParamAdd.ORDER_DESCRIPT = values.ORDER_DESCRIPT;
  }

  public ConfigSearchFamilyCodeAdd: any = {
    ColName: "LOOKUP_FAMILY_CODE",
    PlaceholderText: "Select Family Code",
    SourceController: "wPMS",
    SourceMethodName: "SNM167_SearchFamilyCodeAdd",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
  }

  public SetSearchFamilyCodeAdd(values: any) {
    this.ParamAdd.DISCOUNT_FAMILY = values.FAMILY_CODE;
    this.ParamAdd.FAMILY_NAME = values.FAMILY_NAME;
  }

  //#region Upload templates
  public DownLoadTemplate() {
    let link = "assets/templates/SNM167_Upload_Template.xlsx";
    window.open(link, "_blank");
  }

  public OpenFileBrowser() {

    this.filename = "";
    this.tableSuccess = [];
    this.tableSuccess1 = [];
    this.tableSuccess2 = [];
    this.param.TOTAL_RECORD = "";
    this.param.COMPLETE = "";
    this.param.REJECT = "";
    this.param.UPLOAD_TIME = "";
    this.fileUpload.nativeElement.value = '';
    this.fileUpload.nativeElement.click();
  }

  public SelectFile(evt) {
    this.extension = null;
    var ext = evt.target.files[0].name
    this.extension = (ext.substr(ext.lastIndexOf('.') + 1))
    this.file = null;
    let Files: Array<File> = evt.target.files;

    if (Files.length > 0) {
      this.file = Files[0];
      this.filename = this.file.name;
    }
  }

  public FileChange(fileInput) {
    this.filename = "";
    this.files = fileInput.target.files;
    this.filename = this.files[0].name;

    if (this.filename) {
      this.Upload();
    }
  }

  public Upload() {
    let formData = new FormData();
    formData.append("file", this.files[0]);
    this.http.postFile("wPMS", "SNM167_Upload", formData).subscribe(
      (res) => {
        this.tableUpload = res.filter((x) => x.DISCOUNT_GROUP);
      },
      (err) => {
        console.log(err, "err")
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      }
    );
  }

  public UploadScore() {
    this.http.post("wPMS", "SNM167_Save_Upload", this.tableUpload)
      .subscribe(res => {
        
        if (res.STATUS_MSG == 'DONE') {
          this.tableUpload = []
          this.filename = ""
          this.GetData_Upload();
        } else if (res.STATUS_MSG == 'FAIL') {
          this.modal.warning("Invalid upload data", this.viewRef);
        }
        else {
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        }
      }, err => {
        console.log(err, "err")
        this.modal.warning("Found an error, please contact support team", this.viewRef);
        return;
      })
  }

  public GetData_Upload() {
    this.showSuccess = true;
    this.tableSuccess = [];
    this.tableSuccess2 = [];
    this.http.post("wPMS", "SNM167_GetData_Upload", this.params)
      .subscribe(res => {
        this.tableSuccess = res.Table;
        this.error_list = []
        let countrow = 0;
        this.tableSuccess.map((data,index) => {
          let find = this.tableSuccess.some(
            (x, i) =>
              x.DISCOUNT_GROUP == data.DISCOUNT_GROUP &&
              x.ORDER_CLASS == data.ORDER_CLASS &&
              x.DISCOUNT_FAMILY == data.DISCOUNT_FAMILY &&
              x.START_DATE == data.START_DATE &&
              x.END_DATE == data.END_DATE &&
              i != index
          );
          let find1 = this.tableSuccess.some(
            (x, i) =>
            x.DISCOUNT_GROUP == data.DISCOUNT_GROUP &&
            x.ORDER_CLASS == data.ORDER_CLASS &&
            x.DISCOUNT_FAMILY == data.DISCOUNT_FAMILY &&
              x.START_DATE < data.START_DATE &&
              x.END_DATE  > data.START_DATE &&
              i != index
          );
          let find2 = this.tableSuccess.some(
            (x, i) =>
              x.DISCOUNT_GROUP == data.DISCOUNT_GROUP &&
              x.ORDER_CLASS == data.ORDER_CLASS &&
              x.DISCOUNT_FAMILY == data.DISCOUNT_FAMILY &&
              x.START_DATE < data.END_DATE &&
              x.END_DATE  > data.END_DATE &&
              i != index
          );
          data.REMARKS_TEMP = ''
          if (find) {
              if (data.REMARKS != null) {
                data.REMARKS_TEMP = data.REMARKS + ", Found the duplicate data in upload file." ;
              }else{
                data.REMARKS_TEMP = 
                " Discount Group : " + data.DISCOUNT_GROUP + 
                " Order Class : " + data.ORDER_CLASS +
                " Family Code : " + data.DISCOUNT_FAMILY +
                " Found the duplicate data in upload file." ;
              }
          }
          else if (find1 && find2) {
              if (data.REMARKS != null) {
                data.REMARKS_TEMP = data.REMARKS + ",  Found the duplicate start-end date in upload file." ;
              }else{
                data.REMARKS_TEMP = 
                " Discount Group : " + data.DISCOUNT_GROUP + 
                " Order Class : " + data.ORDER_CLASS +
                " Family Code : " + data.DISCOUNT_FAMILY +
                " Found the duplicate start-end date in upload file." ;
              }
          }
          else if (find1) {
            if (data.REMARKS != null) {
              data.REMARKS_TEMP = data.REMARKS + ", Found the duplicate start date in upload file." ;
            }else{
              data.REMARKS_TEMP = 
              " Discount Group : " + data.DISCOUNT_GROUP + 
                " Order Class : " + data.ORDER_CLASS +
                " Family Code : " + data.DISCOUNT_FAMILY +
                " Found the duplicate start date in upload file." ;
            }
          }
          else if (find2) {
            if (data.REMARKS != null) {
              data.REMARKS_TEMP = data.REMARKS + ", Found the duplicate end date in upload file." ;
            }else{
              data.REMARKS_TEMP = 
              " Discount Group : " + data.DISCOUNT_GROUP + 
                " Order Class : " + data.ORDER_CLASS +
                " Family Code : " + data.DISCOUNT_FAMILY +
                " Found the duplicate end date in upload file." ;
            }
          }
          if (data.REMARKS_TEMP != '') {
            data.REMARKS =  data.REMARKS_TEMP 
          }
          if (data.REMARKS != null) {
            countrow += 1;
            this.error_list.push({
              Records: index + 1 + " REMARK : " + data.REMARKS,
            });
          }
        });
        this.total_error = countrow;

        this.tableSuccess1 = this.tableSuccess;

        this.tableSuccess2 = res.Table1;
        if (res.Table1.length > 0) {
          this.param.TOTAL_RECORD = this.tableSuccess2[0].TOTAL ;
          this.param.COMPLETE = this.tableSuccess2[0].TOTAL - this.total_error;
          this.param.REJECT = this.total_error;
          this.param.UPLOAD_TIME = this.todayDate;
        }
      },
      (err) => {
        console.log(err, "err");
        this.modal.warning(
          "Found an error, please contact support team",
          this.viewRef
        );
      }
    );
  }

  public ConfirmSaveUpload() {
    this.modal.confirm("Do you want to save?", this.viewRef, () => SaveUpload())
    let SaveUpload = () => {
      this.http.post("wPMS", "SNM167_Confirm_Upload", this.params)
        .subscribe(result => {
          if (result.Table[0].STATUS == "DONE") {
            this.modal.info("Upload complete", this.viewRef);
            this.tableSuccess = [];
            this.tableSuccess1 = [];
            this.tableSuccess2 = [];
            this.param.TOTAL_RECORD = '';
            this.param.COMPLETE = '';
            this.param.REJECT = '';
            this.param.UPLOAD_TIME  = '';
          } else if (result.status == "Fail") {
            this.modal.warning(result.message, this.viewRef);
            return;
          } else {
            this.modal.warning("Found an error, please contact support team", this.viewRef);
          }
        }, (err) => {
          console.log(err, "err")
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        })
    }
  }

  public GetMasterDetail() {
    
    const param = {
      DISCOUNT_GROUP : this.paramSearch.DISCOUNT_GROUP,
      ORDER_CLASS : this.paramSearch.ORDER_CLASS,
      DISCOUNT_FAMILY : this.paramSearch.DISCOUNT_FAMILY,
      START_DATE : moment(this.paramSearch.START_DATE).format('YYYY-MM-DD'),
      END_DATE : moment(this.paramSearch.END_DATE).format('YYYY-MM-DD'),
    }
    this.http.post("wPMS", "SNM167_GetData_Master", param)
      .subscribe(res => {
        this.tableData = res.Table;
        this.tableData.forEach(x => {
          let d = new Date();
          let s = new Date(x.START_DATE);
          x.CHKSHOWDIS = false
          if (s < d ){
            x.CHKSHOWDIS = true
          }
        });
        
      }, (err) => {
        console.log(err, "err")
        this.modal.warning("Found an error, please contact support team", this.viewRef);
        return;
      })
  }


  public CancelEditModeSupplier() {
    this.params = {};
    this.editMode = false;
  }
  

  public SaveAdd() {
    if (!this.ParamAdd.DISCOUNT_GROUP ) {
      this.modal.warning('Please enter the discount group information.', this.viewRef);
      return;
    }
    if (!this.ParamAdd.ORDER_CLASS ) {
      this.modal.warning('Please specify order class', this.viewRef);
      return;
    }
    if (!this.ParamAdd.DISCOUNT_FAMILY ) {
      this.modal.warning('Please enter the discount family code information.', this.viewRef);
      return;
    }
    if (!this.ParamAdd.START_DATE ) {
      this.modal.warning('Please specify start date', this.viewRef);
      return;
    }
    if (!this.ParamAdd.END_DATE ) {
      this.modal.warning('Please specify end date', this.viewRef);
      return;
    }
    let d = new Date();
    let s = new Date(this.ParamAdd.START_DATE);
    if (s < d) {
      this.modal.warning("The start date must be more than the current date.", this.viewRef);
      return;
    }

    this.ParamAdd.START_DATE = moment(this.ParamAdd.START_DATE).format('YYYY-MM-DD');
    this.ParamAdd.END_DATE = moment(this.ParamAdd.END_DATE).format('YYYY-MM-DD');

    this.modal.confirm('Do you want to save?', this.viewRef,
      () => {
        this.http.post("wPMS", "SNM167_Insert_Rate_Discount", this.ParamAdd)
          .subscribe(res => {
            if (res.Table[0].STATUS == 'DONE') {
              this.modal.info("Save data complete", this.viewRef);
              this.params = {}
              // this.params.DISCOUNTGROUP = this.ParamAdd.DISCOUNT_GROUP
              // this.params.ORDER_CLASS = this.ParamAdd.ORDER_CLASS
              // this.params.DISCOUNT_FAMILY = this.ParamAdd.DISCOUNT_FAMILY
              this.GetMasterDetail();
              this.ParamAdd = this.global.ClearObject(this.ParamAdd);
              this.dialogAdd.Close();
            }
            else if (res.Table[0].ERROR_MSG != '') {
              this.modal.warning(res.Table[0].ERROR_MSG, this.viewRef);
            }
            else {
              console.log(res.Table[0].MESSAGE, "err")
              this.modal.warning("Found an error, please contact support team", this.viewRef);
            }
          }, (err) => {
            console.log(err, "err")
            this.modal.warning("Found an error, please contact support team", this.viewRef);
          });
      },
      () => { }
    )
  }

  public SaveEdit() {
    if (!this.params.DISCOUNT_GROUP ) {
      this.modal.warning('Please enter the discount group information.', this.viewRef);
      return;
    }
    if (!this.params.ORDER_CLASS ) {
      this.modal.warning('Please specify order class', this.viewRef);
      return;
    }
    if (!this.params.DISCOUNT_FAMILY ) {
      this.modal.warning('Please enter the discount family code information.', this.viewRef);
      return;
    }
    if (!this.params.START_DATE ) {
      this.modal.warning('Please specify start date', this.viewRef);
      return;
    }
    if (!this.params.END_DATE ) {
      this.modal.warning('Please specify end date', this.viewRef);
      return;
    }

    let d = new Date();
    let s = new Date(this.params.START_DATE);
    if (s < d) {
      this.modal.warning("The start date must be more than the current date.", this.viewRef);
      return;
    }
    this.params.START_DATE = moment(this.params.START_DATE).format('YYYY-MM-DD');
    this.params.END_DATE = moment(this.params.END_DATE).format('YYYY-MM-DD');
    
    this.modal.confirm('Do you want to save?', this.viewRef,
      () => {
        this.http.post("wPMS", "SNM167_Update_Rate_Discount", this.params)
          .subscribe(res => {
            if (res.Table[0].STATUS == 'DONE') {
              this.modal.info("Save data complete", this.viewRef);
              this.GetMasterDetail();
              this.dialogEdit.Close();
            }
            else if (res.Table[0].ERROR_MSG != '') {
              this.modal.warning(res.Table[0].ERROR_MSG, this.viewRef);
            }
            else {
              console.log(res.Table[0].MESSAGE, "err")
              this.modal.warning("Found an error, please contact support team", this.viewRef);
            }
          }, (err) => {
            console.log(err, "err")
            this.modal.warning("Found an error, please contact support team", this.viewRef);
          });
      },
      () => { }
    )
  }
  public BackToFirst() {
    this.showList = true;
    this.showListDetail = false;
    this.GetMasterDetail()
  }
  OpendatePopup(datepicker) {
    datepicker.open();
  }


  public EditRow(data1) {
    let data = {...data1}
    this.params = data
    let d = new Date();
    let s = new Date(data.START_DATE);
    this.Chkdis = false
    if (s < d ){
      this.Chkdis = true
    }
    this.params.START_DATE_TEMP = moment(data.START_DATE).format('YYYY-MM-DD');
    this.params.START_DATE = moment(data.START_DATE).format('YYYY-MM-DD');
    this.params.END_DATE_TEMP = moment(data.END_DATE).format('YYYY-MM-DD');
    this.params.END_DATE = moment(data.END_DATE).format('YYYY-MM-DD');

    this.SetPartNoControl.reset();
    this.dialogEdit.OpenDialog();
    this.tabledataEdit = [];
  }

  public CancelAdd() {
    this.dialogAdd.Close();
  }

  public CancleEdit() {
    this.dialogEdit.Close();
  }

 

  openDialog() {
    this.DiscountGroupControl.reset();
    this.SEQControl.reset();
    this.ParamAdd = this.global.ClearObject(this.ParamAdd)
    this.ParamAdd.CUSTOMER_CODE = null
    this.dialogAdd.OpenDialog();
  }

  public Delete(data) {
    const dateparam = {
      DISCOUNT_GROUP : data.DISCOUNT_GROUP,
      ORDER_CLASS : data.ORDER_CLASS,
      DISCOUNT_FAMILY : data.DISCOUNT_FAMILY,
      DISCOUNT_RATE1 : data.DISCOUNT_RATE1,
      DISCOUNT_RATE2 : data.DISCOUNT_RATE2,
      DISCOUNT_RATE3 : data.DISCOUNT_RATE3,
      START_DATE : moment(data.START_DATE).format('YYYY-MM-DD'),
      END_DATE : moment(data.END_DATE).format('YYYY-MM-DD'),
    }

    this.modal.confirm(
      "Do you want to delete this record?",
      this.viewRef,
      () => {
        this.http.post("wPMS", "SNM167_Delete", dateparam).subscribe((res) => {
          if (res.STATUS_MSG == "DONE") {
            this.modal.info(
              "Transaction complete: 1 record applied and deleted.",
              this.viewRef
            );
            this.GetMasterDetail();
            this.dialog.Close();
          } else {
            this.modal.warning(
              "No change to save. Something went wrong.",
              this.viewRef
            );
          }
        });
      }
    );
  }

  public Clear() {
    this.paramSearch.DISCOUNT_GROUP = '';
    this.paramSearch.ORDER_CLASS = '';
    this.paramSearch.DISCOUNT_FAMILY = '';
    this.tableData = []
    this.GetMasterDetail() 
  }

  public SetSearchFamilyCodeMaster(event: any) {
    this.paramSearch.DISCOUNT_FAMILY = event.value;
  }
  public SetFamilyCodeMaster(event: any) {
    this.ParamAdd.DISCOUNT_FAMILY = event.value;
  }

  public GetDataMasterFamilyCode() {
    this.http.post("wPMS", "SNM167_GetData_Master_Family_Code", this.ParamAdd)
      .subscribe(res => {
        console.log("res",res);
        this.FamilyCodeList = res.Table;
        
      }, (err) => {
        console.log(err, "err")
        this.modal.warning("Found an error, please contact support team", this.viewRef);
        return;
      })
  }
}

