import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'snm106p',
  templateUrl: './SNM106P.component.html',
  styleUrls: ['./SNM106P.component.css']
})


export class SNM106PComponent implements OnInit {

  public params: any = {}
  public formData: any;

  public tableData: any = [];
  public chk: number;
  public IsEdit: boolean = false;

  constructor(
    private Http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  @ViewChild("dialog", { static: false }) dialog: any;
  @ViewChild("dialog2", { static: false }) dialog2: any;

  ngOnInit() {
    this.Search();
  }

  Search() {
    this.tableData = [];
    this.Http.post('SL', 'SNM106P_GetData', this.params)
      .subscribe(res => {
        this.tableData = res.Table;
      })
  }

  public lookupUserIDConfig: any = {
    ColName: "LOOKUP_USER_NAME",
    PlaceholderText: "Select User ID",
    SourceController: "SL",
    SourceMethodName: "SNM106P_GetUser",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public SetSelectedUserID(value: any) {
    this.params.USER_ID = value.USER_ID;
    this.params.USER_NAME = value.USER_NAME;
    this.Search();
  }

  public lookupUserIDAddConfig: any = {
    ColName: "LOOKUP_USER_ID",
    PlaceholderText: "Select User ID",
    SourceController: "SL",
    SourceMethodName: "SNM106P_GetUser2",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public SetSelectedUserIDAdd(value: any) {
    this.formData.USER_ID = value.USER_ID;
    this.formData.USER_NAME = value.USER_NAME;
  }

  ConfirmSave() {
    if (this.IsEdit == true) {
      if (this.formData.OLD_REMARK != this.formData.REMARK) {
        this.modal.confirm('Do you want to update on this data?', this.viewref, this.Save)
      }
      else {
        this.modal.warning('There is no data change.', this.viewref)
      }
    }
    else {
      if (this.formData.USER_ID && this.formData.REMARK) {
        this.modal.confirm('Do you want to update on this data?', this.viewref, this.Save)
      }
      else {
        this.modal.warning('Please complete all data.', this.viewref)
      }
    }
  }

  Save = () => {
    this.Http.post('SL', 'SNM106P_SAVE', this.formData)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Done.', this.viewref);
          if (this.chk == 0) {
            this.dialog.Close();
          }
          else {
            this.dialog2.Close();
          }
          this.formData = {};
          this.Search()
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      })
  }

  Delete(data) {
    this.formData = {};
    this.formData = data
    this.modal.confirm('Do you want to delete record?', this.viewref, this.ConfirmDelete)
  }

  ConfirmDelete = () => {
    this.Http.post('SL', 'SNM106P_Delete', this.formData)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Delete done.', this.viewref);
          this.Search();
        } else {
          this.modal.warning('No change. Something went wrong.', this.viewref);
        }
      })
  }

  CreateClick() {
    this.formData = {};
    this.IsEdit = false;
    this.dialog.OpenDialog();
    this.chk = 0;
  }

  CancelAdd() {
    this.dialog.Close();
    this.formData = {};
  }

  EditRow(data) {
    this.formData = {};
    this.formData = JSON.parse(JSON.stringify(data));
    this.formData.OLD_REMARK = this.formData.REMARK
    this.IsEdit = true;
    this.dialog2.OpenDialog();
    this.chk = 1;
  }

  CancelEdit() {
    this.dialog2.Close();
  }
}

