import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'snpp021prn_001',
  templateUrl: './snpp021prn_001.component.html',
  styleUrls: ['./snpp021prn_001.component.css']
})



export class SNPP021PRN_001Component implements OnInit {

  displayedColumns: string[] = [
    'COMPANY_CODE' , 
    'GROUP_PART_NO' , 
    'VENDOR_CODE' , 
    'VENDOR_TYPE' , 
    'ONLINE_FLAG' , 
    'PART_CATEGORY' , 
    'ORDER_QTY_EDF' , 
    'SUGGEST_STATUS' , 
    'PO_PROCESS_DATE' , 
    'ORDER_QTY_MANUA' , 
    'ORDER_STATUS' , 
    'ORDER_QTY_N_01' , 
    'ORDER_QTY_N_02' , 
    'ORDER_QTY_N_03' , 
    'ORDER_QTY_N_04' , 
    'ORDER_QTY_N_05' , 
    'ORDER_QTY_N_06' , 
    'ORDER_QTY_N_07' , 
    'ORDER_QTY_N_08' , 
    'ORDER_QTY_N_09' , 
    'ORDER_QTY_N_10' , 
    'ORDER_QTY_N_11' , 
    'ORDER_QTY_N_12' , 
    'OH_QTY' , 
    'BO_QTY' , 
    'PO_QTY' , 
    'BASE_PRICE' , 
    'ORDER_SC' , 
    'CREATE_BY' , 
    'CREATE_DATE' , 
    'LAST_UPD_PGM' , 
    'LAST_UPD_BY' , 
    'LAST_UPD_DATE' , 
    'ATTRIBUTE01' , 
    'ATTRIBUTE02' , 
    'ATTRIBUTE03' , 
    'ATTRIBUTE04' , 
    'ATTRIBUTE05'
  ];

  public DataResult: PeriodicElement[];//shema of dataset result

  constructor(
    private HttpService: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef 
  ) { }


  ngOnInit() {
  }

  SearchDatasetLocal() { 
      
    this.HttpService.post('IC', 'SNPP021PRN_SK_PRN_LOCAL', null)
        .subscribe(res => {
            console.log("res",res);
            this.DataResult = res.Table;//pointer with []
        })
  }

  SearchDatasetImport(){
    this.HttpService.post('IC', 'SNPP021PRN_SK_PRN_IMPORT', null)
        .subscribe(res => {
            console.log("res",res);
            this.DataResult = res.Table;//pointer with []
        })
  }

}

//for Column of Data set (Report Viewer)
export interface PeriodicElement {
    
COMPANY_CODE: string ; 
GROUP_PART_NO: string ; 
VENDOR_CODE: string; 
VENDOR_TYPE: string; 
ONLINE_FLAG: string; 
PART_CATEGORY: number; 
ORDER_QTY_EDF: number; 
SUGGEST_STATUS: string; 
PO_PROCESS_DATE: Date; 
ORDER_QTY_MANUA: number; 
ORDER_STATUS: string; 
ORDER_QTY_N_01: number; 
ORDER_QTY_N_02: number; 
ORDER_QTY_N_03: number; 
ORDER_QTY_N_04: number; 
ORDER_QTY_N_05: number; 
ORDER_QTY_N_06: number; 
ORDER_QTY_N_07: number; 
ORDER_QTY_N_08: number; 
ORDER_QTY_N_09: number; 
ORDER_QTY_N_10: number; 
ORDER_QTY_N_11: number; 
ORDER_QTY_N_12: number; 
OH_QTY: number; 
BO_QTY: number; 
PO_QTY: number; 
BASE_PRICE: number; 
ORDER_SC: number; 
CREATE_BY: string; 
CREATE_DATE: Date; 
LAST_UPD_PGM: string; 
LAST_UPD_BY: string; 
LAST_UPD_DATE: Date; 
ATTRIBUTE01: string; 
ATTRIBUTE02: string; 
ATTRIBUTE03: string; 
ATTRIBUTE04: string; 
ATTRIBUTE05: string;
}