import { Component, OnInit, ViewContainerRef } from "@angular/core";
import { Router } from "@angular/router";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "src/app/core/modal.service";

@Component({
  selector: "list",
  templateUrl: "list.component.html",
  styleUrls: ["list.component.css"],
})
export class ListComponent implements OnInit {
  constructor(
    private router: Router,
    private http: HttpService,
    private modal: ModalService,
    private viewRef: ViewContainerRef
  ) {}

  public reportList: any[] = [];
  public filterReport: string = "";

  ngOnInit() {
    this.GetReportList();
  }

  private GetReportList() {
    this.http.get("System", "GetReportViewerList").subscribe(
      (reportList) => {
        this.reportList = reportList
      },
      (err) => {
        this.modal.warning(
          "Found an error, please contract support team",
          this.viewRef
        );
      }
    );
  }
  
  public ReportListFilter() {
    return this.reportList.filter(v => v.REPORT_NAME?.toUpperCase().includes(this.filterReport?.toUpperCase()))
  }

  public RunReport(selectedReport: any) {
    const report = selectedReport.options[0].value;

    this.router.navigate([
      "/reportviewer/run",
      { id: report.ID, name: report.REPORT_NAME },
    ]);
  }
}
