import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from 'src/app/core/modal.service';


@Component({
  selector: 'snse001n',
  templateUrl: './SNSE001N.component.html',
  styleUrls: ['./SNSE001N.component.css']
})

export class SNSE001NComponent implements OnInit {

  public files: any = [];
  public FileName: string = "";
  public params: any = {};
  public PreFileList: any = [];
  public FileList: any = [];
  public DataList: any = [];
  public FileNameList: any = [];
  public formData: any;
  public ErrorParams: any = [];
  public ErrorMsg: any = [];

  public ShowChk: boolean = false;

  constructor(
    private Http: HttpService,
    private router: Router,
    private global: Globals,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  @ViewChild("dialogProcess", { static: false }) dialogProcess: any;

  public DataUploadList: any;

  ngOnInit() {
    this.CreateDetailRow(0);
  }

  DownloadTemplate() {
    let link = "assets/templates/Receive_Order_Template.xlsx"
    window.open(link, '_blank')
  }

  OnFileSelect(fileInput) {
    this.FileList = [];
    this.PreFileList = [];
    for (var i = 0; i < fileInput.target.files.length; i++) {
      if (fileInput.target.files[i].type == 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet') {
        this.files[i] = fileInput.target.files[i];
        this.FileName = this.files[i].name;
        this.PreFileList[i] = { 'file': this.files[i], 'FILE_NAME': this.FileName, 'V_SEQ': i + 1 };
      }
      else {
        this.modal.error('Invalid format files please enter file .xlsx', this.viewref)
      }
    }
    this.UpLoad();
    this.FileList = this.PreFileList
    this.CreateDetailRow(this.FileList.length);
  }

  UpLoad = () => {
    this.ErrorMsg = [];
    this.formData = new FormData();
    for (var i = 0; i < this.files.length; i++) {
      this.formData.append('file', this.files[i]);
    }
    this.Http.postFile('SL', 'SNSE001N_UploadFiles', this.formData)
      .subscribe(res => {
        this.FileNameList = res.Error[0];
        this.DataList = [];
        this.Http.get('SL', 'SNSE001_N_GetTempData')
          .subscribe(res => {
            this.DataList = res.Table;
            if (this.DataList.length > 0) {
              this.ShowChk = true;
            }
            else {
              this.ShowChk = false;
            }
          });

      });
  }

  clickProcessLog(err: any) {
    this.ErrorParams = [];
    this.ErrorMsg = [];
    err.forEach((e) => {
      this.ErrorParams.push({ 'FILE_NAME': e });
    });
    this.Http.post('SL', 'SNSE001_N_getErrorData', this.ErrorParams)
      .subscribe(res2 => {
        for (var i = 1; i <= this.ErrorParams.length; i++) {
          res2["Table" + i].forEach((msg) => {
            this.ErrorMsg.push({ 'MESSAGE': 'File : ' + msg.FILE_NAME + ' error on ' + msg.ERROR_TYPE + ' ' + msg.COLUMN_NAME + ' is ' + msg.ERROR_DESCRIPTION });
            this.ErrorMsg = this.ErrorMsg.slice();
          });
        }
        if (this.ErrorMsg.length > 0) {
          this.dialogProcess.OpenDialog();
        }
        else {
          this.modal.info('Process completed.', this.viewref)
          this.DataList = [];
          this.FileList = [];
          this.PreFileList = [];

          this.Http.post('SL', 'SNSE215_ChangeStatus', this.ErrorParams)
            .subscribe(res2 => {
            });
        }
      });
  }

  Close() {
    this.dialogProcess.Close();
    this.ErrorMsg = [];
  }

  CreateDetailRow(tblIndex) {
    let currentMaxRow: number = this.DataList.length || 0;
    let nextMaxRow: number = (Math.floor(currentMaxRow / 10) + 1) * 10;
    if (currentMaxRow - tblIndex <= 2) {
      for (let i = currentMaxRow; i < nextMaxRow; i++) {
        this.DataList.push({
          SEQ: i
        });
      }
      this.DataList = this.DataList.slice();
    }
  }

  ConfirmUpload() {
    this.DataList.some
    let foundErr = this.DataList.some(x => x.REMARK)
    if (foundErr) {
      this.modal.warning('Please Check Error on Column Message.', this.viewref)
    }
    else {
      this.modal.confirm('Do you want to upload data?', this.viewref, this.ClickUpLoad)
    }




   
  }

  ClickUpLoad = () => {
    this.Http.post('SL', 'SNSE001_N_Upload', this.DataList)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.clickProcessLog(this.FileNameList);
        }
        else {
          this.modal.info(res.Table[0].MESSAGE, this.viewref)
        }
      });
  }
}
