import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Globals } from 'src/app/core/global';
import { ModalService } from 'src/app/core/modal.service';
import { SelectionModel } from '@angular/cdk/collections';

enum PageAction {
  Search = 0,
  Detail,
  Retrive
}

@Component({
  selector: 'snse005_n',
  templateUrl: './SNSE005_N.component.html',
  styleUrls: ['./SNSE005_N.component.css']
})

export class SNSE005_NComponent implements OnInit {


  constructor(
    private Http: HttpService,
    private global: Globals,
    private modal: ModalService,
    private viewRef: ViewContainerRef
  ) { }

  @ViewChild("dialogMain", { static: false }) dialogMain: any;
  @ViewChild("dialog", { static: false }) dialog: any;
  @ViewChild("dialogType", { static: false }) dialogType: any;
  @ViewChild("dialogCurr", { static: false }) dialogCurr: any;
  @ViewChild("dialogLog", { static: false }) dialogLog: any;
  @ViewChild("dialogReport", { static: false }) dialogReport: any;

  public ListLog: any = [];
  public params: any = {};
  public dataHead: any = {};
  public MsgLog: any = [];

  public isAdd: boolean = false;

  public selection = new SelectionModel<any>(true, []);
  public DataIsSelected: any = [];
  public PageAction: number;
  public formData: any = null;
  public formData2: any = null;

  public tableData: any = [];
  public tableData2: any = [];
  public TOT_AMOUNT = 0
  public EXPORT_PRICE = 0
  public TOT_ORDER = 0
  public IsSearch: boolean = true;
  public IsDiff: number = 0;
  public params2: any = {}

  public files: any = [];
  public FileName: string = ""

  public tblFooter: any = [
    {
      fieldName: "PART_NO",
      value: "Total",
      show: true
    },
    {
      fieldName: "ORDER_QTY",
      show: true
    },
    {
      fieldName: "AMOUNT",
      show: true
    }

  ]

  public tblFooter2: any = [
    {
      fieldName: "PART_NO",
      value: "Total",
      show: true
    },
    {
      fieldName: "ORDER_QTY",
      show: true
    },
    {
      fieldName: "AMOUNT",
      show: true
    }

  ]

  public ConfigCustomer: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Customer",
    SourceController: "SL",
    SourceMethodName: "SNSE005_N_GetCustomer",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public ConfigBranch: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Customer Branch",
    SourceController: "SL",
    SourceMethodName: "SNSE005_N_GetBranch",
    NoOfShowRecords: 25,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      CUSTOMER_CODE: null
    },
  }

  public ConfigOrder: any = {
    ColName: "LOOKUP_TEXT",
    ColValue: "",
    PlaceholderText: "Select Order No",
    SourceController: "SL",
    SourceMethodName: "SNSE005_N_GetOrder",
    NoOfShowRecords: 25,
    MinLengthSearch: 0,
    UpperCase: true,
    SourceParams: {
      CUSTOMER_CODE: null
    },
  }

  public ConfigOrderFrom: any = {
    ColName: "LOOKUP_TEXT",
    ColValue: "",
    PlaceholderText: "Select Order No",
    SourceController: "SL",
    SourceMethodName: "SNSE005_N_GetOrder",
    NoOfShowRecords: 25,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      CUSTOMER_CODE_FROM: null
    },
  }

  public ConfigOrderTo: any = {
    ColName: "LOOKUP_TEXT",
    ColValue: "",
    PlaceholderText: "Select Order No",
    SourceController: "SL",
    SourceMethodName: "SNSE005_N_GetOrder",
    NoOfShowRecords: 25,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      CUSTOMER_CODE_TO: null
    },
  }

  public ConfigPartNo: any = {
    ColName: "PART_NAME_TXT",
    PlaceholderText: "Select Part No",
    SourceController: "SL",
    SourceMethodName: "SNSE005_N_GetPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public ConfigPartNoAdd: any = {
    ColName: "PART_NAME_TXT",
    PlaceholderText: "Select Part No",
    SourceController: "SL",
    SourceMethodName: "SNSE005_N_GetPartNoAdd",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      CUSTOMER_CODE: '',
      ORDER_DATE: '',
      CURRENCY_CODE: ''
    },
    UpperCase: true
  }

  ngOnInit() {
    this.TOT_AMOUNT = 0
    this.EXPORT_PRICE = 0
    this.TOT_ORDER = 0

  }

  public delay(ms: number) {
    return new Promise(resolve => setTimeout(resolve, ms));
  }

  public SetPartNo2(row, data) {

    data.PART_NO = null;
    data.PART_NAME = null;
    data.UNIT_PRICE = null;
    data.EXPORT_PRICE = null;

    data.RETAIL_PRICE_B = null;
    data.RETAIL_PRICE_C = null;
    data.STANDARD_COST = null;
    data.AVERAGE_COST = null;

    var param: any = {};
    var gMsg = '';

    param.PART_NO = row.PART_NO;
    if (param.PART_NO) {
      param.CUSTOMER_CODE = this.dataHead.CUSTOMER_CODE;
      param.ORDER_DATE = this.dataHead.ORDER_DATE;
      param.CURRENCY_CODE = this.dataHead.CURRENCY_CODE;

      this.Http.post('SL', 'SNSE005_N_GetPartInfo', param)
        .subscribe(res => {

          if (res.Table != '') {
            var dataCheck = res.Table[0];
            if (dataCheck.STATUS == 'ERROR') {
              this.modal.warning(dataCheck.MESSAGE, this.viewRef);
            } else {

              var Dup: boolean = false;
              this.tableData2.forEach((e) => {
                if (e.PART_NO == row.PART_NO) {
                  Dup = true;
                }
              });

              if (Dup == false) {
                var dataPart = res.Table1[0];

                data.PART_NO = dataPart.PART_NO;
                data.PART_NAME = dataPart.PART_NAME;
                data.UNIT_PRICE = dataPart.EXPORT_PRICE
                data.EXPORT_PRICE = dataPart.EXPORT_PRICE;
                data.RETAIL_PRICE_B = dataPart.RETAIL_PRICE_B;
                data.RETAIL_PRICE_C = dataPart.RETAIL_PRICE_C;
                data.STANDARD_COST = dataPart.STANDARD_COST;
                data.AVERAGE_COST = dataPart.AVERAGE_COST;
                data.SALES_PACKAGE = dataPart.SALES_PACKAGE;
              }
              else {
                data.PART_NO = '';
                this.modal.warning("Cannot Input Duplicate Record, Please Check.", this.viewRef);
              }
            }

            this.tableData2 = this.tableData2.slice();
            this.tblFooter2 = this.tblFooter2.slice();
            

          } else {
            this.modal.warning('Error checking part no', this.viewRef);
          }

        });
    }

  }

  public SetPartNo(row, data) {

    data.PART_NO = null;
    data.PART_NAME = null;
    data.UNIT_PRICE = null;
    data.EXPORT_PRICE = null;

    data.RETAIL_PRICE_B = null;
    data.RETAIL_PRICE_C = null;
    data.STANDARD_COST = null;
    data.AVERAGE_COST = null;

    var param: any = {};
    var gMsg = '';

    param.PART_NO = row.PART_NO;
    if (param.PART_NO) {
      param.CUSTOMER_CODE = this.params.CUSTOMER_CODE;
      param.ORDER_DATE = this.params.DSP_ORDER_DATE;
      param.CURRENCY_CODE = this.params.CURRENCY_CODE;

      this.Http.post('SL', 'SNSE005_N_GetPartInfo', param)
        .subscribe(res => {

          if (res.Table != '') {
            var dataCheck = res.Table[0];
            if (dataCheck.STATUS == 'ERROR') {
              this.modal.warning(dataCheck.MESSAGE, this.viewRef);
            } else {

              var Dup: boolean = false;
              this.tableData.forEach((e) => {
                if (e.PART_NO == row.PART_NO) {
                  Dup = true;
                }
              });

              if (Dup == false) {
                var dataPart = res.Table1[0];

                data.PART_NO = dataPart.PART_NO;
                data.PART_NAME = dataPart.PART_NAME;
                //data.UNIT_PRICE = dataPart.UNIT_PRICE
                data.UNIT_PRICE = dataPart.EXPORT_PRICE;
                data.EXPORT_PRICE = dataPart.EXPORT_PRICE;
                data.RETAIL_PRICE_B = dataPart.RETAIL_PRICE_B;
                data.RETAIL_PRICE_C = dataPart.RETAIL_PRICE_C;
                data.STANDARD_COST = dataPart.STANDARD_COST;
                data.AVERAGE_COST = dataPart.AVERAGE_COST;

                data.SALES_PACKAGE = dataPart.SALES_PACKAGE;
              }
              else {
                data.PART_NO = '';
                this.modal.warning("Cannot Input Duplicate Record, Please Check.", this.viewRef);
              }
            }
           
            this.tableData = this.tableData.slice();
            this.tblFooter = this.tblFooter.slice();

          } else {
            this.modal.warning('Error checking part no', this.viewRef);
          }

        });
    }
  }

  //-------------For Report---------------

  public SelectedCustomerFrom(event) {
    this.params2.CUSTOMER_CODE_FROM = event.CUSTOMER_CODE
    this.params2.ORDER_NO_FROM = null;

    this.ConfigOrderFrom.SourceParams.CUSTOMER_CODE = event.CUSTOMER_CODE;
  }

  public SelectedCustomerTo(event) {
    this.params2.CUSTOMER_CODE_TO = event.CUSTOMER_CODE
    this.params2.ORDER_NO_TO = null;

    this.ConfigOrderTo.SourceParams.CUSTOMER_CODE = event.CUSTOMER_CODE;
  }

  public SelectedOrderNoFrom(event) {
    this.params2.ORDER_NO_FROM = event.ORDER_NO;
  }

  public SelectedOrderNoTo(event) {
    this.params2.ORDER_NO_TO = event.ORDER_NO;
  }

  //--------------------------------------

  public SelectedCust(event) {

    this.params.CUSTOMER_CODE = event.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = event.CUSTOMER_NAME

    this.params2.CUSTOMER_CODE_FROM = event.CUSTOMER_CODE
    this.ConfigOrderFrom.SourceParams.CUSTOMER_CODE = event.CUSTOMER_CODE;
    this.params2.CUSTOMER_CODE_TO = event.CUSTOMER_CODE
    this.ConfigOrderTo.SourceParams.CUSTOMER_CODE = event.CUSTOMER_CODE;

    this.params.BRANCH_CODE = event.BRANCH_CODE;
    this.params.BRANCH_NAME = event.BRANCH_NAME;

    this.params.COUNTRY = event.COUNTRY;
    this.params.CURRENCY_CODE = event.CURRENCY_CODE;
    this.params.PAYMENT_TERM = event.PAYMENT_TERM;
    this.params.PRICE_TERM_CODE = event.PRICE_TERM_CODE;
    this.params.EXCHANGE_RATE = event.EXCHANGE_RATE;

    this.ConfigPartNo.SourceParams.DATA = this.params;
    this.ConfigBranch.SourceParams.CUSTOMER_CODE = event.CUSTOMER_CODE;
    this.ConfigOrder.SourceParams.CUSTOMER_CODE = event.CUSTOMER_CODE;
  }

  public SelectedCust2(event) {

    this.dataHead.CUSTOMER_CODE = event.CUSTOMER_CODE;
    this.dataHead.CUSTOMER_NAME = event.CUSTOMER_NAME

    this.dataHead.BRANCH_CODE = event.BRANCH_CODE;
    this.dataHead.BRANCH_NAME = event.BRANCH_NAME;

    this.dataHead.COUNTRY = event.COUNTRY;
    this.dataHead.CURRENCY_CODE = event.CURRENCY_CODE;
    this.dataHead.PAYMENT_TERM = event.PAYMENT_TERM;
    this.dataHead.PRICE_TERM_CODE = event.PRICE_TERM_CODE;
    this.dataHead.EXCHANGE_RATE = event.EXCHANGE_RATE;

    this.ConfigPartNoAdd.SourceParams.CUSTOMER_CODE = event.CUSTOMER_CODE;

    this.ConfigPartNoAdd.SourceParams.CURRENCY_CODE = event.CURRENCY_CODE;
    this.CheckOrderExists();
  }

  public OrderSelected(event) {

    this.params.ORDER_NO = event.ORDER_NO;
    this.params.ORDER_DATE = event.ORDER_DATE;
    this.params.DSP_ORDER_DATE = event.DSP_ORDER_DATE;

    this.params2.ORDER_NO_FROM = event.ORDER_NO;
    this.params2.ORDER_NO_TO = event.ORDER_NO;

    this.params.LAST_UPD_NAME = event.LAST_UPD_NAME;
    this.params.LAST_UPD_DATE = event.LAST_UPD_DATE;

    this.params.BO_FLAG = event.BO_FLAG;
    this.params.DELIVERY_CODE = event.DELIVERY_CODE;
    this.params.ORDER_CLASS = event.ORDER_CLASS;
    this.params.ORDER_CLASS_TEXT = event.ORDER_CLASS_TEXT;

    if (this.params.ORDER_NO) {

      this.Search();
    }
    else {
      this.tableData = []
    }

  }

  private Search() {

    this.tableData = []
    this.Http.post('SL', 'SNSE005_N_GetData', this.params)
      .subscribe(res => {
        this.tableData = res.Table;
      //  this.SummaryAmount();
        let formattedDt = this.DateToString(new Date());
        //--- Not allow to add if not today
        if (this.params.ORDER_DATE != formattedDt) {
          this.isAdd = false;
          return;
        }
        this.isAdd = true;

        if (this.tableData.length > 0) {

          this.tableData.forEach((e) => {

            //e.ITEM_NO = index + 1

            if (e.STATUS == 'UA' || e.STATUS == 'ER' || e.STATUS == 'C') {
              this.selection.select(e)
              e.BK_ORDER_QTY = 0;
              e.BK_AMOUNT = 0;
              e.BK_RETAIL_B = 0;
              e.BK_RETAIL_C = 0;
              e.BK_STD_AMT = 0;
              e.BK_AVG_AMT = 0;
              e.BK_NET_AMT_C = 0;
              e.BK_NET_AMT_B = 0;
              e.BK_UNIT_C = 0;
              e.BK_UNIT_B = 0;
            }
            else {
              e.Chk_Status = 'N';
              e.BK_ORDER_QTY = e.ORDER_QTY;
              e.BK_AMOUNT = e.AMOUNT;
              e.BK_RETAIL_B = e.RETAIL_AMT_B;
              e.BK_RETAIL_C = e.RETAIL_ATM_C;
              e.BK_STD_AMT = e.STANDARD_AMT;
              e.BK_AVG_AMT = e.AVERAGE_AMT;
              e.BK_NET_AMT_C = e.NET_AMT_C;
              e.BK_NET_AMT_B = e.NET_AMT_B;
              e.BK_UNIT_C = e.UNIT_PRICE_C;
              e.BK_UNIT_B = e.UNIT_PRICE_B;
            }
          });
          this.tableData.push({
            'EDIT': 'ADD',
            'ITEM_NO': null,
            'PART_NO': null,
            'PART_NAME': null,
            'ORDER_QTY': null,
            'UNIT_PRICE': null,
            'EXPORT_PRICE': null,
            'AMOUNT': null,
            'STATUS': null
          });
          this.tableData = this.tableData.slice();
          this.PageAction = PageAction.Retrive;


        }
      })
  }

  private DateToString(pDate) {

    let day = pDate.getDate();
    let year = pDate.getFullYear()
    let month = pDate.getMonth() + 1;

    let newMonth = month.toString().length < 2 ? 0 + '' + month : month;
    day = day.toString().length < 2 ? 0 + '' + day : day;
    //this.Month = newMonth.toString();
    return day + '-' + this.GetMonthName(newMonth) + '-' + year;
  }

  private GetMonthName(pValue) {

    var returnValue;

    if (pValue == '04') {
      returnValue = 'Apr';
    } else if (pValue == '05') {
      returnValue = 'May';
    } else if (pValue == '06') {
      returnValue = 'Jun';
    } else if (pValue == '07') {
      returnValue = 'Jul';
    } else if (pValue == '08') {
      returnValue = 'Aug';
    } else if (pValue == '09') {
      returnValue = 'Sep';
    } else if (pValue == '10') {
      returnValue = 'Oct';
    } else if (pValue == '11') {
      returnValue = 'Nov';
    } else if (pValue == '12') {
      returnValue = 'Dec';
    } else if (pValue == '01') {
      returnValue = 'Jan';
    } else if (pValue == '02') {
      returnValue = 'Feb';
    } else if (pValue == '03') {
      returnValue = 'Mar';
    }
    return returnValue;
  }

  public CheckboxChange(event, data) {
    if (event.checked && (data.STATUS_CODE == 'N' || data.STATUS_CODE == 'B')) {
      data.STATUS = 'C'
    }
    else {
      data.STATUS = data.STATUS_CODE;
    }
    //this.SummaryAmount();
  }

  public CheckboxChange2(event, data) {
    if (event.checked) {
      data.STATUS = 'C'
    }
    else {
      data.STATUS = data.STATUS_CODE;
    }
    this.SummaryAmount2();
  }

  public AppendRow(Item) {
    Item.STATUS = 'N'
    Item.AMOUNT = 0;
    var max = 0;
    for (var i = 0; i < this.tableData.length; i++) {
      if (this.tableData[i].ITEM_NO > max) {
        max = this.tableData[i].ITEM_NO;
      }
      if (this.tableData[i].EDIT === "ADD") {
        this.tableData[i].EDIT = 'DEL';
        this.tableData[i].ITEM_NO = max + 1;
      }
    }

    this.tableData.push({
      'EDIT': 'ADD',
      'ITEM_NO': null,
      'PART_NO': null,
      'PART_NAME': null,
      'ORDER_QTY': null,
      'UNIT_PRICE': null,
      'EXPORT_PRICE': null,
      'AMOUNT': null,
      'STATUS': null
    });
    this.tableData = this.tableData.slice();
  }

  public AppendRow2(Item) {
    Item.STATUS = 'N'
    Item.AMOUNT = 0;
    for (var i = 0; i < this.tableData2.length; i++) {
      if (this.tableData2[i].EDIT === "ADD") {
        this.tableData2[i].EDIT = 'DEL';
        this.tableData2[i].ITEM_NO = this.tableData2.length;
      }
    }
    this.tableData2.push({
      'EDIT': 'ADD',
      'ITEM_NO': null,
      'PART_NO': null,
      'PART_NAME': null,
      'ORDER_QTY': null,
      'UNIT_PRICE': null,
      'EXPORT_PRICE': null,
      'AMOUNT': null,
      'STATUS': null
    });
    this.tableData2 = this.tableData2.slice();

  }

  public DeleteRow(Item) {
    if (this.PageAction == PageAction.Retrive) {
      let index = this.tableData.findIndex(x => x == Item)
      this.tableData.splice(index, 1);
      if (this.tableData.find(e => e.EDIT === 'ADD') == undefined) {
        this.tableData.push({
          'EDIT': 'ADD',
          'ITEM_NO': null,
          'PART_NO': null,
          'PART_NAME': null,
          'ORDER_QTY': null,
          'UNIT_PRICE': null,
          'EXPORT_PRICE': null,
          'AMOUNT': null,
          'STATUS': null
        });
      }

      //this.SummaryAmount();
      //this.tableData = this.tableData.slice();


    }
  }

  public DeleteRow2(Item) {
    var itemNo;
    itemNo = Item.ITEM_NO;
    //---------- Remove row ---------------------
    this.tableData2 = this.tableData2.filter(obj => obj !== Item);

    //for (var i = 0; i < this.tableData2.length; i++) {
    //  if (this.tableData2[i].ITEM_NO > itemNo) {
    //    this.tableData2[i].ITEM_NO = this.tableData2[i].ITEM_NO - 1;
    //  }
    //}

    this.tableData2.forEach((e, index) => {
      e.ITEM_NO = index + 1;
    });

    this.tableData2 = this.tableData2.slice();
    this.SummaryAmount2();
  }

  public CalculateAmount(event, data, iView) {
    if (data.ORDER_QTY % data.SALES_PACKAGE > 0) {
      this.modal.warning("Invalid value number, Please check. The sales package is " + data.SALES_PACKAGE + " .", this.viewRef);
      data.ORDER_QTY = data.ORDER_QTY + (data.SALES_PACKAGE - (data.ORDER_QTY % data.SALES_PACKAGE));
    }
    if (data.UNIT_PRICE && data.ORDER_QTY) {
      data.AMOUNT = data.UNIT_PRICE * data.ORDER_QTY
    }

    if (iView == 1) {
      //this.SummaryAmount();
    } else {
      this.SummaryAmount2();
    }


  }

  public ConfirmDelete() {
    if (this.formData) {
      if (this.formData.CHK_DUP != 'Y') {
        if (this.formData.EDIT) {
          this.modal.warning('Cannot Delete this Data.', this.viewRef);
        }
        else {
          this.modal.confirm('Do you want to delete data?', this.viewRef, this.Delete)
        }
      }
      else {
        this.modal.warning('Cannot Delete this Data.', this.viewRef);
      }
    }
    else {
      this.modal.warning('Please select data.', this.viewRef);
    }
  }

  public Delete = () => {
    this.Http.post('SL', 'SNSE005_N_Delete', this.formData)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Delete Successful.', this.viewRef);
          this.Search()
          this.formData = null;
        } else {
          this.modal.error('No change to delete. Something went wrong.', this.viewRef);
        }
      })
  }

  public ConfirmSave() {

    this.DataIsSelected = []
    this.tableData.forEach((e, index) => {
      if ((e.CHK_DUP == 'N' && e.STATUS == 'C') && e.EDIT != 'ADD') {
        this.DataIsSelected.push(e)
      }
      if ((e.EDIT == 'DEL' && e.PART_NO != null)) {

        e.CUSTOMER_CODE = this.params.CUSTOMER_CODE
        e.BRANCH_CODE = this.params.BRANCH_CODE
        e.ORDER_CLASS = this.params.ORDER_CLASS

        e.ORDER_NO = this.params.ORDER_NO
        e.BO_FLAG = this.params.BO_FLAG
        e.DELIVERY_CODE = this.params.DELIVERY_CODE
        e.EXCHANGE_RATE = this.params.EXCHANGE_RATE
        e.UNIT_PRICE_B = e.UNIT_PRICE * e.EXCHANGE_RATE
        e.RETAIL_AMT_B = e.RETAIL_PRICE_B * e.ORDER_QTY
        e.RETAIL_AMT_C = e.RETAIL_PRICE_C * e.ORDER_QTY
        e.NET_AMT_B = e.UNIT_PRICE_B * e.ORDER_QTY
        e.NET_AMT_C = e.UNIT_PRICE * e.ORDER_QTY
        e.AVERAGE_AMT = e.AVERAGE_COST * e.ORDER_QTY
        e.STANDARD_AMT = e.STANDARD_COST * e.ORDER_QTY
        this.DataIsSelected.push(e)
      }
    });



    if (this.DataIsSelected.length > 0) {
      this.MsgLog = []
      this.tableData.forEach((e) => {
        var gMsg = '';
        if ((e.PART_NO != null && e.PART_NO != '') && e.EDIT == 'DEL') {

          if (e.ORDER_QTY == '' || e.ORDER_QTY == 0 || e.ORDER_QTY == null) {
            gMsg = 'There is no order qty on part no. ' + e.PART_NO + ' - Item no. ' + e.ITEM_NO;
            this.MsgLog.push(gMsg)
            return;
          }

          if (e.UNIT_PRICE == '' || e.UNIT_PRICE == 0 || e.UNIT_PRICE == null) {
            gMsg = 'There is no unit price on part no. ' + e.PART_NO + ' - Item no. ' + e.ITEM_NO;
            this.MsgLog.push(gMsg)
            return;
          }
        }

      });

      if (this.MsgLog.length > 0) {
        this.dialogLog.OpenDialog();
        return;
      }

      if (this.params.CUSTOMER_CODE && this.params.ORDER_NO && this.params.ORDER_CLASS) {
        this.modal.confirm('Do you want to save changed?', this.viewRef, this.Save)
      }
      else {
        this.modal.warning('Please complete all information!', this.viewRef)
      }
    }
    else {
      this.modal.warning('There is no data change.', this.viewRef)
    }



  }

  public CloseDialogLog() {
    this.dialogLog.Close();
  }

  public ConfirmAdd() {
    this.dataHead.ORDER_NO = this.dataHead.ORDER_NO.replace(/\s/g, "");
    this.dataHead.ORDER_NO = this.dataHead.ORDER_NO.toUpperCase();
    if (this.dataHead.CUSTOMER_CODE && this.dataHead.ORDER_NO && this.dataHead.ORDER_CLASS && this.dataHead.BO_FLAG && this.dataHead.DELIVERY_CODE) {
      let found = this.tableData2.some(e => e.PART_NO)
      if (found) {
        this.MsgLog = []
        this.tableData2.forEach((e) => {
          var gMsg = '';
          if ((e.PART_NO != null && e.PART_NO != '') && e.EDIT == 'DEL') {

            if (e.ORDER_QTY == '' || e.ORDER_QTY == 0 || e.ORDER_QTY == null) {
              gMsg = 'There is no order qty on part no. ' + e.PART_NO + ' - Item no. ' + e.ITEM_NO;
              this.MsgLog.push(gMsg)
              return;
            }

            if (e.REMARK == 'This part not found in master!!') {
              gMsg = 'There is part not found in master on part no. ' + e.PART_NO + ' - Item no. ' + e.ITEM_NO;
              this.MsgLog.push(gMsg)
              return;
            }

          }

        });

        if (this.MsgLog.length > 0) {
          this.dialogLog.OpenDialog();
          return;
        }

        if (this.dataHead.CUSTOMER_CODE && this.dataHead.ORDER_NO && this.dataHead.ORDER_CLASS && this.dataHead.BO_FLAG && this.dataHead.DELIVERY_CODE) {
          this.Http.post("wPMS", "CheckOrderExists", this.dataHead)
            .subscribe(result => {
              if (result.Table.length > 0) {
                this.modal.warning('There is duplicate order no. in system. Please check!!!', this.viewRef);
                this.dataHead.ORDER_NO = '';
              } else {
          this.modal.confirm('Do you want to add new order?', this.viewRef, this.AddData)
              }
            })
        }
        else {
          this.modal.warning('Please complete all information!', this.viewRef)
        }
      } else {
        this.modal.warning('Not found item.', this.viewRef)
      }
    }
    else {
      this.modal.warning('Please complete all information!', this.viewRef)
    }
  }

  private Save = () => {
    this.Http.post('SL', 'SNSE005_N_Save', this.DataIsSelected)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Save Successful.', this.viewRef);
          this.Search()
        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewRef);
        }
      })
  }

  public CheckOrderExists() {
    this.dataHead.ORDER_NO = this.dataHead.ORDER_NO.replace(/\s/g, "");

    this.Http.post("wPMS", "CheckOrderExists", this.dataHead)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.modal.warning('There is duplicate order no. in system. Please check!!!', this.viewRef);
          this.dataHead.ORDER_NO = '';
        };

      })

  }

  public ClickNew() {
    this.IsSearch = false;
    this.FileName = '';
    this.dataHead = {};
    this.dataHead.BO_FLAG = 'Y'
    this.dataHead.DELIVERY_CODE = '03';
    this.dataHead.ORDER_DATE = new Date();
    this.ConfigPartNoAdd.SourceParams.ORDER_DATE = this.dataHead.ORDER_DATE;
    this.tableData2 = [];
    this.Prepare2();
  }

  public OrderDateAddChange() {
    this.ConfigPartNoAdd.SourceParams.ORDER_DATE = this.dataHead.ORDER_DATE;
  }

  private Prepare2() {

    this.tableData2 = []

    this.tableData2.push({
      'EDIT': 'ADD',
      'CUSTOMER_CODE': this.dataHead.CUSTOMER_CODE,
      'BRANCH_CODE': this.dataHead.BRANCH_CODE,
      'ORDER_CLASS': this.dataHead.ORDER_CLASS,
      'ORDER_NO': this.dataHead.ORDER_NO,
      'BO_FLAG': this.dataHead.BO_FLAG,
      'DELIVERY_CODE': this.dataHead.DELIVERY_CODE,
      'EXCHANGE_RATE': this.dataHead.EXCHANGE_RATE,

      'ITEM_NO': null,
      'PART_NO': null,
      'PART_NAME': null,
      'ORDER_QTY': null,
      'UNIT_PRICE': null,
      'EXPORT_PRICE': null,
      'AMOUNT': null,
      'STATUS': null
    });
    this.tableData2 = this.tableData2.slice();
    this.SummaryAmount2();
  }

  public Back() {
    this.IsSearch = true;
  }

  public OnFileSelect(fileInput) {
    this.files = fileInput.target.files;
    this.FileName = this.files[0].name;
  }


  public Upload() {
    this.dataHead.ORDER_NO = this.dataHead.ORDER_NO.replace(/\s/g, "");

    if (this.dataHead.CUSTOMER_CODE && this.dataHead.ORDER_NO && this.dataHead.ORDER_CLASS) {
      this.MsgLog = []
      var gMsg = '';
      if (this.files.length == 0) {
        this.modal.error('Please Open xlsx File First...', this.viewRef)
      } else {
        let formData = new FormData();
        formData.append('file', this.files[0]);

        //UPLOAD DATA
        this.Http.postFile('SL', 'SNSE005_N_Upload', formData)
          .subscribe(res => {
            if (res.Error.length <= 0) {

              //VALIDATE DATA
              this.Http.post('SL', 'SNSE005_N_CheckUploadPart', this.dataHead)
                .subscribe(res => {
                  if (res.Table[0].STATUS == "DONE") {
                    this.tableData2 = [];
                    var iQTY = 0, iAmount = 0;

                    //GET DATA
                    this.Http.get('SL', 'SNSE005_N_GetTempData')
                      .subscribe(res => {
                        this.tableData2 = res.Table;

                        if (this.tableData2.length > 0) {

                          this.tableData2.forEach((e) => {

                            //Check Lock Sales      
                            if (e.LOCK_SALES == 117) {
                              e.STATUS = 'B';
                            }

                            //Check Sales Package
                            if (e.ORDER_QTY % e.SALES_PACKAGE > 0) {
                              e.ORDER_QTY = e.ORDER_QTY + (e.SALES_PACKAGE - (e.ORDER_QTY % e.SALES_PACKAGE));
                            } else {
                              e.ORDER_QTY = e.ORDER_QTY;
                            }
                            e.AMOUNT = e.ORDER_QTY * e.UNIT_PRICE;

                            e.AVERAGE_AMT = e.AVERAGE_COST * e.ORDER_QTY
                            e.STANDARD_AMT = e.STANDARD_COST * e.ORDER_QTY
                            e.RETAIL_AMT_B = e.RETAIL_PRICE_B * e.ORDER_QTY;
                            e.RETAIL_AMT_C = e.RETAIL_PRICE_C * e.ORDER_QTY;

                            iQTY += e.ORDER_QTY
                            iAmount += e.AMOUNT

                            if (e.REMARK) {
                              gMsg = " Item no. " + e.ITEM_NO + ' Error checking ' + e.REMARK + "."
                              this.MsgLog.push(gMsg)
                            }

                          });

                          if (this.MsgLog.length > 0) {
                            this.dialogLog.OpenDialog();
                          }
                        }
                        this.tblFooter2[1].value = iQTY;
                        this.tblFooter2[2].value = iAmount;
                        this.tblFooter2 = this.tblFooter2.slice();
                        //this.tableData2 = this.tableData2.slice();
                        this.tableData2.push({
                          'EDIT': 'ADD',
                          'ITEM_NO': null,
                          'PART_NO': null,
                          'PART_NAME': null,
                          'ORDER_QTY': 0,
                          'UNIT_PRICE': null,
                          'EXPORT_PRICE': null,
                          'AMOUNT': 0,
                          'STATUS': null
                        });
                        this.tableData2 = this.tableData2.slice();

                      }, (err) => {
                        this.modal.error("Get data error, please contract support team", this.viewRef);
                      });
                  }
                }, (err) => {
                  this.modal.error("Validate data error, please contract support team", this.viewRef);
                });
            }
          }, (err) => {
            this.modal.error("Upload error, please contract support team", this.viewRef);
          });
      }
    }
    else {
      this.modal.warning('Please complete all information!', this.viewRef)
    }
  }

  private AddData = () => {

    if (this.tableData2.length == 0) {
      this.modal.warning('No data add', this.viewRef);
      return;
    }

    this.DataIsSelected = []
    this.tableData2.forEach((e, index) => {

      if (e.PART_NO != null) {
        e.CUSTOMER_CODE = this.dataHead.CUSTOMER_CODE;
        e.BRANCH_CODE = this.dataHead.BRANCH_CODE;
        e.ORDER_CLASS = this.dataHead.ORDER_CLASS;
        e.ORDER_NO = this.dataHead.ORDER_NO;
        e.BO_FLAG = this.dataHead.BO_FLAG;
        e.DELIVERY_CODE = this.dataHead.DELIVERY_CODE;
        e.ORDER_DATE = this.dataHead.ORDER_DATE;
        if (this.dataHead.ORDER_CLASS == 2) {
          e.SENT_BY = 'A';
          e.ORDER_TYPE = '1';
        } else if (this.dataHead.ORDER_CLASS == 3) {
          e.SENT_BY = 'S';
          e.ORDER_TYPE = '2';
        } else if (this.dataHead.ORDER_CLASS == 4) {
          e.SENT_BY = 'S';
          e.ORDER_TYPE = '3';
        }


        e.EXCHANGE_RATE = this.dataHead.EXCHANGE_RATE;
        e.UNIT_PRICE_B = e.UNIT_PRICE * e.EXCHANGE_RATE;
        e.RETAIL_AMT_B = e.RETAIL_PRICE_B * e.ORDER_QTY;
        e.RETAIL_AMT_C = e.RETAIL_PRICE_C * e.ORDER_QTY;
        e.NET_AMT_B = e.UNIT_PRICE_B * e.ORDER_QTY;
        e.NET_AMT_C = e.UNIT_PRICE * e.ORDER_QTY;
        e.AVERAGE_AMT = e.AVERAGE_COST * e.ORDER_QTY;
        e.STANDARD_AMT = e.STANDARD_COST * e.ORDER_QTY;
        this.DataIsSelected.push(e)
      }

    });

    this.Http.post('SL', 'SNSE005_N_Add', this.DataIsSelected)
      .subscribe(res => {
        this.IsSearch = true;
        this.params.CUSTOMER_CODE = this.dataHead.CUSTOMER_CODE;
        this.params.CUSTOMER_NAME = this.dataHead.CUSTOMER_NAME;
        this.params.BRANCH_CODE = this.dataHead.BRANCH_CODE;
        this.params.BRANCH_NAME = this.dataHead.BRANCH_NAME;
        this.params.ORDER_NO = this.dataHead.ORDER_NO;
        this.params.ORDER_DATE = this.dataHead.ORDER_DATE;
        this.params.CURRENCY_CODE = this.dataHead.CURRENCY_CODE;

        this.params.ORDER_CLASS_TEXT = this.dataHead.ORDER_CLASS;
        this.params.BO_FLAG = this.dataHead.BO_FLAG;
        this.params.DELIVERY_CODE = this.dataHead.DELIVERY_CODE;

        if (res.substring(0, 4) == "DONE") {
          this.Http.post('SL', 'SNSE215_ChangeStatusByOrder', this.params)
            .subscribe(res => {
              if (res.Table[0].STATUS == "DONE") {
                this.Http.post("SL", "SNSE005_N_GetOrderInfo", this.params)
                  .subscribe(async result => {
                    this.modal.info("Save data successfully.", this.viewRef);
                    if (result.Table.length > 0) {
                      this.OrderSelected(result.Table[0]);
                      function delay(ms: number) {
                        return new Promise(resolve => setTimeout(resolve, ms));
                      }
                      await delay(1200);
                      this.Search();
                    };
                  })
              }
              else {
                this.modal.warning("CHANGE STATUS ERROR", this.viewRef);
              }
            });
        } else {
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public openReport() {
    this.dialogReport.OpenDialog();
  }

  public CloseReport() {
    this.dialogReport.Close();
  }

  public GoToReport() {
    if (this.params2.CUSTOMER_CODE_FROM && this.params2.CUSTOMER_CODE_TO && this.params2.ORDER_NO_FROM && this.params2.ORDER_NO_TO) {
      this.global.GoToReport("PMS_RPT_SALES_SNSE005R", {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_CUST_CODE_FROM: this.params2.CUSTOMER_CODE_FROM,
        P_CUST_CODE_TO: this.params2.CUSTOMER_CODE_TO,
        P_ORDER_NO_FROM: this.params2.ORDER_NO_FROM,
        P_ORDER_NO_TO: this.params2.ORDER_NO_TO
      })
    }
    else {
      this.modal.warning("Please fill Customer Code Or Order No.", this.viewRef);
    }
  }

  //private SummaryAmount() {

  //  var iQTY: number;
  //  var iAmount: number;

  //  iQTY = 0;
  //  iAmount = 0;

  //  this.IsDiff = 0;
  //  for (var i = 0; i < this.tableData.length; i++) {

  //    if (this.tableData[i].UNIT_PRICE != this.tableData[i].EXPORT_PRICE) {
  //      this.IsDiff = 1;
  //      //console.log('Diff price', this.tableData[i].UNIT_PRICE + ' ' + this.tableData[i].EXPORT_PRICE)
  //    }

  //    if (this.tableData[i].PART_NO != null) {
  //      iQTY = iQTY + this.tableData[i].ORDER_QTY;
  //      iAmount = iAmount + this.tableData[i].AMOUNT;

  //    }
  //  }

  //  this.tblFooter[1].value = iQTY;
  //  this.tblFooter[2].value = iAmount;   
  //  this.tableData = this.tableData.slice();
  //  this.tblFooter = this.tblFooter.slice();
  //}

  private SummaryAmount2() {

    var iQTY: number;
    var iAmount: number;

    this.tableData2 = this.tableData2.slice();

    iQTY = 0;
    iAmount = 0;

    for (var i = 0; i < this.tableData2.length; i++) {

      if (this.tableData2[i].STATUS != 'C' && this.tableData2[i].PART_NO != null) {

        iQTY = iQTY + this.tableData2[i].ORDER_QTY;
        iAmount = iAmount + this.tableData2[i].AMOUNT;

      }
    }

    this.tblFooter2[1].value = iQTY;
    this.tblFooter2[2].value = iAmount;
    this.tblFooter2 = this.tblFooter2.slice();
    this.tableData2 = this.tableData2.slice();
  }

  public DownloadTemplate() {
    let link = "assets/templates/SaleExport_NonDragon_Upload_Template.xlsx"
    window.open(link, '_blank')
  }

  private isNumeric(number) {
    if (typeof number == "number") {
      return true;
    }
    else {
      return false;
    }
  }
}
