import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { AuthService } from 'src/app/core/auth-service.service';

enum PageAction {
  Search = 0,
  Detail,
  Retrive
}

@Component({
  selector: 'snse025_n',
  templateUrl: './SNSE025_N.component.html',
  styleUrls: ['./SNSE025_N.component.css']
})



export class SNSE025_NComponent implements OnInit {

  constructor(
    private Http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private auth: AuthDecode,
    private authService: AuthService
  ) { }

  public params: any = {};
  public params2: any = {};

  public TableData2: any = [];
  public TableData: any = [];
  public OldTableData: any = [];

  public tblFooterDetail: any = [
    {
      fieldName: "INPUT_PART_NO",
      value: "Total",
      show: true
    },
    {
      fieldName: "BAL_QTY",
      show: true
    },
    {
      fieldName: "PACK_QTY",
      show: true
    }]

  public PageAction: number;
  public FormData: any = [];

  public IsSearch: boolean = true;
  public IsSelect: any;

  ngOnInit() { }

  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSE025_N_GetCustomerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedCustomerCode(values: any) {
    this.params.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = values.CUSTOMER_NAME;
    this.params.BRANCH_CODE = values.BRANCH_CODE;
    this.params.BRANCH_NAME = values.BRANCH_NAME;
    this.ngOnInit();
  }

  public lookupCaseNoConfig: any = {
    ColName: "LOOKUP_CASE_NO",
    PlaceholderText: "Select Case No",
    SourceController: "SL",
    SourceMethodName: "SNSE025_N_GetCaseNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedCaseNo(values: any) {
    this.params.CASE_NO = values.CASE_NO;
    this.params.SUB_CASE_NO = values.SUB_CASE_NO;
    this.params.SENT_BY = values.SENT_BY;
    //this.params.PACK_BY = values.PACK_BY;
    //this.params.DSP_PACK_BY = values.DSP_PACK_BY;
    this.params.PACK_DATE = values.PACK_DATE;
    //this.params.PACK_TIME = values.LAST_UPD_DATE;
    this.Search();
  }

  public lookupInstructionNoConfig: any = {
    ColName: "LOOKUP_INSTRUCTION_NO",
    PlaceholderText: "Select Instruction No",
    SourceController: "SL",
    SourceMethodName: "SNSE025_N_GetInstructionNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedInstructionNo(values: any, row: any) {
    let dup = this.TableData.some(e => e.INSTRUCTION_NO == values.INSTRUCTION_NO)
    if (dup) {
      row.INSTRUCTION_NO = null;
      row.ORDER_NO = null;
      row.ORDER_PART_NO = null;
      row.ACCEPT_PART_NO = null;
      row.BAL_QTY = null;
      row.ORDER_DATE = null;
      row.OLD_SUB_ITEM_NO = null;
      row.OVERSEA_FLAG_C = null;
      row.ORDER_CLASS = null;
      row.NET_WEIGHT = null;
      row.TRAIFF_CODE = null;
      row.DUTY_RATE = null;
      row.INVOICE_NO = null;
      row.INOVICE_DATE = null;
      row.ACCEPT_QTY = null;
      row.ITEM_NO = null;
      row.SUB_ITEM_NO = null;
      row.PICK_LOT_DATE = null;
      row.PICK_LOT_SEQ = null;
      row.PACK_QTY = 0;
      row.INPUT_PART_NO = null;
      this.TableData = this.TableData.slice()
      this.modal.warning('This Instruction cannot duplicate.', this.viewref);
    }
    else {
      row.INSTRUCTION_NO = values.INSTRUCTION_NO;
      row.ORDER_NO = values.ORDER_NO;
      row.ORDER_PART_NO = values.ORDER_PART_NO
      row.ACCEPT_PART_NO = values.ACCEPT_PART_NO
      row.BAL_QTY = values.BAL_QTY
      row.ORDER_DATE = values.ORDER_DATE
      row.OLD_SUB_ITEM_NO = values.OLD_SUB_ITEM_NO
      row.OVERSEA_FLAG_C = values.OVERSEA_FLAG_C
      row.ORDER_CLASS = values.ORDER_CLASS
      row.NET_WEIGHT = values.NET_WEIGHT
      row.TRAIFF_CODE = values.TRAIFF_CODE
      row.DUTY_RATE = values.DUTY_RATE
      row.INVOICE_NO = values.INVOICE_NO
      row.INOVICE_DATE = values.INOVICE_DATE
      row.ACCEPT_QTY = values.ACCEPT_QTY
      row.ITEM_NO = values.ITEM_NO
      row.SUB_ITEM_NO = values.SUB_ITEM_NO
      row.PICK_LOT_DATE = values.PICK_LOT_DATE
      row.PICK_LOT_SEQ = values.PICK_LOT_SEQ
      row.PACK_QTY = 0
      row.INPUT_PART_NO = null;
      this.TableData = this.TableData.slice()
    }
  }

  public SetSelectedNewInstructionNo(values: any, row: any) {
    let dup = this.TableData2.some(e => e.INSTRUCTION_NO == values.INSTRUCTION_NO)
    if (dup) {
      row.INSTRUCTION_NO = null;
      row.ORDER_NO = null;
      row.ORDER_PART_NO = null;
      row.ACCEPT_PART_NO = null;
      row.BAL_QTY = null;
      row.ORDER_DATE = null;
      row.OLD_SUB_ITEM_NO = null;
      row.OVERSEA_FLAG_C = null;
      row.ORDER_CLASS = null;
      row.NET_WEIGHT = null;
      row.TRAIFF_CODE = null;
      row.DUTY_RATE = null;
      row.INVOICE_NO = null;
      row.INOVICE_DATE = null;
      row.ACCEPT_QTY = null;
      row.ITEM_NO = null;
      row.SUB_ITEM_NO = null;
      row.PICK_LOT_DATE = null;
      row.PICK_LOT_SEQ = null;
      row.PACK_QTY = 0;
      row.INPUT_PART_NO = null;
      this.TableData2 = this.TableData2.slice()
      this.modal.warning('This Instruction cannot duplicate.', this.viewref);
    }
    else {
      row.INSTRUCTION_NO = values.INSTRUCTION_NO;
      row.ORDER_NO = values.ORDER_NO;
      row.ORDER_PART_NO = values.ORDER_PART_NO
      row.ACCEPT_PART_NO = values.ACCEPT_PART_NO
      row.BAL_QTY = values.BAL_QTY
      row.ORDER_DATE = values.ORDER_DATE
      row.OLD_SUB_ITEM_NO = values.OLD_SUB_ITEM_NO
      row.OVERSEA_FLAG_C = values.OVERSEA_FLAG_C
      row.ORDER_CLASS = values.ORDER_CLASS
      row.NET_WEIGHT = values.NET_WEIGHT
      row.TRAIFF_CODE = values.TRAIFF_CODE
      row.DUTY_RATE = values.DUTY_RATE
      row.INVOICE_NO = values.INVOICE_NO
      row.INOVICE_DATE = values.INOVICE_DATE
      row.ACCEPT_QTY = values.ACCEPT_QTY
      row.ITEM_NO = values.ITEM_NO
      row.SUB_ITEM_NO = values.SUB_ITEM_NO
      row.PICK_LOT_DATE = values.PICK_LOT_DATE
      row.PICK_LOT_SEQ = values.PICK_LOT_SEQ
      row.PACK_QTY = 0
      row.INPUT_PART_NO = null;
      this.TableData2 = this.TableData2.slice()
    }
  }

  private Search = () => {
    this.TableData = [];
    this.Http.post('SL', 'SNSE025_N_getData', this.params)
      .subscribe(res => {
        this.TableData = res.Table;
        this.TableData.push({
          'EDIT': 'ADD',
          'INSTRUCTION_NO': null,
          'ORDER_NO': null,
          'ORDER_PART_NO': null,
          'ACCEPT_PART_NO': null,
          'NG_DG': null,
          'INPUT_PART_NO': null,
          'BAL_QTY': null,
          'PACK_QTY': 0,
          'CUSTOMER_CODE': this.params.CUSTOMER_CODE,
          'BRANCH_CODE': this.params.BRANCH_CODE,
          'CASE_NO': this.params.CASE_NO,
          'SUB_CASE_NO': this.params.SUB_CASE_NO,
          'SENT_BY': this.params.SENT_BY,
          'PACK_BY': this.params.PACK_BY,
          'PACK_DATE': this.params.PACK_DATE,
          'CASE_SEQ': this.params.CASE_SEQ || 0
        });
        this.TableData = this.TableData.slice();
        this.PageAction = PageAction.Retrive;

        this.OldTableData = JSON.parse(JSON.stringify(this.TableData));

        if (this.TableData.length > 0) {
          this.params.PACK_BY = this.TableData[0].PACK_BY;
          this.params.DSP_PACK_BY = this.TableData[0].DSP_PACK_BY;
          //this.params.PACK_DATE = this.TableData[0].PACK_DATE;
          this.params.PACK_TIME = this.TableData[0].LAST_UPD_DATE;
        }
      })
  }

  public ChangePackQTY(data) {
    let index = this.TableData.findIndex(x => x.INSTRUCTION_NO == data.INSTRUCTION_NO)
    this.TableData[index].PACK_QTY = data.PACK_QTY;
    this.TableData = this.TableData.slice()
    if (data.PACK_QTY > 0) {
      if (data.PACK_QTY > data.BAL_QTY) {
        this.modal.warning('Pack Qty Must Be <= Bal. Qty', this.viewref);
        data.PACK_QTY = data.BAL_QTY;
      }
    } else {
      this.modal.warning('Pack Qty must be more than 0', this.viewref);
      data.PACK_QTY = 1;
    }

    var num = data.PACK_QTY % 1;
    if (num != 0) {
      this.modal.warning('Pack Qty must not be decimal', this.viewref);
      data.PACK_QTY = 1;
    }
  }

  public ChangeNewPackQTY(data) {
    let index = this.TableData2.findIndex(x => x.INSTRUCTION_NO == data.INSTRUCTION_NO)
    this.TableData2[index].PACK_QTY = data.PACK_QTY;
    this.TableData2 = this.TableData2.slice()
    if (data.PACK_QTY > 0) {
      if (data.PACK_QTY > data.BAL_QTY) {
        this.modal.warning('Pack Qty Must Be <= Bal. Qty', this.viewref);
        data.PACK_QTY = data.BAL_QTY;
      }
    } else {
      this.modal.warning('Pack Qty must be more than 0', this.viewref);
      data.PACK_QTY = 1;
    }

    var num = data.PACK_QTY % 1;
    if (num != 0) {
      this.modal.warning('Pack Qty must not be decimal', this.viewref);
      data.PACK_QTY = 1;
    }
  }

  public ConfirmSave() {
    let notchange = (JSON.stringify(this.OldTableData) == JSON.stringify(this.TableData))
    if (notchange) {
      this.modal.warning('There is no data change.', this.viewref)
    }
    else {
      let found = this.TableData.some(e => e.INSTRUCTION_NO)
      if (found) {
        let err = this.TableData.some(e => e.INSTRUCTION_NO && !e.INPUT_PART_NO)
        if (err) {
          this.modal.warning('Input Part No. cannot empty.', this.viewref)
        }
        else {
          let err = this.TableData.some(e => e.BAL_QTY < e.PACK_QTY)
          if (err) {
            this.modal.warning('Pack Qty Must Be <= Bal. Qty', this.viewref);
          }
          else {
            let err = this.TableData.some(e => e.INSTRUCTION_NO && e.PACK_QTY < 1)
            if (err) {
              this.modal.warning('Pack Qty must be more than 0', this.viewref)
            }
            else {
              this.modal.confirm('Do you want to update on this data?', this.viewref, this.Save)
            }
          }
        }
      } else {
        this.modal.warning('Not found item.', this.viewref)
      }
    }
  }

  private Save = () => {
    this.FormData = [];
    this.TableData.forEach((e) => {
      if (e.INSTRUCTION_NO && e.ORDER_NO && e.ORDER_PART_NO && e.INPUT_PART_NO) {
        this.FormData.push(e);
      }
    })
    this.Http.post('SL', 'SNSE025_N_Update', this.FormData)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Save Complete.', this.viewref);
          this.Search();

        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      })
  }

  public AppendRow() {
    for (var i = 0; i < this.TableData.length; i++) {
      if (this.TableData[i].EDIT === "ADD") {
        this.TableData[i].EDIT = 'DEL';
        this.TableData[i].ITEM = this.TableData.length;
      }
    }
    this.TableData.push({
      'EDIT': 'ADD',
      'INSTRUCTION_NO': null,
      'ORDER_NO': null,
      'ORDER_PART_NO': null,
      'ACCEPT_PART_NO': null,
      'NG_DG': null,
      'INPUT_PART_NO': null,
      'BAL_QTY': null,
      'PACK_QTY': 0,

      'CUSTOMER_CODE': this.params.CUSTOMER_CODE,
      'BRANCH_CODE': this.params.BRANCH_CODE,
      'CASE_NO': this.params.CASE_NO,
      'SUB_CASE_NO': this.params.SUB_CASE_NO,
      'SENT_BY': this.params.SENT_BY,
      'PACK_BY': this.params.PACK_BY,
      'PACK_DATE': this.params.PACK_DATE,
      'CASE_SEQ': this.params.CASE_SEQ || 0
    });
    this.TableData = this.TableData.slice();
  }

  public DeleteRow(Item) {
    if (this.PageAction == PageAction.Retrive) {
      let index = this.TableData.findIndex(x => x == Item)
      this.TableData.splice(index, 1);
      this.TableData = this.TableData.slice();
    }
  }

  public CheckInputPartNo(data) {
    data.INPUT_PART_NO = data.INPUT_PART_NO.trim().toUpperCase()
    if (data.INPUT_PART_NO != data.ACCEPT_PART_NO) {
      this.modal.warning('Value is not match.', this.viewref);
      data.INPUT_PART_NO = null;
    }
  }

  public Delete() {
    if (this.IsSelect) {
      this.modal.confirm("Do you want to delete record?", this.viewref, this.ConfirmDelete)
    } else {
      this.modal.warning("Plese select record on table for delete.", this.viewref)
    }
  }

  private ConfirmDelete = () => {
    this.Http.post('SL', 'SNSE025N_Delete', this.IsSelect)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.Search();
        }
        else {
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })
  }

  public IsSelectRow(data) {
    this.IsSelect = null;
    this.IsSelect = data
  }

  public ClickNew() {
    this.TableData2 = [];
    this.params2.CUSTOMER_CODE = null;
    this.params2.CUSTOMER_NAME = null;
    this.params2.BRANCH_CODE = null;
    this.params2.BRANCH_NAME = null;
    this.params2.SENT_BY = null;
    this.params2.CASE_NO = null;
    this.params2.SUB_CASE_NO = '0';
    this.params2.PACK_BY = this.authService.isAuthenticated() && this.auth.getDetail().ssNameEN;
    this.params2.PACK_TIME = new Date();
    this.IsSearch = false;
  }

  public Back() {
    this.IsSearch = true;
    this.params = {};
    this.TableData = [];
  }

  public SetSelectedCustomerCode2(values: any) {
    this.params2.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.params2.CUSTOMER_NAME = values.CUSTOMER_NAME;
    this.params2.BRANCH_CODE = values.BRANCH_CODE;
    this.params2.BRANCH_NAME = values.BRANCH_NAME;
    this.OnInitData();
  }

  private OnInitData() {
    this.TableData2 = [];
    this.params2.SENT_BY = null;
    this.params2.CASE_NO = null;
    this.params2.SUB_CASE_NO = '0';
    this.params2.PACK_BY = this.authService.isAuthenticated() && this.auth.getDetail().ssNameEN;
    this.params2.PACK_TIME = new Date();
  }

  public GetCaseNO() {
    this.Http.post('SL', 'SNSE025_N_GetCaseNo2', this.params2)
      .subscribe(res => {
        this.params2.CASE_NO = res.Table[0].CASE_NO
        this.params2.CASE_NO_OLD = res.Table[0].CASE_NO_OLD

        this.params2.SUB_CASE_NO = res.Table[0].SUB_CASE_NO;
        this.params2.PACK_BY = res.Table[0].PACK_BY;
        this.params2.PACK_DATE = res.Table[0].PACK_DATE;
        this.params2.PACK_TIME = res.Table[0].PACK_TIME;
        if (!this.params2.SUB_CASE_NO) {
          this.params2.SUB_CASE_NO = '0';
          this.params2.PACK_BY = this.authService.isAuthenticated() && this.auth.getDetail().ssNameEN;
          let pack_d = new Date();
          var monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun",
            "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
          ];
          this.params2.PACK_DATE = (pack_d.getDate() + "-" + monthNames[pack_d.getMonth()] + "-" + pack_d.getFullYear()).toString();
          this.params2.PACK_TIME = new Date();
        }
        this.Search2();
      })
  }

  public ConfirmSaveNewCase() {
    let found = this.TableData2.some(e => e.INSTRUCTION_NO)
    if (found) {
      let err = this.TableData2.some(e => e.INSTRUCTION_NO && !e.INPUT_PART_NO)
      if (err) {
        this.modal.warning('Input Part No. cannot empty.', this.viewref)
      }
      else {
        let err = this.TableData2.some(e => e.BAL_QTY < e.PACK_QTY)
        if (err) {
          this.modal.warning('Pack Qty Must Be <= Bal. Qty', this.viewref);
        }
        else {
          let err = this.TableData2.some(e => e.INSTRUCTION_NO && e.PACK_QTY < 1)
          if (err) {
            this.modal.warning('Pack Qty must be more than 0', this.viewref)
          }
          else {
            this.modal.confirm('Do you want to update on this data?', this.viewref, this.SaveNewCase)
          }
        }
      }
    }
    else {
      this.modal.warning('Not found item.', this.viewref)
    }
  }

  private SaveNewCase = () => {
    this.FormData = [];
    this.TableData2.forEach((e) => {
      e.CASE_NO_OLD = this.params2.CASE_NO_OLD
      if (e.INSTRUCTION_NO && e.ORDER_NO && e.ORDER_PART_NO && e.INPUT_PART_NO) {
        this.FormData.push(e);
      }
    })
    this.Http.post('SL', 'SNSE025_N_Insert', this.FormData)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Done.', this.viewref);
          this.params = this.params2
          this.TableData = [];
          this.TableData2 = [];
          this.IsSearch = true;
          if (this.params.CUSTOMER_CODE && this.params.BRANCH_CODE && this.params.SENT_BY) {
            this.Search();
            this.lookupInstructionNoConfig.SourceParams.DATA = this.params;
            this.lookupCaseNoConfig.SourceParams.DATA = this.params;
          }


        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      })
  }

  private Search2 = () => {
    this.TableData2 = [];
    this.Http.post('SL', 'SNSE025_N_getData', this.params2)
      .subscribe(res => {
        this.TableData2 = res.Table;
        this.TableData2.push({
          'EDIT': 'ADD',
          'INSTRUCTION_NO': null,
          'ORDER_NO': null,
          'ORDER_PART_NO': null,
          'ACCEPT_PART_NO': null,
          'NG_DG': null,
          'INPUT_PART_NO': null,
          'BAL_QTY': null,
          'PACK_QTY': 0,
          'CUSTOMER_CODE': this.params2.CUSTOMER_CODE,
          'BRANCH_CODE': this.params2.BRANCH_CODE,
          'CASE_NO': this.params2.CASE_NO,
          'SUB_CASE_NO': this.params2.SUB_CASE_NO,
          'SENT_BY': this.params2.SENT_BY,
          'PACK_BY': this.params2.PACK_BY,
          'PACK_DATE': this.params2.PACK_DATE,
          'CASE_SEQ': this.params2.CASE_SEQ || 0,
          'CASE_NO_OLD': this.params2.CASE_NO_OLD
        });
        this.TableData2 = this.TableData2.slice();
        this.PageAction = PageAction.Retrive;
      })
  }

  public NewAppendRow() {
    for (var i = 0; i < this.TableData2.length; i++) {
      if (this.TableData2[i].EDIT === "ADD") {
        this.TableData2[i].EDIT = 'DEL';
        this.TableData2[i].ITEM = this.TableData2.length;
      }
    }
    this.TableData2.push({
      'EDIT': 'ADD',
      'INSTRUCTION_NO': null,
      'ORDER_NO': null,
      'ORDER_PART_NO': null,
      'ACCEPT_PART_NO': null,
      'NG_DG': null,
      'INPUT_PART_NO': null,
      'BAL_QTY': null,
      'PACK_QTY': 0,

      'CUSTOMER_CODE': this.params2.CUSTOMER_CODE,
      'BRANCH_CODE': this.params2.BRANCH_CODE,
      'CASE_NO': this.params2.CASE_NO,
      'SUB_CASE_NO': this.params2.SUB_CASE_NO,
      'SENT_BY': this.params2.SENT_BY,
      'PACK_BY': this.params2.PACK_BY,
      'PACK_DATE': this.params2.PACK_DATE,
      'CASE_SEQ': this.params2.CASE_SEQ || 0,
      'CASE_NO_OLD': this.params2.CASE_NO_OLD
    });
    this.TableData2 = this.TableData2.slice();
  }

  public NewDeleteRow(Item) {
    if (this.PageAction == PageAction.Retrive) {
      let index = this.TableData2.findIndex(x => x == Item)
      this.TableData2.splice(index, 1);
      this.TableData2 = this.TableData2.slice();
    }
  }

  public lookupNewInstructionNoConfig: any = {
    ColName: "LOOKUP_INSTRUCTION_NO",
    PlaceholderText: "Select Instruction No",
    SourceController: "SL",
    SourceMethodName: "SNSE025_N_GetInstructionNo2",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params2
    },
    UpperCase: true
  }

  public selectedSentBy() {
    this.params.CASE_NO = null;
    this.params.SUB_CASE_NO = null;
    this.params.PACK_BY = null;
    this.params.PACK_TIME = null;
  }
}

