import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { ModalService } from 'src/app/core/modal.service';
import { HttpService } from 'src/app/core/http.service';
import { Globals } from 'src/app/core/global';


@Component({
  selector: 'SNSE039P',
  templateUrl: './SNSE039P.component.html',
  styleUrls: ['../saleorder.component.css']
})

export class SNSE039PComponent implements OnInit {

  constructor(
    private Http: HttpService,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private global: Globals
  ) { }


  public params: any = {};
  public tableData: any = [];

  ngOnInit() {
  }

  public ConfigInvoiceSeq: any = {
    ColName: "INVOICE_SEQ_DSP",
    PlaceholderText: "Select Invoice Seq",
    SourceController: "WH",
    SourceMethodName: "SNSE039PInvoiceSeqList",
    SourceParams: {
      DATA: this.params
    },
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  };



  public SetInvoiceSeq(values: any) {
    this.params.INVOICE_SEQ = values.INVOICE_SEQ;
    this.params.BEGIN_INVOICE_NO = values.BEGIN_INVOICE_NO;
    this.params.END_INVOICE_NO = values.END_INVOICE_NO;
  }

  private GoToReport() {
    this.global.GoToReport("PMS_RPT_SALES_SNSE039R_P_A4", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_INVOICE_NO_FROM: this.params.BEGIN_INVOICE_NO,
      P_INVOICE_NO_TO: this.params.END_INVOICE_NO
    });

  }

  public CheckDataPreview() {
    if (this.params.BEGIN_INVOICE_NO && this.params.END_INVOICE_NO) {

      this.Http.post('WH', 'SNSE039P_CheckDataReport', this.params)
        .subscribe(res => {
          if (res.Table.length > 0) {
            this.GoToReport()
          } else {
            this.modal.warning("No Data Found!", this.viewRef);
          }
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })
    }

    else {
      this.modal.warning('Please fill all data for print report!!', this.viewRef)
    }
  }

  public CheckDataReport() {
    if (this.params.BEGIN_INVOICE_NO && this.params.END_INVOICE_NO) {

      this.Http.post('WH', 'SNSE039P_SetPrintData', this.params)
      .subscribe(res => {
        if(res === "Exists") {
          this.modal.info("Please wait for printing.", this.viewRef);
        } else {
          this.modal.info("Not found data for printing.", this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })

      // this.Http.post('WH', 'SNSE039P_CheckDataReport', this.params)
      //   .subscribe(res => {
      //     if (res.Table.length > 0) {
      //       this.GoToReport()
      //     } else {
      //       this.modal.warning("No Data Found!", this.viewRef);
      //     }
      //   }, (err) => {
      //     console.log(err, 'err')
      //     this.modal.warning("Found an error, please contract support team", this.viewRef);
      //   })
    }

    else {
      this.modal.warning('Please fill all data for print report!!', this.viewRef)
    }
  }
}
