
import { Component, OnInit,  ViewChild, ViewContainerRef} from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';


import { ModalService } from 'src/app/core/modal.service';
import { MatDialog,  MAT_DIALOG_DATA } from '@angular/material/dialog';


@Component({
  selector: 'snsq005_001',
  templateUrl: './SNSQ005_001.component.html',
  styleUrls: ['./SNSQ005_001.component.css']
})

export class SNSQ005_001Component implements OnInit {

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    public dialog: MatDialog,

    private viewRef: ViewContainerRef
  ) { }

  @ViewChild("ShowDetail", { static: false }) dialogDetail;
  @ViewChild("dialogKit", { static: false }) dialogKit;
  @ViewChild("dialogDN", { static: false }) dialogDN;
  @ViewChild("dialogSubOrderBO", { static: false }) dialogSubOrderBO; 
  @ViewChild("dialogSubOrderBO_VOR", { static: false }) dialogSubOrderBO_VOR; 
  @ViewChild("dialogSubOrderAllocate", { static: false }) dialogSubOrderAllocate; 

  public PageTitle: string;
  public info: any = {};
  public partData: any = {};
  public ExiseTax: any = {};
  public PartOption: any = {};
  public stockData: any = {};
  public dataList: any = [];
  public dataDetail: any = {};

  public dataListETP: any = [];
  public dataListBackOrder: any = [];
  public dataListAllocate: any = [];
  public dataListChainPart: any = [];
  public dataListLocation: any = [];

  public dataListSuspTF: any = [];
  public dataListSusp: any = {};
  public dataListTF: any = {};

  private vendorETD: any = {};
  public findPO: any;
  public CustomerList: any;
  public tableData: any;
  public filter: any = [];
  public iActiveTab: number = 0;

  public partNumber: string;

  public dataDrilldown: any = [];

  
  public dataListKitDetail : any = [];
  public dataKitHeader : any = {};
  public hideCols: Array<string> = [];
  public designNoteList: any = [];
  public dataListSubOrderBO : any = [];
  public dataListSubOrderBO_VOR : any = [];
  public dataListSubOrderAllocate : any = [];

  public lookupConfig: any = {
    ColName: "LOOKUP_PART_VALUE",
    PlaceholderText: "Select Part",
    SourceController: "IC",
    SourceMethodName: "SNSQ005_GetPart",
    NoOfShowRecords: 50,
    UpperCase: true
  }

  public hideCol = ["EDIT","DELETE"]

  ngOnInit() {
    this.partNumber = '';
    this.partData.PART_NO = ''; //'402063HA0A'; //H210A3GFMA
    this.iActiveTab = 0;
    this.partData.SPPS_CODE = null;
    this.partData.DESIGN_NOTE_NUMBER = null;
  }

  public SetSelectedPart(value: any) {
    this.partData.PART_NO = value.PART_NO;
    this.partNumber = value.PART_NO

    this.GetDataTab1();
    this.SetActiveTab();
  }

  public TabChanged(event) {
    this.iActiveTab = event.index;
    this.SetActiveTab();
  }

  private SetActiveTab() {

    if (this.iActiveTab == 0) {

    } else if (this.iActiveTab == 1) {

    } else if (this.iActiveTab == 2) {
      this.GetDataTab3();
    } else if (this.iActiveTab == 3) {
      this.GetDataTab4();
    } else if (this.iActiveTab == 4) {

    } else if (this.iActiveTab == 5) {
      this.GetDataTab5();
    } else if (this.iActiveTab == 6) {
      this.GetDataTab6();
    }else if (this.iActiveTab == 7) {
      this.GetDataTab7();
    }
    

  }

  private GetDataTab1() {

    this.stockData = {};
    this.info = {};
    if (this.partData.PART_NO.length >= 3) {
      this.http.get("IC", "SNSQ005_GetPartInfo", this.partData.PART_NO)
        .subscribe(result => {
          this.partData = result.Table[0];
          this.stockData = result.Table1[0];
          this.info = result.Table2[0];
        })

      this.http.get("IC", "SNSQ005_GetPartInfo_G2", this.partData.PART_NO)
        .subscribe(result => {
          this.ExiseTax = result.Table[0] || {};
          this.PartOption = result.Table1[0] || {};
        })


    } else {

    }
  }

  public OpenSubOrderBO(event){
    this.http.post("IC","SNSQ005_GetSubOrderBO",event)
      .subscribe(res => {
        if(res.Table.length > 0){
          this.dataListSubOrderBO = res.Table
          this.dialogSubOrderBO.OpenDialog();
        }
      })
  }

  public OpenSubOrderAllocate(event){
    this.http.post("IC","SNSQ005_GetSubOrderAllocate",event)
      .subscribe(res => {
        if(res.Table.length > 0){
          this.dataListSubOrderAllocate = res.Table
          this.dialogSubOrderAllocate.OpenDialog();
        }
      })
  }
  public OpenSubOrderBOVOR(event){
    console.log("event",event);
    this.http.post("IC","SNSQ005_GetSubOrderBO_VOR",event)
      .subscribe(res => {
        if(res.Table.length > 0){
          this.dataListSubOrderBO_VOR = res.Table
          this.dialogSubOrderBO_VOR.OpenDialog();
        }
      })
  }
  public OpenSubOrderAllocateVOR(event){
    this.http.post("IC","SNSQ005_GetSubOrderAllocate",event)
      .subscribe(res => {
        if(res.Table.length > 0){
          this.dataListSubOrderAllocate = res.Table
          this.dialogSubOrderAllocate.OpenDialog();
        }
      })
  }
  
  private GetDataTab3() {
    this.http.get("IC", "SNSQ005_GetPartInfo_G3", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListBackOrder = result.Table; // Tab 3 : Back order
      })
  }

  private GetDataTab4() {
    this.http.get("IC", "SNSQ005_GetPartInfo_G4", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListAllocate = result.Table; // Tab 3 : Back order
      })
  }


  private GetDataTab5() {
    this.http.get("IC", "SNSQ005_GetPartInfo_G5", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListETP = result.Table; // Tab 5 : ETP
      })

  }

  private GetDataTab6() {
    this.http.get("IC", "SNSQ005_GetPartInfo_G6", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListChainPart = result.Table; // Tab 6 : dataListChainPart
      })
  }

  private GetDataTab7() {
    this.http.get("IC", "SNSQ005_GetPartInfo_G7", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListLocation = result.Table; // Tab 7
      })
  }


  public OpenSuspend() {
    this.dataListSuspTF = [];
    if (this.stockData.SUSPEND_QTY == 0) {
      return;
    }
    this.http.get("IC", "SNSQ005_GetPartInfo_SUS", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListSuspTF = result.Table;
      })
    this.dialogDetail.OpenDialog();

  }

  public OpenTransafer() {
    this.dataListSuspTF = [];
    if (this.stockData.TRANSFER_QTY == 0) {
      return;
    }
    this.http.get("IC", "SNSQ005_GetPartInfo_TF", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListSuspTF = result.Table;
      })
    this.dialogDetail.OpenDialog();
  }

  public OpenKitPart(){

    // if(this.partData.KIT_FLAG == 'N'){
    //   this.modal.warning('Cannot click if component part is "N"', this.viewRef);
    //   return;
    // }


    this.hideCols = [];
    this.hideCols.push("EDIT")
    this.dataListKitDetail = []
    this.dataKitHeader ={}
    this.http.get("IC", "SNSQ005_GetPartInfo_KIT", this.partData.PART_NO)
      .subscribe(result => {
        console.log(result)
        if(result.Table.length == 0){
          this.dataKitHeader = {};
          this.dataListKitDetail = []
        }else{
          this.dataKitHeader = result.Table[0];
          this.dataListKitDetail = result.Table1;
         
        }
        this.dialogKit.OpenDialog();
         
      })
  }

  Download() {

    if(!this.dataKitHeader.FILE_NAME){
      this.modal.warning("File not found!",this.viewRef)
      return
    }
    
    this.http.Download('TI', 'SNM130P_Download',{filename : this.dataKitHeader.FILE_NAME})
        .subscribe(res => {
            if (res) {
              this.writeContents(res,this.dataKitHeader.FILE_NAME)     
            }              
        },err => {
          this.modal.warning("File not found",this.viewRef)
        })
  }

  public OpenDesignNote(action: string) {
    this.http.get("TI", "SNM001P_M_MC_GetDesignNote", this.partData.PART_NO)
      .subscribe(result => {
        console.log(result)
        this.designNoteList = result.Table
        this.hideCols.push("EDIT")
        if (action === 'N') {
          this.dialogDN.OpenDialog();
        }
      })
  }
  public DownloadDesignNote(data) {
    console.log(data, 'designNotedata')
    if (!data.FILE_NAME) {
      this.modal.warning("File not found!", this.viewRef)
      return
    }
    this.http.Download('TI', 'SNM131P_Download', { filename: data.FILE_NAME })
      .subscribe(res => {
        if (res) {
          this.writeContents(res, data.FILE_NAME)
        }
      },err => {
        this.modal.warning("File not found",this.viewRef)
      })
  }
  writeContents(content,filename) {
    
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = filename;
    a.click();
  }
  

}
