import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';



@Component({
  selector: 'snsq025_001',
  templateUrl: './SNSQ025_001.component.html',
  styleUrls: ['./SNSQ025_001.component.css']
})


export class SNSQ025_001Component implements OnInit {

  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  public params: any = {};
  public ParamSearch: any = {};
  public CustomerList: any;
  public tableData: any = [];
  public totalRecord = 0;
  public PROCESS_LOG: any = [];
  public value_date = this.ShowCurrentDate();
  public date_1 = this.value_date[0];
  public date_2 = this.value_date[1];
  public date_3 = this.value_date[2];
  public date_4 = this.value_date[3];
  public date_5 = this.value_date[4];
  public date_6 = this.value_date[5];
  public date_7 = this.value_date[6];
  public date_8 = this.value_date[7];

  ngOnInit() {
  }

  public ConfigVendorS: any = {
    ColName: "LOOKUP_VENDOR",
    PlaceholderText: "Select Vendor Code",
    SourceController: "SL",
    SourceMethodName: "SNSQ025_GetVendor",
    NoOfShowRecords: 60,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigPartNo: any = {
    ColName: "LOOKUP_PART_NO",
    PlaceholderText: "Select Part No",
    SourceController: "SL",
    SourceMethodName: "SNSQ025_GetPartNo",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public Search() {
    console.log(this.ParamSearch)
    this.tableData = [];
    this.http.post("SL", "SNSQ025_001_GET_LIST", this.ParamSearch)
      .subscribe(res => {
        this.tableData = res.Table;
        this.totalRecord = this.tableData.length
      })
  }

  public ExportExcel() {
    this.http.Download("SL", "SNSQ025_Export_Excle", JSON.stringify(this.tableData))
      .subscribe(res => {
        if (res) {
          this.WriteContents(res)
          this.PROCESS_LOG.push('Export complete ' + this.tableData.length + ' records.');
        } else {
          this.modal.error('Download not complete', this.viewref)
        }
      })
  }

  private WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    var date_export = new Date();
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ025" + "_" + date_export.getFullYear() + (date_export.getMonth() + 1) + date_export.getDate() + ".csv";
    a.click();
  }


  public ShowCurrentDate() {

    var week_day = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
    var tomorrow = new Date();
    var col = [];
  
    for(var i = 0; i < 9; i++) {

        var tomorrow = new Date();
        tomorrow.setDate(tomorrow.getDate() + i);
        var date = week_day[tomorrow.getDay()] + "\n " + tomorrow.getDate() + "-" + (tomorrow.getMonth() + 1) + "-" + tomorrow.getFullYear();
        col.push(date);

    }

    return [col[0], col[1], col[2], col[3], col[4], col[5], col[6], col[7]];

  }

  

}
