import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'snse127_1',
  templateUrl: './snse127_1.component.html',
  styleUrls: ['./snse127_1.component.css']
})



export class SNSE127_1Component implements OnInit {

  public SelectYearList: any;
  public SelectMonthList: any;

  constructor(
    private http: HttpService,
    private modal : ModalService,
    private viewref : ViewContainerRef
  ) { }

  public ConfigVendor: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Vendor Code",
    SourceController: "TI",
    SourceMethodName: "SNSE127_1_GetVendor",
    NoOfShowRecords: 20,
    MinLengthSearch: 1,
    UpperCase: true
  }

  public ConfigPricing: any = {
    ColName: "PRICING_CODE",
    ColValue: "PRICING_CODE",
    PlaceholderText: "Select Pricing Code",
    SourceController: "TI",
    SourceMethodName: "SNSE127_1_GetPricing",
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: true
  }

  @ViewChild("dialog",{static : false}) dialog : any;
  public params : any = {};
  ngOnInit() {

    // this.SelectYearList = [{ ID: 1, SELECT_YEAR: "2018" }, { ID: 2, SELECT_YEAR: "2019" }, { ID: 3, SELECT_YEAR: "2020" }]
    // this.SelectMonthList = [{ ID: 1, SELECT_MONTH: "January" }, { ID: 2, SELECT_MONTH: "February" }, { ID: 3, SELECT_MONTH: "March" }, { ID: 4, SELECT_MONTH: "April" } 
    //   , { ID: 5, SELECT_MONTH: "May" }, { ID: 6, SELECT_MONTH: "June" }, { ID: 7, SELECT_MONTH: "July" }, { ID: 8, SELECT_MONTH: "August" }
    //   , { ID: 9, SELECT_MONTH: "September" }, { ID: 10, SELECT_MONTH: "October" }, { ID: 11, SELECT_MONTH: "November" }, { ID: 12, SELECT_MONTH: "December" }]


  }


  //------------------box1------------------------------//



  //---------------------//------------------------------

  
  //------------------box2------------------------------//


  //---------------------//------------------------------
  

  //------------------box5------------------------------//

  CalByVendor(){
    if(!this.params.YEAR){
      this.modal.warning("Please insert year",this.viewref)
      return
    }

    if(!this.params.MONTH){
      this.modal.warning("Please insert month",this.viewref)
      return
    }

    if(!this.params.VENDOR_CODE){
      this.modal.warning("Please insert vendor code",this.viewref)
      return
    }

    this.modal.confirm("Do you want to cal print price",this.viewref,() => ConfirmCal())

    let ConfirmCal = () =>{
      this.http.post("TI","SNSE127_1_CalByVendor",this.params)
      .subscribe(res =>{
         if(res.STATUS_MSG == 'DONE'){
           this.modal.info("Process complete",this.viewref)
         }else{
          this.modal.error("Found eror, please contact support team.", this.viewref);
         }
      },err =>{
        this.modal.error("Found eror, please contact support team.", this.viewref);
      })
    }


  }

  CalByPricing(){

    if(!this.params.YEAR){
      this.modal.warning("Please insert year",this.viewref)
      return
    }

    if(!this.params.MONTH){
      this.modal.warning("Please insert month",this.viewref)
      return
    }

    if(!this.params.PRICING_CODE){
      this.modal.warning("Please insert vendor code",this.viewref)
      return
    }

    this.modal.confirm("Do you want to cal print price",this.viewref,() => ConfirmCal())

    let ConfirmCal = () =>{
      this.http.post("TI","SNSE127_1_CalByPricing",this.params)
      .subscribe(res =>{
         if(res.STATUS_MSG == 'DONE'){
           this.modal.info("Process complete",this.viewref)
         }else{
          this.modal.error("Found eror, please contact support team.", this.viewref);
         }
      },err =>{
        this.modal.error("Found eror, please contact support team.", this.viewref);
      })
    }
  }

  CalPrintPrice(){

    if(!this.params.YEAR){
      this.modal.warning("Please insert year",this.viewref)
      return
    }

    if(!this.params.MONTH){
      this.modal.warning("Please insert month",this.viewref)
      return
    }

    this.modal.confirm("Do you want to cal print price",this.viewref,() => ConfirmCal())

    let ConfirmCal = () =>{
      this.http.post("TI","SNSE127_1_CalPrice",this.params)
      .subscribe(res =>{
         if(res.STATUS_MSG == 'DONE'){
           this.modal.info("Process complete",this.viewref)
         }else{
          this.modal.error("Found eror, please contact support team.", this.viewref);
         }
      },err =>{
        this.modal.error("Found eror, please contact support team.", this.viewref);
      })
    }

  }

  Genfile(){
    this.dialog.OpenDialog();
  }
  //---------------------//------------------------------

}
