import { Component, OnInit,ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'snse131_m',
  templateUrl: './SNSE131_M.component.html',
  styleUrls: ['./SNSE131_M.component.css']
})



export class SNSE131_MComponent implements OnInit {

  public SelectYearList: any;
  public SelectMonthList: any;

  constructor(
    private http: HttpService,
    private modal : ModalService,
    private viewref : ViewContainerRef
  ) { }

 
  public params : any = {};
  ngOnInit() {

    let d = new Date();

    this.params.PROCESS_YEAR = d.getFullYear();
    this.params.PROCESS_MONTH = d.getMonth() + 1;
    this.params.EXPORT_TYPE = 1;


  }

  Download() {

    if(!this.params.PROCESS_YEAR){
        this.modal.warning("Please insert year",this.viewref)
        return
      }
  
    if(!this.params.PROCESS_MONTH){
        this.modal.warning("Please insert month",this.viewref)
        return
    }

    let method_name = ""
    let file_name = ""

    if(this.params.EXPORT_TYPE == 1){
        file_name = "PRICE01"
        method_name = "SNSE127_EXPORT_1"
    }else if(this.params.EXPORT_TYPE == 2){
        file_name = "PART"
        method_name = "SNSE127_EXPORT_2"
    }else{
        file_name = "CAR_D"
        method_name = "SNSE127_EXPORT_3"
    }

    this.http.Download('TI', method_name, this.params)
        .subscribe(res => {
            if (res) {
              this.writeContents(res,file_name)     
            }              
        })
  }

  writeContents(content,file_name) {
  const a = document.createElement('a');
  const file = new Blob([content], { type: content.type });
  a.href = URL.createObjectURL(file);
  a.download = file_name + ".txt";
  a.click();
  }



}
