import { Component, ElementRef, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { FormControl, Validators } from '@angular/forms';
import { ModalService } from 'src/app/core/modal.service';
import { SelectionModel } from '@angular/cdk/collections';

@Component({
  selector: 'snse218',
  templateUrl: './SNSE218.component.html',
  styleUrls: ['./SNSE218.component.css']
})



export class SNSE218PComponent implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private modal : ModalService,
    private viewref : ViewContainerRef
  ) { }

  public ConfigPart: any = {
    ColName: "LOOKUP",
    PlaceholderText: "Select Part No.",
    SourceController: "TI",
    SourceMethodName: "SNSE218_GetPart",
    NoOfShowRecords: 30
  }



  @ViewChild("dialog",{static: false}) dialog : any;
  public ParamSearch :any ={};
  public Params :any ={};
  public categoryList: any = [];
  public tabledata : any = [];
  public isAdd : boolean = false;
  public tableDataUpload : any = [];
  public tempData : any = [];
  public FileName: string = "";
  public selection = new SelectionModel<any>(true,[]);
  public hideColupload : any = [];
  public 
  @ViewChild("fileInput") fileInput: ElementRef;

  ngOnInit() {

  }

  Search(){
    this.selection.clear()
    this.tabledata = []
    this.http.post("TI","SNSE218_Search",this.ParamSearch)
    .subscribe(res =>{
      //console.log(res)
          this.tabledata = res.Table
    })

  }

  DownloadTemplate(){
    let link = "assets/templates/Campaign_Template.xlsx"
    window.open(link,'_blank')
  }

  openFileBrowser() {
    this.FileName = "";
    this.fileInput.nativeElement.value = '';
    this.fileInput.nativeElement.click();
  }

  selectFile(evt) {
    
    let Files: Array<File> = evt.target.files;

    if (Files.length > 0) {
        let File: File = Files[0];
        this.FileName = File.name;

        let formData = new FormData();
        formData.append('file', File);
        this.tableDataUpload = [];
        this.http.postFile("TI", "SNSE218_Upload", formData)
            .subscribe(result => {
              
              this.tableDataUpload = result
              console.log('result',result)
              
            }, err => {
              this.modal.error("Upload not complete", this.viewref);
            })

    }
  }

  Delete(){
    this.modal.confirm("Do you want to delete record?",this.viewref,() => ConfirmDelete())

    let ConfirmDelete = () =>{
      this.http.post("TI","SNSE218_Delete",this.selection.selected)
      .subscribe(res =>{

        if(res.STATUS_MSG == "DONE"){
          this.modal.info("Delete " + this.selection.selected.length + " record complete",this.viewref)
          this.Search()
        }else{
          this.modal.warning("Delete fail",this.viewref)
        }
            
      },err => {
        this.modal.warning("Delete fail",this.viewref)
      })
    }
  }


  Save(){
    this.modal.confirm("Do you want to save change you have made?",this.viewref,this.ConfirmSave)
  }

  ConfirmSave = () =>{

    this.http.post("TI","SNSE218_Save",this.tableDataUpload)
      .subscribe(res =>{
        if(res.STATUS_MSG == 'DONE'){
          this.modal.confirm("Process complete",this.viewref)
          this.dialog.Close();
          this.Search()
        }else{
          this.modal.confirm("Process not complete",this.viewref)
        }     
      })
  
  }

  
  isAllSelected() {
    const numSelected = this.selection.selected.length;
    const numRows = this.tabledata.length;
    return numSelected === numRows;
  }

  Toggle() {
    this.isAllSelected() ?
      this.selection.clear() :
      this.tabledata.forEach(row => this.selection.select(row));
  }

  OpenUpload(){
    this.tableDataUpload = []
    this.FileName = "";
    ///this.hideColupload.push("SELECT","PART_NAME","UPDATE_BY","UPDATE_DATE")
    this.dialog.OpenDialog();
  }

  Cancel(){
    this.dialog.Close();
  }
}

