import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';

@Component({
    selector: 'snm109p',
    templateUrl: './SNM109P.component.html',
    styleUrls: ['./SNM109P.component.css']
})

export class SNM109PComponent implements OnInit {

    constructor(
        private http: HttpService,
        private router: Router,
        private modal: ModalService,
        private viewref: ViewContainerRef
    ) { }
    @ViewChild("dialogAdd", { static: false }) dialogAdd: any;

    public DataList: Array<any> = [];
    public OldDataList: Array<any> = [];
    public PrefixPartNo: string;
    public ReccordCount: any = 0;

    public selectedRow: any = {};

    public AddData = {
      PREFIX_PART_NO: null,
      PREFIX_DEXCRIPTION: null
    }

    ngOnInit() { }

    GetData() {
        this.DataList = [];
        this.selectedRow = {};
        this.http.get("WH", "SNM109P_Query", this.PrefixPartNo || "null")
            .subscribe(result => {
            if (result.Table.length > 0) {
                this.DataList = result.Table;
              this.ReccordCount = result.Table.length;
                this.OldDataList = JSON.parse(JSON.stringify(this.DataList));
            } else {
              this.ReccordCount = 0;
            }
            }, err => {
                this.modal.error(err.message, this.viewref);
            })
    }

    RowClicked(data: any) {
        this.selectedRow = data;
    }

    SavePrefixDescription() {
        let saveableList: Array<any> = this.DataList.filter(v => {

            //If found matched record, mean this record is not changed.
            return this.OldDataList.find(o => JSON.stringify(o) === JSON.stringify(v)) ? false : true;
        })

        if (saveableList.length > 0) {

            this.modal.confirm("Are you sure to save all changes?", this.viewref
                , () => {
                    this.http.post("WH", "SNM109P_Save", saveableList)
                        .subscribe(result => {
                            this.modal.info("Saved successfully", this.viewref);
                            this.GetData();
                        }, err => {
                            this.modal.error(err.message, this.viewref);
                        })
                })

        } else {
            this.modal.error("Unable to save 0 row.", this.viewref);
        }
    }

    RevertData(rollbackAll: boolean, data: any = null) {
        if (rollbackAll) {
            this.modal.confirm("Are you sure to reset all data?", this.viewref
                , () => {
                    this.DataList = this.OldDataList.slice();
                }, () => { })
        } else {

            this.modal.confirm("Are you sure to reset data of this row?", this.viewref
                , () => {
                  let oldRec = this.OldDataList.find(o => o.PREFIX_PART_NO === data.PREFIX_PART_NO);
                    Object.keys(data).forEach(v => {
                        data[v] = oldRec[v];
                    })
                }, () => { })
        }
    }

    DeleteData(data: any) {
        this.modal.confirm("Do you want to delete this record?", this.viewref
            , () => {
                this.http.post("WH", "SNM109P_Delete", data)
                    .subscribe(result => {
                        this.modal.info("Deleted successfully", this.viewref);
                        this.GetData();
                    })
            }, () => {})
    }

    CheckRowChange(data: any) {
        let oldRec = this.OldDataList.find(o => o.PREFIX_PART_NO === data.PREFIX_PART_NO);

        return JSON.stringify(oldRec) !== JSON.stringify(data);
    }

    SaveAdd() {
      this.modal.confirm('Do you want to save changed you have made?', this.viewref, this.ConfirmSaveAdd)
    }

    ConfirmSaveAdd = () => {
      this.http.post('WH', 'SNM109P_Insert', this.AddData)
        .subscribe(res => {
          if (res.Table[0].STATUS == 'DONE') {
            this.modal.info('Transaction complete: applied and saved.', this.viewref);
            this.dialogAdd.Close();
            this.AddData.PREFIX_PART_NO = null;
            this.AddData.PREFIX_DEXCRIPTION = null;
            this.GetData();
          } else {
            this.modal.info('No change to save. Something went wrong.', this.viewref);
          }

        })
    }

    CancelAdd() {
      this.dialogAdd.Close();
      this.AddData = {
        PREFIX_PART_NO: null,
        PREFIX_DEXCRIPTION: null
      };
    }

    Delete(data) {
    this.modal.confirm('Do you want to delete record?', this.viewref, () => this.ConfirmDelete(data))
  }

    ConfirmDelete = data => {
    this.http.post("WH", "SNM109P_Deletes", data)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Deleted successfully', this.viewref);
          this.GetData();
        } else {
          this.modal.info('No change to delete. Something went wrong.', this.viewref);
        }
      })
    }

  checkdata() {
    if (this.AddData.PREFIX_PART_NO) {
      return false;
    } else {
      return true;
    }
  }
}

