import { Component, OnInit, ViewEncapsulation, ViewContainerRef,ViewChild } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';
import { SelectionModel } from '@angular/cdk/collections';

@Component({
  selector: 'snse032_w',
  templateUrl: './SNSE032_W.component.html',
  styleUrls: ['./SNSE032_W.component.css']
})



export class SNSE032_WComponent implements OnInit {

  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private global: Globals,
  ) { }

  public ConfigVan: any = {
    ColName: "LOOKUP",
    PlaceholderText: "Select Van",
    SourceController: "WH",
    SourceMethodName: "SNSE032_W_GetVanNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 1,
    UpperCase: true,
    SourceParams: {
      CUSTOMER_CODE: ""
    }
  }

  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "WH",
    SourceMethodName: "SNSE032_W_GetCustomerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 1,
    UpperCase: true
  }

  public lookupPreInvoice: any = {
    ColName: "PINVOICE_TEXT",
    PlaceholderText: "Select Pre-invoice no.",
    SourceController: "WH",
    SourceMethodName: "SNSE032_W_GetPreInvoiceAir",
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: true,
    SourceParams: {
      CUSTOMER_CODE: "",
      BRANCH_CODE: "01"
    }
  }

  public lookupPreInvoiceNo: any = {
    ColName: "PINVOICE_TEXT",
    PlaceholderText: "Select Pre-invoice no.",
    SourceController: "WH",
    SourceMethodName: "SNSE032_W_GetPreInvoiceNoAir",
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: true,
    SourceParams: {
      CUSTOMER_CODE: "",
      BRANCH_CODE: "01"
    }
  }

  public tableData: any = [];
  public dataSelected: any = [];

  public formData: any = {};
  public dataHeader: any = {};

  public tableName: string;
  public show: boolean = true;
  public params: any = {};
  public paramsReprint: any = {};

  public selectCase: any = {};

  public DataIsSelected: any = [];
  public selection = new SelectionModel<any>(true, []);
  public tableVan : any = []

  public fileUrlPart : any  = "";
  public caseDetail : any = []
  @ViewChild("dialogMain", { static: false }) dialogMain: any;
  @ViewChild("dialogDetail", { static: false }) dialogDetail: any;  
  @ViewChild("dialogReprint", { static: false }) dialogReprint: any;
  @ViewChild("dialogCaseDetail", { static: false }) dialogCaseDetail: any;
  

  public tblFooter: any = [
    {
      fieldName: "NB_DG",
      value: "Total",
      show: true
    },
    {
      fieldName: "GROSS_WEIGHT",
      show: true
    },
    {
      fieldName: "GROSS_MM",
      show: true
    },
    {
      fieldName: "PACK_QTY",
      show: true
    },
    {
      fieldName: "ACCEPT_QTY",
      show: true
    }

  ]

  public tblFooter2: any = [
    {
      fieldName: "SUB_ITEM_NO",
      value: "Total",
      show: true
    },
    {
      fieldName: "PACK_QTY",
      show: true
    },
    {
      fieldName: "ACCEPT_QTY",
      show: true
    }

  ]

  public docDate: any;
  public vanDetail : any = {}
  ngOnInit() {
    this.docDate = new Date();
    this.params.ATTACH_SHEET = 'Y';
  }

  initData() {
    this.tableData = [];
    this.dataSelected = [];
    this.selection.clear()
    this.selectCase.TotolSelect = 0;
    this.selectCase.TotolCase = 0;
    this.selectCase.TotalError = 0;
  }

  

  public SetSelectedCustomerCode(values: any) {
    this.params.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = values.CUSTOMER_NAME;

    this.params.BRANCH_CODE = values.BRANCH_CODE;
    this.params.BRANCH_NAME = values.BRANCH_NAME;

    this.params.COUNTRY = values.COUNTRY;
    this.params.CURRENCY_CODE = values.CURRENCY_CODE;
    this.params.PAYMENT_TERM = values.PAYMENT_TERM;
    this.params.EXCHANGE_RATE = values.EXCHANGE_RATE;

    this.lookupPreInvoice.SourceParams.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.lookupPreInvoice.SourceParams.BRANCH_CODE = values.BRANCH_CODE;
    this.ConfigVan.SourceParams.CUSTOMER_CODE = values.CUSTOMER_CODE;

    this.GetVanData();
  }

  public SetSelectedVan(event){
    this.selectCase.VAN_NO = event.VAN_NO
    this.params.VAN_NO = event.VAN_NO;
    //this.GetData();
  }

  public GetVanData(){

    this.http.post("WH","SNSE032_W_GetVanData",this.params)
    .subscribe(res =>{
      this.tableVan = res.Table;
    })
  }

  public GetDataDetail(values : any){
    this.http.post('WH', 'SNSE032_W_GetData', values)
    .subscribe(res => {
      this.tableData = res.Table;
      this.dialogDetail.OpenDialog();
    })
  }


  public GetData = () => {
    
    this.initData()
    this.http.post('WH', 'SNSE032_W_GetData', this.params)
      .subscribe(res => {
        this.tableData = res.Table;
      })
  }

  public GetCaseDetail(data : any){
    this.http.post("WH","SNSE032_W_GetCaseDetail",data)
    .subscribe(res =>{
      this.caseDetail = res.Table
      this.vanDetail = data;
      this.dialogCaseDetail.OpenDialog()
    })
  }

  public isAllSelected() {
    const numSelected = this.selection.selected.length;
    const numRows = this.tableVan.length;
    return numSelected === numRows;
  }

  public Toggle() {
    if(this.isAllSelected()){
        this.selection.clear()
    } else{
      this.tableVan.forEach((row) =>{
        this.selection.select(row);

      })
    }
  }

  public TotalCase(){
    return this.selection.selected.reduce((a,b) => a + (b.TOTAL_CASE || 0),0)
  }

  public CheckVanChange(event, row) {

    if (event.checked) {
      this.tableVan.forEach((x) => {
        if(x.VAN_GROUP && x.VAN_GROUP == row.VAN_GROUP)
          this.selection.select(x);
        })
    } else {
      this.tableVan.forEach((x) => {
        if(x.VAN_GROUP && x.VAN_GROUP == row.VAN_GROUP)
          this.selection.deselect(x);
        })
    }
  }


  public CheckToPack(event, data) {
    if (event.checked) {
      this.dataSelected.push(data);
      this.selectCase.TotolCase += 1;
      this.selectCase.TotolSelect += data.PACK_QTY;
    }
    else {
      this.dataSelected.splice(this.dataSelected.indexOf(data), 1);
      this.selectCase.TotolCase -= 1;
      this.selectCase.TotolSelect -= data.PACK_QTY;
    }
  }

  public CheckPrintChange(value) {
    if (value.checked == true) {
      this.params.ATTACH_SHEET = 'Y'
    }
    else {
      this.params.ATTACH_SHEET = 'N'
    }
  }


  public ConfirmPre() {

    if (this.selection.selected.length > 0) {
      this.modal.confirm("Are you sure to confirm Pre-invoice ?", this.viewRef,
        () => {

          this.http.post("WH", "SNSE032_W_ConfirmPre", this.selection.selected)
            .subscribe(result => {
              if (result.substring(0, 4) == "DONE") {
                
                this.GetVanData();
                this.selection.clear();
                this.modal.info("Confirm successfully [Pre-Invoice no.] : " + result.substring(5, 14), this.viewRef);
                if (this.params.ATTACH_SHEET == 'Y') {
                  this.OpenReport(result.substring(5, 14));
                }

              } else {
                this.GetVanData();
                this.selection.clear()
                this.modal.warning("Found an error, please contact support team", this.viewRef);
              }
            }, (err) => {
              this.GetVanData();
              this.selection.clear();
              console.log(err, 'err')
              this.modal.warning("Found an error, please contact support team", this.viewRef);
            })


        }, () => { })
    } else {
      this.modal.warning("Please select data for confirm Pre-invoice.", this.viewRef);
    }

  }
  private ProcessCondition() {

    var countError = 0;
    this.tableData.forEach((value) => {

      //countSelect = countSelect + value.PACK_QTY;

      if (value.GROSS_WEIGHT == '' && value.GROSS_WEIGHT > 0) {
        if (value.NET_WEIGHT > value.GROSS_WEIGHT) {
          value.CHK_BOX = false;
          value.ERROR = 1;
          value.REMARK = 'GW error';
          countError = countError + 1;
          value.CHECK = 0;
        }
        else {
          value.CHK_BOX = true;
          value.SELECT = value.ACCEPT_QTY;
          value.CHECK = 1;
        }
      }
      else {
        value.CHK_BOX = true;
        value.SELECT = value.ACCEPT_QTY;
        value.CHECK = 1;
      }

    });


    this.selectCase.TotolCase = this.tableData.length;
    this.selectCase.TotalError = countError;
    // this.CheckToPack(event, data)

  }



  private OpenReport(preInovice) {
    this.dialogMain.OpenDialog();
    this.fileUrlPart = null;
    this.http
      .Download("WH", "SNSE032_W_Load_report", {
        ReportPrefix: "PMS_RPT_SALES_SNSE032_W",
        ReportSuffix: ".PDF",
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_CUST_S: this.params.CUSTOMER_CODE,
        P_CUST_E: this.params.CUSTOMER_CODE,
        P_PINV_NO_START: preInovice,
        P_PINV_NO_END: preInovice,
        P_PINV_DATE_S: this.global.ConvertDateToFormatSTD(this.docDate),
        P_PINV_DATE_E: this.global.ConvertDateToFormatSTD(this.docDate),
        P_SENT_BY: 'A'
      })
      .subscribe((res) => {
        if (res) {
          this.SetIFramePartContent(res);
        }
      });
    // this.global.GoToReport("PMS_RPT_SALES_SNSE032_W", {
    //   P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
    //   P_CUST_S: this.params.CUSTOMER_CODE,
    //   P_CUST_E: this.params.CUSTOMER_CODE,
    //   P_PINV_NO_START: preInovice,
    //   P_PINV_NO_END: preInovice,
    //   P_PINV_DATE_S: this.global.ConvertDateToFormatSTD(this.docDate),
    //   P_PINV_DATE_E: this.global.ConvertDateToFormatSTD(this.docDate),
    //   P_SENT_BY: 'A'
    // })
  }

  private SetIFramePartContent(content: any) {
    const file = new Blob([content], { type: content.type });
    const fileUrlPart = URL.createObjectURL(file);
    this.fileUrlPart = fileUrlPart;
  }

  public Reprint() {
    this.lookupPreInvoiceNo.SourceParams.CUSTOMER_CODE = "";
    this.lookupPreInvoiceNo.SourceParams.BRANCH_CODE = "";
    this.paramsReprint ={};
    this.dialogReprint.OpenDialog();
  }

  public SetSelectedCus(content: any) {
  
    this.paramsReprint.CUSTOMER_CODE = content.CUSTOMER_CODE;
    this.paramsReprint.CUSTOMER_NAME = content.CUSTOMER_NAME;

    this.lookupPreInvoiceNo.SourceParams.CUSTOMER_CODE = content.CUSTOMER_CODE;
    this.lookupPreInvoiceNo.SourceParams.BRANCH_CODE = content.BRANCH_CODE;    
  }

  public SetSelectedPreInvoiceNo(content: any) {
    this.paramsReprint.PRE_INVOICE_NO = content.PINVOICE_NO;
    this.paramsReprint.CUSTOMER_CODE = content.CUSTOMER_CODE ;
    this.paramsReprint.PINVOICE_DATE = content.PINVOICE_DATE ;    
  }

  public ReprintAction(){
    this.dialogMain.OpenDialog();
    this.fileUrlPart = null;
    this.http
      .Download("WH", "SNSE032_W_Load_report", {
        ReportPrefix: "PMS_RPT_SALES_SNSE032_W",
        ReportSuffix: ".PDF",
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_CUST_S: this.paramsReprint.CUSTOMER_CODE,
        P_CUST_E: this.paramsReprint.CUSTOMER_CODE,
        P_PINV_NO_START: this.paramsReprint.PRE_INVOICE_NO,
        P_PINV_NO_END: this.paramsReprint.PRE_INVOICE_NO,
        P_PINV_DATE_S: this.global.ConvertDateToFormatSTD(this.paramsReprint.PINVOICE_DATE),
        P_PINV_DATE_E: this.global.ConvertDateToFormatSTD(this.paramsReprint.PINVOICE_DATE),
        P_SENT_BY: 'A'
      })
      .subscribe((res) => {
        if (res) {
          this.SetIFramePartContent(res);
        }
      });
  }

  public ReportExcel(number){
    let reportname: string;
    let params: any = {};
    let filename: string;
    switch (number) {
      case 1:
        reportname = "PMS_RPT_SALES_SNSE032_W_RPT";
        params = {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_CUSTOMER_CODE: this.params.CUSTOMER_CODE,
          };
        filename = "Pre_air_customer_" + this.params.CUSTOMER_CODE;
        break;
      case 2:
        reportname = "PMS_RPT_SALES_SNSE032_W_DETAIL_RPT";
        params = {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_CUSTOMER_CODE: this.vanDetail.CUSTOMER_CODE,
            P_VAN_GROUP: this.vanDetail.VAN_GROUP,
            P_VAN_NO: this.vanDetail.VAN_NO,
          };
        filename = "Pre_air_van_detail_" + this.caseDetail.VAN_NO;
        break;
    }

    if(reportname){
      this.global.GoToExportName(reportname, params, filename, "EXCELOPENXML");
    }
  }
}
