import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from '../../../core/global';

@Component({
  selector: 'snse054d_zb',
  templateUrl: './SNSE054D_ZB.component.html',
  styleUrls: ['./SNSE054D_ZB.component.css']
})



export class SNSE054D_ZBComponent implements OnInit {


  constructor(
    private HttpService: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private route: ActivatedRoute,
    private global: Globals
  ) { }

  public dataListSeqByInvoiceDate: any =[];
  public dataListCustByInvoiceDateBySeq: any =[];

  public PROCESSTYPE: any = {
      T: "T",
      S:  "S"
  };

  public METHOD_T: string ="SNSE054D_ZB_PitkLotDate_Find_T";
  public METHOD_S: string ="SNSE054D_ZB_PitkLotDate_Find_S";

  public selectedProcessType: string;

  public ListDataReportCondition: any = {
      PROCESS_TYPE : null, 
      PICK_LOT_DATE : null,
      PICK_LOT_SEQ : null,
      CUSTOMER_CODE : null
  };

  public ConfigPickLotDate: any = {
    ColName: "PICK_LOT_DATE",
    ColValue: "PICK_LOT_DATE",
    PlaceholderText: "Select Pick Lot Date in format[DD-MM-YYYY]",
    SourceController: "WH",
    SourceMethodName: "SNSE054D_ZB_PitkLotDate_Find_T",
    NoOfShowRecords: 100,
    MinLengthSearch: 1,
    UpperCase: true
  }

  public reportName: string;

  ngOnInit() {
    this.ListDataReportCondition.PROCESS_TYPE = this.PROCESSTYPE.T;

    this.ConfigPickLotDate.SourceMethodName = this.METHOD_T;//Load Pick lot Date to autocomplete
  }
  
  FindSeqByInvoiceDate(strDate: any){
    var PickLotDate = strDate.format('DD-MMM-YYYY');
    if (!!PickLotDate) {
        // console.log("Before data: ",this.dataListSeqByInvoiceDate);
      this.HttpService.get("WH", "SNSE054D_ZB_SEQ_BY_DATE", PickLotDate || "null",this.PROCESSTYPE.T)
        .subscribe(result => {

            //clear data that reletion with date.
            //this.ListDataReportCondition.PICK_LOT_SEQ = null;
            //this.ListDataReportCondition.CUSTOMER_CODE = null;

            this.dataListSeqByInvoiceDate = result.Table;
            //console.log("After Seq: ",this.dataListSeqByInvoiceDate);
        }, err => {
            this.modal.error(err.message, this.viewref);
        });

      } else {
      alert('Please input date for Pick Lot Date!!');
      }
  }
  
  SeqSelectChange(iSeq: any){
    this.FindCustByDateSeq(this.ListDataReportCondition.PICK_LOT_DATE.format('DD-MMM-YYYY'),iSeq);
  }

  FindCustByDateSeq(strDate: any,strSeq: any){
      // console.log("Input func: "+strDate+"and"+strSeq);
      if (!!strDate) {
        // console.log("Before Cust: ",this.dataListCustByInvoiceDateBySeq);
        this.HttpService.get("WH", "SNSE054D_ZB_CUST_BY_DATE_SEQ" ,strDate || "null",this.PROCESSTYPE.T,strSeq)
        .subscribe(result => {

            //clear data that reletion with date.
            this.ListDataReportCondition.CUSTOMER_CODE = null;

            this.dataListCustByInvoiceDateBySeq = result.Table;
            // console.log("After Cust: ",this.dataListCustByInvoiceDateBySeq);
        }, err => {
            this.modal.error(err.message, this.viewref);
        });
      } else {
        alert('Please input at less 3 characters');
      }
  }

  radioChange(value: any){
      console.log(this.ListDataReportCondition.PROCESS_TYPE);
      this.clearData();

      //reload autocomplete follow radio change.
      if(this.ListDataReportCondition.PROCESS_TYPE == this.PROCESSTYPE.T ){
          this.ConfigPickLotDate.SourceMethodName = this.METHOD_T;
      }else if(this.ListDataReportCondition.PROCESS_TYPE == this.PROCESSTYPE.S ){
          this.ConfigPickLotDate.SourceMethodName = this.METHOD_S;
      }
  }

  clearData(){
      //this.ListDataReportCondition.PROCESS_TYPE = null;
      this.ListDataReportCondition.PICK_LOT_DATE = null;
      this.ListDataReportCondition.PICK_LOT_SEQ = null;
      this.ListDataReportCondition.CUSTOMER_CODE = null;
  }

  OpenReport(){
      if(this.CheckSearchCondition()){
        this.SavePackingCardBeforePrint(this.ListDataReportCondition.PICK_LOT_DATE,this.ListDataReportCondition.PROCESS_TYPE,this.ListDataReportCondition.PICK_LOT_SEQ,this.ListDataReportCondition.CUSTOMER_CODE );
      }  
  }
  SavePackingCardBeforePrint(strDate:string ,strProcessType:string ,strSeq:string,strCustomerCode:any){
    //if (!!this.ListDataReportCondition.PICK_LOT_SEQ) {
        console.log("Data save sticker:", this.ListDataReportCondition);
        this.HttpService.get("WH", "SNSE054D_ZB_SAVE_TO_TEMP" ,strDate,strProcessType,strSeq,strCustomerCode || "null")
        .subscribe(result => {
          console.log("result of save sticker: ",result);
          
          this.GoToReport_A4();//show roport viewer. 

        }, err => {
            this.modal.error(err.message, this.viewref);
        });
    //}
  }

  OpenReport98NF(){
      if(this.CheckSearchCondition()){
        this.SavePackingCardBeforePrint98NF(this.ListDataReportCondition.PICK_LOT_DATE,this.ListDataReportCondition.PROCESS_TYPE,this.ListDataReportCondition.PICK_LOT_SEQ,this.ListDataReportCondition.CUSTOMER_CODE );
      } 
  }
  SavePackingCardBeforePrint98NF(strDate:string ,strProcessType:string ,strSeq:string,strCustomerCode:any){
    //if (!!this.ListDataReportCondition.PICK_LOT_SEQ) {
        console.log("Data save sticker:", this.ListDataReportCondition);
        this.HttpService.get("WH", "SNSE054D_ZB_SAVE_TO_TEMP" ,strDate,strProcessType,strSeq,strCustomerCode || "null")
        .subscribe(result => {
          console.log("result of save sticker: ",result);
          
          this.GoToReport_ZB98();//show roport viewer. SNSE054R_ZB98

        }, err => {
            this.modal.error(err.message, this.viewref);
        });
    //}
  }

  OpenReport98NS(){
      if(this.CheckSearchCondition()){
        this.SavePackingCardBeforePrint98NS(this.ListDataReportCondition.PICK_LOT_DATE,this.ListDataReportCondition.PROCESS_TYPE,this.ListDataReportCondition.PICK_LOT_SEQ,this.ListDataReportCondition.CUSTOMER_CODE );
      } 
  }
  SavePackingCardBeforePrint98NS(strDate:string ,strProcessType:string ,strSeq:string,strCustomerCode:any){
    //if (!!this.ListDataReportCondition.PICK_LOT_SEQ) {
        console.log("Data save sticker:", this.ListDataReportCondition);
        this.HttpService.get("WH", "SNSE054D_ZB_SAVE_TO_TEMP" ,strDate,strProcessType,strSeq,strCustomerCode || "null")
        .subscribe(result => {
          console.log("result of save sticker: ",result);
          
          this.GoToReport_ZB();//show roport viewer.

        }, err => {
            this.modal.error(err.message, this.viewref);
        });
    //}
  }

  CheckSearchCondition():boolean{
      let boolHadSelectedCondition : boolean;
      boolHadSelectedCondition = false;//maening: User is not selecting condition search report.
      
      if(!this.ListDataReportCondition.PICK_LOT_DATE || !this.ListDataReportCondition.PICK_LOT_SEQ){
          boolHadSelectedCondition = false;
      }else{
          boolHadSelectedCondition = true;
      }

      return boolHadSelectedCondition;
  }//end CheckSearchCondition


  
  GoToReport_ZB98() {
    this.global.GoToReport("PMS_RPT_WH_SNSE054R_ZB98",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      }
    );
  }

  GoToReport_ZB() {
    this.global.GoToReport("PMS_RPT_WH_SNSE054R_ZB",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      }
    );
  }

  GoToReport_A4() {
    this.global.GoToReport("PMS_RPT_WH_SNSE054R_ZBA4",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      }
    );
  }
  

}
