import { Component, OnInit, ViewContainerRef } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from '../../../core/modal.service';

@Component({
  selector: 'snse181',
  templateUrl: './SNSE181.component.html',
  styleUrls: ['./SNSE181.component.css']
})

export class SNSE181Component implements OnInit {

  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }


  public FileName: any;
  public ShowPreview: any = true;
  public ShowUpload: any = true;
  public tableData: any;
  public files: any;
  public rowCount: any = 0;


  ngOnInit() {

  }

  fileChange(p: any) {
    this.ShowPreview = false;
    this.FileName = p.target.files[0].name;
    this.files = p.target.files;

  }
  LoadData() {
    let formData = new FormData();
    formData.append('file', this.files[0]);
    this.ShowUpload = true;
    this.http.postFile('WH', 'SNSE181_UploadFiles', formData)
      .subscribe(res => {
        if (res.Table1 !== undefined) {
          if (res.Table1.length > 0) {
            this.rowCount = res.Table1.length;
            this.ShowUpload = false;
          }
        }
        this.tableData = res.Table1;
      });
  }
  SaveData() {
    if (this.tableData.length > 0) {
      this.tableData[0].CREATE_FILE_NAME = this.FileName;
    }

    this.http.post('WH', 'SNSE181_UpdateUpload', this.tableData)
      .subscribe(res => {
        if (res.Table[0].STATUS === "DONE") {
          this.modal.info('Transaction complete', this.viewref);
          this.tableData = {};
          this.files = "";
          this.FileName = "";
          this.ShowUpload = true;
          this.ShowPreview = true;
        }
      });
  }
}
