import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { MatDatepicker } from '@angular/material/datepicker';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from '../../../core/global';

@Component({
  selector: 'snse202',
  templateUrl: './SNSE202.component.html',
  styleUrls: ['./SNSE202.component.css']
})



export class SNSE202Component implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals
  ) { }
  @ViewChild("dialog", { static: false }) dialog: any;


  //public tabledata2: any;
  //public SelectList: any;
  //public formData: any = {};
  public tableData: any;
  public WarningMsg: any = "";
  public MatCheckbox: any;
  public dataList: any = [];
  public data: any = {
    COMPANY_CODE: null,
    PROCESS_DATE: Date,
    STATUS_SEQ: null,
    DISP_CUR_STATUS: null,
    DIMENSION_MARGIN_RATE: null,
    WEIGHT_MARGIN_RATE: null,
    RANGE_NEW_PART: null,
    RANGE_ETD_INCOMING: null,
    COMPLETE_FLAG: null,
    CREATE_BY: null,
    CREATE_PGM: null,
    CREATE_DATE: null,
    LAST_UPD_BY: null,
    LAST_UPD_PGM: null,
    LAST_UPD_DATE: null,
    ATTRIBUTE1: null,
    ATTRIBUTE2: null,
    ATTRIBUTE3: null,
    ATTRIBUTE4: null,
    ATTRIBUTE5: null,
  };

  public dataPartExclue: any = [{
    COMPANY_CODE: null,
    PROCESS_DATE: null,
    PART_NO: null,
    PART_NAME_TH: null,
    IS_CHECK: null
  }]

  public dataSugguestionList: any = [{
    COMPANY_CODE: null,
    PROCESS_DATE: Date,
    PART_NO: null,
    INCOMING_QTY: null,
    UNIT_DIMENSION_MAX: null,
    UNIT_DIMENSION_MID: null,
    UNIT_DIMENSION_MIN: null,
    UNIT_WEIGHT: null,
    AVERAGE_DEMAND: null,
    ESTIMATE_STOCK: null,
    ESTIMATE_CATEGORY: null,
    TOTAL_M3: null,
    TOTAL_WEIGHT: null,
    LOCATION_NO: null,
    ACCEPT_FLAG: null,
    EXCLUDE_FLAG: null,
    CREATE_BY: null,
    CREATE_PGM: null,
    CREATE_DATE: null,
    LAST_UPD_BY: null,
    LAST_UPD_PGM: null,
    LAST_UPD_DATE: null,
    ATTRIBUTE1: null,
    ATTRIBUTE2: null,
    ATTRIBUTE3: null,
    ATTRIBUTE4: null,
    ATTRIBUTE5: null,
    IS_CHECK: null
  }]

  ngOnInit() {

  }

  CheckSuggustionList = (evt, data) => {


    if (data.ATTRIBUTE1 !== "" && data.ATTRIBUTE1 !== null) {
      evt.source._checked = false;
      this.WarningMsg = data.ATTRIBUTE1;
    } else {
      this.WarningMsg = "";
      if (evt.source._checked) {
        data.IS_CHECK = true;
      } else {
        data.IS_CHECK = false;
      }

    }
    //console.log(checkbox.checked);
  }
  CheckRetriveIncomingPart(data) {
    let result = this.dataPartExclue.filter(x => x.PART_NO === data.PART_NO);
    if (result.length > 0) {
      if (result[0].IS_CHECK === undefined || result[0].IS_CHECK === false) {
        result[0].IS_CHECK = true;
      } else {
        result[0].IS_CHECK = false;
      }
    }

    console.log(result);
  }

  openDialog() {
    this.tableData = [];
    this.http.get("WH", "SNSE202_Get_Sugguestion_Header", "@@@")
      .subscribe(result => {
        this.tableData = result.Table;
        this.dialog.title = "";
        this.dialog.OpenDialog()
      });
  }

  Edit(data) {
    console.log(data, 'data')
    var convertProcessDate = this.global.ConvertDateToFormatSTD(data.PROCESS_DATE);
    this.FindPart(convertProcessDate);
    this.data.PROCESS_DATE = data.PROCESS_DATE;
    this.ProcessDateChange(convertProcessDate);
    this.dialog.Close();
  }
  getDateParam(dt) {
    let year = dt.getFullYear();
    let month = (1 + dt.getMonth()).toString().padStart(2, '0');
    let day = dt.getDate().toString().padStart(2, '0');
    var p_Date = year + '-' + month + '-' + day;
    return p_Date;
  }
  ProcessDateChange(event) {
    let newDate = new Date(event);
    var p_Date = this.getDateParam(newDate);
    this.http.get("WH", "SNSE202_Get_Sugguestion_Header", p_Date)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.data = result.Table[0];
          this.FindPart(p_Date);
        } else {
          this.data = {};
          this.data.PROCESS_DATE = newDate;
        }
      });
  }
  FindPart(p_Date) {
    this.http.get("WH", "SNSE202_Get_Sugguestion_Part", p_Date)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.dataSugguestionList = result.Table;
          this.dataPartExclue = result.Table1;
        } else {
          this.dataSugguestionList = {};
          this.dataPartExclue = {};
        }
      });
  }
  RetriveIncomingParts() {
    this.modal.confirm("Do you want to retreive parts to be suggested?", this.viewref, this.ConfirmRetriveIncomingParts)
  }
  ConfirmRetriveIncomingParts = () => {
    this.http.post('WH', 'SNSE202_Retrive_Incoming_Part', this.data)
      .subscribe(res => {
        if (res.Table[0].STATUS === "DONE") {
          this.FindPart(this.getDateParam(new Date(this.data.PROCESS_DATE)));
          this.data.DISP_CUR_STATUS = "2: Retrived Incoming Parts";
          this.data.STATUS_SEQ = 2;
        }
      });

  }
  ConfirmFactor() {
    this.modal.confirm("Do you want to confirm margin factor?", this.viewref, this.ConfirmForConfirmFactor)
  }
  ConfirmForConfirmFactor = () => {
    this.http.post('WH', 'SNSE202_Confirm_Factor', this.data)
      .subscribe(res => {
        if (res.Table[0].STATUS === "DONE") {
          this.FindPart(this.getDateParam(new Date(this.data.PROCESS_DATE)));
          this.data.DISP_CUR_STATUS = "3: Confirmed Dimension & Weight Margin";
          this.data.STATUS_SEQ = 3;
        }
      });
  }
  MoveParts = () => {
    this.http.post('WH', 'SNSE202_Parts_Move', this.dataPartExclue)
      .subscribe(res => {
        if (res !== "DONE") {
          this.modal.warning(res, this.viewref)
        } else {
          this.FindPart(this.getDateParam(new Date(this.data.PROCESS_DATE)));
        }
      });
  }
  GetDimensionAndWeight() {
    this.http.post('WH', 'SNSE202_Update_Dimension', this.data)
      .subscribe(res => {
        if (res.Table[0].STATUS !== "DONE") {
          this.modal.warning(res, this.viewref)
        } else {
          this.FindPart(this.getDateParam(new Date(this.data.PROCESS_DATE)));
        }
      });
  }
  ProcessSuggestion() {
    this.modal.confirm("Do you want to confirm process suggestion?", this.viewref, this.ConfirmProcessSuggestion)
  }
  ConfirmProcessSuggestion = () => {
    this.http.post('WH', 'Process_Suggestion', this.dataSugguestionList)
      .subscribe(res => {
        if (res.STATUS != "DONE") {
          if (res.Table[0].STATUS !== "DONE") {
            this.modal.warning(res, this.viewref)
          } else {
            this.FindPart(this.getDateParam(new Date(this.data.PROCESS_DATE)));
            this.data.DISP_CUR_STATUS = "4: Process Suggestion Location";
            this.data.STATUS_SEQ = 4;
          }
        }
      });
  }
  ExportFile() {
    this.http.Download('WH', 'SNSE202_Export', JSON.stringify(this.dataSugguestionList))
      .subscribe(res => {
        if (res) {
          this.WriteContents(res)
        } else {
          this.modal.error('EXPORT_NOT_COMPLETE', this.viewref)
        }

      })
  }
  WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "SNSE202.csv";
    a.click();
  }
  ConFirmLocation() {
    this.modal.confirm("Do you want to confirm location?", this.viewref, this.ConfirmForConFirmLocation)
  }
  ConfirmForConFirmLocation = () => {
    this.http.post('WH', 'ConFirm_Location', this.dataSugguestionList)
      .subscribe(res => {
        if (res.STATUS == "NO_CHECK") {
          this.modal.warning("No data selection", this.viewref)
        } else {
          if (res.Table[0].STATUS !== "DONE") {
            this.modal.warning(res, this.viewref)
          } else {
            this.data.DISP_CUR_STATUS = "5: Completed Process";
            this.data.STATUS_SEQ = 5;
          }
        }
      });
  }
}

