import { filter } from 'rxjs/operators';
import { Component, ElementRef, OnInit, ViewChild } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from "../../../core/modal.service";
import { ViewContainerRef } from "@angular/core";
import { SelectionModel } from '@angular/cdk/collections';
import { FormControl } from "@angular/forms";
import { isBoolean } from "util";

@Component({
  selector: 'SNWR004',
  templateUrl: './SNWR004.component.html',
  styleUrls: ['../warehouse.component.css']
})

export class SNWR004Component implements OnInit {
  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private global: Globals
  ) { }

  public dataPartTempLocation: any = [];
  public dataCategoryChange: any = [];
  public dataHighCapacity: any = [];
  public dataLowCapacity: any = [];
  public dataManualSelect: any = [];
  public dataPartSubLocation: any = [];

  public dataLocationStatus: any = [];
  public dataLocationList1: any = [];
  public dataLocationList2: any = [];
  public dataLocationList3: any = [];
  public dataLocationList4: any = [];
  public dataLocationList4Temp: any = [];
  public dataLocationList6: any = [];

  public paramSearch: any = {};
  public paramSearchHistory: any = {};

  public partInfo: any = {};
  public partPO: any = {};

  public dataConfig: any = {};

  public selectedLocation: any = {};
  public currentLocation: any = {};
  public dataByCat: any = {};
  public dataByEmpty: any = {};
  public dataByMain: any = {};

  public iTab: number = 0;
  public iByCat: number = 0;
  public iByEmpty: number = 0;
  public iByMain: number = 0;

  public iMax: number = 0;
  public iMaxEmpty: number = 0;
  public iMaxMain: number = 0;

  public selection = new SelectionModel<any>(true, []);
  public dataIsSelected: any = [];


  public ReccordCount: any = 0;
  public params = {
    locationFrom: null,
    locationTo: null,
    PrintFrom: null,
    PartFrom: null,
    PartTo: null,
    PRINT_NO: null,
    PrintTo: null
  }
  @ViewChild("dialogMain", { static: false }) dialogMain: any;
  @ViewChild("dialogSecond", { static: false }) dialogSecond: any;
  @ViewChild("fileInput") fileInput: ElementRef;
  @ViewChild("dialogUpload", { static: false }) dialogUpload: any;
  @ViewChild("dialogError", { static: false }) dialogError: any;
  @ViewChild("dialogHistory", { static: false }) dialogHistory: any;
  public tableDataUpload : any = [];
  public paramUpload: any = {};
  public error_list: any = [];
  private file : any;
  public fileNameInput: string = "";
  public isSave : boolean = false;

  myControl = new FormControl();

  public tableDataHistory: any = [];


  public ConfigLocation: any = {
    ColName: "LOOKUP_LOCATION_NO",
    PlaceholderText: "Select Location",
    SourceController: "WH",
    SourceMethodName: "SNWR004_GetLocation",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.paramSearch,
    },
    UpperCase: true
  }

  public SetLocationNoSearch(value: any) {
    if(value.LOCATION_NO){
      this.paramSearch.LOCATION_NO = value.LOCATION_NO;
      this.paramSearch.PART_NO = value.PART_NO;
      this.paramSearch.PART_NAME = value.PART_NAME;
    }
    if(this.paramSearch.PART_NO || this.paramSearch.LOCATION_NO){
      this.Search();
    }
  }

  public ConfigPart: any = {
    ColName: "LOOKUP_PART_NO",
    PlaceholderText: "Select Part",
    SourceController: "WH",
    SourceMethodName: "SNWR004_GetPart",
    NoOfShowRecords: 50,
    //locationFrom: this.params.locationFrom !== null ? this.params.locationFrom:"null",
    //locationTo: this.params.locationTo !== null ? this.params.locationTo : "null",

    SourceParams: {
      locationFrom: null,
      locationTo: null
    },
    MinLengthSearch: 1,
    UpperCase: true
  }

  public SetPartNoSearch(value: any) {
    if(value.PART_NO){
      this.paramSearch.PART_NO = value.PART_NO;
      this.paramSearch.PART_NAME_TH = value.PART_NAME_TH;
      this.paramSearch.LOCATION_NO = null;
    }
    if(this.paramSearch.PART_NO || this.paramSearch.LOCATION_NO){
      this.Search();
    }
  }

  public ConfigPrint: any = {
    ColName: "PRINT_NO",
    ColValue: "PRINT_NO",
    PlaceholderText: "Select Print",
    SourceController: "WH",
    SourceMethodName: "SNWR001_GetPrint",
    locationFrom: this.params.locationFrom !== null ? this.params.locationFrom : "null",
    locationTo: this.params.locationTo !== null ? this.params.locationTo : "null",
    PartFrom: this.params.PartFrom !== null ? this.params.PartFrom : "null",
    PartTo: this.params.PartTo !== null ? this.params.PartTo : "null",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }

  ngOnInit() {
    this.dataConfig.COMING_IN_DAY = 0;
    this.dataConfig.ETD_DAY = 0;
    this.dataConfig.M3_MAGIN_RATE = 10;
    this.dataConfig.WEIGHT_MAGIN_RATE = 10;
    this.GetPartReLocationStatus();
    this.paramSearch.LOCATION_NO = '';
    //this.GetPartReLocation1();
    //this.GetPartReLocation2();
    //this.GetPartReLocation3();
    //this.GetPartReLocation4();
  }

  public TabChange($event) {
    if ($event.index == 0) {
      this.GetPartReLocationStatus();
    } else if ($event.index == 1) {
      //this.GetPartReLocation1();
    } else if ($event.index == 2) {
      //this.GetPartReLocation6();
    } else if ($event.index == 3) {
      //this.GetPartReLocation2();
    } else if ($event.index == 4) {
      //this.GetPartReLocation3();
    } else if ($event.index == 5) {
      //this.GetPartReLocation4();
    } else if ($event.index == 6) {
      //this.GetPartReLocation5();
    }
  }

  public Search() {
    //this.myControl.markAsTouched();
    // if (this.paramSearch.LOCATION_NO.length < 4) {
    //   this.modal.warning("Please input location at less 4 characters.", this.viewRef);
    //   return;
    // }
    if (!this.paramSearch.PART_NO && !this.paramSearch.LOCATION_NO) {
      this.modal.warning("Please input location or part no to search", this.viewRef);
      return;
    } else {
    
      this.http.post('WH', 'SNWR004_GetReLocationL5', this.paramSearch)
        .subscribe(res => {
          this.dataManualSelect = res.Table;
        }, (err) => {
          console.log(err, 'err');
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });
    }
  }
  public SearchHistory() {
    this.http.post('WH', 'SNWR004_GetReLocationHistory', this.paramSearchHistory)
      .subscribe(res => {
        this.tableDataHistory = res.Table;
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });
  }

  GetPrint(code, p) {
    if (p === "F") {
      this.params.PrintFrom = code;
    }
    if (p === "T") {
      this.params.PrintTo = code;
    }
  }
  GetPart(code, p) {
    if (p === "F") {
      this.params.PartFrom = code;
    }
    if (p === "T") {
      this.params.PartTo = code;
    }
  }

  public GetPartReLocationStatus() {
    this.http.get("WH", "SNWR004_GetReLocationStatus")
      .subscribe(result => {
        this.dataLocationStatus = result.Table;
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetPartReLocation1() {
    //Temp to main location
    this.http.get("WH", "SNWR004_GetReLocationL1",this.paramSearch.TEMP_LOCATION)
      .subscribe(result => {
        this.dataPartTempLocation = result.Table;
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetPartReLocation2() {
    //Movement/Category changed
    this.http.get("WH", "SNWR004_GetReLocationL2",this.paramSearch.MOVEMENT_LOCATION)
      .subscribe(result => {
        this.dataCategoryChange = result.Table;
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetPartReLocation3() {
    //High empty
    this.http.get("WH", "SNWR004_GetReLocationL3",this.paramSearch.HIGH_LOCATION)
      .subscribe(result => {
        this.dataHighCapacity = result.Table;
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetPartReLocation4() {
    //Low empty
    this.http.get("WH", "SNWR004_GetReLocationL4",this.paramSearch.LOW_LOCATION)
      .subscribe(result => {
        this.dataLowCapacity = result.Table;
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  //public GetPartReLocation5() {
  //  this.http.post("WH", "SNWR004_GetReLocationL5", this.paramSearch)
  //    .subscribe(result => {
  //      this.dataManualSelect = result.Table;
  //    }, err => {
  //      console.log(err);
  //      this.modal.error("Found eror, please contact support team.", this.viewRef);
  //    });
  //}

  public GetPartReLocation6() {
    //Sub to main location
    this.http.get("WH", "SNWR004_GetReLocationL6", this.paramSearch.SUB_LOCATION)
      .subscribe(result => {
        this.dataPartSubLocation = result.Table;
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  //----------------- Tab 2 ------------------

  //public RetreivePart() {
  //  this.dataPartPOComming = {};
  //  this.http.post("WH", "SNWR002_GetIncomingPart", this.dataConfig)
  //    .subscribe(result => {
  //      if (result.Table.length > 0) {
  //        this.dataPartPOComming = result.Table;
  //      }
  //    }, err => {
  //      console.log(err);
  //      this.modal.error("Found eror, please contact support team.", this.viewRef);
  //    });
  //}


  public EditData(data, pTab) {
    if(data.TOTAL_QTY > 0){
      this.modal.confirm("โลเคชั่นนี้เป็นโลเคชั่นที่อยู่ระหว่าง การรับเข้าสินค้า จัดสินค้าหรือแพ็คสินค้า <br>คุณแน่ใจที่จะดำเนินการต่อใช่หรือไม่?", 
        this.viewRef, () => {
          this.ConfirmEdit(data, pTab);
      });
      // this.modal.warning("ไม่สามารถย้ายโลเคชั่นได้ เนื่องจากอยู่ระหว่าง รับเข้าสินค้า จัดสินค้าหรือแพ็คสินค้า",this.viewRef)
      // return;
    }else{
      this.ConfirmEdit(data, pTab);
    }
  }

  private ConfirmEdit(data, pTab){
    this.iTab = pTab;
    this.selectedLocation = {};
    this.currentLocation = {};
    this.iByCat = 0;
    this.partPO = data;

    this.http.post('WH', 'SNWR004_GetLocationSuggest', data)
      //this.http.get("WH", "SNWR004_GetLocationSuggest"
      //  , data.PART_NO !== null ? data.PART_NO : "null"
      //  , data.PART_CATEGORY !== null ? data.PART_CATEGORY : "null"
      //  , data.LOCATION_NO !== null ? data.LOCATION_NO : "null"
      //  , this.params.PartTo !== null ? this.params.PartTo : "null")

      .subscribe(result => {

        this.partInfo = result.Table[0];
        this.dataLocationList1 = result.Table1;
        this.dataLocationList2 = result.Table2;
        this.dataLocationList3 = result.Table3;
        this.dataLocationList4 = result.Table4;
        this.dataLocationList4Temp = result.Table4;
        this.dataLocationList6 = result.Table5;

        this.currentLocation = this.dataLocationList3[0];
        if(pTab == '6'){
          this.selectedLocation = this.dataLocationList6[0];
        } else{
          if (this.currentLocation.LOCATION_STATUS == 'R' || this.currentLocation.LOCATION_STATUS == 'DR' || this.currentLocation.LOCATION_STATUS == 'FR') {
            this.selectedLocation = this.dataLocationList2[0];
          } else {
  
          }
        }
        this.iMax = this.dataLocationList1.length;
        this.iMaxEmpty = this.dataLocationList4.length;
        this.iMaxMain = this.dataLocationList6.length;

        this.SetByCat(0);
        this.SetByEmpty(0);
        this.SetByMain(0);
        // this.SetByTemp(0);
        this.dialogMain.OpenDialog();
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }


  public SelectLocation(data) {
    let ConfirmSelectLocation = (values) =>{
      if(this.currentLocation.PARTIAL_RELOCATE == 'Y'){
        if(this.currentLocation.CAPACITY_QTY > values.CAPACITY_QTY){
          this.modal.confirm('โลเคชั่นนี้มีพื้นที่เก็บไม่เพียงพอต่อการย้ายรายการทั้งหมด <br>แน่ใจจะดำเนินการต่อใช่หรือไม่?' 
                 + ' <br> Old Shelve qty ' + this.currentLocation.CAPACITY_QTY + ' > New Capacity ' + values.CAPACITY_QTY
                 + ' <br> Location no. : ' + values.LOCATION_NO
                 + ' <br> Part no. : ' + this.partInfo.PART_NO, 
              this.viewRef, 
              () => { 
                this.selectedLocation = values;
              },
              () => {},
              {width:"35rem", height:"22rem"});
        } else{
          this.selectedLocation = values;
        }
      } else{
        this.selectedLocation = values;
      }
    }

    if (data == 1) {
      ConfirmSelectLocation(this.dataByCat)
      //this.selectedLocation = this.dataByCat; //this.dataLocationList1[this.iByCat];
    } else if (data == 3) {
      ConfirmSelectLocation(this.dataByEmpty)
      //this.selectedLocation = this.dataByEmpty; //this.dataLocationList4[this.iByEmpty];
    } else if (data == 5) {
      ConfirmSelectLocation(this.dataByMain)
      //this.selectedLocation = this.dataByMain; //this.dataLocationList4[this.iByEmpty];
    }
  }

  public SetByCat(idx) {
    this.iByCat = this.iByCat + idx;
    if (this.iByCat < 0) {
      this.iByCat = 0;
    }
    if (this.iByCat >= this.dataLocationList1.length) {
      this.iByCat = this.dataLocationList1.length - 1;
    }

    if (this.dataLocationList1.length > 0) {
      this.dataByCat = this.dataLocationList1[this.iByCat];
    }
  }

  //public FindLocation() {
  //  var temp = this.dataByEmpty.FIND_LOCATION_NO;

  //  if (this.dataLocationList4.length > 0) {
  //    this.dataByEmpty = this.dataLocationList4.find(x => x.LOCATION_NO == temp);
  //    this.dataByEmpty.FIND_LOCATION_NO = temp;
  //  }

  //}

  public FindLocation() {
    var findlocation = this.currentLocation.FIND_LOCATION_NO;
    const params = {
      LOCATION_NO: findlocation,
    }
    this.http.post("WH", "SNWR004_GetFindLocation", params)
      .subscribe(result => {
        this.dataLocationList4Temp = result.Table;
        this.dataLocationList4 = this.dataLocationList4Temp.filter(x => x.LOCATION_NO.indexOf(findlocation) == 0);
  
        if (this.dataLocationList4.length > 0){
          this.dataByEmpty = this.dataLocationList4[0];
        }else{
          this.dataByEmpty = null;
        }
  
        this.iMaxEmpty = this.dataLocationList4.length;
        this.iByEmpty = 0;
        this.SetByEmpty(0);
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public SetByEmpty(idx) {
    this.iByEmpty = this.iByEmpty + idx;
    if (this.iByEmpty < 0) {
      this.iByEmpty = 0;
    }
    if (this.iByEmpty >= this.dataLocationList4.length) {
      this.iByEmpty = this.dataLocationList4.length - 1;
    }
    if (this.dataLocationList4.length > 0) {
      this.dataByEmpty = this.dataLocationList4[this.iByEmpty];
    }
  }

  public SetByMain(idx) {
    this.iByMain = this.iByMain + idx;
    if (this.iByMain < 0) {
      this.iByMain = 0;
    }
    if (this.iByMain >= this.dataLocationList6.length) {
      this.iByMain = this.dataLocationList6.length - 1;
    }
    if (this.dataLocationList6.length > 0) {
      this.dataByMain = this.dataLocationList6[this.iByMain];
    }
  }


  private RefreshData() {
    this.dataConfig.COMING_IN_DAY = 0;
    this.dataConfig.ETD_DAY = 0;
    this.dataConfig.M3_MAGIN_RATE = 10;
    this.dataConfig.WEIGHT_MAGIN_RATE = 10;
    this.GetPartReLocationStatus();
    this.paramSearch.PART_NO = '';
    this.paramSearch.LOCATION_NO = '';
    //this.GetPartReLocation1();
    //this.GetPartReLocation2();
    //this.GetPartReLocation3();
    //this.GetPartReLocation4();
    this.dataCategoryChange = [];
    this.dataHighCapacity = [];
    this.dataLowCapacity = [];
    this.dataManualSelect = [];
    this.dataPartSubLocation = [];

    // if (this.iTab == 0) {

    // } else if (this.iTab == 1) {
    //   this.GetPartReLocation1();
    // } else if (this.iTab == 2) {
    //   this.GetPartReLocation2();
    // } else if (this.iTab == 3) {
    //   this.GetPartReLocation3();
    // } else if (this.iTab == 4) {
    //   this.GetPartReLocation4();
    // } else if (this.iTab == 5) {
    //   //this.GetPartReLocation5();
    // } else if (this.iTab == 6) {
    //   this.GetPartReLocation6();
    // } 
    // this.GetPartReLocationStatus();
  }

  public ConfirmLocation() {
    if (!this.selectedLocation.LOCATION_NO) {
      this.modal.warning("Please select location first", this.viewRef);
      return;
    }
    this.modal.confirm('Do you want to confirm set this relocation?' 
           + ' <br> Location no. : ' + this.currentLocation.LOCATION_NO + ' >>> ' + this.selectedLocation.LOCATION_NO
           + ' <br> Part no. : ' + this.partInfo.PART_NO, 
        this.viewRef, 
        () => { 
          this.ConfirmSaveLocation()
        },
        () => {},
        {width:"35rem", height:"22rem"});
  }

  private ConfirmSaveLocation = () => {
    this.selectedLocation.PART_NO = this.partInfo.PART_NO;
    this.selectedLocation.LOCATION_NO_OLD = this.currentLocation.LOCATION_NO;

    this.http.post('WH', 'SNWR004_ReLocation', this.selectedLocation)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Successfully to confirm save new location', this.viewRef);
          this.dialogMain.Close();
          this.RefreshData();
        } else if(res.Table[0].STATUS == 'FAILED'){
          this.modal.warning(res.Table[0].MESSAGE, this.viewRef);
        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.error("Found an error, please contact support team", this.viewRef);
      });
  }

  public ConfirmReLocation() {
    if (!this.selectedLocation.LOCATION_NO) {
      this.modal.warning("Please select location first", this.viewRef);
      return;
    }
    this.modal.confirm('Do you want to confirm to finish re-location for this part?' 
           + ' <br> Old Location no. : ' + this.currentLocation.LOCATION_NO
           + ' <br> New Location no. : ' + this.selectedLocation.LOCATION_NO
           + ' <br> Part no. : ' + this.partInfo.PART_NO, 
        this.viewRef, 
        () => { 
          this.ConfirmSaveReLocation()
        },
        () => {},
        {width:"35rem", height:"22rem"});
  }

  private ConfirmSaveReLocation = () => {
    this.selectedLocation.PART_NO = this.partInfo.PART_NO;
    this.selectedLocation.LOCATION_NO_OLD = this.currentLocation.LOCATION_NO;

    this.http.post('WH', 'SNWR004_ConfirmReLocation', this.selectedLocation)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.RefreshData();
          this.modal.info('Successfully to confirm location', this.viewRef);
          this.dialogMain.Close();

        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });
  }
  
  public ConfirmSubToMainLocation() {
    if (!this.selectedLocation.LOCATION_NO) {
      this.modal.warning("Please select location first", this.viewRef);
      return;
    }
    this.modal.confirm('Do you want to confirm to move sub location to selected location?' 
           + ' <br> Location no. : ' + this.currentLocation.LOCATION_NO + ' >>> ' + this.selectedLocation.LOCATION_NO
           + ' <br> Part no. : ' + this.partInfo.PART_NO, 
        this.viewRef, 
        () => { 
          this.ConfirmSaveSubToMainLocation()
        },
        () => {},
        {width:"35rem", height:"22rem"});
  }

  private ConfirmSaveSubToMainLocation = () => {
    this.selectedLocation.PART_NO = this.partInfo.PART_NO;
    this.selectedLocation.LOCATION_NO_OLD = this.currentLocation.LOCATION_NO;

    this.http.post('WH', 'SNWR004_ConfirmSubToMainLocation', this.selectedLocation)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.RefreshData();
          this.modal.info('Successfully to confirm location', this.viewRef);
          this.dialogMain.Close();
        } else {
          this.modal.error('No change to save. Something went wrong.', this.viewRef);
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });
  }

  public ConfirmRelocationList(){
    if(this.selection.isEmpty()){
      this.modal.warning("Please select some location befire confirm",this.viewRef)
      return
    }

    // let findRemark = this.selection.selected.some(x => x.ACCEPT_QTY != x.ORDER_QTY && !x.REMARKS)
    // if(findRemark){
    //   this.modal.warning("In case of edit accpet qty. Pleas input remarks",this.viewRef)
    //   return;
    // }

    this.modal.confirm("Do you want to confirm relocation?<br>Selected: " + this.selection.selected.length + " location", this.viewRef, () => ConfirmSave())

    let ConfirmSave = () =>{
      let data = {
        DETAIL : this.selection.selected
      }
      this.http.post("WH", "SNWR004_ConfirmReLocationList", data)
      .subscribe(res =>{
        if(res.STATUS == "DONE"){
          this.RefreshData();
          this.modal.info("Successfully to confirm all selected location.<br>Selected: " + this.selection.selected.length + " location", this.viewRef);
          this.selection.clear()
        }else{
          this.modal.error("Found error please contact support team",this.viewRef);
        }
      }, err =>{
        console.log(err, 'err');
        this.modal.error("Found error please contact support team",this.viewRef);
      })
    }
  }

  public isAllSelected() {
    const numSelected = this.selection.selected.length;
    const numRows = this.dataLocationStatus.filter((x) => x.NEW_LOCATION_NO).length;
    return numSelected === numRows;
  }

  public Toggle() {
    if (this.isAllSelected()) {
      this.selection.clear()
      this.dataLocationStatus.filter((x) => x.NEW_LOCATION_NO).map(x => {
        this.dataIsSelected = [];
      })
    } else {
      this.dataIsSelected = [];
      this.dataLocationStatus.filter((x) => x.NEW_LOCATION_NO).forEach(row => this.selection.select(row));
      this.dataLocationStatus.filter((x) => x.NEW_LOCATION_NO).map(x => {
        this.dataIsSelected.push(x);
      })
    }

  }

  public CheckboxChange(event, data) {
    if (event.checked) {

      this.dataIsSelected.push(data);
    }
    else {
      this.dataIsSelected.splice(this.dataIsSelected.indexOf(data), 1);
    }
    // this.params.CNT_SEL = this.dataIsSelected.length;
  }

  public OpenReport() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR004_RE_LOCATION_ST",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_USER_ID: '1'
      });
  }

  public OpenRelocationHistoryReport() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR004_RELOCATION_HISTORY", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_LOCATION_NO: this.paramSearchHistory.LOCATION_NO,
      P_PART_NO: this.paramSearchHistory.PART_NO,
    });
  }
  public OpendialogRelocationHistoryReport() {
    this.dialogHistory.OpenDialog();
    this.fileNameInput = "";
    this.tableDataHistory = []
  }

  public PrintLocation() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR004_RE_LOCATION_ST",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_USER_ID: '1'
      });
  }

  public OpendialogUpload(){
    this.paramUpload = {};
    this.paramUpload.errorList = [];
    this.paramUpload.errorCount = 0;
    this.error_list = [];
    this.dialogUpload.OpenDialog();
    this.fileNameInput = "";
    //this.fileInput.nativeElement.value = '';
    this.tableDataUpload = []
    this.isSave = false
  }
  public OpenFileBrowser() {
    this.fileNameInput = "";
    this.fileInput.nativeElement.value = '';
    this.fileInput.nativeElement.click();
  }
  public SelectFile(evt) {
    let Files: Array<File> = evt.target.files;
    if (Files.length > 0) {
      //let File: File = Files[0];
      this.file = Files[0];
      this.fileNameInput = this.file.name;
    }
  }
  public PreView() {
    if (!this.fileInput) {
      this.modal.warning("Please Open File First...", this.viewRef)
      return;
    }
        let formData = new FormData();
        formData.append('file', this.file);
        
        this.tableDataUpload = [];
        this.paramUpload.errorList = [];
        this.paramUpload.errorCount = 0;
        this.http.postFile("WH", "SNWR004_PreviewUploadExcel", formData)
            .subscribe(result => {   
              this.tableDataUpload = result.set.Table;
              this.isSave = false;
              let countrow = 0;
              this.tableDataUpload.map((x,i) => {
                if(x.ERR_FLAG == 'Y'){
                    countrow += 1;
                    this.paramUpload.errorList.push({
                        record : x.SEQ,
                        message : x.ERR_MSG
                    })
                } 
                this.paramUpload.errorCount = countrow;
              })
            }, err => {
              console.log(err, 'err');
              this.modal.error("Upload not complete", this.viewRef);
            })
  }

  public SaveByUpload(){
    this.modal.confirm("Do you want to confirm relocation?",this.viewRef,() => ConfirmSave())

    let ConfirmSave = () => {
      const params = {}
      this.http.post("WH","SNWR004_SaveByUpload", params)
      .subscribe(res => {
        if(res.status == "DONE"){
          this.RefreshData();
          this.isSave = true;
          this.dialogUpload.Close();
          this.modal.info("Save Relocation " + this.tableDataUpload.length + " records complete", this.viewRef);
        }else{
          this.modal.error(res.message,this.viewRef)
        }
      },err => {
        console.log(err, 'err')
        this.modal.error('Found an error, please contract support team.', this.viewRef);
      })
    }
  }

  public OpenDialogError(data){
    this.error_list = data;
    this.dialogError.OpenDialog()
  }

  public DownloadTemplate(){
    let link = "assets/templates/SNWR004_RELOCATION_TEMPLATE.xlsx"
    window.open(link,'_blank')
  }
}
