import { Component, OnInit, AfterViewInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Globals } from 'src/app/core/global';
import { ModalService } from "../../../core/modal.service";

import { MatTableModule } from '@angular/material/table';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';
import { MatTableDataSource } from '@angular/material/table';
import * as moment from 'moment';


@Component({
  selector: 'SNWR009',
  templateUrl: './SNWR009.component.html',
  styleUrls: ['./SNWR009.component.css']
})

export class SNWR009Component implements OnInit {

  constructor(
    private httpService: HttpService,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private global: Globals
  ) { }

  @ViewChild(MatPaginator, { static: true }) paginator: MatPaginator;
  @ViewChild(MatSort, { static: true }) sort: MatSort;
  @ViewChild("dialogPART", { static: true }) dialogPART: any;
  @ViewChild("dialogINVOICE", { static: true }) dialogINVOICE: any;
  @ViewChild("dialogChart", { static: true }) dialogChart: any;

  public displayedColumns_Daily =
    [
      'VIEW_DATE',
      'P_TOTAL_INVOICE',
      'P_TOTAL_ITEM',
      'P_TOTAL_QTY',
      'R_TOTAL_INVOICE',
      'R_TOTAL_ITEM',
      'R_TOTAL_QTY',
      'S_TOTAL_INVOICE',
      'S_TOTAL_ITEM',
      'S_TOTAL_QTY'
    ];

  public displayedColumns_Performance =
    [
      'PIC_RECEIVE',
      'R_TOTAL_INVOICE',
      'R_TOTAL_ITEM',
      'R_TOTAL_QTY',
      'S_TOTAL_INVOICE',
      'S_TOTAL_ITEM',
      'S_TOTAL_QTY'
    ];

  public displayedColumns_ReceiveMonitor =
    [
      'ROW_NUMBER',
      'CREATE_DATE',
      'INVOICE_TYPE',
      'INVOICE_NO',
      'VENDOR_CODE',
      'VENDOR_TYPE',
      'TOTAL_ITEM',
      'TOTAL_QTY',
      'ITEM',
      'QTY',
      'REMAIN_ITEM',
      'REMAIN_QTY'
    ];
  public displayedColumns_ReceiveMonitor_Summary =
    [
      'HEAD',
      'HEAD_INVOICE_TYPE',
      'SUM_TOTAL_INVOICE',
      'SUM_CAPTION',
      'SUM_TOTAL_ITEM',
      'SUM_TOTAL_QTY',
      'SUM_ITEM',
      'SUM_QTY',
      'SUM_REMAIN_ITEM',
      'SUM_REMAIN_QTY'
    ];

  public displayedColumns_ReceiveMonitorPlus =
    [
      'ROW_NUMBER',
      'CREATE_DATE',
      'INVOICE_TYPE',
      'INVOICE_NO',
      'VENDOR_CODE',
      'VENDOR_TYPE',
      'TOTAL_ITEM',
      'TOTAL_QTY',
      'ITEM',
      'QTY',
      'REMAIN_ITEM',
      'REMAIN_QTY'
    ];

  public displayedColumns_ReceiveMonitorPlus_Summary =
    [
      'HEAD',
      'HEAD_INVOICE_TYPE',
      'SUM_TOTAL_INVOICE',
      'SUM_CAPTION',
      'SUM_TOTAL_ITEM',
      'SUM_TOTAL_QTY',
      'SUM_ITEM',
      'SUM_QTY',
      'SUM_REMAIN_ITEM',
      'SUM_REMAIN_QTY'
    ];

  public dataDaily: MatTableDataSource<any>;
  public dataPerformance: MatTableDataSource<any>;
  public dataTimeUsagePart: any = {};
  public dataTimeUsageInvoice: any = {};

  public dataRow: any = {};
  public dataPIC: any = {};

  public paramDaily: any = { START_DATE:'', END_DATE:'' };
  public paramPerformance: any = { PIC_RECEIVE: '', VIEW_DATE: ''};
  public paramTimeUsagePart: any = { PIC_RECEIVE: '', PART_NO: '', VIEW_DATE: '', TYPE: ''};
  public paramTimeUsageInvoice: any = { PIC_RECEIVE:'', INVOICE_NO: '', VIEW_DATE: ''};


  public dataReceiveMonitor: MatTableDataSource<any>;
  public dataReceiveMonitorPlus: MatTableDataSource<any>;

  public paramReceiveMonitor: any = { START_DATE: '', END_DATE: '' };
  public paramReceiveMonitorPlus: any = { START_DATE: '', END_DATE: '' };

  public showList: boolean = true;
  public showReport: any = {};


  public arrayRoute: string[] = [];
  public routes: any = {};
  public DataCard :any = []
  public Legent : any =[]


  public ngOnInit(): void {

    this.Legent = [{ legend: "PICK", color: '#1e477b' }, { legend: "SHELVE", color: '#ffa500'}]
    //this.paramDaily.START_DATE = moment("2022-02-01", "YYYY-MM-DD").format("DD-MMM-YY");
    //this.paramDaily.END_DATE = moment("2022-02-05", "YYYY-MM-DD").format("DD-MMM-YY");

    //this.paramReceiveMonitor.START_DATE = moment("2022-02-01", "YYYY-MM-DD").format("DD-MMM-YY");
    //this.paramReceiveMonitor.END_DATE = moment("2022-02-05", "YYYY-MM-DD").format("DD-MMM-YY");

    this.routes = '';

    this.dataDaily = new MatTableDataSource();
    this.dataPerformance = new MatTableDataSource();
    this.dataReceiveMonitor = new MatTableDataSource();
    this.dataReceiveMonitorPlus = new MatTableDataSource();

    //this.GetDaily();
    //this.dataDaily.paginator = this.paginator;
    //this.dataDaily.sort = this.sort;

    //this.dataPerformance.paginator = this.paginator;
    //this.dataPerformance.sort = this.sort;
  }

  public OpenChart(){
    this.dialogChart.OpenDialog();
  }
  public OpenReportChart(){
    this.global.GoToReport("PMS_RPT_WMS_SNWR009_DAILY_CHART", {  
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: this.SetFormatDate(this.paramDaily.START_DATE), 
      P_END_DATE: this.SetFormatDate(this.paramDaily.END_DATE)})
  }

  public OpenReportProductLocal() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR009_PRODUCTIVITY_LOCAL", {
      P_START_DATE: this.SetFormatDate(this.paramDaily.START_DATE),
      P_END_DATE: this.SetFormatDate(this.paramDaily.END_DATE)   
    })
  }

  public OpenReportProductImport() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR009_PRODUCTIVITY_IMPORT", {
      P_START_DATE: this.SetFormatDate(this.paramDaily.START_DATE),
      P_END_DATE: this.SetFormatDate(this.paramDaily.END_DATE)
    })
  }


  public OpenReportProductLocalMonthly() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR009_PRODUCTIVITY_SUM_LOCAL", {
      P_START_DATE: this.SetFormatDate(this.paramDaily.START_DATE),
      P_END_DATE: this.SetFormatDate(this.paramDaily.END_DATE)
    })
  }


  public OpenReportProductImportMonthly() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR009_PRODUCTIVITY_SUM_IMPORT", {
      P_START_DATE: this.SetFormatDate(this.paramDaily.START_DATE),
      P_END_DATE: this.SetFormatDate(this.paramDaily.END_DATE)
    })
  }


  public OpenReportShelveLocal() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR009_PRODUCTIVITY_SHELVE_LOCAL", {
      P_START_DATE: this.SetFormatDate(this.paramDaily.START_DATE),
      P_END_DATE: this.SetFormatDate(this.paramDaily.END_DATE)
    })
  }

  public OpenReportShelveImport() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR009_PRODUCTIVITY_SHELVE_IMPORT", {
      P_START_DATE: this.SetFormatDate(this.paramDaily.START_DATE),
      P_END_DATE: this.SetFormatDate(this.paramDaily.END_DATE)
    })
  }


  public OpenReportShelveLocalMonthly() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR009_PRODUCTIVITY_SUM_SHELVE_LOCAL", {
      P_START_DATE: this.SetFormatDate(this.paramDaily.START_DATE),
      P_END_DATE: this.SetFormatDate(this.paramDaily.END_DATE)
    })
  }


  public OpenReportShelveImportMonthly() {
    this.global.GoToReport("PMS_RPT_WMS_SNWR009_PRODUCTIVITY_SUM_SHELVE_IMPORT", {
      P_START_DATE: this.SetFormatDate(this.paramDaily.START_DATE),
      P_END_DATE: this.SetFormatDate(this.paramDaily.END_DATE)
    })
  }

  public GetDaily(): void {
    if (this.paramDaily.START_DATE.length <= 0) {
      this.modal.warning("Please input Start date", this.viewRef);
      return;
    }
    else if (this.paramDaily.END_DATE.length <= 0) {
      this.modal.warning("Please input End date", this.viewRef);
      return;
    }
    else if (this.paramDaily.START_DATE > this.paramDaily.END_DATE) {
      this.modal.warning("Please input Start date < End date", this.viewRef);
      return;
    }
    this.dataDaily = new MatTableDataSource<any>();
    this.httpService.post("WH", "SNWR009_GetDaily", this.paramDaily)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.dataDaily = new MatTableDataSource<any>(result.Table);
        }
        else {
          this.modal.info("No data found!.", this.viewRef);
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });


      let param = {
        START_DATE : this.SetFormatDate(this.paramDaily.START_DATE),
        END_DATE : this.SetFormatDate(this.paramDaily.END_DATE),
      }
      this.httpService.post("WH", "SNWR009_GetDailyChart", param)
      .subscribe(result => {
          
          this.DataCard = result.Table
          console.log(this.DataCard,'dd')
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public ViewDetail(data): void {
    this.showList = false;
    this.dataRow = data;

    this.PushRoute("Daily Report");
    this.PushRoute("Shelve Performance");
    this.GetPerformance();
  }

  public GetPerformance(): void {

    this.paramPerformance.VIEW_DATE = this.dataRow.VIEW_DATE;

    this.dataPerformance = new MatTableDataSource<any>();
    this.httpService.post("WH", "SNWR009_GetPerformance", this.paramPerformance)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.dataPerformance = new MatTableDataSource<any>(result.Table);
        }
        else {
          this.modal.info("No data found!.", this.viewRef);
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetTimeUsagePart(): void {

    this.paramTimeUsagePart.VIEW_DATE = this.dataRow.VIEW_DATE;

    this.dataTimeUsagePart = {};
    this.httpService.post("WH", (this.paramTimeUsagePart.TYPE == "R" ? "SNWR009_GetTimeUsagePartReceive" : "SNWR009_GetTimeUsagePartShelve"), this.paramTimeUsagePart)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.dataTimeUsagePart = result.Table;
        }
        else {
          this.modal.info("No data found!.", this.viewRef);
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetTimeUsageInvoice(): void {

    this.paramTimeUsageInvoice.VIEW_DATE = this.dataRow.VIEW_DATE;

    this.dataTimeUsageInvoice = {};
    this.httpService.post("WH", "SNWR009_GetTimeUsageInvoice", this.paramTimeUsageInvoice)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.dataTimeUsageInvoice = result.Table;
        }
        else {
          this.modal.info("No data found!.", this.viewRef);
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetReceiveMonitor(): void {
    this.dataReceiveMonitor = new MatTableDataSource<any>();
    this.httpService.post("WH", "SNWR009_GetReceiveMonitor", this.paramReceiveMonitor)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.dataReceiveMonitor = new MatTableDataSource<any>(result.Table);
        }
        else {
          this.modal.info("No data found!.", this.viewRef);
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetReceiveMonitorPlus(): void {
    this.dataReceiveMonitorPlus = new MatTableDataSource<any>();
    this.httpService.post("WH", "SNWR009_GetReceiveMonitorPlus", this.paramReceiveMonitorPlus)
      .subscribe(result => {
        if (result.Table.length > 0) {
          this.dataReceiveMonitorPlus = new MatTableDataSource<any>(result.Table);
        }
        else {
          this.modal.info("No data found!.", this.viewRef);
        }
      }, err => {
        console.log(err);
        this.modal.error("Found eror, please contact support team.", this.viewRef);
      });
  }

  public GetSummary(column) {
    //console.log(this.dataReceiveMonitor.data);
    //console.log(this.dataReceiveMonitor.data.reduce);
    let initialValue = 0
    let sum = this.dataReceiveMonitor.data.reduce(function (previousValue, currentValue) {
      switch (column) {
        case "TOTAL_ITEM": return previousValue + currentValue.TOTAL_ITEM
          break;
        case "TOTAL_QTY": return previousValue + currentValue.TOTAL_QTY
          break;
        case "ITEM": return previousValue + currentValue.ITEM
          break;
        case "QTY": return previousValue + currentValue.QTY
          break;
        case "REMAIN_ITEM": return previousValue + currentValue.REMAIN_ITEM
          break;
        case "REMAIN_QTY": return previousValue + currentValue.REMAIN_QTY
          break;
        default: 0
      }
    }, initialValue)

    return sum;
  }

  public GetSummaryPlus(column) {
    //console.log(this.dataReceiveMonitor.data);
    //console.log(this.dataReceiveMonitor.data.reduce);
    let initialValue = 0
    let sum = this.dataReceiveMonitorPlus.data.reduce(function (previousValue, currentValue) {
      switch (column) {
        case "TOTAL_ITEM": return previousValue + currentValue.TOTAL_ITEM
          break;
        case "TOTAL_QTY": return previousValue + currentValue.TOTAL_QTY
          break;
        case "ITEM": return previousValue + currentValue.ITEM
          break;
        case "QTY": return previousValue + currentValue.QTY
          break;
        case "REMAIN_ITEM": return previousValue + currentValue.REMAIN_ITEM
          break;
        case "REMAIN_QTY": return previousValue + currentValue.REMAIN_QTY
          break;
        default: 0
      }
    }, initialValue)

    return sum;
  }

  public GetCountItem(column) {
    let initialValue = 0;
    let count = 0;
    this.dataReceiveMonitor.data.reduce(function (previousValue, currentValue) {
      count += 1
    }, initialValue)

    return count;
  }

  public GetCountItemPlus(column) {
    let initialValue = 0;
    let count = 0;
    this.dataReceiveMonitorPlus.data.reduce(function (previousValue, currentValue) {
      count += 1
    }, initialValue)

    return count;
  }

  public TabChange($event): void {
    if ($event.index == 0) {
      if (this.paramDaily.START_DATE.lenght > 0 && this.paramDaily.END_DATE.lenght > 0) {
        this.GetDaily();
      }
    } else if ($event.index == 1) {
      this.GetReceiveMonitor();
    } else if ($event.index == 2) {
      this.GetReceiveMonitorPlus();
    }
  }

  public OpenDialogPart(row,type): void {
    this.paramTimeUsagePart.PIC_RECEIVE = row.PIC_RECEIVE;
    this.paramTimeUsagePart.TYPE = type;
    this.GetTimeUsagePart();
    this.dialogPART.OpenDialog();
  }

  public OpenDialogInvoice(row): void {
    this.paramTimeUsageInvoice.PIC_RECEIVE = row.PIC_RECEIVE;
    this.GetTimeUsageInvoice();
    this.dialogINVOICE.OpenDialog();
  }

  public BackToHead(): void {
    this.showList = true;
    this.PopRoute();
    this.PopRoute();
  }

  public OpenReport(tab): void {
    switch (tab) {
      case "Daily":
        this.global.GoToReport("PMS_RPT_WMS_SNWR009_DAILY",
          {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_START_DATE: moment(this.paramDaily.START_DATE, "YYYY-MM-DD").format("DD-MMM-YY"),
            P_END_DATE: moment(this.paramDaily.END_DATE, "YYYY-MM-DD").format("DD-MMM-YY"),
            P_USER: this.global.GetTokenDetail("ssUserID")
          });
        break;
      case "Performance":
        this.global.GoToReport("PMS_RPT_WMS_SNWR009_PERFORMANCE",
          {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_USER: this.global.GetTokenDetail("ssUserID"),
            P_VIEW_DATE: moment(this.paramPerformance.VIEW_DATE, "YYYY-MM-DD").format("DD-MMM-YY")
          });
        break;
      case "TimeUsagePart":
        if (this.paramTimeUsagePart.TYPE == "R") {
          this.global.GoToReport("PMS_RPT_WMS_SNWR009_TIME_USAGE_PART_RECEIVE",
            {
              P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
              P_USER: this.global.GetTokenDetail("ssUserID"),
              P_PIC: this.paramTimeUsagePart.PIC_RECEIVE,
              P_VIEW_DATE: moment(this.paramTimeUsagePart.VIEW_DATE, "YYYY-MM-DD").format("DD-MMM-YY")
            });
        }
        else {

          this.global.GoToReport("PMS_RPT_WMS_SNWR009_TIME_USAGE_PART",
            {
              P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
              P_USER: this.global.GetTokenDetail("ssUserID"),
              P_PIC: this.paramTimeUsagePart.PIC_RECEIVE,
              P_VIEW_DATE: moment(this.paramTimeUsagePart.VIEW_DATE, "YYYY-MM-DD").format("DD-MMM-YY")
            });
        }
        break;
      case "TimeUsageInvoice":
        this.global.GoToReport("PMS_RPT_WMS_SNWR009_TIME_USAGE_INVOICE",
          {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_USER: this.global.GetTokenDetail("ssUserID"),
            P_PIC: this.paramTimeUsageInvoice.PIC_RECEIVE,
            P_VIEW_DATE: moment(this.paramTimeUsageInvoice.VIEW_DATE, "YYYY-MM-DD").format("DD-MMM-YY")
          });
        break;
      case "ReceiveMonitor":
        this.global.GoToReport("PMS_RPT_WMS_SNWR009_RECEIVE_MONITOR_R",
          {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode")
          });
        break;
      case "ReceiveMonitorPlus":
        this.global.GoToReport("PMS_RPT_WMS_SNWR009_RECEIVE_MONITOR_S_PLUS",
          {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode")
          });
        break;
    }
  }

  public CheckIsZeroOrNull(value) {
    if (value == 0 || value == '') {
      return true;
    } else {
      return false;
    }
  }

  public PushRoute(value) {
    this.arrayRoute.push(value);
    this.SetRoute();
  }

  public PopRoute() {
    this.arrayRoute.pop();
    this.SetRoute();
  }

  public SetRoute() {
    this.routes = this.arrayRoute.join(" -> ");
  }

  SetFormatDate(date) {
    if (date) {
      let d = new Date(date);
      let day = d.getDate();
      let newDay = day.toString().length < 2 ? 0 + '' + day : day
      let year = d.getFullYear()
      let month = d.getMonth() + 1;
      let newMonth = month.toString().length < 2 ? 0 + '' + month : month
      return newDay + '-' + newMonth + '-' + year;
    }
  }

}

