import { SelectionModel } from "@angular/cdk/collections";
import {
  Component,
  ElementRef,
  OnInit,
  ViewChild,
  ViewContainerRef,
} from "@angular/core";
import { Globals } from "src/app/core/global";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "src/app/core/modal.service";

@Component({
  selector: "snwr010",
  templateUrl: "SNWR010.component.html",
})
export class SNWR010Component implements OnInit {
  constructor(
    private global: Globals,
    private http: HttpService,
    private modal: ModalService,
    private viewRef: ViewContainerRef
  ) {}

  public deliveryConfirmedUPC: any[] = [];
  private file: any;
  public fileNameInput: string = "";
  @ViewChild("fileInput") fileInput: ElementRef;

  ngOnInit() {}

  public OpenFileBrowser() {
    this.fileNameInput = "";
    this.fileInput.nativeElement.value = "";
    this.fileInput.nativeElement.click();
  }

  public SelectFile(evt) {
    let Files: Array<File> = evt.target.files;
    if (Files.length > 0) {
      this.file = Files[0];
      this.fileNameInput = this.file.name;
    }
  }

  public UploadDeliveryList() {
    if (!this.fileInput) {
      this.modal.warning("Please Open File First...", this.viewRef);
      return;
    }
    let formData = new FormData();
    formData.append("file", this.file);
    this.http.postFile("WH", "SNWR010_UploadFile", formData).subscribe(
      (res) => {
        this.deliveryConfirmedUPC = res;
        this.modal.info("Upload complete", this.viewRef);
      },
      (err) => {
        this.modal.error("Upload not complete", this.viewRef);
      }
    );
  }
}
