import { Component, OnInit, ViewContainerRef, ViewChild } from "@angular/core";
import * as moment from "moment";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "src/app/core/modal.service";
import { DialogTemplateComponent } from "src/app/components/shared/dialog-template/dialog-template.component";

@Component({
  selector: "SNWR016",
  templateUrl: "SNWR016.component.html",
})
export class SNWR016Component implements OnInit {
  constructor(
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private http: HttpService
  ) { }

  public params: any = {};
  public invoiceData: any = {};
  public insData: any = {};
  private currentDate: moment.Moment = moment();

  public tableDataPick: any = [];
  public tablePickingByPicker: any = [];

  public iSelectTab: number = 0;
  public iShowBy: number = 0;
  public tabIndex: number = 0;
  public ENABLE_CANCEL_PICK = '';

  public sumPick: any[] = [
    {
      fieldName: 'CUSTOMER_CODE',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'NO_OF_INSTRUCTION',
      show: true,
    },
    {
      fieldName: 'ACCEPT_QTY',
      show: true,
    },
    {
      fieldName: 'PICK_QTY',
      show: true,
    },
    {
      fieldName: 'PICK_QTY_BAL',
      show: true,
    },
  ];
  public sumPack: any[] = [
    {
      fieldName: 'CUSTOMER_CODE',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'NO_OF_INSTRUCTION',
      show: true,
    },
    {
      fieldName: 'ACCEPT_QTY',
      show: true,
    },
    {
      fieldName: 'PICK_QTY',
      show: true,
    },
    {
      fieldName: 'PICK_QTY_BAL',
      show: true,
    },
  ];
  public sumInv: any[] = [
    {
      fieldName: 'PART_NAME',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'ITEM_QTY',
      show: true,
    },
    {
      fieldName: 'NET_AMT_B',
      show: true,
    },
    {
      fieldName: 'TOTAL_ITEM',
      show: true,
    },
    {
      fieldName: 'TOTAL_QTY',
      show: true,
    },
    {
      fieldName: 'TOTAL_RETAIL_B',
      show: true,
    },
  ];

  public tableDataAllocated: any = [];
  public tableDataNotPick: any = [];
  public tableDataPicking: any = [];
  public tableDataPicked: any = [];
  public tableDataPacked: any = [];
  public tableDataInvoice: any = [];
  public tableDetailName: any = '';

  public tableDataDetail: any = [];
  public invoiceDetail: any = [];

  @ViewChild("dialogDetail", { static: false }) dialogDetail: any;
  @ViewChild("InvoiceDialog") InvoiceDialog: DialogTemplateComponent;
  @ViewChild("InstructionDialog") InstructionDialog: DialogTemplateComponent;

  ngOnInit() {
    this.params.START_DATE = this.currentDate;
    this.params.END_DATE = this.currentDate;
    this.params.CUSTOMER_ZONE = 'ALL';
    this.params.ORDER_TYPE = 'ALL';
    this.iSelectTab = 0;
    this.iShowBy = 1;
    this.Search();
  }

  public ViewBy1(i) {
    this.iShowBy = i;
  }

  public tabClick(tab: any) {
    this.iSelectTab = tab;
    this.Search();
  }

  public FindIns() {

    this.tableDataDetail = [];
    this.tableDetailName = 'SNWR016_INSTRUCTION_DETAIL';
    this.params.INSTRUCTION_NO = '';
    this.insData = {};
    this.InstructionDialog.OpenDialog();
   

  }

  public CutoffBKK() {

    this.tableDataDetail = [];
    this.params.CUSTOMER = '';
    var data;
    this.http.post('WH', 'SNWR016_GetCutOffBKK', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR016_PICKED_DETAIL';
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })

  }

  public CutoffUPC() {

    this.tableDataDetail = [];
    this.params.CUSTOMER = '';
    var data;
    this.http.post('WH', 'SNWR016_GetCutOffUPC', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR016_PICKED_DETAIL';
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })

  }

  public FindInsClick() {
  
    //this.tableDetailName = 'SNWR016_PICKED_DETAIL';
   // this.InstructionDialog.OpenDialog();
    this.ENABLE_CANCEL_PICK = '';
    this.http.post('WH', 'SNWR016_FindInstruction', this.params)
      .subscribe(res => {
        var tableDataDetail = res.Table;


    
       // console.log('1 res.Table ' ,res.Table);
        //console.log('2 tableDataDetail',tableDataDetail);
       // console.log('3 tableDataDetail.RowCount', tableDataDetail.length);
       
        if (tableDataDetail.length > 0) {
          if (tableDataDetail[0].COMPLETE_FLAG == 'A') {
            this.tableDetailName = 'SNWR016_ALLOCATE_DETAIL';
          } else if (tableDataDetail[0].COMPLETE_FLAG == 'N') {
            this.tableDetailName = 'SNWR016_NOT_PICK_DETAIL';
          } else if (tableDataDetail[0].COMPLETE_FLAG == 'L') {
            this.tableDetailName = 'SNWR016_PICKING_DETAIL';
          } else if (tableDataDetail[0].COMPLETE_FLAG == 'P') {
            this.tableDetailName = 'SNWR016_PICKED_DETAIL';
          } else if (tableDataDetail[0].COMPLETE_FLAG == 'C') {
            this.tableDetailName = 'SNWR016_PACKED_DETAIL';
          } else if (tableDataDetail[0].COMPLETE_FLAG == 'I') {
            this.tableDetailName = 'SNWR023_INV_DETAIL';
          } else {
            this.tableDetailName = 'SNWR023_INV_DETAIL';
          }

          //console.log('this.tableDetailName', this.tableDetailName);

          this.tableDataDetail = res.Table;

          this.insData = this.tableDataDetail[0];
          this.ENABLE_CANCEL_PICK = this.tableDataDetail[0].ENABLE_CANCEL_PICK;
        } else {
          this.modal.warning("ไม่พบข้อมูล กรุณารบกวนตรวจสอบเลข instruction", this.viewRef);
        }

       // this.InstructionDialog.OpenDialog();

      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      });

  }

  public CancelPick() {

    this.modal.confirm("Are you sure to cancel pick : P/N =  " + this.insData.ACCEPT_PART_NO + " ?", this.viewRef, () => {

      this.http.post('WH', 'SNWR016_CancelPick', this.params)
        .subscribe(res => {
          this.modal.info('Cancel pick completed', this.viewRef);
          this.InstructionDialog.Close()
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })

    });

  }
  

  public Search() {
    if (this.iSelectTab == 0) {
      this.http.post('WH', 'SNWR016_GetDataAllocated', this.params)
        .subscribe(res => {
          this.tableDataAllocated = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        });

    } else if (this.iSelectTab == 1) {
      this.http.post('WH', 'SNWR016_GetDataNotPick', this.params)
        .subscribe(res => {
          this.tableDataNotPick = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        });

    } else if (this.iSelectTab == 2) {
      this.http.post('WH', 'SNWR016_GetDataPicking', this.params)
        .subscribe(res => {
          this.tableDataPicking = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        });

    } else if (this.iSelectTab == 3) {
      this.http.post('WH', 'SNWR016_GetDataPicked', this.params)
        .subscribe(res => {
          this.tableDataPicked = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        });

    } else if (this.iSelectTab == 4) {
      this.http.post("WH", "SNWR016_GetDataPacked", this.params)
        .subscribe((res) => {
          this.tableDataPacked = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });

    } else if (this.iSelectTab == 5) {
      this.http.post('WH', 'SNWR016_GetDataInvoice', this.params)
        .subscribe(res => {
          this.tableDataInvoice = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })
    }
  }

  public ViewDetailAllocated(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR016_GetDetailAllocated', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR016_ALLOCATE_DETAIL';
        this.dialogDetail.OpenDialog();

      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public ViewDetailNotPick(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR016_GetDetailNotPick', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR016_NOT_PICK_DETAIL';
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public ViewDetailPicking(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR016_GetDetailPicking', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR016_PICKING_DETAIL';
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public ViewDetailPicked(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR016_GetDetailPicked', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR016_PICKED_DETAIL';
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public ViewDetailPacked(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR016_GetPackedDetail', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR016_PACKED_DETAIL';
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public ViewDetailInvoice(data: any) {
    this.InvoiceDialog.OpenDialog();
    this.invoiceData = data;
    this.http.post("WH", "SNWR023_GetInvoiceDetail", this.invoiceData)
      .subscribe(res => {
        this.invoiceDetail = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }

  public ViewDetailByPicker(data: any) {
    this.tableDataDetail = [];
    this.http.post('WH', 'SNWR016_GetDataDetailByPicker', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewRef);
      })
  }




}
