import { Component, OnInit, ViewContainerRef, ViewChild } from "@angular/core";
import * as moment from "moment";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "src/app/core/modal.service";
import { Globals } from 'src/app/core/global';
import { DialogTemplateComponent } from "src/app/components/shared/dialog-template/dialog-template.component";

@Component({
  selector: "SNWR036",
  templateUrl: "SNWR036.component.html",
})
export class SNWR036Component implements OnInit {
  constructor(
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private global: Globals,
    private http: HttpService
  ) { }

  public params: any = {};
  public invoiceData: any = {};
  public insData: any = {};
  private currentDate: moment.Moment = moment();

  public tableDataPick: any = [];
  public tablePickingByPicker: any = [];

  public iSelectTab: number = 0;
  public iShowBy: number = 0;
  public tabIndex: number = 0;
  public searchBy: string = '';
  public ENABLE_CANCEL_PICK = '';

  public sumAllocate: any[] = [
    {
      fieldName: 'CUSTOMER_CODE',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'NO_OF_ITEM',
      show: true,
    },
    {
      fieldName: 'ACCEPT_QTY',
      show: true,
    },
  ];
  public sumPick: any[] = [
    {
      fieldName: 'CUSTOMER_CODE',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'NO_OF_INSTRUCTION',
      show: true,
    },
    {
      fieldName: 'ACCEPT_QTY',
      show: true,
    },
    {
      fieldName: 'PICK_QTY',
      show: true,
    },
    {
      fieldName: 'PICK_QTY_BAL',
      show: true,
    },
  ];
  public sumReceive: any[] = [
    {
      fieldName: 'CUSTOMER_CODE',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'NO_OF_INSTRUCTION',
      show: true,
    },
    {
      fieldName: 'NO_OF_BABYCARD',
      show: true,
    },
    {
      fieldName: 'ACCEPT_QTY',
      show: true,
    },
    {
      fieldName: 'PICK_QTY',
      show: true,
    },
    {
      fieldName: 'PICK_QTY_BAL',
      show: true,
    },
    {
      fieldName: 'RECEIVE_QTY',
      show: true,
    },
  ];
  public sumPack: any[] = [
    {
      fieldName: 'CUSTOMER_CODE',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'NO_OF_CASE',
      show: true,
    },
    {
      fieldName: 'NO_OF_INSTRUCTION',
      show: true,
    },
    {
      fieldName: 'NO_OF_BABYCARD',
      show: true,
    },
    {
      fieldName: 'BABY_QTY',
      show: true,
    },
    {
      fieldName: 'RECEIVE_QTY',
      show: true,
    },
    {
      fieldName: 'PACK_QTY',
      show: true,
    },
    {
      fieldName: 'PACK_QTY_BAL',
      show: true,
    },
  ];
  public sumVan: any[] = [
    {
      fieldName: 'CUSTOMER_CODE',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'NO_OF_CASE',
      show: true,
    },
    {
      fieldName: 'NO_OF_INSTRUCTION',
      show: true,
    },
    {
      fieldName: 'NO_OF_BABYCARD',
      show: true,
    },
    {
      fieldName: 'TOTAL_QTY',
      show: true,
    },
    {
      fieldName: 'BABY_QTY',
      show: true,
    },
    {
      fieldName: 'RECEIVE_QTY',
      show: true,
    },
    {
      fieldName: 'PACK_QTY',
      show: true,
    },
  ];
  public sumPreinvoice: any[] = [
    {
      fieldName: 'PART_NAME',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'NO_OF_VAN',
      show: true,
    },
    {
      fieldName: 'NO_OF_CASE',
      show: true,
    },
  ];
  public sumInv: any[] = [
    {
      fieldName: 'PART_NAME',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'ITEM_QTY',
      show: true,
    },
    {
      fieldName: 'NET_AMT_B',
      show: true,
    },
    {
      fieldName: 'TOTAL_ITEM',
      show: true,
    },
    {
      fieldName: 'TOTAL_QTY',
      show: true,
    },
    {
      fieldName: 'TOTAL_RETAIL_B',
      show: true,
    },
  ];

  public tableDataAllocated: any = [];
  public tableDataNotPick: any = [];
  public tableDataPicked: any = [];
  public tableDataReceived: any = [];
  public tableDataPacked: any = [];
  public tableDataVan: any = [];
  public tableDataPreinvoice: any = [];
  public tableDataInvoice: any = [];

  public tableDataDetail: any = [];
  public tableDetailName: any;
  public tableDetailFooter: any;
  public tableDetailReport: any;
  public invoiceDetail: any = [];

  @ViewChild("dialogDetail", { static: false }) dialogDetail: any;
  @ViewChild("InvoiceDialog") InvoiceDialog: DialogTemplateComponent;
  @ViewChild("InstructionDialog") InstructionDialog: DialogTemplateComponent;

  ngOnInit() {

    this.params.TYPE_DATE = 'LAST6MONTH'
    this.http.post('WH', 'GetDateByFormat', this.params)
      .subscribe(res => {
        this.params.START_DATE = res.Table[0].LAST6MONTH;

        this.params.END_DATE = this.currentDate;
        this.params.CUSTOMER_ZONE = 'ALL';
        this.params.ORDER_TYPE = 'ALL';
        this.iSelectTab = 0;
        this.iShowBy = 1;
        this.Search();
      });


  }

  public ViewBy1(i) {
    this.iShowBy = i;
  }

  public tabClick(tab: any) {
    this.iSelectTab = tab;
    this.Search();
  }

  public FindIns() {

    this.tableDataDetail = [];
    this.tableDetailName = 'SNWR036_INSTRUCTION_DETAIL';
    this.params.INSTRUCTION_NO = '';
    this.params.PICKING_LIST_NO = '';
    this.params.PART_NO = '';
    this.ENABLE_CANCEL_PICK = '';
    this.insData = {};
    this.InstructionDialog.OpenDialog();


  }

  public FindDataClick(Action) {
    //public FindInsClick() {
    let txtAction: string = '';
    let apiName: string = '';
    this.ENABLE_CANCEL_PICK = '';

    if (Action == 1) {
      txtAction = 'instruction';
      apiName = 'SNWR036_FindInstruction';
      this.searchBy = 'Search By Instruction No.';
    } else if (Action == 2) {
      txtAction = 'Picking list';
      apiName = 'SNWR036_FindPickinglistNo';
      this.searchBy = 'Search By Picking list No.';
    } else if (Action == 3) {
      txtAction = 'Part';
      apiName = 'SNWR036_FindPartNo';
      this.searchBy = 'Search By Part No.';
    }
    //this.tableDetailName = 'SNWR036_PICKED_DETAIL';
    // this.InstructionDialog.OpenDialog();

    this.http.post('WH', apiName, this.params)
      .subscribe(res => {
        var tableDataDetail = res.Table;

        // console.log('1 res.Table ' ,res.Table);
        //console.log('2 tableDataDetail',tableDataDetail);
        // console.log('3 tableDataDetail.RowCount', tableDataDetail.length);

        if (tableDataDetail.length > 0) {
          if (Action == 1) {
            if (tableDataDetail[0].COMPLETE_FLAG == 'A') {
              this.tableDetailName = 'SNWR036_ALLOCATE_DETAIL';
            } else if (tableDataDetail[0].COMPLETE_FLAG == 'N') {
              this.tableDetailName = 'SNWR036_NOT_PICK_DETAIL';
            } else if (tableDataDetail[0].COMPLETE_FLAG == 'L') {
              this.tableDetailName = 'SNWR036_PICKING_DETAIL';
            } else if (tableDataDetail[0].COMPLETE_FLAG == 'P') {
              this.tableDetailName = 'SNWR036_PICKED_DETAIL';
            } else if (tableDataDetail[0].COMPLETE_FLAG == 'R') {
              this.tableDetailName = 'SNWR036_RECEIVED_DETAIL';
            } else if (tableDataDetail[0].COMPLETE_FLAG == 'C') {
              this.tableDetailName = 'SNWR036_PACKED_DETAIL';
            } else if (tableDataDetail[0].COMPLETE_FLAG == 'I') {
              this.tableDetailName = 'SNWR036_INV_DETAIL';
            } else {
              this.tableDetailName = 'SNWR036_INV_DETAIL';
            }
          } else if (Action == 2) {
            this.tableDetailName = 'SNWR036_PICKING_LIST_NO';
          } else if (Action == 3) {
            this.tableDetailName = 'SNWR036_PICKING_LIST_NO';
          }


          //console.log('this.tableDetailName', this.tableDetailName);

          this.tableDataDetail = res.Table;

          this.insData = this.tableDataDetail[0];
          this.ENABLE_CANCEL_PICK = this.tableDataDetail[0].ENABLE_CANCEL_PICK;
        } else {
          this.tableDataDetail = [];
          this.modal.warning("ไม่พบข้อมูล กรุณารบกวนตรวจสอบเลข " + txtAction, this.viewRef);
        }

        // this.InstructionDialog.OpenDialog();

      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });

  }

  public CancelPick() {

    this.modal.confirm(
      "Are you sure to cancel card?" + 
      "<br> Instruction: " + this.insData.INSTRUCTION_NO  + 
      "<br> P/N: " + this.insData.ACCEPT_PART_NO  + 
      "<br> จำนวน: " + this.insData.ACCEPT_QTY  + 
      "<br> Qty: " + this.insData.PICK_QTY  + 
      "<br> หาของ: " + this.insData.PICK_QTY_BAL  + 
      "<br> Status: " + this.insData.STATUS 
      , this.viewRef
      , () => {
        this.http.post('WH', 'SNWR036_CancelPick', this.params)
          .subscribe(res => {
            this.modal.info('Cancel card completed', this.viewRef);
            this.InstructionDialog.Close()
          }, (err) => {
            console.log(err, 'err')
            this.modal.warning("Found an error, please contract support team", this.viewRef);
          })}
      , () => {}
      , { height:"24rem", width:"38rem" }
      );

  }


  public Search() {
    if (this.iSelectTab == 0) {
      this.http.post('WH', 'SNWR036_GetDataAllocated', this.params)
        .subscribe(res => {
          this.tableDataAllocated = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });

    } else if (this.iSelectTab == 1) {
      this.http.post('WH', 'SNWR036_GetDataNotPick', this.params)
        .subscribe(res => {
          this.tableDataNotPick = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });



    } else if (this.iSelectTab == 2) {
      this.http.post('WH', 'SNWR036_GetDataPicked', this.params)
        .subscribe(res => {
          this.tableDataPicked = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });

    } else if (this.iSelectTab == 3) {
      this.http.post('WH', 'SNWR036_GetDataReceived', this.params)
        .subscribe(res => {
          this.tableDataReceived = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });

    } else if (this.iSelectTab == 4) {
      this.http.post("WH", "SNWR036_GetDataPacked", this.params)
        .subscribe((res) => {
          this.tableDataPacked = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });



    } else if (this.iSelectTab == 5) {
      this.http.post("WH", "SNWR036_GetDataVan", this.params)
        .subscribe((res) => {
          this.tableDataVan = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });

    } else if (this.iSelectTab == 6) {
      this.http.post("WH", "SNWR036_GetDataPreinvoice", this.params)
        .subscribe((res) => {
          this.tableDataPreinvoice = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });


    } else if (this.iSelectTab == 7) {
      this.http.post('WH', 'SNWR036_GetDataInvoice', this.params)
        .subscribe(res => {
          this.tableDataInvoice = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        })
    }
  }

  public ViewDetailAllocated(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR036_GetDetailAllocated', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR036_ALLOCATE_DETAIL';
        this.tableDetailFooter = undefined;
        this.tableDetailReport = undefined;
        this.dialogDetail.OpenDialog();

      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailNotPick(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR036_GetDetailNotPick', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR036_NOT_PICK_DETAIL';
        this.tableDetailFooter = undefined;
        this.tableDetailReport = undefined;
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailReceived(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR036_GetDetailReceived', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR036_RECEIVED_DETAIL';
        this.tableDetailFooter = undefined;
        this.tableDetailReport = {
          REPORT_NAME: "PMS_RPT_WMS_SNWR036_GET_DETAIL_RECEIVE_BY_VIEW",
          PARAMETER: {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_CUSTOMER_CODE: data.CUSTOMER_CODE,
            P_BRANCH_CODE: data.BRANCH_CODE,
            P_ORDER_TYPE: data.ORDER_TYPE,
            P_ALLOCATE_DATE: moment(this.params.ALLOCATE_DATE).format("DD-MMM-YYYY"),
            P_PRINT_DATE: moment(this.params.PRINT_DATE).format("DD-MMM-YYYY"),
          }
        };
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailPicked(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR036_GetDetailPicked', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR036_PICKED_DETAIL';
        this.tableDetailFooter = undefined;
        this.tableDetailReport = undefined;
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailPacked(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR036_GetPackedDetail', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR036_PACKED_DETAIL';
        this.tableDetailFooter = this.sumPack;
        this.tableDetailReport = {
          REPORT_NAME: "PMS_RPT_WMS_SNWR036_GET_DETAIL_PACKED_BY_VIEW",
          PARAMETER: {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_CUSTOMER_CODE: data.CUSTOMER_CODE,
            P_BRANCH_CODE: data.BRANCH_CODE,
            P_ORDER_TYPE: data.ORDER_TYPE,
          }
        };
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailVan(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR036_GetVanDetail', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDataDetail.map((x, i) => x.SEQ = i + 1)
        this.tableDetailName = 'SNWR036_VAN_DETAIL';
        this.tableDetailFooter = this.sumVan;
        this.tableDetailReport = {
          REPORT_NAME: "PMS_RPT_WMS_SNWR036_GET_DETAIL_VAN_BY_VIEW",
          PARAMETER: {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_VAN_NO: data.VAN_NO,
            P_VAN_GROUP: data.VAN_GROUP,
          }
        };
        this.dialogDetail.title = "Van No : " + data.VAN_NO + " - " + data.CUSTOMER;
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailPreInvoice(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR036_GetPreInvoiceDetail', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDataDetail.map((x, i) => x.SEQ = i + 1)
        this.tableDetailName = 'SNWR036_PRE_INVOICE_DETAIL';
        this.tableDetailFooter = undefined;
        this.tableDetailReport = undefined;
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailInvoice(data: any) {
    this.InvoiceDialog.OpenDialog();
    this.invoiceData = data;
    this.http.post("WH", "SNWR036_GetInvoiceDetail", this.invoiceData)
      .subscribe(res => {
        this.invoiceDetail = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailByPicker(data: any) {
    this.tableDataDetail = [];
    this.http.post('WH', 'SNWR036_GetDataDetailByPicker', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailFooter = undefined;
        this.tableDetailReport = undefined;
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }


  public ReportDialog() {
    const report = this.tableDetailReport;
    this.global.GoToExport(
      report.REPORT_NAME,
      report.PARAMETER,
      true,
      "EXCELOPENXML"
    );
  }
  public ReportNotPickData() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR036_GET_DETAIL_NOT_PICK", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_ORDER_TYPE: this.params.ORDER_TYPE,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportPickedData() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR036_GET_DETAIL_PICKED", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_ORDER_TYPE: this.params.ORDER_TYPE,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportReceiveData() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR036_GET_DETAIL_RECEIVE", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_ORDER_TYPE: this.params.ORDER_TYPE,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportPackedData() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR036_GET_DETAIL_PACKED", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_ORDER_TYPE: this.params.ORDER_TYPE,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportVanData() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR036_GET_DETAIL_VAN", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_ORDER_TYPE: this.params.ORDER_TYPE,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportInvoiceData() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR036_GET_DETAIL_INVOICE", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_ORDER_TYPE: this.params.ORDER_TYPE,
    }, true, "EXCELOPENXML"
    );
  }
}
