import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Globals } from 'src/app/core/global';
import { ModalService } from 'src/app/core/modal.service';
import { SelectionModel } from '@angular/cdk/collections';
import { CdkDragDrop, moveItemInArray, transferArrayItem } from '@angular/cdk/drag-drop';
import * as moment from 'moment';

enum PageAction {
  Search = 0,
  Detail,
  Retrive
}

@Component({
  selector: 'SNWR044',
  templateUrl: './SNWR044.component.html',
  styleUrls: ['./SNWR044.component.css']
})

export class SNWR044Component implements OnInit {


  constructor(
    private Http: HttpService,
    private global: Globals,
    private modal: ModalService,
    private viewRef: ViewContainerRef
  ) { }

  @ViewChild("dialog", { static: false }) dialog: any;
  @ViewChild("dialogMain", { static: false }) dialogMain: any;
  @ViewChild("dialogSelectCasetypes", { static: false }) dialogSelectCasetypes: any;
  @ViewChild("dialogVanMaster", { static: false }) dialogVanMaster: any;
  @ViewChild("dialogCaseDetail", { static: false }) dialogCaseDetail: any;

  public ListLog: any = [];
  public params: any = {};
  public dataHead: any = {};
  public MsgLog: any = [];
  public formData: any = {};

  public isAdd: boolean = false;

  public selection = new SelectionModel<any>(true, []);
  public DataIsSelected: any = [];
  public PageAction: number;

  public formData2: any = null;

  public tableData: any = [];
  public tableDataDetail: any = [];
  public tableDataCaseType: any = [];
  public tableDataVanMaster: any = [];
  public ListsDataVanMaster: any = [];
  public TOT_AMOUNT = 0
  public EXPORT_PRICE = 0
  public TOT_ORDER = 0
  public IsSearch: boolean = true;
  public IsDiff: number = 0;
  public params2: any = {}
  public IsConfirm: boolean = false;

  public files: any = [];
  public FileName: string = ""

  public BoxList: any = [];
  public PalletList: any = [];
  public RackList: any = [];

  public displayedColumns: any = [];
  public dataSource: any = [];
  public fileUrlPart : any  = "";
  public filter: any = {};
  public hideColumns: string[];
  
  public alertMessages: string[] = [];

  public isEdit: boolean = false;

  public paramSearch: any = {};
  public selectedVan: any = undefined;
  public isVan: boolean = false;
  public caseList: any = [];
  //public selection = new SelectionModel<any>(true, []);
  public selectionCase = new SelectionModel<any>(true, []);
  public vanList: any = [];
  public newVanList: any = [];
  public vanDetail: any = [];
  public vanView: any = [];
  public tempCase : any = []
  public caseDetail: any = [];
  public editdata: any = [];
  public canEdit : boolean = true;
  public paramData : any = {}
  public selectionVan = new SelectionModel<any>(true, []);
  public tableAvailableCase : any = []
  public paramSearchCase : any = {};
  public paramSearchReport : any = {}
  public tblFooter: any = [
    {
      fieldName: "PART_NO",
      value: "Total",
      show: true
    },
    {
      fieldName: "ORDER_QTY",
      show: true
    },
    {
      fieldName: "AMOUNT",
      show: true
    }
  ]
 
  public ConfigCustomer: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Customer",
    SourceController: "WH",
    SourceMethodName: "SNWR044_N_GetCustomer",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  } 

  public ConfigVan: any = {
    ColName: "LOOKUP_TEXT",
    ColValue: "",
    PlaceholderText: "Select Van No",
    SourceController: "WH",
    SourceMethodName: "SNWR044_N_GetVanNo",
    NoOfShowRecords: 25,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      CUSTOMER_CODE: null
    },
  } 

  public ConfigVanNo: any = {
    ColName: "LOOKUP_TEXT",
    ColValue: "",
    PlaceholderText: "Select Van No",
    SourceController: "WH",
    SourceMethodName: "SNWR044_N_GetVanNolog",
    NoOfShowRecords: 25,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      CUSTOMER_CODE: null
    },
  } 



  ngOnInit() {
    this.TOT_AMOUNT = 0;
    this.EXPORT_PRICE = 0;
    this.TOT_ORDER = 0;
    const today = new Date(); 
    const year = today.getFullYear();
    const month = today.getMonth();
    const startDate = moment().format('YYYY-MM-01');    
    const endDate = new Date(year, month + 1, 0);
    this.params.VAN_DATE_FROM = startDate;
    this.params.VAN_DATE_TO  = endDate;
    this.dataHead.BOX    = 0;
    this.dataHead.PALLET = 0;
    this.dataHead.RACK   = 0;
    this.hideColumns = [];
    this.Search();
    this.GetDataVanMaster();
  }

 

  public ClickNew() {
    this.IsSearch = false;

    this.FileName = '';
    this.dataHead = {};
    this.tableDataDetail = []; 
    this.dataHead.STATUS = 'NEW'
    this.dataHead.SIMULATE_DATE = new Date(); 
    this.dataHead.VOLUMEAll = 0;
    this.dataHead.VOLUMEPERCENT = 0;
    this.dataHead.DIMENSION = 0;
    this.dataHead.MAX_VOLUME = 0;    
    this.dataHead.OVER_LOAD = false;
    this.IsConfirm = false;
    this.hideColumns = [];
  }

  public TabChanged(event){
    if(event.index == 2){
      if(!this.paramSearchCase.ORDER_TYPE)
      this.paramSearchCase.ORDER_TYPE = "ALL"
      this.SearchRemainCase()
    }else if(event.index == 3){
      this.paramSearchReport.START_DATE = moment().startOf('month');
      this.paramSearchReport.END_DATE = moment();
      this.paramSearchReport.ORDER_TYPE = "ALL"
    }
  }

  public ViewDetail(data) {
  
    //console.log(data,"ddddddddddddddddd")
    this.IsSearch = false;
    this.paramData = data;

    //this.EditData = data;

    this.FileName = '';
    this.dataHead = {};
    this.tableDataDetail = []; 
    this.dataHead.STATUS  = 'EDIT'
    this.dataHead.SIMULATE_DATE = new Date();    
    this.dataHead.VOLUMEAll = 0;
    this.dataHead.VOLUMEPERCENT = 0;
    this.dataHead.OVER_LOAD = false;   
    this.dataHead.VAN_GROUP = data.VAN_GROUP
    
    this.params.VAN_NO = data.VAN_NO; 
    this.params.CUSTOMER_CODE = data.CUSTOMER_CODE ; 

    this.GetDataVan();

    if (data.STATUS == "CONFIRM") {
      this.SelectNewVan(data)
    } else {
      this.SelectVanForEdit(data)
    }

    if(data.STATUS == "Invoice" || data.STATUS == "Complete")
      this.canEdit = false
    
  }


  public  GetDataVan (){
    const params ={
      VAN_NO :  this.params.VAN_NO,
      CUSTOMER_CODE : this.params.CUSTOMER_CODE
    };

    this.Http.post('WH', 'SNWR044_N_GetDataVan', params)
      .subscribe(res => {
        try {  
                   
          if (res.Table.length >0 ) {    
            this.dataHead.VAN_NO         = res.Table[0].VAN_NO
            this.dataHead.AIR_SEA        = res.Table[0].AIR_SEA
            this.dataHead.CUSTOMER_CODE  = res.Table[0].CUSTOMER_CODE
            this.dataHead.CUSTOMER_NAME  = res.Table[0].CUSTOMER_NAME
            this.dataHead.DIMENSION_W    = res.Table[0].DIMENSION_W
            this.dataHead.DIMENSION_D    = res.Table[0].DIMENSION_D
            this.dataHead.DIMENSION_H    = res.Table[0].DIMENSION_H
            this.dataHead.ORDER_TYPE    = res.Table[0].ORDER_TYPE

            const M3 = this.global.Round((res.Table[0].DIMENSION_W * res.Table[0].DIMENSION_D * res.Table[0].DIMENSION_H) / Math.pow(10, 9), 3);
            this.dataHead.DIMENSION = M3;

            this.dataHead.BOX            = res.Table[0].BOX
            this.dataHead.PALLET         = res.Table[0].PALLET
            this.dataHead.RACK           = res.Table[0].RACK   
            this.dataHead.SIMULATE_STATUS  = res.Table[0].STATUS   

            if  (this.dataHead.SIMULATE_STATUS  !== 'NEW' && this.dataHead.SIMULATE_STATUS  !== 'SIMULATE' && this.dataHead.SIMULATE_STATUS  !== 'RETURN'){
              this.IsConfirm = true;
              this.hideColumns = ["DELETE"];
            }else{
              this.IsConfirm = false;
              this.hideColumns = [];
            }

            this.dataHead.MAX_VOLUME = M3//res.Table[0].DIMENSION;
            this.dataHead.VAN_NAME = res.Table[0].VAN_NAME;
            this.dataHead.CONTAINER_NO = res.Table[0].CONTAINER_NO
            this.dataHead.SEAL_NO = res.Table[0].SEAL_NO
            this.dataHead.BOOKING_NO = res.Table[0].BOOKING_NO
            this.vanList = res.Table

            this.GetDataVanDeatil();
          } else {
         
            this.dataHead = {};
            this.dataHead.VAN_NO = this.params.VAN_NO;
            this.dataHead.STATUS = 'NEW'
            this.IsConfirm = false;
            this.hideColumns = [];
            this.dataHead.VOLUMEAll = 0;
            this.dataHead.VOLUMEPERCENT = 0;
            this.dataHead.DIMENSION = 0;
            this.dataHead.MAX_VOLUME = 0;
            this.dataHead.BOX    = 0;
            this.dataHead.PALLET = 0;
            this.dataHead.RACK   = 0;
          } 
          
          console.log(this.dataHead,"ddddddddddddddddd");
        } catch (error) {
          console.log(error, 'err') 
        }   
      }, err => {
        console.log(err, 'err');
        this.modal.error("Found an error, please contact support team", this.viewRef);
      })
  }

  public  GetDataVanDeatil (){
    const params ={
      VAN_NO :  this.params.VAN_NO,
      CUSTOMER_CODE : this.params.CUSTOMER_CODE
    };

    this.Http.post('WH', 'SNWR044_N_GetDataVanDetail', params)
    .subscribe(res => {
      
      try {  
        if (res.Table.length >0 ) {   
          this.tableDataDetail = res.Table; 
          let volumeAll : number = 0;        
          this.tableDataDetail.map((value) => {       
            if (value.DIMENSION != null &&  value.DIMENSION != '') {     
              volumeAll = volumeAll+parseFloat(value.DIMENSION);  
            }   

            let find = this.tableDataCaseType.find(obj => value.CASE_TYPE === obj.CASE_TYPE && value.CASE_NAME === obj.CASE_NAME )
            if (find){
              value.CAN_CONFIG = find.CAN_CONFIG;
            }            
          });       

          this.dataHead.VOLUMEAll = this.global.Round( (volumeAll/ Math.pow(10, 9)), 3);   
          this.dataHead.VOLUMEPERCENT =  (this.dataHead.VOLUMEAll / this.dataHead.MAX_VOLUME) * 100;


          
        } else {
          this.tableDataDetail = [];           
        }  
      } catch (error) {
        console.log(error, 'err') 
      }   
    }, err => {
      console.log(err, 'err');
      this.modal.error("Found an error, please contact support team", this.viewRef);
    })
  }


  public CalRectangleVolume(Name) {     

    let ChkNumber : boolean = false;   
    if( this.dataHead.DIMENSION_W <= 0){
      ChkNumber = true
    }else if( this.dataHead.DIMENSION_D <= 0){
      ChkNumber = true
    }else if( this.dataHead.DIMENSION_H <= 0){
      ChkNumber = true
    }

    if (ChkNumber) {
      this.dataHead.OVER_LOAD = true;
    }else{
      this.dataHead.OVER_LOAD = false;
    }

    let ChkAlert : boolean = false;    
    if( this.dataHead[Name] <= 0 ){
      ChkAlert = true
      this.dataHead[Name] = ''
    }   
    if (ChkAlert){
      this.alertMessages[Name] = 'Number must more than 0';
    }else{
      this.alertMessages[Name] = null;
    }   

    let width  : number = this.dataHead.DIMENSION_W == null ? 0 : this.dataHead.DIMENSION_W;
    let length : number = this.dataHead.DIMENSION_D == null ? 0 : this.dataHead.DIMENSION_D;    
    let height : number = this.dataHead.DIMENSION_H == null ? 0 : this.dataHead.DIMENSION_H;
    const volume = width * length * height;
    const M3 = this.global.Round((width * length * height) / Math.pow(10, 9), 3);

    this.dataHead.DIMENSION = M3;

    this.dataHead.MAX_VOLUME = M3;

    this.CalOver();  
  }

  public CalRectangleCase(data) {
    
    let length : number = data.CASE_DEPTH == null ? 0 : data.CASE_DEPTH;
    let width  : number = data.CASE_WIDTH == null ? 0 : data.CASE_WIDTH;
    let height : number = data.CASE_HEIGHT == null ? 0 : data.CASE_HEIGHT;
    let qty : number = data.QTY == null ? 0 : data.QTY;

    const volume = (width * length * height ) * qty;
    data.DIMENSION = volume;
    data.VOLUME = this.global.Round( ((width * length * height )/ Math.pow(10, 9)), 3);  
    this.CalOver();    
  }

  public CalOver(){
    let volumeAll : number = 0;
    this.tableDataDetail.forEach((value) => {       
      if (value.DIMENSION != null &&  value.DIMENSION != '') {     
        volumeAll = volumeAll+parseFloat(value.DIMENSION);  
      }   
    });       
    this.dataHead.VOLUMEAll = this.global.Round( (volumeAll/ Math.pow(10, 9)), 3);      
    this.dataHead.VOLUMEPERCENT =  (this.dataHead.VOLUMEAll / this.dataHead.MAX_VOLUME) * 100; 
    this.dataHead.OVER_LOAD = false;

    if ( this.dataHead.VOLUMEAll >= this.dataHead.MAX_VOLUME && this.dataHead.MAX_VOLUME > 0) {
      this.dataHead.OVER_LOAD = true;
      this.modal.warning('ความจุเกินกำหนด', this.viewRef);
      return false;
    }

  }
   
  public VanSelected(event) {
    this.params.VAN_NO = event.VAN_NO;
    this.params.LAST_UPD_NAME = event.LAST_UPD_PGM == null  ? event.CREATE_PGM  :event.LAST_UPD_PGM;
    this.params.LAST_UPD_DATE = event.LAST_UPD_DATE == null ? event.CREATE_DATE :event.LAST_UPD_DATE;    
    if (this.params.VAN_NO) {
      this.Search();      
    }
    else {
      this.tableData = [];
    }
  }

  public VanNoSelected(event) {
    this.dataHead.VAN_NO = event.VAN_NO;
    const params ={
      VAN_NO : event.VAN_NO,
      CUSTOMER_CODE : '' 
    };
    this.ViewDetail(event);
   
  }

  

  public Search() {
    this.tableData = []
    this.Http.post('WH', 'SNWR044_N_GetData', this.params)
      .subscribe(res => {
        try {  
          this.tableData = res.Table;
        } catch (error) {
          this.tableData = []
          console.log(error, 'err') 
        }       
      }, err => {
        console.log(err, 'err');
        this.modal.error("Found an error, please contact support team", this.viewRef);
      })
  }

  public GetCaseType() {

    if (!this.dataHead.CUSTOMER_CODE) {
      this.modal.warning('Please enter Customer Code!', this.viewRef);
      return false;
    }

    if (!this.dataHead.AIR_SEA) {
      this.modal.warning('Please select AIR/SEA!', this.viewRef);
      return false;
    }

    this.tableDataCaseType = [];   
    this.Http.post('WH', 'SNWR044_N_GetCaseTypeMaster', this.dataHead)
    .subscribe(res => {
      try {         
        this.tableDataCaseType = res.Table;
      } catch (error) {
        this.tableDataCaseType = []
        console.log(error, 'err') 
      }   
    }, err => {
      console.log(err, 'err');
      this.modal.error("Found an error, please contact support team", this.viewRef);
    }) 
    this.dialogSelectCasetypes.OpenDialog();    
  }

  public SelectedCust(event) {
    this.params.CUSTOMER_CODE = event.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = event.CUSTOMER_NAME;    
    this.ConfigVan.SourceParams.CUSTOMER_CODE = event.CUSTOMER_CODE;
    this.Search();
  }

  public SelectedCust2(event) {
    this.dataHead.CUSTOMER_CODE = event.CUSTOMER_CODE
    this.dataHead.CUSTOMER_NAME = event.CUSTOMER_NAME
  }

  OpendatePopup(datepicker) {
    datepicker.open();
  }
    
  public ConfirmAdd() {

    if (!this.dataHead.AIR_SEA) {
      this.modal.warning('Please select AIR/SEA!', this.viewRef);
      return false;
    }
    if (!this.dataHead.CUSTOMER_CODE) {
      this.modal.warning('Please enter Customer Code!', this.viewRef);
      return false;
    }
    if (!this.dataHead.DIMENSION_W) {
      this.modal.warning('Please enter Dimension W!', this.viewRef);
      return false;
    }
    if (!this.dataHead.DIMENSION_D) {
      this.modal.warning('Please enter Dimension D!', this.viewRef);
      return false;
    }
    if (!this.dataHead.DIMENSION_H) {
      this.modal.warning('Please enter Dimension H!', this.viewRef);
      return false;
    }   

    let flgAlert : boolean = false;
    let msgAlert : string ='';
    this.tableDataDetail.forEach(find => {  
      if(find.CASE_WIDTH <= 0){
        flgAlert = true;
        msgAlert = 'Please enter Case width must more than 0 <br>For Case Name : '+find.CASE_NAME;
      }else if (find.CASE_DEPTH <= 0){
        flgAlert = true;
        msgAlert = 'Please enter Case depth must more than 0 <br>For Case Name : '+find.CASE_NAME;       
      }else if (find.CASE_HEIGHT <= 0){
        flgAlert = true;
        msgAlert = 'Please enter Case height must more than 0 <br>For Case Name : '+find.CASE_NAME;              
      }else if (find.QTY <= 0){
        flgAlert = true;
        msgAlert = 'Please enter Qty must more than 0 <br>For Case Name : '+find.CASE_NAME;   
      //}else if (!find.ROW_NO){
      //  flgAlert = true;
      //  msgAlert = 'Please enter Row No. <br>For Case Name : '+find.CASE_NAME;  
      }
    });
    if (flgAlert) {
      this.modal.warning(msgAlert, this.viewRef);
      return false;
    } 

    this.modal.confirm('Do you want to add new Van?', this.viewRef, this.Save)    
  }

  private Save = () => {   

    var listCase = this.tableDataDetail.filter((x) => x.QTY > 0);
    if (listCase.length>0){
      this.dataHead.SIMULATE_STATUS='SIMULATE'
    }else{
      this.dataHead.SIMULATE_STATUS='NEW'
    }
    var qty_case : number = 0;    
    listCase.forEach((value) => {    
      qty_case = qty_case+parseFloat(value.QTY);  
    });  
    this.dataHead.QTY_CASE = qty_case;

    const saveData = {
      HEADER: this.dataHead,
      DETAIL: listCase
    }    
    this.Http.post('WH', 'SNWR044_N_Save', saveData)
      .subscribe(res => { 
        try {  
          if (res.Table[0].STATUS == 'DONE') {
            this.modal.info('Save Complete.', this.viewRef);
            this.dataHead.VAN_NO = res.Table[0].VAN_NO;
            this.dataHead.SIMULATE_STATUS = res.Table[0].SIMULATE_STATUS;
            this.dataHead.STATUS = 'EDIT';
            this.Search();
          } else {
            this.modal.error('No change to save. Something went wrong.', this.viewRef);
          }
        } catch (error) {
          console.log(error, 'err') 
        }   
      }, err => {
        console.log(err, 'err');
        this.modal.error("Found an error, please contact support team", this.viewRef);
      })
  }

  public ConfirmVan() {
    if (!this.dataHead.AIR_SEA) {
      this.modal.warning('Please select AIR/SEA!', this.viewRef);
      return false;
    }
    if (!this.dataHead.CUSTOMER_CODE) {
      this.modal.warning('Please enter Customer Code!', this.viewRef);
      return false;
    }
    if (!this.dataHead.DIMENSION_W) {
      this.modal.warning('Please enter Dimension W!', this.viewRef);
      return false;
    }
    if (!this.dataHead.DIMENSION_D) {
      this.modal.warning('Please enter Dimension D!', this.viewRef);
      return false;
    }
    if (!this.dataHead.DIMENSION_H) {
      this.modal.warning('Please enter Dimension H!', this.viewRef);
      return false;
    }  
    var listCase = this.tableDataDetail.filter((x) => x.QTY > 0);
    if (listCase.length <= 0) {
      this.modal.warning('Please enter Qty Case Type!', this.viewRef);
      return false;
    }     
    
    let flgAlert : boolean = false;
    let msgAlert : string ='';
    this.tableDataDetail.forEach(find => {  
      if(find.CASE_WIDTH <= 0){
        flgAlert = true;
        msgAlert = 'Please enter Case width must more than 0 <br>For Case Name : '+find.CASE_NAME;
      }else if (find.CASE_DEPTH <= 0){
        flgAlert = true;
        msgAlert = 'Please enter Case depth must more than 0 <br>For Case Name : '+find.CASE_NAME;       
      }else if (find.CASE_HEIGHT <= 0){
        flgAlert = true;
        msgAlert = 'Please enter Case height must more than 0 <br>For Case Name : '+find.CASE_NAME;              
      }else if (find.QTY <= 0){
        flgAlert = true;
        msgAlert = 'Please enter Qty must more than 0 <br>For Case Name : '+find.CASE_NAME;   
      //}else if (!find.ROW_NO){
      //  flgAlert = true;
      //  msgAlert = 'Please enter Row No. <br>For Case Name : '+find.CASE_NAME;  
      }
    });
    if (flgAlert) {
      this.modal.warning(msgAlert, this.viewRef);
      return false;
    } 

    this.modal.confirm('Do you want to Confirm Van?', this.viewRef, this.Confirm)    
  }

  private Confirm = () => {   
    var listCase = this.tableDataDetail.filter((x) => x.QTY > 0);
    var qty_case : number = 0;
    listCase.forEach((value) => {    
      qty_case = qty_case+parseFloat(value.QTY);  
    });  

    this.dataHead.SIMULATE_STATUS = 'CONFIRM';
    this.dataHead.QTY_CASE = qty_case;
    const saveData = {
      HEADER: this.dataHead,
      DETAIL: listCase
    }            
    this.Http.post('WH', 'SNWR044_N_Save', saveData)
      .subscribe(res => {   
        try {  
          if (res.Table[0].STATUS == 'DONE') {          
            this.modal.info('Confirm Complete.', this.viewRef);
            this.dataHead.VAN_NO = res.Table[0].VAN_NO;
            this.dataHead.SIMULATE_STATUS = res.Table[0].SIMULATE_STATUS;
            this.IsConfirm = true;
            this.hideColumns = ["DELETE"];
            //this.Search();
            this.paramData = this.dataHead
            this.paramData.ORDER_TYPE = this.dataHead.AIR_SEA
            this.paramData.STATUS = this.dataHead.SIMULATE_STATUS
            
            this.ViewDetail(this.paramData);

          } else {
            this.IsConfirm = false;
            this.hideColumns = [];
            this.modal.error('No change to save. Something went wrong.', this.viewRef);
          }
        } catch (error) {       
          console.log(error, 'err') 
        }       
      }, err => {
        console.log(err, 'err');
        this.modal.error("Found an error, please contact support team", this.viewRef);
      })
  }


  public SaveEdit(){
    this.modal.confirm("Do you want to save?",this.viewRef,()=> Confirm())

    let Confirm = () => {
      const data = {
        VAN_NO : this.dataHead.VAN_NO,
        CONTAINER_NO : this.dataHead.CONTAINER_NO,
        SEAL_NO : this.dataHead.SEAL_NO,
        BOOKING_NO : this.dataHead.BOOKING_NO
      }
      this.Http.post("WH","SNWR044_SaveEdit",data)
      .subscribe(res => {
        if(res.Status == "DONE"){
          this.modal.info("Save data complete",this.viewRef)
          this.isVan = false;
          this.Back()
        }else{
          this.modal.error("Found an error, please contact support team", this.viewRef);
        }
      },err => {
        this.modal.error("Found an error, please contact support team", this.viewRef);
        console.log(err)
      })
    }
    console.log("saveEdit")
  }

  public PrintVanNo() {
    this.dialogMain.OpenDialog();
    this.fileUrlPart = null;
    this.Http
      .Download("WH", "SNWR044_Preview_Vannumber", {
        ReportPrefix: "PMS_RPT_WMS_SNWR044_VAN",
        ReportSuffix: ".PDF",
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_VAN_NO_FROM: this.dataHead.VAN_NO,
        P_VAN_NO_TO: this.dataHead.VAN_NO
      })
      .subscribe((res) => {
        if (res) {
          this.SetIFramePartContent(res);
        }
      });
  }

  private SetIFramePartContent(content: any) {
    const file = new Blob([content], { type: content.type });
    const fileUrlPart = URL.createObjectURL(file);
    this.fileUrlPart = fileUrlPart;
  }
  
  public Back() {
    this.params.VAN_NO ='';
    this.params.CUSTOMER_CODE ='';
    this.Search();
    this.IsSearch = true;
    this.selectionCase.clear()
    this.canEdit = true;
  }

  public OpenSelectCaseType(){    
    this.GetCaseType();
  }

  public CaseTypeDetailFilter() {
      if (this.tableDataCaseType && this.tableDataDetail) {
          return this.tableDataCaseType.filter(icase => {
              return this.tableDataDetail.findIndex( caseSelect => 
                caseSelect.CASE_TYPE === icase.CASE_TYPE && caseSelect.CASE_NAME === icase.CASE_NAME  && icase.CAN_CONFIG !== 'Y' ) === -1
                && ((icase.CASE_TYPE+' - '+icase.CASE_NAME).toUpperCase().indexOf(this.filter.Unselected?.toUpperCase()) !== -1 || !this.filter.Unselected
              )
          })
      }
      return [];
  }

  public SelectCaseTypeDetailFilter() {
      return this.tableDataDetail.filter(icase => {
          return (icase.CASE_TYPE+' - '+icase.CASE_NAME).toUpperCase().indexOf(this.filter.Selected?.toUpperCase()) !== -1 || !this.filter.Selected
      })
  }

  public DetailDrop(event: CdkDragDrop<any[]>): void  {
    if (event.previousContainer === event.container) {   
      moveItemInArray(event.container.data, event.previousIndex, event.currentIndex);
    } else {
      const newItem = { ...event.previousContainer.data[event.previousIndex], id: this.generateNewItemId(),QTY:0 };
      this.tableDataDetail.splice(event.currentIndex, 0, newItem);
    }   
    this.tableDataDetail = this.tableDataDetail.slice();    
  }

  public DelDetailDrop(event: CdkDragDrop<any[]>): void  {    
    if (event.previousContainer === event.container) {   
      moveItemInArray(event.container.data, event.previousIndex, event.currentIndex);
    } else {
      let Row = this.tableDataDetail.findIndex(x => x == event.previousContainer.data[event.previousIndex])
      this.tableDataDetail.splice(Row, 1);
    } 
    this.tableDataDetail = this.tableDataDetail.slice();    
  }

   
  private generateNewItemId(): number {
    return Date.now();
  }

  public SaveCaseTypeDetail(){
    this.dialogSelectCasetypes.Close();    
  }

  public DeleteRow(data){  
    this.modal.confirm('คุณต้องการลบ Case Name : '+data.CASE_NAME +' ใช่หรือไม่', this.viewRef ,
    () => { 

      let Row = this.tableDataDetail.findIndex(x => x == data)
      this.tableDataDetail.splice(Row, 1);
      this.tableDataDetail = this.tableDataDetail.slice();
      this.CalOver();    
    
    }, () => { }) 
    
  }


  public  GetDataVanMaster (){
    const params ={
      VAN_NAME :  this.formData.VAN_NAME 
    };
    this.Http.post('WH', 'SNWR044_N_GetDataVanMaster', params)
    .subscribe(res => {     
      try {  
        if (res.Table.length >0 ) {   
          this.tableDataVanMaster = res.Table; 
          this.ListDataVanMaster();
        } else {
          this.tableDataVanMaster = [];           
        }  
      } catch (error) {
        console.log(error, 'err') 
      }   
    }, err => {
      console.log(err, 'err');
      this.modal.error("Found an error, please contact support team", this.viewRef);
    })
  }

  public AddVanMaster(){ 
    this.formData.TYPE ='ADD';
    this.dialogVanMaster.OpenDialog(); 
    //this.GetDataVanMaster();    
  }

  public ViewVanDetail(data){ 
    
    this.formData.TYPE ='EDIT';
    this.formData.VAN_NAME = data.VAN_NAME;
    this.formData.VAN_WIDTH = data.VAN_WIDTH;
    this.formData.VAN_DEPTH = data.VAN_DEPTH;
    this.formData.VAN_HEIGHT = data.VAN_HEIGHT;
    this.formData.LAST_UPD_BY = data.LAST_UPD_BY;
    this.formData.LAST_UPD_DATE = data.LAST_UPD_DATE;
    this.formData.STATUS = data.STATUS;
    //this.GetDataVanMaster();  
    this.dialogVanMaster.OpenDialog();   
  }

  public SaveVanMaster(){ 

    if (!this.formData.VAN_NAME) {
      this.modal.warning('Please enter Van Name!', this.viewRef);
      return false;
    }
    if (!this.formData.VAN_WIDTH) {
      this.modal.warning('Please enter Van Width!', this.viewRef);
      return false;
    }
    if (!this.formData.VAN_DEPTH) {
      this.modal.warning('Please enter Van Depth!', this.viewRef);
      return false;
    }
    if (!this.formData.VAN_HEIGHT) {
      this.modal.warning('Please enter Van Height!', this.viewRef);
      return false;
    }  

    if (this.formData.VAN_WIDTH <= 0) {
      this.modal.warning('Please enter Van Width must more than 0!', this.viewRef);
      return false;
    }
    if (this.formData.VAN_DEPTH <= 0) {
      this.modal.warning('Please enter Van Depth must more than 0!', this.viewRef);
      return false;
    }
    if (this.formData.VAN_HEIGHT <= 0) {
      this.modal.warning('Please enter Van Height must more than 0!', this.viewRef);
      return false;
    } 

    const params = {
      VAN_NAME: this.formData.VAN_NAME,
      VAN_WIDTH: this.formData.VAN_WIDTH,
      VAN_DEPTH: this.formData.VAN_DEPTH,
      VAN_HEIGHT: this.formData.VAN_HEIGHT,
      STATUS: 'Y',
    }    
    this.Http.post('WH', 'SNWR044_N_SaveVanMaster', params)
      .subscribe(res => { 
        try {  
               
          this.formData =[] ;
          this.modal.info(res.Table[0].MESSAGE, this.viewRef);
          this.GetDataVanMaster();
        
        } catch (error) {
          console.log(error, 'err') 
        }   
      }, err => {
        console.log(err, 'err');
        this.modal.error("Found an error, please contact support team", this.viewRef);
      })

      this.dialogVanMaster.Close();
  }

  public EditVanMaster(){ 

    if (!this.formData.VAN_NAME) {
      this.modal.warning('Please enter Van Name!', this.viewRef);
      return false;
    }
    if (!this.formData.VAN_WIDTH) {
      this.modal.warning('Please enter Van Width!', this.viewRef);
      return false;
    }
    if (!this.formData.VAN_DEPTH) {
      this.modal.warning('Please enter Van Depth!', this.viewRef);
      return false;
    }
    if (!this.formData.VAN_HEIGHT) {
      this.modal.warning('Please enter Van Height!', this.viewRef);
      return false;
    }  

    if (this.formData.VAN_WIDTH <= 0) {
      this.modal.warning('Please enter Van Width must more than 0', this.viewRef);
      return false;
    }
    if (this.formData.VAN_DEPTH <= 0) {
      this.modal.warning('Please enter Van Depth must more than 0', this.viewRef);
      return false;
    }
    if (this.formData.VAN_HEIGHT <= 0) {
      this.modal.warning('Please enter Van Height must more than 0', this.viewRef);
      return false;
    } 
    if (this.formData.STATUS == 'N') {
      this.modal.confirm('คุณต้องการยกเลิกการใช้งาน '+this.formData.VAN_NAME+' ใช่หรือไม่', this.viewRef , this.EditVan)   
    }else{
      this.EditVan();
    }
    
  }

  private EditVan = () => { 
    const params = {
      VAN_NAME: this.formData.VAN_NAME,
      VAN_WIDTH: this.formData.VAN_WIDTH,
      VAN_DEPTH: this.formData.VAN_DEPTH,
      VAN_HEIGHT: this.formData.VAN_HEIGHT,
      STATUS: this.formData.STATUS,
    }       
    this.Http.post('WH', 'SNWR044_N_EditVanMaster', params)
      .subscribe(res => { 
        try {  

          this.formData =[] ;
          this.modal.info(res.Table[0].MESSAGE, this.viewRef);
          this.GetDataVanMaster();

        } catch (error) {
          console.log(error, 'err') 
        }   
      }, err => {
        console.log(err, 'err');
        this.modal.error("Found an error, please contact support team", this.viewRef);
      })
      this.dialogVanMaster.Close();
  }

  public ChangeVan(data){

    this.dataHead.VAN_NAME = data.value

    let find = this.tableDataVanMaster.find(obj => obj.VAN_NAME === data.value )
    if (find){
      this.dataHead.DIMENSION_W = find.VAN_WIDTH
      this.dataHead.DIMENSION_D = find.VAN_DEPTH
      this.dataHead.DIMENSION_H = find.VAN_HEIGHT;
    }   

    let width  : number = this.dataHead.DIMENSION_W == null ? 0 : this.dataHead.DIMENSION_W;
    let length : number = this.dataHead.DIMENSION_D == null ? 0 : this.dataHead.DIMENSION_D;    
    let height : number = this.dataHead.DIMENSION_H == null ? 0 : this.dataHead.DIMENSION_H;
    const volume = width * length * height;    
    const M3 = this.global.Round((width * length * height) / Math.pow(10, 9), 3);

    this.dataHead.DIMENSION = M3;
     
    this.dataHead.MAX_VOLUME = M3;
    this.CalOver();  
    
  }

  public CloseVanMaster(){
    
    this.formData.VAN_NAME ='';
    this.dialogVanMaster.Close();
    this.GetDataVanMaster(); 
  }

  public ListDataVanMaster(){    
    this.ListsDataVanMaster = this.tableDataVanMaster.filter(icase => icase.STATUS !== 'N' );
  }



  //public EditVanDetail(data: any) {

  //  if (data.STATUS == "CONFIRM") {
  //    this.SelectNewVan(data)
  //  } else {
  //    this.SelectVanForEdit(data)
  //  }

  //}

  public SelectVanForEdit(data: any) {
    this.isEdit = true
    const param = {
      CUSTOMER_CODE: data.CUSTOMER_CODE,
      BRANCH_CODE: '01',
      ORDER_TYPE: data.ORDER_TYPE,
      VAN_GROUP: data.VAN_GROUP
    }
    this.paramSearch.VAN_GROUP = data.VAN_GROUP
    //this.tempVan = this.vanList.filter(x => x.VAN_GROUP == data.VAN_GROUP)
    //this.tabGroup.selectedIndex = 1
    this.isVan = true
    this.selectionCase.clear()
    this.Http.post("WH", "SNWR044_GetVanForEdit", param)
      .subscribe(res => {
        this.vanDetail = res.Table
        this.caseList = res.Table1;

        if(this.canEdit){
          this.caseList.map(x => {
            if (x.VAN_GROUP == data.VAN_GROUP)
              this.selectionCase.select(x)
          })
        }else{
          this.caseList = this.caseList.filter(x => x.VAN_GROUP == data.VAN_GROUP)
        }
        
        this.FindTotalCase();
        //this.dialogVanDetail.OpenDialog();
      })
  }

  public SelectNewVan(data: any) {


    this.tempCase = []
    const x = data.VAN_NO
 
    this.isVan = true
   // this.tabGroup.selectedIndex = 1
    //this.tempVan = this.vanList.filter(x => x.VAN_NO == data.VAN_NO)
    const param = {
      CUSTOMER_CODE: data.CUSTOMER_CODE,
      BRANCH_CODE: '01',
      ORDER_TYPE: data.ORDER_TYPE,
      VAN_NO: x
    }
    this.Http.post("WH", "SNWR044_GetCaseByNewVan", param)
      .subscribe(res => {
        
        this.selectionCase.clear();
        this.vanDetail = res.Table
        this.caseList = res.Table1;
        if (this.tempCase.length > 0) {
          this.tempCase.map(x => {
            let find = this.caseList.find(z => z.CASE_NO == x.CASE_NO)
            const totalQty = this.vanDetail.find(c => c.CASE_NAME == x.CASE_NAME).QTY
            const totalCase = this.tempCase.filter(v => v.CASE_NAME == x.CASE_NAME).length
            if (find && (totalQty >= totalCase)) {
              this.selectionCase.select(find)
            }
          })
        }
        this.FindTotalCase();


      })
  }

  private FindTotalCase() {
    this.vanDetail.map(x => {
      const totalCase = this.selectionCase.selected.filter(z => z.CASE_NAME == x.CASE_NAME).length
      x.TOTAL_CASE = totalCase
    })
  }

  public SaveCase() {
    if (this.selectionCase.selected.length == 0) {
      this.modal.warning("Please select case number", this.viewRef)
      return;
    }
    this.modal.confirm("Do you want to save?", this.viewRef, () => Confirm())
    let Confirm = () => {
      let data = {
        vanNo: "",
        // vanList: this.isEdit ? this.tempVan : this.selection.selected,
        vanList: this.vanList,
        customer: this.dataHead.CUSTOMER_CODE,
        branch: "01",
        order_type: this.dataHead.ORDER_TYPE,
        caseList: this.selectionCase.selected
      }

      this.Http.post("WH", "SNWR044_SaveVan", data)
        .subscribe(res => {
          if (res.STATUS_MESSAGE == "DONE") {
          
            this.modal.info("Save data complete", this.viewRef)
            this.isVan = false;
            this.Back()

           // this.SearchVan();
      
          } else {
            this.modal.error("Found an error, please contact support team", this.viewRef)
          }
        }, err => {
          console.log(err, 'err');
          this.modal.error("Found an error, please contact support team", this.viewRef);
        })
    }
  }

  public DisableCheckbox(caseName) {
    return this.vanDetail.some(x => x.CASE_NAME == caseName && x.QTY == x.TOTAL_CASE)
  }

  public CheckboxChange(event, row) {
    let find = this.vanDetail.find(x => x.CASE_NAME == row.CASE_NAME)
    if (event.checked) {
      if (find)
        find.TOTAL_CASE += 1;
    } else {
      if (find)
        find.TOTAL_CASE -= 1;
    }
  }

  public GetCaseDetail(data: any) {
    this.Http.post("WH", "SNWR044_GetCaseDetail", data)
      .subscribe(res => {
        this.caseDetail = res.Table
        this.dialogCaseDetail.OpenDialog()
      })
  }

  public ReturnVan() {

    this.modal.confirm("Do you want to return?", this.viewRef, () => Confirm())

    let Confirm = () => {

      this.Http.post("WH", "SNWR044_ReturnVan", this.dataHead)
        .subscribe(res => {
          if (res.STATUS_MESSAGE == "DONE") {
            this.modal.info("Return complete", this.viewRef)
            this.ViewDetail(this.paramData);
           
          } else {
            this.modal.error("Found an error, please contact support team", this.viewRef)
          }
        }, err => {
          console.log(err, 'err');
          this.modal.error("Found an error, please contact support team", this.viewRef)
        })
    }
  }

  public VanReport() {

    if(this.selectionVan.selected.length == 0){
      this.modal.warning("Please select van",this.viewRef)
      return
    }
    const van_no = this.selectionVan.selected.map(x => x.VAN_NO).join(",")
    const customer = this.selectionVan.selected.map(x => x.CUSTOMER_CODE).join(",")
    this.global.GoToExportName("PMS_RPT_WMS_SNWR044_VAN_DETAIL", {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_CUSTOMER_CODE: customer,
            P_VAN_NO: van_no,
            P_VAN_GROUP : "VAN_GROUP"
      } , "PMS_RPT_WMS_SNWR044_VAN_DETAIL", "EXCELOPENXML"
    ); 
  }

  public VanReportByDetail(){


     this.Http
      .Download("WH", "SNWR044_VAN_DETAIL_REPORT", {
        ReportPrefix: "PMS_RPT_WMS_SNWR044_VAN_DETAIL",
        ReportSuffix: ".EXCELOPENXML",
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_CUSTOMER_CODE: this.dataHead.CUSTOMER_CODE,
        P_VAN_NO: this.dataHead.VAN_NO,
        P_VAN_GROUP : "VAN_GROUP"
      })
      .subscribe((res) => {
        if (res) {
          this.writeContents(res);
        }
      }, (err) => {
        console.log(err, 'err');
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });

    
    // this.global.GoToExportName("PMS_RPT_WMS_SNWR044_VAN_DETAIL", {
    //   P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
    //   P_CUSTOMER_CODE: this.dataHead.CUSTOMER_CODE,
    //   P_VAN_NO: this.dataHead.VAN_NO,
    //   P_VAN_GROUP : "VAN_GROUP"
    // } , "PMS_RPT_WMS_SNWR044_VAN_DETAIL", "EXCELOPENXML"); 
  }

  private writeContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "PMS_RPT_WMS_SNWR044_VAN_DETAIL.xlsx" ;
    a.click();
  }

  public ReportDialog() {
    // this.tableDetailReport = {
    //   REPORT_NAME: "PMS_RPT_WMS_SNWR036_GET_DETAIL_PACKED_BY_VIEW",
    //   PARAMETER: {
    //     P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
    //     P_CUSTOMER_CODE: data.CUSTOMER_CODE,
    //     P_BRANCH_CODE: data.BRANCH_CODE,
    //     P_ORDER_TYPE: data.ORDER_TYPE,
    //   }
    // };
    //const report = this.tableDetailReport;
    this.global.GoToExport(
      "report.REPORT_NAME", 
      "report.PARAMETER",
      true, 
      "EXCELOPENXML"
    ); 
  }


  public SearchRemainCase(){
    this.Http.post("WH","SNWR044_GetRemainCase",this.paramSearchCase)
    .subscribe(res => {
      this.tableAvailableCase = res.Table;
    })
  }



  public VanReportSummary(){
    if(!this.paramSearchReport.START_DATE || !this.paramSearchReport.END_DATE){
      this.modal.warning("Please select start date and end date",this.viewRef)
      return
    }
    
    let startdate = this.paramSearchReport.START_DATE.format("DD-MMM-YYYY").toString()
    let enddate = this.paramSearchReport.END_DATE.format("DD-MMM-YYYY").toString()
    this.global.GoToExportName("PMS_RPT_WMS_SNWR044_VAN_SUMMARY", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_CUSTOMER_CODE: this.paramSearchReport.CUSTOMER_CODE,
      P_START_DATE: startdate,
      P_END_DATE : enddate
    } , "PMS_RPT_WMS_SNWR044_VAN_SUMMARY", "EXCELOPENXML"); 
  }


}
