import { Component, OnInit, ViewContainerRef, ViewChild, Input } from "@angular/core";
import * as moment from "moment";
import { HttpService } from "src/app/core/http.service";
import { ModalService } from "src/app/core/modal.service";
import { Globals } from 'src/app/core/global';
import { DialogTemplateComponent } from "src/app/components/shared/dialog-template/dialog-template.component";

@Component({
  selector: "SNWR056",
  templateUrl: "SNWR056.component.html",
})
export class SNWR056Component implements OnInit {
  @Input("FORM") form: string = "";

  constructor(
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private global: Globals,
    private http: HttpService
  ) { }

  public params: any = {};
  public invoiceData: any = {};
  public insData: any = {};
  private currentDate: moment.Moment = moment();

  public tableDataPick: any = [];
  public tablePickingByPicker: any = [];

  public iSelectTab: number = 0;
  public iShowBy: number = 0;
  public tabIndex: number = 0;
  public searchBy: string = '';
  public searchByCode: string = '';
  public ENABLE_CANCEL_PICK = '';

  public sumSummary: any[] = [
    {
      fieldName: 'CUSTOMER_CODE',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'NO_OF_ITEM',
      show: true,
    },
    {
      fieldName: 'ACCEPT_QTY',
      show: true,
    },
  ];
  public sumAllocate: any[] = [
    {
      fieldName: 'CUSTOMER_CODE',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'NO_OF_ITEM',
      show: true,
    },
    {
      fieldName: 'ACCEPT_QTY',
      show: true,
    },
  ];
  public sumPick: any[] = [
    {
      fieldName: 'CUSTOMER',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'NO_OF_INSTRUCTION',
      show: true,
    },
    {
      fieldName: 'ACCEPT_QTY',
      show: true,
    },
    {
      fieldName: 'PICK_QTY',
      show: true,
    },
    {
      fieldName: 'PICK_QTY_BAL',
      show: true,
    },
  ];
  public sumPack: any[] = [
    {
      fieldName: 'CUSTOMER',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'NO_OF_CASE',
      show: true,
    },
    {
      fieldName: 'NO_OF_INSTRUCTION',
      show: true,
    },
    {
      fieldName: 'PACK_QTY',
      show: true,
    },
    {
      fieldName: 'PACK_QTY_BAL',
      show: true,
    },
  ];
  public sumInv: any[] = [
    {
      fieldName: 'ACCEPT_PART_NAME',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'ITEM_QTY',
      show: true,
    },
    {
      fieldName: 'TOTAL_ITEM',
      show: true,
    },
    {
      fieldName: 'TOTAL_QTY',
      show: true,
    },
    {
      fieldName: 'TOTAL_RETAIL_B',
      show: true,
    },
    {
      fieldName: 'RETAIL_PRICE_B',
      show: true,
    },
    {
      fieldName: 'DISCOUNT_AMT',
      show: true,
    },
    {
      fieldName: 'NET_AMT_B',
      show: true,
    },
  ];
  public sumVan: any[] = [
    {
      fieldName: 'ACCEPT_PART_NAME',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'ITEM_QTY',
      show: true,
    },
    {
      fieldName: 'TOTAL_ITEM',
      show: true,
    },
    {
      fieldName: 'TOTAL_QTY',
      show: true,
    },
    {
      fieldName: 'TOTAL_RETAIL_B',
      show: true,
    },
    {
      fieldName: 'RETAIL_PRICE_B',
      show: true,
    },
    {
      fieldName: 'DISCOUNT_AMT',
      show: true,
    },
    {
      fieldName: 'NET_AMT_B',
      show: true,
    },
  ];

  //public tableDataAllocated: any = [];
  //public tableDataNotPick: any = [];
  //public tableDataPicked: any = [];
  //public tableDataPacked: any = [];
  //public tableDataVan: any = [];
  //public tableDataInvoice: any = [];

  public tableDataHeader: any = [];
  public tableDataDetail: any = [];
  public tableDetailName: any;
  public tableDetailFooter: any;
  public tableDetailReport: any;
  public invoiceDetail: any = [];

  @ViewChild("dialogDetail", { static: false }) dialogDetail: any;
  @ViewChild("InvoiceDialog") InvoiceDialog: DialogTemplateComponent;
  @ViewChild("InstructionDialog") InstructionDialog: DialogTemplateComponent;

  public VendorSearchConfig: any = {
    ColName: "LOOKUP_VENDOR_CODE",
    PlaceholderText: "Select Vendor Code",
    SourceController: "WH",
    SourceMethodName: "SNWR056_GetVendorCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params,
    },
    UpperCase: true,
  };

  public SetSelectedVendorCode(value: any) {
    this.params.VENDOR_CODE = value.VENDOR_CODE;
    this.params.VENDOR_NAME = value.VENDOR_NAME;
    this.Search();
  }

  public PartNoSearchConfig: any = {
    ColName: "LOOKUP_PART_NO",
    PlaceholderText: "Select Part No",
    SourceController: "WH",
    SourceMethodName: "SNWR056_GetPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params,
    },
    UpperCase: true,
  };

  public SetSelectedPartNo(value: any) {
    this.params.PART_NO = value.PART_NO;
    this.params.PART_NAME = value.PART_NAME;
    this.Search();
  }
  
  ngOnInit() {
    this.params.TYPE_DATE = 'LAST2MONTH'
    this.http.post('WH', 'GetDateByFormat', this.params)
      .subscribe(res => {
        //this.params.START_DATE = res.Table[0].TARGETMONTH;
        this.params.START_DATE = this.currentDate;
        this.params.END_DATE = this.currentDate;
        this.iSelectTab = 0;
        this.iShowBy = 1;
        this.Search();
      });
  }

  public ViewBy1(i) {
    this.iShowBy = i;
  }

  public tabClick(tab: any) {
    this.iSelectTab = tab;
    this.Search();
  }

  public FindIns() {
    this.tableDataDetail = [];
    this.tableDetailName = 'SNWR056_INSTRUCTION_DETAIL';
    this.params.INSTRUCTION_NO = '';
    this.params.PICKING_LIST_NO = '';
    this.params.PART_NO = '';
    this.ENABLE_CANCEL_PICK = '';
    this.insData = {};
    this.InstructionDialog.OpenDialog();
  }

  public FindDataClick(Action) {
    //public FindInsClick() {
    let txtAction: string = '';
    let apiName: string = '';
    this.ENABLE_CANCEL_PICK = '';

    if (Action == 1) {
      txtAction = 'instruction';
      apiName = 'SNWR056_FindInstruction';
      this.searchBy = 'Search By Instruction No.';
      this.searchByCode = 'Instruction';
    } else if (Action == 2) {
      txtAction = 'Picking list';
      apiName = 'SNWR056_FindPickinglistNo';
      this.searchBy = 'Search By Picking list No.';
      this.searchByCode = 'PickingList';
    } else if (Action == 3) {
      txtAction = 'Part';
      apiName = 'SNWR056_FindPartNo';
      this.searchBy = 'Search By Part No.';
      this.searchByCode = 'PartNo';
    }
    //this.tableDetailName = 'SNWR056_PICKED_DETAIL';
    //this.InstructionDialog.OpenDialog();

    this.http.post('WH', apiName, this.params)
      .subscribe(res => {
        var tableDataDetail = res.Table;
        // console.log('1 res.Table', res.Table);
        // console.log('2 tableDataDetail', tableDataDetail);
        // console.log('3 tableDataDetail.RowCount', tableDataDetail.length);
        if (tableDataDetail.length > 0) {
          if (Action == 1) {
            if (tableDataDetail[0].COMPLETE_FLAG == 'A') {
              this.tableDetailName = 'SNWR056_ALLOCATE_DETAIL';
            } else if (tableDataDetail[0].COMPLETE_FLAG == 'N') {
              this.tableDetailName = 'SNWR056_NOT_PICK_DETAIL';
            } else if (tableDataDetail[0].COMPLETE_FLAG == 'L') {
              this.tableDetailName = 'SNWR056_NOT_PICK_DETAIL';
            } else if (tableDataDetail[0].COMPLETE_FLAG == 'P') {
              this.tableDetailName = 'SNWR056_PICKED_DETAIL';
            } else if (tableDataDetail[0].COMPLETE_FLAG == 'C') {
              this.tableDetailName = 'SNWR056_PACKED_DETAIL';
            } else if (tableDataDetail[0].COMPLETE_FLAG == 'I') {
              this.tableDetailName = 'SNWR056_INVOICE_DETAIL';
            } else {
              this.tableDetailName = 'SNWR056_INVOICE_DETAIL';
            }
          } else if (Action == 2) {
            this.tableDetailName = 'SNWR056_INSTRUCTION_FIND';
          } else if (Action == 3) {
            this.tableDetailName = 'SNWR056_INSTRUCTION_FIND';
          }

          //console.log('this.tableDetailName', this.tableDetailName);
          this.tableDataDetail = res.Table;
          this.insData = this.tableDataDetail[0];
          this.ENABLE_CANCEL_PICK = this.tableDataDetail[0].ENABLE_CANCEL_PICK;
        } else {
          this.tableDataDetail = [];
          this.modal.warning("ไม่พบข้อมูล กรุณารบกวนตรวจสอบเลข " + txtAction, this.viewRef);
        }
        // this.InstructionDialog.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      });

  }

  public CancelPick() {
    this.modal.confirm(
      "Are you sure to cancel card?" + 
      "<br> Instruction: " + this.insData.INSTRUCTION_NO  + 
      "<br> P/N: " + this.insData.ACCEPT_PART_NO  + 
      "<br> จำนวน: " + this.insData.ACCEPT_QTY  + 
      "<br> Qty: " + this.insData.PICK_QTY  + 
      "<br> หาของ: " + this.insData.PICK_QTY_BAL  + 
      "<br> Status: " + this.insData.STATUS 
      , this.viewRef
      , () => {
        this.http.post('WH', 'SNWR056_CancelPick', this.params)
          .subscribe(res => {
            this.modal.info('Cancel card completed', this.viewRef);
            this.InstructionDialog.Close()
          }, (err) => {
            console.log(err, 'err')
            this.modal.warning("Found an error, please contract support team", this.viewRef);
          })}
      , () => {}
      , { height:"24rem", width:"38rem" }
      );
  }

  public Search() {
    if(!this.params.START_DATE || !this.params.END_DATE){
      this.modal.warning("กรุณาใส่วันที่เพื่อกำหนดช่วงข้อมูล", this.viewRef);
      return;
    }

    if (this.iSelectTab == 0) {
      this.http.post('WH', 'SNWR056_GetDataSummary', this.params)
        .subscribe(res => {
          this.tableDataHeader = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });
    } else if (this.iSelectTab == 1) {
      // this.http.post('WH', 'SNWR056_GetDataAllocated', this.params)
      //   .subscribe(res => {
      //     this.tableDataHeader = res.Table;
      //   }, (err) => {
      //     console.log(err, 'err')
      //     this.modal.warning("Found an error, please contact support team", this.viewRef);
      //   });
      this.http.post('WH', 'SNWR056_GetDataAllocatedV2', this.params)
        .subscribe(res => {
          this.tableDataHeader = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });
    } else if (this.iSelectTab == 2) {
      this.http.post('WH', 'SNWR056_GetDataNotPick', this.params)
        .subscribe(res => {
          this.tableDataHeader = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });
    } else if (this.iSelectTab == 3) {
      this.http.post('WH', 'SNWR056_GetDataPicked', this.params)
        .subscribe(res => {
          this.tableDataHeader = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });
    } else if (this.iSelectTab == 4) {
      this.http.post("WH", "SNWR056_GetDataPacked", this.params)
        .subscribe((res) => {
          this.tableDataHeader = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });
    } else if (this.iSelectTab == 5) {
      this.http.post('WH', 'SNWR056_GetDataInvoice', this.params)
        .subscribe(res => {
          this.tableDataHeader = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        })
    } else if (this.iSelectTab == 6) {
      this.http.post("WH", "SNWR056_GetDataVan", this.params)
        .subscribe((res) => {
          this.tableDataHeader = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });
    } else if (this.iSelectTab == 7) {
      this.http.post("WH", "SNWR056_GetDataReceived", this.params)
        .subscribe((res) => {
          this.tableDataHeader = res.Table;
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contact support team", this.viewRef);
        });
    }
  }

  public ViewDetailSummary(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.VENDOR;
    this.http.post('WH', 'SNWR056_GetDetailSummary', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR056_SUMMARY_DETAIL';
        this.tableDetailFooter = undefined;
        this.tableDetailReport = {
          REPORT_NAME: "PMS_RPT_WMS_SNWR056_GET_DETAIL_SUMMARY",
          PARAMETER: {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_VENDOR_CODE: data.VENDOR_CODE,
            P_PO_NO: data.PO_NO,
            P_PO_DATE:  moment(data.PO_DATE).format("DD-MMM-YYYY"),
            P_ITEM_NO: data.ITEM_NO,
          }
        };
        this.dialogDetail.title = "PO No : " + data.PO_NO + " - " + data.VENDOR;
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailAllocated(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR056_GetDetailAllocated', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR056_ALLOCATE_DETAIL';
        this.tableDetailFooter = undefined;
        this.tableDetailReport = {
          REPORT_NAME: "PMS_RPT_WMS_SNWR056_GET_DETAIL_ALLOCATED",
          PARAMETER: {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_CUSTOMER_CODE: data.CUSTOMER_CODE,
            P_PICKING_LIST_NO: data.PICKING_LIST_NO,
            P_ALLOCATE_DATE:  moment(data.ALLOCATE_DATE).format("DD-MMM-YYYY"),
          }
        };
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailNotPick(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR056_GetDetailNotPick', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR056_NOT_PICK_DETAIL';
        this.tableDetailFooter = this.sumPick;
        this.tableDetailReport = {
          REPORT_NAME: "PMS_RPT_WMS_SNWR056_GET_DETAIL_NOT_PICK",
          PARAMETER: {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_CUSTOMER_CODE: data.CUSTOMER_CODE,
            P_PICKING_LIST_NO: data.PICKING_LIST_NO,
            P_PRINT_DATE:  moment(data.PRINT_DATE).format("DD-MMM-YYYY"),
          }
        };
        this.dialogDetail.title = data.CUSTOMER;
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailPicked(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR056_GetDetailPicked', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR056_PICKED_DETAIL';
        this.tableDetailFooter = this.sumPick;
        this.tableDetailReport = {
          REPORT_NAME: "PMS_RPT_WMS_SNWR056_GET_DETAIL_PICKED",
          PARAMETER: {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_CUSTOMER_CODE: data.CUSTOMER_CODE,
            P_PICKING_LIST_NO: data.PICKING_LIST_NO,
            P_PRINT_DATE:  moment(data.PRINT_DATE).format("DD-MMM-YYYY"),
          }
        };
        this.dialogDetail.title = data.CUSTOMER;
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailPacked(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR056_GetPackedDetail', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailName = 'SNWR056_PACKED_DETAIL';
        this.tableDetailFooter = this.sumPack;
        this.tableDetailReport = {
          REPORT_NAME: "PMS_RPT_WMS_SNWR056_GET_DETAIL_PACKED",
          PARAMETER: {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_CUSTOMER_CODE: data.CUSTOMER_CODE,
            P_PICKING_LIST_NO: data.PICKING_LIST_NO,
            P_PRINT_DATE:  moment(data.PRINT_DATE).format("DD-MMM-YYYY"),
          }
        };
        this.dialogDetail.title = data.CUSTOMER;
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailInvoice(data: any) {
    this.invoiceDetail = [];
    this.invoiceData = data;
    this.http.post("WH", "SNWR056_GetInvoiceDetail", this.invoiceData)
      .subscribe(res => {
        this.invoiceDetail = res.Table;
        this.InvoiceDialog.title = data.DOCUMENT_NO + " - " + data.CUSTOMER;
        this.InvoiceDialog.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailVan(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR056_GetVanDetail', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDataDetail.map((x, i) => x.SEQ = i + 1)
        this.tableDetailName = 'SNWR056_VAN_DETAIL';
        this.tableDetailFooter = this.sumVan;
        this.tableDetailReport = {
          REPORT_NAME: "PMS_RPT_WMS_SNWR056_GET_DETAIL_VAN",
          PARAMETER: {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_DOCUMENT_NO: data.DOCUMENT_NO,
          }
        };
        this.dialogDetail.title = data.DOCUMENT_NO + " - " + data.CUSTOMER;
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailReceived(data: any) {
    this.tableDataDetail = [];
    this.params.CUSTOMER = data.CUSTOMER;
    this.http.post('WH', 'SNWR056_GetReceivedDetail', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDataDetail.map((x, i) => x.SEQ = i + 1)
        this.tableDetailName = 'SNWR056_RECEIVED_DETAIL';
        this.tableDetailFooter = this.sumVan;
        this.tableDetailReport = {
          REPORT_NAME: "PMS_RPT_WMS_SNWR056_GET_DETAIL_RECEIVED",
          PARAMETER: {
            P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
            P_VENDOR_CODE: data.VENDOR_CODE,
            P_PO_NO: data.PO_NO,
            P_PO_DATE:  moment(data.PO_DATE).format("DD-MMM-YYYY"),
            P_ITEM_NO: data.ITEM_NO,
          }
        };
        this.dialogDetail.title = data.PO_NO + " - " + data.VENDOR;
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ViewDetailByPicker(data: any) {
    this.tableDataDetail = [];
    this.http.post('WH', 'SNWR056_GetDataDetailByPicker', data)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
        this.tableDetailFooter = undefined;
        this.tableDetailReport = undefined;
        this.dialogDetail.OpenDialog();
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contact support team", this.viewRef);
      })
  }

  public ReportDialog() {
    const report = this.tableDetailReport;
    this.global.GoToExport(
      report.REPORT_NAME,
      report.PARAMETER,
      true,
      "EXCELOPENXML"
    );
  }
  public ReportSummaryData() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR056_GET_SUMMARY", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_VENDOR_CODE: this.params.VENDOR_CODE,
      P_PART_NO: this.params.PART_NO,
      P_PO_NO: this.params.PO_NO,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportSummaryDetail() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR056_GET_SUMMARY_DETAIL", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_VENDOR_CODE: this.params.VENDOR_CODE,
      P_PART_NO: this.params.PART_NO,
      P_PO_NO: this.params.PO_NO,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportAllocatedData() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR056_GET_ALLOCATED_V2", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_VENDOR_CODE: this.params.VENDOR_CODE,
      P_PART_NO: this.params.PART_NO,
      P_PO_NO: this.params.PO_NO,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportNotPickData() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR056_GET_NOT_PICK", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_VENDOR_CODE: this.params.VENDOR_CODE,
      P_PART_NO: this.params.PART_NO,
      P_PO_NO: this.params.PO_NO,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportPickedData() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR056_GET_PICKED", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_VENDOR_CODE: this.params.VENDOR_CODE,
      P_PART_NO: this.params.PART_NO,
      P_PO_NO: this.params.PO_NO,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportPackedData() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR056_GET_PACKED", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_VENDOR_CODE: this.params.VENDOR_CODE,
      P_PART_NO: this.params.PART_NO,
      P_PO_NO: this.params.PO_NO,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportInvoiceData() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR056_GET_INVOICE", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_VENDOR_CODE: this.params.VENDOR_CODE,
      P_PART_NO: this.params.PART_NO,
      P_PO_NO: this.params.PO_NO,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportInvoiceDetail() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR056_GET_INVOICE_DETAIL", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_VENDOR_CODE: this.params.VENDOR_CODE,
      P_PART_NO: this.params.PART_NO,
      P_PO_NO: this.params.PO_NO,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportVanData() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR056_GET_VAN", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_VENDOR_CODE: this.params.VENDOR_CODE,
      P_PART_NO: this.params.PART_NO,
      P_PO_NO: this.params.PO_NO,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportVanDetail() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR056_GET_VAN_DETAIL", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_VENDOR_CODE: this.params.VENDOR_CODE,
      P_PART_NO: this.params.PART_NO,
      P_PO_NO: this.params.PO_NO,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportReceiveData() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR056_GET_RECEIVED", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_VENDOR_CODE: this.params.VENDOR_CODE,
      P_PART_NO: this.params.PART_NO,
      P_PO_NO: this.params.PO_NO,
    }, true, "EXCELOPENXML"
    );
  }
  public ReportReceiveDetail() {
    this.global.GoToExport("PMS_RPT_WMS_SNWR056_GET_RECEIVED_DETAIL", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_START_DATE: moment(this.params.START_DATE).format("DD-MMM-YYYY"),
      P_END_DATE: moment(this.params.END_DATE).format("DD-MMM-YYYY"),
      P_VENDOR_CODE: this.params.VENDOR_CODE,
      P_PART_NO: this.params.PART_NO,
      P_PO_NO: this.params.PO_NO,
    }, true, "EXCELOPENXML"
    );
  }
}
